************************************************************
      subroutine atlas( nstar , temp , alogg , nspec , lgTrace )
      implicit none
*interpolate on atlas model atmospheres, by K Volk
      real alogg , temp
      integer nstar,nspec
      logical lgTrace
      include "ncell.par"
      include "limspc.par"
      include "terp.com"
      include "path.com"
      character chLine*80
      include "pthset.com"
      include "called.com"
      include "StarSize.com"
      include "rfield.com"
      include "NumUpper.com"
      include "IOqq.com"
*
*     local variables
      real dev1 , dev2
      integer j,k,j1,ierr,nmods,i , jmod
      logical lgAgain
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*     these routines written by Kevin Volk
      parameter (nmods=412)
*     tnu array will be used to hold stellar array
*
*
* nmods is the number of accessable models in the new model set
* record 3 is the wavelength grid, record 2 holds the log(g) values,
* and record 1 holds the T_eff values, so there are nmods+3 records
* in the main file
*
* the values are all in integer format, usually of log10 quantities
*     real flux(ncell)
      integer ivals(ncell)
      real teff(nmods),xlogg(nmods)
      real tval(61)
      integer jval(11,61)
      data tval/3500.,3750.,4000.,4250.,4500.,4750.,5000.,5250.,
     1          5500.,5750.,6000.,6250.,6500.,6750.,7000.,7250.,
     1          7500.,7750.,8000.,8250.,8500.,8750.,9000.,9250.,
     1          9500.,9750.,10000.,10500.,
     1          11000.,11500.,12000.,12500.,13000.,14000.,15000.,
     1          16000.,17000.,18000.,19000.,20000.,21000.,22000.,
     1          23000.,24000.,25000.,26000.,27000.,28000.,29000.,
     1          30000.,31000.,32000.,33000.,34000.,35000.,37500.,
     1          40000.,42500.,45000.,47500.,50000./
* these arrays hold the teff and log(g) values for the models in the
* set; if the parameters are in range, interpolation is done first in
* temperature and then in log(g)
*
* start by reading in the parameters
*
*
*     add together path to form atlas file 
*
*     true is special path set, false if file in same dir
      if( lgPathSet ) then
        j = 1
        lgAgain = .true.
        i = 1
*     >>chng 97 may 13, get rid of statement numbers
*       do i=1,80
        do while (lgAgain.and. i.le.80 )
          if( chPath(i:i).ne.' ') then
            chLine(j:j) = chPath(i:i)
            j = j + 1
          else
*           go to2
            lgAgain = .false.
          endif
          i = i + 1
        end do
*2      continue
*       j now points to first free character
        chLine(j:j+8) = 'atlas.mod'
*       end string with zero character
        chLine(j+9:j+9) = char(0)
      else
        chLine(1:9) = 'atlas.mod'
*       end string with zero character
        chLine(10:10) = CHAR(0)
      endif
*
      do j=1,11
        do k=1,61
          jval(j,k) = -1
        end do
      end do
*
*     gjf open(unit=92,file='atlas.mod',
      if(lgTrace)write(qq,'('' About to open file='',A80)') chLine
      open(unit=92,file=chLine,
     1     status='old',access='direct',
     1     form='formatted',iostat=ierr,recl=7*ncell)
*
*     something went wrong
      if( ierr.ne.0 ) then
        write(qq,'(''Error: Kurucz stellar atmosphere file'',
     1  '' atlas.mod not found.'')')
        write(qq,'('' The path I tried:'',A80)') chLine
        write(qq,'('' And here comes its octal representation:'')')
        write(qq,'(1X,A1,Z4)') (chLine(i:i),chLine(i:i),i=1,80)
*       write(qq,'(1X,A1,O4)') (chLine(i:i),chLine(i:i),i=1,80)
        stop
      endif
*
      if(lgTrace)write(qq,'('' About to get temps'')')
      read(92,'(4000i7)' ,rec=1,iostat=ierr) (ivals(j),j=1,nmods)
*999  format(4000i7)
      if( ierr.ne.0 ) then
        write(qq,'('' IOSTAT returned'',I3,'' when reading '',
     1   ''temperatures.'')') ierr
        stop
      endif
*
      do j=1,nmods
        teff(j) = float(ivals(j))
      end do
*
      if(lgTrace)write(qq,'('' About to get gravs'')')
      read(92,'(4000i7)' ,rec=2,iostat=ierr) (ivals(j),j=1,nmods)
*       write(66,'(4i10)') (ivals(j),j=1,nmods)
      if( ierr.ne.0 ) then
        write(qq,'('' IOSTAT returned'',I3,'' when reading '',
     1   ''gravities.'')') ierr
        stop
      endif
*
      do j=1,nmods
        xlogg(j) = float(ivals(j))/100000.0
      end do
*
      if(lgTrace)write(qq,'('' About to get wavelengths'')')
      read(92,'(4000i7)' ,rec=3,iostat=ierr) (ivals(j),j=1,nAtlas)
      if( ierr.ne.0 ) then
        write(qq,'('' IOSTAT returned'',I3,'' when reading '',
     1   ''wavelengths.'')') ierr
        stop
      endif
*
*     dec alpha compiler was too smart, flagged following sanity check
      i = nAtlas
      j = ncell
*     if( nAtlas.gt.ncell ) then
      if( i.gt.j ) then
        write(qq,'('' Too many points read in from stellar atmosphere.''
     1  ,''  Increase ncell everywhere.  Min='',I5)')nAtlas
        stop
      endif
*
      do j=1,nAtlas
*       tnu holds the frequency arrays
        tnu(nspec,j) = 10.**(-1.*float(ivals(j))/1000000.+5.0)
      end do
*
      do j=1,nmods
        j1 = int(2.*xlogg(j)+0.001)+1
        if( j1.lt.1 .or. j1.gt.11 ) then
          write(qq,'('' atlas finds insane j1:'',i5,
     1    '' j, xlogg(j),='',i5,1p,e10.2)') j1,j,xlogg(j)
          stop
        endif
        do k=1,61
          if( teff(j).eq.tval(k) ) jval(j1,k)=j+1
        end do
      end do
*
*      determine which model or models are needed.
*
*     TEMP and ALOGG are desired temp and log g
*
      jmod = -1
*
      lgAgain = .true.
      j = 1
*     doj=1,nmods
*     >>chng 97 may 13, get rid of statement number
      do while( lgAgain.and. j.le.nmods )
        dev1 = abs(temp/teff(j)-1.)
        if( xlogg(j).gt.0.4 ) then
          dev2 = abs(alogg/xlogg(j)-1.)
        else
          dev2 = abs(alogg-xlogg(j))
        endif
*       this is because log(g) can be zero for the new set of models
*       this is test for exact model, result is jmod still -1 if hit
        if (dev1.le.0.001.and.dev2.le.0.001) then
          jmod = j+1
*         go to335
          lgAgain = .false.
        endif
        j = j + 1
      end do
*335  continue
*
      if (alogg.lt.0..or.alogg.gt.5.) then
*       this rejects temps outside the range of models
        write(qq,'('' Gravity outside range of 0.0 to'',
     1  '' 5.0'')')
        stop
      endif
*     following blocks either a) interpolate or b) get exact model
      if (jmod.eq.-1) then
         if (temp.lt.3500..or.temp.gt.50000.) then
*          this rejects values outside the range of model temperatures
           write(qq,'('' Temperature outside range of 3500 to'',
     1     '' 50,000K'')')
           stop
         endif
         if(lgTrace)write(qq,'('' About to call GETATL.'')')
         call getatl(temp,alogg,jval,tval,ierr,teff,xlogg)
         if( ierr.eq.1 ) then
           write(qq,'('' GETATL returned ierr=1, stop.'')')
           stop
         endif
*        the GETATL subroutine carries out the interpolation
*        in t_eff and log(g)
      else
         if(lgTrace)write(qq,'('' Exact model about to be read in.'')')
*        read in the values (log10 of F_nu in cgs units)
         read(92,'(4000i7)' ,rec=jmod+2,iostat=ierr)(ivals(j),
     1   j=1,nAtlas)
*
         if( ierr.ne.0 ) then
           write(qq,'('' IOSTAT returned'',I3,'' when reading '',
     1      ''atlas model number'',I3)') ierr , jmod+2
           stop
         endif
*
          if(lgTalk)write(qq,'(23X,''*<<< K. Volk s Kurucz model '',I3,
     1    '' read in.  T_eff = '',F8.2,'' log(g) = '',F8.5,
     2    ''  >>> *'')') jmod-1,teff(jmod-1),xlogg(jmod-1)
*
          do j=1,nAtlas
            if( ivals(j).lt.9999999 ) then
              flux(j) = 10.**(-1.*float(ivals(j))/100000.0)
            else
              flux(j) = 0.
            endif
          end do
      endif
*
      do j=1,nAtlas
*       TSLOP is f_nu for each TNU point
        tslop(nspec,j) = flux(j)
      end do
      do j=nAtlas+1, ncell
        tslop(nspec,j) = 0.
      end do
*
      nstar = nAtlas
*
      close(unit=92)
*
      end
