******************************************************************************
      subroutine boltgn
      implicit none
*evaluate Boltzmann factors for the continuum, and related variables
      include "te1ryd.par"
      include "ncell.par"
      include "NumUpper.com"
      include "nhlvl.par"
      include "nh.com"
      include "gaunts.com"
      include "trace.com"
      include "trgant.com"
      include "corind.com"
      include "rfield.com"
      include "phycon.com"
      include "he.com"
      include "maxcor.com"
      include "IOqq.com"
      include "tgff.com"
*
*     local variables
      logical lgGauntF(2)
*     real toler
*     parameter (toler=0.015)
      real fac , fanu 
      integer i , if1
*
*     correction factors for induced recombination, 
*     also used as Boltzmann factors
*     check for zero is because ContBoltz is zeroed out in initizationation
*     of code, its possible this is a constant density grid of models
*     in which the code is called as a subroutine
      if( tgffused.ne.te .or. ContBoltz(1).le.0. ) then
        tgffused = te
        fac = te1ryd / te
        i = 1
        fanu = fac * anu(i)
        do while(i.le.nupper.and.fanu.lt.84. )
          ContBoltz(i) = exp(-fanu)
          i = i + 1
          fanu = fac * anu(i)
        end do
        maxcor = i - 1
*       zero out remainder
        do i=maxcor+1,nupper
          ContBoltz(i) = 0.
        end do
      endif
*
*     find frequency where thin to brems or plasma frequency
      call tauff
*
      if( abs(1.-tgffsued2/te) .gt. 0.10) then
        call gffsub(0.,anulog,gff,1,nflux,ncell,if1)
*       follwoing for ionized helium
        call gffsub(0.30103,anulog,gffhe2,1,nflux,ncell,if1)
        tgffsued2 = te
        lgGauntF(1) = .true.
      else
        lgGauntF(1) = .false.
      endif
*
      if( lgTrace.and.lgTrGant ) then
        write(qq,'(5X,''BOLTGN; gaunt facs?'',
     1  2L2,'' g 1 2='',1P,2E9.2,'' flag'',I2,'' guv(1,n)'',2E9.2)')
     2  lgGauntF,gff(1),gff(ipHn(2)),if1,gff(ipHn(2)+1),
     3  gff(nflux)
      endif
*
      end
