******************************************************************************
      subroutine carcol
      implicit none
*evaluate total cooling due to carbon
      include "ipLnArry.par"
      include "nta.par"
      include "ndfst.par"
      include "limelm.par"
      include "limLevelN.par"
      include "ncell.par"
      include "dcool.com"
      include "coolc.com"
      include "pciexc.com"
      include "embesq.com"
      include "p2ovp1.com"
      include "h.com"
      include "TePowers.com"
      include "phycon.com"
      include "TLineEXP.com"
      include "hmi.com"
      include "r1335.com"
      include "edsqte.com"
      include "occnum.com"
      include "ots.com"
      include "PopLevls.com"
      include "TauDmmy.com"
      include "DoppVel.com"
      include "IonFracs.com"
      include "he.com"
*     local variables
      real cse01,cse12,cse02,csh01,csh12,csh02,csh201,csh212,csh202
      real csh2p01,csh2p12,csh2p02,csh2o01,csh2o12,csh2o02
*
*     subroutine level3( t10,t21,t20)
*
*     local variables
*     real conpmp, damp
      real cs01,cs12,cs02,cs13,cs23,a21,a31,cs,
     1 pop3, cs2s2p,cs2s3p,a32 , popup , SaveAbun
*---------------------------------------------------------------------
*     Carbon cooling
*
*     C I 1656, collision strength from transition prob
      call PutCS( 7.3 , t1656 )
      call level2( t1656 )
*
*     C I fine structure lines
* >>chng 99 Jun 01
* begin changes by Peter van Hoof 
*     >>refer Tielens, A.G.G., & Hollenbach, D. 1985, ApJ, 291, 722
* effective collision strength of C I(3P) with e
*     >>refer Johnson, C.T., Burke, P.G., Kingston, A.E. 1987, JPhB, 20, 2553
* these data are valid for 7.5K <= Te <= 10,000K
      if( te.le.3.0e3 ) then
* the first fit is valid for 10K <= Te <= 300K, the second 300K <= Te <= 3000K
         cse01 = max(4.80E-06*te*te20/te03,8.24E-07*te32/te01)
         cse12 = max(7.67E-05*te/te10/te03,1.47E-06*te32*te10/te03)
         cse02 = max(4.72E-05*te70*te03,3.05E-07*te32*te10)
      else
* the first fit is valid for 300K <= Te <= 3000K, the second upto 10,000K
         cse01 = min(8.24E-07*te32/te01,0.0035*sqrte*te01)
         cse12 = min(1.47E-06*te32*te10/te03,0.0088*sqrte*te01*te005)
         cse02 = min(3.05E-07*te32*te10,0.00448*sqrte/te10*te03*te005)
      endif
      if( te.le.1.0e3 ) then
* rate coefficients for collisional de-excitation of C I(3P) with neutral H(2S1/2)
*     >>refer Launay & Roueff 1977, AA 56, 289
* the first fit is for Te <= 100K, the second for Te >= 250K
* these data are valid for 4K <= Te <= 1000K
         csh01 = max(1.61e-10,5.66e-11*te20)
* these data are valid for 7K <= Te <= 1000K
         csh12 = max(1.93e-10*te05*te03,5.64e-11*te30*te02)
* these data are valid for 10K <= Te <= 1000K
         csh02 = max(1.08e-10/te03,1.67e-11*te30*te02*te02)
      else
         csh01 = 0.
         csh12 = 0.
         csh02 = 0.
      endif
      if( te.le.1.2e3 ) then
* rate coefficients for collisional de-excitation of O I(3P) with H2(J=1,0)
*     >>refer Schroeder et al. 1991, J.Phys.B 24, 2487
* these data are valid for 10K <= Te <= 1200K
* the first entry is contribution from ortho H2, the second para H2.
         if( te.le.30. ) then
            csh2p01 = min(8.38E-11*te05*te01,2.12e-10/te20/te05/te01)
         else if( te.le.150. ) then
            csh2p01 = max(6.60e-11,2.12e-10/te20/te05/te01)
         else
            csh2p01 = min(8.10e-11,max(6.60e-11,3.38e-11*te10*te03))
         endif
         if( te.le.30. ) then
            csh2o01 = min(5.17E-11*te10*te05,1.07e-10/te10*te01)
         else if( te.le.150. ) then
            csh2o01 = max(7.10e-11,1.07e-10/te10*te01)
         else
            csh2o01 = min(8.57e-11,max(7.1e-11,3.37e-11*te10*te02*te02))
         endif
* assume standard mixture of ortho and para H2
         csh201 = 0.75*csh2o01 + 0.25*csh2p01
         if( te.le.30. ) then
            csh2p12 = min(1.48E-10*te05*te02,2.25e-10/te03/te03)
         else if( te.le.100. ) then
            csh2p12 = max(1.75e-10,2.25e-10/te03/te03)
         else
            csh2p12 = min(2.61e-10,max(1.75e-10,6.23e-11*te20*te01))
         endif
         csh2o12 = min(2.83e-10,4.46e-11*te30/te03)
         csh212 = 0.75*csh2o12 + 0.25*csh2p12
         if( te.le.30 ) then
            csh2p02 = min(8.67E-11*te02*te02,1.35e-10/te10)
         else if( te.le.150. ) then
            csh2p02 = max(8.40e-11,1.35e-10/te10)
         else
            csh2p02 = min(1.04e-10,max(8.4e-11,4.04e-11*te10*te02*te02))
         endif
         csh2o02 = min(1.11e-10,3.16e-11*te20/te02)
         csh202 = 0.75*csh2o02 + 0.25*csh2p02
      else
         csh201 = 0.
         csh212 = 0.
         csh202 = 0.
      endif         
* assume CS for HeI is the same as HI
      cs01 = cse01 + 3.*(csh01*(hi+hei) + csh201*htwo)/cdsqte
      cs12 = cse12 + 5.*(csh12*(hi+hei) + csh212*htwo)/cdsqte
      cs02 = cse02 + 5.*(csh02*(hi+hei) + csh202*htwo)/cdsqte
      call PutCS( cs01 , t610 )
      call PutCS( cs12 , t370 )
      call PutCS( cs02 , TauDummy )     
* end Peter van Hoof changes
*
      call level3(  t610,t370,TauDummy)
*
*     C I 9850, 8727, A from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
      if( xIonFracs(6,1) .gt.0.  .and. te.lt.40000. ) then
        cs12 = 1.156e-4*te*(1.09-7.5e-6*te-2.1e-10*te*te)
        cs13 = 2.8e-3*sqrte 
        cs23 = 2.764e-3*sqrte
        a21 = 3.26e-4 * t9830(ipLnEscP)
        a31 = 2.73e-3
        a32 = 0.528 * t8727(ipLnEscP)
* 666 error! change to level3
        c8727 = pop3( 9.,5.,1., cs12,cs13,cs23 , a21,a31,a32 ,
     1  1.417e4,1.255e4,pciexc,xIonFracs(6,1),0.) * a32 * 2.28E-12
*       >>chng get rid of carb()
*    1  1.417e4,1.255e4,pciexc,carb(1),0.) * a32 * 2.28E-12
        t9830(ipLnPopOpc) = xIonFracs(6,1)
        t9830(ipLnPopl) = xIonFracs(6,1)
        t9830(ipLnPopu) = 0.
        t9830(ipLnCS) = cs12
        t8727(ipLnPopOpc) = c8727 / (a32*2.28E-12)
        t8727(ipLnPopl) = c8727 / (a32*2.28E-12)
        t8727(ipLnPopu) = 0.
        t8727(ipLnCS) = cs23
        c9850 = pciexc * a21 * 2.02e-12
        dCooldT = dCooldT + c9850 * ( 1.468e4*tsq1 + halfte )
        dCooldT = dCooldT + c8727 * ( 1.255e4*tsq1 + halfte )
*
*       C I 9850 correction for deexcitation, needed for rec line
        r9850 = a21 / (a21 + cs12/5.*8.629e-6/sqrte*eden)
*
      else
        c9850 = 0.
        c8727 = 0.
        r9850 = 0.
        pciexc = 0.
        t9830(ipLnPopOpc) = 0.
        t9830(ipLnPopl) = 0.
        t9830(ipLnPopu) = 0.
        t8727(ipLnPopOpc) = 0.
        t8727(ipLnPopl) = 0.
        t8727(ipLnPopu) = 0.
      endif
      call coladd( 'C  1' ,  8727 , c8727 )
      call coladd( 'C  1' ,  9850 , c9850 )
*
*     C II 158 micron emission, A=
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     CS From 
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
*     neutral collision data from 
*     >>refer Tielens, A.G.G., & Hollenbach, D. 1985, ApJ, 291, 722
*     >>chng 96aug 01, better fit to cs 
      cs = min( 2.20 , 0.403*te20/te02*te001*te001) +
     1 5.8e-10*te02/cdsqte*4.* (hi+htwo)
      call PutCS( cs , t157 )
      call level2( t157 )
*
*     following used for pumping
* 666 error! put all these in cooling
      t386(ipLnPopOpc) = xIonFracs(6,3)
      t386(ipLnPopl) = xIonFracs(6,3)
      t386(ipLnPopu) = 0.
      t310(ipLnPopOpc) = xIonFracs(6,3)
      t310(ipLnPopl) = xIonFracs(6,3)
      t310(ipLnPopu) = 0.
      t291(ipLnPopOpc) = xIonFracs(6,3)
      t291(ipLnPopl) = xIonFracs(6,3)
      t291(ipLnPopu) = 0.
      t280(ipLnPopOpc) = xIonFracs(6,3)
      t280(ipLnPopl) = xIonFracs(6,3)
      t280(ipLnPopu) = 0.
      t274(ipLnPopOpc) = xIonFracs(6,3)
      t274(ipLnPopl) = xIonFracs(6,3)
      t274(ipLnPopu) = 0.
      t270(ipLnPopOpc) = xIonFracs(6,3)
      t270(ipLnPopl) = xIonFracs(6,3)
      t270(ipLnPopu) = 0.
*
*     all collision strengths and A'S from 
*     >>refer Lennon, D.J., Dufton, P.L., Hibbert, A., Kingston, A.E. 1985,
*     >>refer ApJ, 294, 200
*     3134=guess
*     CS and trans prob from 
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
      call PutCS( 2.51 , t2326 )
      cs = min(6.73 , 2.316*te10 )
      call PutCS( cs , t1335 )
      call PutCS(  5.39 , TauDummy )
*     subroutine level3( t10,t21,t20)
      call level3( t2326,TauDummy, t1335)
*
*     assumed to be optically thin
* 666 error! transfer this line
      c3134 = 0.
*
*     C III  1909
*     A for 1909 itself from 
*     >>refer Kwong, V., Fang, Z., Gibbons, T.T., Parkinson, W.H., Smith, P.L.
*     >>refer 1993, ApJ, 411, 431
*     experimental value of 121 is larger than old NS 96, cs from
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
*     BESEQ(CS23,CS24,CS34,tarray,A41)
      cs = min( 1.1 , 2.67 / te10 )
      call PutCS( cs , t1909 )
*     C1909 = BESEQ(.96,.73,2.8 , T1909 ,5.19E-3 )
*     A's 
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279 , 1289
      call beseq(.96,.73,2.8 , t1909 ,5.149E-3 )
*     call dumpline( t1909 )
      em1908 = PopLevels(3)*5.19e-3 * 1.04E-11
*
*     CIII 1175 excited state line 
*     following were computed by previous call to beseq 
      popup = PopLevels(1) + PopLevels(2)+PopLevels(3)
      SaveAbun = xIonFracs(6,3)
      xIonFracs(6,3) = popup
*     cs 
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
      cs = min( 30., 4.806*te10*te05/te01/te003 )
      call PutCS( 18.45 , c31175 )
      call level2( c31175 )
      xIonFracs(6,3) = SaveAbun
*
*     C III 977, cs from 
*     >>refer Berrington, K.A. 1985, JPhB, 18, L395
      cs = min( 7.0 , 1.556 * te10 )
      call PutCS( cs , t977 )
      call level2( t977 )
*     call DumpLine( t977 )
*
*     CIV 1548, 1550 doublet
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 6 , t1548, t312, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , t1548 )
      call PutCS( cs2s2p*0.5 , t1550 )
      call PutCS(  1.0 , TauDummy )
      call level3( t1550,TauDummy, t1548)
      call PutCS( cs2s3p , t312 )
      call level2( t312 )
*
      end
