      real function cdasum(n,dx,incx)
c
c     takes the sum of the absolute values.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified to correct problem with negative increment, 8/21/90.
c
      real dx(*),dtemp
      integer i,incx,ix,m,mp1,n
c
      cdasum = 0.00
      dtemp = 0.00
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      do i = 1,n
        dtemp = dtemp + abs(dx(ix))
        ix = ix + incx
      end do
      cdasum = dtemp
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,6)
      if( m .eq. 0 ) go to 40
      do i = 1,m
        dtemp = dtemp + abs(dx(i))
      end do
      if( n .lt. 6 ) go to 60
   40 mp1 = m + 1
      do i = mp1,n,6
        dtemp = dtemp + abs(dx(i)) + abs(dx(i + 1)) + abs(dx(i + 2))
     *  + abs(dx(i + 3)) + abs(dx(i + 4)) + abs(dx(i + 5))
      end do
   60 cdasum = dtemp
      return
      end
