********************************************************
      subroutine cfit(iz,in,t,c)
      implicit none
*D Verner's routine to compute collisional ionization rate coefficients
* Version 3, April 21, 1997
* Cu (Z=29) and Zn (Z=30) are added (fits from Ni, correct thresholds).
******************************************************************************
*** This subroutine calculates rates of direct collisional ionization 
*** for all ionization stages of all elements from H to Ni (Z=28)
*** by use of the fits from G. S. Voronov, 1997, ADNDT, 65, 1
*** Input parameters:  iz - atomic number 
***                    in - number of electrons from 1 to iz 
***                    t  - temperature, K
*** Output parameter:  c  - rate coefficient, cm^3 s^(-1)
******************************************************************************
      integer iz,in
      real t,c
      real CF,te,u
      common/CF/CF(5,30,30)
      c=0.0
      if(iz.lt.1.or.iz.gt.30)return
      if(in.lt.1.or.in.gt.iz)return
      te=t*8.617385e-05
      u=CF(1,iz,in)/te
      if(u.gt.80.0)return
      c=CF(3,iz,in)*(1.0+CF(2,iz,in)*sqrt(u))/(CF(4,iz,in)+u)*
     *u**CF(5,iz,in)*exp(-u)
      return
      end
