******************************************************************************
      subroutine ChckFill
      implicit none
*perform sanity check confirming that the energy array has been properly filled
      include "nfill.par"
      include "ncell.par"
      include "fillnu.com"
      include "rfield.com"
      include "widflx.com"
      include "IOqq.com"
*
*     local variables
      integer i , ipoint , ipnt
      real energy
      logical lgFail
*
      lgFail = .false.
      do i=1,nrange
*       test middle of energy bound
        energy = (filbnd(i)+filbnd(i+1))/2.
        ipnt = ipoint( energy )
        if( energy.lt. anu(ipnt)-widflx(ipnt)*0.5 ) then
          write(qq,'('' ChckFill middle test low fail'')')
          lgFail = .true.
        else if (energy.gt. anu(ipnt)+widflx(ipnt)*0.5) then
          write(qq,'('' ChckFill middle test high fail'')')
          lgFail = .true.
        endif
*       test near low bound
        energy = filbnd(i)*0.99 +filbnd(i+1)*0.01
        ipnt = ipoint( energy )
        if( energy.lt. anu(ipnt)-widflx(ipnt)*0.5 ) then
          write(qq,'('' ChckFill low test low fail'')')
          lgFail = .true.
        else if (energy.gt. anu(ipnt)+widflx(ipnt)*0.5) then
          write(qq,'('' ChckFill low test high fail'')')
          lgFail = .true.
        endif
*       test near high bound
        energy = filbnd(i)*0.01 +filbnd(i+1)*0.99
        ipnt = ipoint( energy )
        if( energy.lt. anu(ipnt)-widflx(ipnt)*0.5 ) then
          write(qq,'('' ChckFill high test low fail'')')
          lgFail = .true.
        else if (energy.gt. anu(ipnt)+widflx(ipnt)*0.5) then
          write(qq,'('' ChckFill high test high fail'')')
          lgFail = .true.
        endif
      end do
      if( lgFail ) stop
*
      end
