******************************************************************************
      subroutine cholup( dc , loop )
      implicit none
*called by tfirst, calls ConvIoniz and coolr to get converged ion, cooling
      real dc
      integer loop
*
      include "nhlvl.par"
      include "tcool.com"
      include "heat.com"
      include "TrConvg.com"
      include "phycon.com"
      include "trace.com"
      include "htnext.com"
      include "newion.com"
      include "DoPhoto.com"
      include "LevTrace.com"
      include "IOqq.com"
*
*     local variables
      real hold , cold  , tol
      integer llim
      logical lgGivewn
      save lgGivewn
*
*     this routine only called by tfirst, when poking around
*     for initial solution
*
      lgGivewn = .true.
      hold = 0.
      cold = 0.
      loop = 1
*     must do very first solution several times to get stable answer
*     since there is some hysteresis in the problem
*     this routine keeps at it until the heating and cooling do not change
      tol = 0.1
      llim = 20
      do while( loop.lt.llim .and. 
     1   (abs(cold/ctot-1.).gt.tol .or.
     2   abs(hold/max(1e-37,htot)-1.).gt.tol ))
         hold = htot
         cold = ctot
         lgNewIon = .true.
         lgDoPhoto = .true.
         call ConvIoniz
         if( htot.eq.0. .and.lgGivewn ) then
            write(qq,'(''  '')')
            write(qq,'('' HELP!!! I found a heating rate of zero and ''
     1      ,''will probably soon crash.'')')
            write(qq,'('' Whats wrong??  There MUST be a heating '',
     1      ''source.'')')
            lgGivewn = .false.
            write(qq,'(''  '')')
            write(qq,'(''  '')')
         endif
         call coolr(ctot,dc )
         if( lgTrace ) then
           write(qq,'('' RETURN TO CHOLUP 1, HTOT:'',1P,E10.3,
     1     ''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e10.2,25(''<''))
     2     ')
     2     htot , ctot , te,eden
         end if
*        force reevaluation of H trans rates
         htnext(3,2) = htnext(3,2) * 0.9999
         if(lgTrConvg.and.nLevTrace.lt.2 ) then
           write(qq,'(''   cholup'',i3,'' htot,old'',1p,2e9.2
     1     ,'' ctot,old='',2e9.2)') loop,htot,hold,ctot,cold
         endif
         loop = loop + 1
      end do
*     repair optical depths
      htnext(3,2) = htnext(3,2) * 0.9999
      if( loop.gt.1 ) then
        htnext(3,2) = htnext(3,2) / ( 0.9999**loop )
      endif
*
      if( loop.ge.llim+1 ) then
        write(qq,'('' CHOLUP did not converge heating'',
     1  '' and cooling, loop='',I3,'' te='',1P,E10.2)') loop,te
      endif
*
*     write(QQ,'('' cholup, te, lup, h c'',1p,e10.2,i3,2e10.2)')
*    1 te , loop , htot , ctot
*
      end
