******************************************************************************
      subroutine colred( chCard )
      implicit none
*read observed column densities & errors for optimizer
      character*80 chCard
*
      include "ncollm.par"
      include "obscol.com"
      include "colab.com"
      include "tropt.com"
*     include "troptm.com"
      include "trace.com"
      include "IOqq.com"
*
*     local variables
      integer  i , j
      real fread
      real deferr
      parameter (deferr=0.05)
      character*80  chCap , chVlt*1
      logical lgEOF , lgEOL
*
*     read observed column densities & errors
*
      ncobs = 0
*
*     get first line
      call readar( chCard , lgEOF )
      chCap = chCard
      call caps( chCap )
      if( lgEOF ) then
        write(qq,'('' Hit EOF while reading column density list; use ''
     1  ,''END to end list.'')')
        stop
      endif
*
      do while( .not.lgEOF )
        ncobs = ncobs + 1
        if( ncobs.gt.ncollm ) then
          write(qq,'('' Too many column densities have been entered; '',
     1    ''the limit is'',i4,''.  Increase variable NCOLLM.'')') ncollm
          stop
        endif
*
*       order on line is label (col 1-4), ionization stage, column density, err
        call cap4( chCard(1:4) , chColmnLab(ncobs) )
        i = 5
        ionam(ncobs) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'(1X,A80)') chCard
          write(qq,'('' The ionization stage MUST appear on this line.''
     1    ,''  Sorry.'')')
          stop
        else if( ionam(ncobs) .le.0 ) then
          write(qq,'(1X,A80)') chCard
          write(qq,'('' An ionization stage of'',I4,'' does not make '',
     1    ''sense.  Sorry.'')') ionam(ncobs)
          stop
        endif
*
        amcol(ncobs) = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'(1X,A80)') chCard
          write(qq,'('' An observed column density MUST be entered.  '',
     1    ''Sorry.'')')
          stop
        endif
*
        amcerr(ncobs) = fread( chCard , i , 76 , lgEOL )
        if(amcerr(ncobs).le.0.0 ) then
*         this is the relative error allowed
          amcerr(ncobs) = deferr
        endif
*
*       check if number is a limit
        chVlt=' '
        do j=1,80
          if(chCard(j:j).EQ.'<') then
*           limit value assumed
            chVlt='<'
          endif
        end do
*
        if(chVlt.EQ.'<') then
*         value is an upper limit only, use negative error to flag
          amcerr(ncobs) = -amcerr(ncobs)
        endif
*
        call readar( chCard , lgEOF )
        chCap = chCard
        call caps( chCap )
        if( lgEOF ) then
          write(qq,'('' Hit EOF while reading column density list; use''
     1    ,'' END to end list.'')')
          stop
        endif
        if( chCap(1:3).eq.'END' ) lgEOF = .true.
      end do
*
      if(lgTrace.and.lgTrOpt ) then
        write(qq,'(i4,'' colunms were entered, they were;'')') ncobs
        do i=1,ncobs
          write(qq,'(1X,A4,'' ion='',i5,1P,2E10.2)') chColmnLab(i),
     1    ionam(i),amcol(i),amcerr(i)
        end do
      endif
*
      end
