******************************************************************************
      subroutine comole( lgNegPop , lgZerPop )
      implicit none
*fills in matrix for heavy elements molecular routines
      logical lgNegPop , lgZerPop
      include "ncell.par"
      include "saha.par"
      include "limelm.par"
      include "itrdim.par"
      include "cmfrac.com"
      include "shullc.com"
      include "logte.com"
      include "h.com"
      include "rfield.com"
      include "ots.com"
      include "TePowers.com"
      include "hmi.com"
      include "heating.com"
      include "trmole.com"
      include "trace.com"
      include "nomole.com"
      include "he.com"
      include "phycon.com"
      include "coatom.com"
      include "hvmolEXP.com"
      include "hvcolEXP.com"
      include "moldrv.com"
      include "ghabng.com"
      include "h2ozer.com"
      include "codish.com"
      include "covib.com"
      include "heat.com"
      include "ZoneCnt.com"
      include "IonFracs.com"
      include "DestCrt.com"
      include "AgeMole.com"
      include "IOqq.com"
*
*     local variables
      integer nmole
      parameter (nmole=15)
      double precision c(nmole+1,nmole+1) 
      real csav(nmole,nmole)
      logical lgEOL
      character*4 chLab(nmole)
      character*80 chCard
*
      integer ioatm,ich,ichp,ioh,iohp,ich2p,icp,icatm,j,i ,loop
      integer ico,icop,ih2o,ih2op,ih3op,io2,io2p , merror
*
      real po2lte,expo2,pc2lte,expc2,chplte,expchp,pcolte,
     1 expco,coplte,sexp,h2lim,fread,fac,expcop,cartot,oxytot,
     2 chchp,choco ,h2pchp,h3pchp,cpchp,
     3 chph,chpe,chohwa,chch2,ch2ph3,ch2pch,wachoh,coch,cch,
     4 chhchp,chhc,chooh,hmrate,chphch,ohohp,ohcop,ohco,oho2,
     5 oho,oh2wat,ohohwa,o2oh,ohpoh,cooh,waoh,wa2oh,wapoh,
     6 waph3p,e3opoh , h3pwap,ohprm,ohpwap,waohp,wapohp,ratio,
     7 opohp,oohp,h3pohp,ohph3p,o2o2p,o2rm,o2cop,o2co,co2co,coo2,ho2p
      real eo2o,cocp,cocn,phodco,copco,h3pcop,coprm,wacop,ch2pco,
     1 wawap,wapwa,h3oh3p,wah3op,h3opwa,e3opwa,h3pwai,waprm,
     2 cocop,waiwai,h3owai,ch2pc,crden , cf , cpch2p
*
*     free statement labels >=13
*
      call molav( 1 )
*999  continue
      loop = 0
      do while( lgDriveMole.or.(loop.lt.1 ) )
      loop = loop + 1
      if( lgDriveMole ) then
*       option to allow user to enter oh abundances
        write(qq,'('' enter log of OH abundance'')')
        read(5,'(a80)') chCard
        i = 1
*       option to set OH here
        fac = fread( chCard , i , 76 , lgEOL )
        if( fac.eq.1. ) then
           return
        else if( fac.eq.0. ) then
           call molav(2)
        else
           oh = 10.** fac
        endif
        write(qq,'('' enter log of H2O abundance'')')
        read(5,'(a80)') chCard
        i = 1
*       option to set H2O here
        fac = fread( chCard , i , 76 , lgEOL )
        if( fac.ne.0. ) h2o = 10.** fac
      endif
*
      ctwo = 0.
      c2p = 0.
      otwo = 0.
      o2p = 0.
      h3p = 0.
*
*     H2LIM is smallest ratio of H2/HDEN for which we will
*     even try to invert heavy element network
      h2lim=1e-4
      if( lgNoMole .or. te.gt.3800. .or. htwo/hden.lt.h2lim
     1  .or. xIonFracs(6,1)*xIonFracs(8,1).eq.0. ) then
        catmic = xIonFracs(6,1)
        oatmic = xIonFracs(8,1)
        ch = 0.
        chp = 0.
        oh = 0.
        ohp = 0.
        otwo = 0.
        co = 0.
        cop = 0.
        h2o = 0.
        h2op = 0.
        o2p = 0.
        c2p = 0.
        h3op = 0.
        ch2p = 0.
        ch2 = 0.
        ch3 = 0.
        cp = 0.
*       heating due to CO photodissociation
        heating(1,10) = 0.
        COVibCool = 0.
        dCOVdT = 0.
        CODissHeat = 0.
        return
      endif
*     call PrtMolDif('init',0)
*
*     dissociation energies;
*     CO 11.09, CO+ 8.3eV, CH+ 3.8eV
*     LTE population of CO+
      expcop = sexp(9.632e4 /te )
      if( expcop.gt.0. ) then
         coplte = saha / (te32*expcop) * (1. / ( 6.*9. ) )
      else
         coplte = 0.
      endif
*
      expco = sexp( 1.287e5 / te )
      if( expco.gt.0. ) then
         pcolte = saha / (te32*expco ) * (1./(9.*9.))
      else
         pcolte = 0.
      endif
*
      expchp = sexp( 4.4098e4 / te )
      if( expchp.gt.0. ) then
         chplte = saha / (te32*expchp ) * (1./(1.*6.))
      else
         chplte = 0.
      endif
*
      expc2 = sexp( 4.4098e4 / te )
      if( expc2.gt.0. ) then
         pc2lte = saha / (te32*expc2 ) * (1./(9.*9.))
      else
         pc2lte = 0.
      endif
*
      expo2 = sexp( 4.4098e4 / te )
      if( expo2.gt.0. ) then
         po2lte = saha / (te32*expo2 ) * (3./(9.*9.))
      else
         po2lte = 0.
      endif
*
*     molecule formation
*
      do i=1,nmole
        c(i,nmole+1) = 0.
        do j=1,nmole
          c(i,j) = 0.
        end do
      end do
*
*     set up pointers
      icatm = 1
      chLab(icatm) = 'C   '
      ioatm = 2
      chLab(ioatm) = 'O   '
      ich = 3
      chLab(ich) = 'CH  '
      ichp = 4
      chLab(ichp) = 'CH+ '
      ioh = 5
      chLab(ioh) = 'OH  '
      iohp = 6
      chLab(iohp) = 'OH+ '
      ich2p = 7
      chLab(ich2p) = 'CH2+'
      icp = 8
      chLab(icp) = 'C+  '
      ico = 9
      chLab(ico) = 'CO  '
      icop = 10
      chLab(icop) = 'CO+ '
      ih2o = 11
      chLab(ih2o) = 'H2O '
      ih2op = 12
      chLab(ih2op) = 'H2O+'
      ih3op = 13
      chLab(ih3op) = 'H3O+'
      io2 = 14
      chLab(io2) = 'O2  '
      io2p = 15
      chLab(io2p) = 'O2+ '
*     
*     carbon conservation
      cartot = 0.
      do i=3,7
        cartot = cartot + xIonFracs(6,i)
      end do
      cartot = xIonFracs(6,0) - cartot
      c(icatm,nmole+1) = cartot
*
*     oxygen conservation
      if( oatmic.eq.0. ) oatmic = xIonFracs(8,1)
      oxytot = 0.
      do i=2,9
        oxytot = oxytot + xIonFracs(8,i)
      end do
      oxytot = xIonFracs(8,0) - oxytot
      c(ioatm,nmole+1) = oxytot
*
*--------------------------------------------------------------------
*
*     first equation is carbon conservation
      c(icatm,icatm) = 1.
      c(icatm,ioatm) = 0.
      c(icatm,ich) = 1.
      c(icatm,ichp) = 1.
      c(icatm,ioh) = 0.
      c(icatm,iohp) = 0.
      c(icatm,io2) = 0.
      c(icatm,io2p) = 0.
      c(icatm,ico) = 1.
      c(icatm,icop) = 1.
      c(icatm,ih2o) = 0.
      c(icatm,ih2op) = 0.
      c(icatm,ih3op) = 0.
      c(icatm,ich2p) = 1.
      c(icatm,icp) = 1.
*
*--------------------------------------------------------------------
*
*     second equation is oxygen conservation
      c(ioatm,icatm) = 0.
      c(ioatm,ioatm) = 1.
      c(ioatm,ich) = 0.
      c(ioatm,ichp) = 0.
      c(ioatm,ioh) = 1.
      c(ioatm,iohp) = 1.
      c(ioatm,io2) = 2.
      c(ioatm,io2p) = 2.
      c(ioatm,ico) = 1.
      c(ioatm,icop) = 1.
      c(ioatm,ih2o) = 1.
      c(ioatm,ih2op) = 1.
      c(ioatm,ih3op) = 1.
      c(ioatm,ich2p) = 0.
      c(ioatm,icp) = 0.
*
*--------------------------------------------------------------------
*
*     balance equations;
*     (1,n) is C, called ICATM
*     (2,n) is O, called IOATM
*     (3,n) is CH, called ICH
*     (4,n) is CHP, called ICHP
*     (5,n) is OH, called IOH
*     (6,n) is OHP, called IOHP
*     (7,n) is CH2P, called ICH2P
*     (8,n) is CP, called ICP
*     (9,n) is CO, called ICO
*     (10,n) is COP, called ICOP
*     (11,n) is H2O, called IH2O
*     (12,n) is H2OP, called IH2OP
*     (13,n) is H3OP, called IH3OP
*     (14,n) is OTWO, IO2
*     (15,n) is O2P, called IO2P
*
*--------------------------------------------------------------------
*
*     CH balance equations
*
*     sum of CH + HII => ch+ and both H+ and Ho
*     also electrons to 2e
      chchp = hmrate( 8.83e-14,0.5, 1.29e5 )*(hii+hi+htwo) +
     1 1.90e-9*hii +
     1 hmrate( 5.2e-10 , 0.5 , 1.50e5 )*eden
      c(ich,ich) = c(ich,ich) - chchp
*     o + ch => co + h
      choco = hmrate( 9.53e-11 , 0.5 , 0. ) * oatmic
      c(ich,ich) = c(ich,ich) - choco
*     O + CH => C + OH
      chooh = hmrate( 1.73e-11 , 0.50 , 4000. ) * oatmic
      c(ich,ich) = c(ich,ich) - chooh
*     CH + H => C + H2
      chhc = hmrate( 1.80e-11 , 0.50 , 4000. ) * hi
*     there is no carbon balance equation
      c(ich,ich) = c(ich,ich) - chhc
*     CH + H => CH+ + H + e
      chhchp = hmrate( 8.83e-14 , 0.5 , 1.29e5 ) * hi
      c(ich,ich) = c(ich,ich) - chhchp
*     C + H2 => CH + H
      cch = hmrate( 4.50e-11 , 0.5 , 1.56e4 ) * htwo
      c(ich,icatm) = c(ich,icatm) + cch
*     CO + H => CH + O
      coch = hmrate( 9.53e-11,0.5,8.83e4) * hi
      c(ich,ico) = c(ich,ico) + coch
*     H2O + C => CH + OH
      wachoh = hmrate( 1.43e-10, 0.50 , 2.40e4 ) * catmic
      c(ich,ih2o) = c(ich,ih2o) + wachoh
*     e- + CH2+ => CH + H
      ch2pch = hmrate( 2.50e-7 , -0.5 , 0. ) * eden
      c(ich,ich2p) = c(ich,ich2p) + ch2pch
*     H2 + CH2+ => CH + H3+
      ch2ph3 = hmrate( 1.20e-9 , 0. , 4.22e4 ) * htwo
      c(ich,ich2p) = c(ich,ich2p) + ch2ph3
*     CH + H2 => CH2 + H
      chch2 = hmrate( 3.60e-10 , 0. , 3.90e3 ) * htwo
      c(ich,ich) = c(ich,ich) - chch2
*     OH + CH => H2O + C
      chohwa = 1e-10 * oh
      c(ich,ich) = c(ich,ich) - chohwa
*
*--------------------------------------------------------------------
*
*     CH+ balance equation
*
*     CH+ + e => C + H
      chpe = hmrate( 3.00e-7 , -0.40 , 0. ) * eden
      c(ichp,ichp) = c(ichp,ichp) - chpe
*     CH+ + H => H2 + C+
      chph = hmrate( 6.00e-10 , -0.25 , 0. ) * hi
      c(ichp,ichp) = c(ichp,ichp) - chph
*     make CH+ from CH via collisions with protons and electrons, H
      c(ichp,ich) = c(ichp,ich) + chchp + chhchp
*     H2 + C+ => H + CH+
      cpchp = hmrate(2.00e-10,0.,4640. ) * htwo
      c(ichp,icp) = c(ichp,icp) + cpchp
*     C + H3+ => H2 + CH+
      h3pchp = 2.00e-9 * h3plus
      c(ichp,icatm) = c(ichp,icatm) + h3pchp
*     H + CH2+ => H2 + CH+
      h2pchp = hmrate( 1.00e-9 , 0. , 1.20e4 ) * hi
      c(ichp,ich2p) = c(ichp,ich2p) + h2pchp
*     H2 + CH+ => H + CH2+
      chphch = 1.00e-9 * htwo
      c(ichp,ichp) = c(ichp,ichp) - chphch
*
*--------------------------------------------------------------------
*
*     OH balance equations
*
*     various processes which change OH to OH+
      ohohp = 2.10e-10*hii + hmrate(8.83e-14,0.5,1.53e5 )*(hii+hi+htwo)+
     1 7.60e-10*h2plus + hmrate(5.20e-10,0.5,1.5e5 )*eden
      c(ioh,ioh) = c(ioh,ioh) - ohohp
*     this is first major step to making CO
*     OH + C+ => H + CO+
      ohcop = 7.70e-10 * cp
      c(ioh,ioh) = c(ioh,ioh) - ohcop
*     OH + CH => H2O + C
      chohwa = 1e-10 * ch
      c(ioh,ioh) = c(ioh,ioh) - chohwa
*     C + OH => CO + H
      ohco = hmrate( 1.11e-10 , 0.5 , 0. ) * catmic
      c(ioh,ioh) = c(ioh,ioh) - ohco
*     O + OH => O2 + H
      oho2 = hmrate( 4.33e-11 , -0.5, 30.0 )* oatmic
      c(ioh,ioh) = c(ioh,ioh) - oho2
*     OH + H => O + H2
      oho = hmrate( 6.60e-13 , 1.53 , 2970. ) * hi
*     this is really OH + cr => O + H, enhance from Gredel et al. ApJ 347, 289
      oho = oho + csupra * 500.
      c(ioh,ioh) = c(ioh,ioh) - oho
*     two ways to make water, H2 and OH
*     first is OH + H2 => H2O + H
      oh2wat = hmrate( 8.80e-13,1.95,1420. ) * htwo
*     second is OH + OH => H2O + O
      ohohwa =  hmrate( 4.20e-12 , 0. , 242. ) * oh
      c(ioh,ioh) = c(ioh,ioh) - oh2wat - ohohwa*2.
*     O2 + H => OH + O
      o2oh = hmrate( 1.63e-9 , -0.9 , 8750. ) * hi
      c(ioh,io2) = c(ioh,io2) + o2oh
*     OH+ + stuff goes to OH
      ohpoh = hmrate( 2.10e-9 , 0. , 2800. )*hi +
     1 hmrate( 7.60e-10 , 0. , 2.36e4 ) * htwo
      c(ioh,iohp) = c(ioh,iohp) + ohpoh
*     O + CH => C + OH
      c(ioh,ich) = c(ioh,ich) + chooh
*     CO + H => C + OH
      cooh = hmrate( 1.11e-10,0.5, 7.77e4)*hi
      c(ioh,ico) = c(ioh,ico) + cooh
*     water into OH
      waoh = 2.03e-10*heii + hmrate(9.20e-9,-0.5,6.96e4)*eden +
     1 hmrate( 7.44e-12,1.57,9140. ) * hi
      c(ioh,ih2o) = c(ioh,ih2o) + waoh
*     H2O + O => OH + OH
      wa2oh = hmrate( 1.35e-12 , 1.75 , 7860. ) * oatmic
      c(ioh,ih2o) = c(ioh,ih2o) + wa2oh*2.
*     H2O + C => CH + OH
      c(ioh,ih2o) = c(ioh,ih2o) + wachoh
*     ionized water into OH
      wapoh = hmrate(7.60e-10,0.,4e4)*hi +
     1 hmrate(1.30e-9,0.,2.03e4)*htwo +hmrate(2e-7,-0.5,0.)*eden
      c(ioh,ih2op) = c(ioh,ih2op) + wapoh
*     H2 + H2O+ => OH + H3+
      waph3p = hmrate(1.30e-9 , 0. , 2.03e4 ) * htwo
      c(ioh,ih2op) = c(ioh,ih2op) + waph3p
*     e- + H3O+ => OH + H3
      e3opoh = hmrate( 3.00e-7 , -0.5 , 0. ) * eden
      c(ioh,ih3op) = c(ioh,ih3op) + e3opoh
*     OH + H3P => H2 + H2O+
      h3pwap = 1.0e-9 * h3plus
      c(ioh,ioh) = c(ioh,ioh) - h3pwap
*
*--------------------------------------------------------------------
*    
*     OH+ balance equations
*
*     following remove OH+ from network
*     both collide with H, go to H2 or H2+
      ohprm = hmrate(1.60e-9,0.,2.26e4)*hi +
     1 hmrate( 4.90e-10,-0.03, 1970. ) * hi +
     2 hmrate( 2.00e-7 , -0.5 , 0. ) * eden
      c(iohp,iohp) = c(iohp,iohp) - ohprm
*     OH+ + H => OH + H+ and OH+ + H2 => OH + H2+
      c(iohp,iohp) = c(iohp,iohp) - ohpoh
*     h2 + oh+ => h + h2o+
      ohpwap = 1.10e-9 * htwo
      c(iohp,iohp) = c(iohp,iohp) - ohpwap
*     several processes converting OH into OH+
      c(iohp,ioh) = c(iohp,ioh) + ohohp
*     water into OH+
      waohp = 2.86e-10*heii 
      c(iohp,ih2o) = c(iohp,ih2o) + waohp
*     H + H2O+ => H2 + OH+
      wapohp = hmrate( 1.70e-9 , 0.29 , 1.40e4 ) * hi
      c(iohp,ih2op) = c(iohp,ih2op) + wapohp
*     O+ + H2 => H + OH+
      if( xIonFracs(8,2).gt.0. ) then
         ratio = xIonFracs(8,2) / xIonFracs(8,1) 
         opohp = 1.60e-9*ratio*htwo
         c(iohp,ioatm) = c(iohp,ioatm) + opohp
      endif
*     O + H2+ => H + OH+
      oohp = 1.50e-9 * h2plus
      c(iohp,ioatm) = c(iohp,ioatm) + oohp
*     O + H3P => H2 + OHP
      h3pohp = 8.00e-10*h3plus
      c(iohp,ioatm) = c(iohp,ioatm) + h3pohp
*     H2 + OH+ => O + H3P
      ohph3p = hmrate( 8.00e-10 , 0. , 2900. ) * htwo
      c(iohp,iohp) = c(iohp,iohp) - ohph3p
*
*--------------------------------------------------------------------
*
*     O2 balance equation
*
*     reactions that remove O2 from network
      o2o2p = 1.20e-9*hii + hmrate( 2.37e-15, 1.04 , 1.40e5 )*hii +
     1 2.70e-9*h2plus + hmrate( 1.40e-11,1.04,1.40e5 )*eden +
     2 hmrate( 2.37e-15,1.04,1.40e5 ) * ( hi  + htwo )
      c(io2,io2) = c(io2,io2) - o2o2p
      o2rm = 1.10e-9*heii +  hmrate( 2.30e-9,-0.5, 6.96e4 ) * eden
*     cr destruction with enhancement from Gredel et al.
      o2rm = o2rm + csupra * 730.
      c(io2,io2) = c(io2,io2) - o2rm
*     O2 + C+ => O + CO+
      o2cop = 3.76e-10 * cp
      c(io2,io2) = c(io2,io2) - o2cop
*     O2 + C+ => CO + O+
      o2co = 6.14e-10 * cp
      c(io2,io2) = c(io2,io2) - o2co
*     C + O2 => CO + O
      co2co =  hmrate( 1.80e-11,0.5,0.)*catmic
      c(io2,io2) = c(io2,io2) - co2co
*     O2 + H => OH + O
      c(io2,io2) = c(io2,io2) - o2oh
*     o + oh => o2 + h
      c(io2,ioh) = c(io2,ioh) + oho2
*     o + co => c + o2
      coo2 = hmrate( 2.90e-11,0.5,6.93e4 ) * oatmic
      c(io2,ico) = c(io2,ico) + coo2
*     h + o2+ => o2 + h+
      ho2p = hmrate( 2.80e-10 , -0.04 , 1.78e4 ) * hi
      c(io2,io2p) = c(io2,io2p) + ho2p
*
*--------------------------------------------------------------------
*
*     O2+ balance
*
*     e + O2+ => O + O
      eo2o = hmrate( 2.00e-7 , -0.5 , 0. ) * eden
      c(io2p,io2p) = c(io2p,io2p) - eo2o
*     H + O2+ => O2 + H+
      c(io2p,io2p) = c(io2p,io2p) - ho2p
*     various processes creating O2+ from O2
      c(io2p,io2) = c(io2p,io2) + o2o2p
*
*------------------------------------------------------------------
*
*     CO balance equation carbon monoxide
*
*     CO + H+ => H + CO+, also CO + H+ => CO+ +
      cocop = hmrate( 1.90e-10,0.,4660.) * hii +
     1 hmrate( 1.13e-13,0.6,1.63e5 ) * (hii+hi+htwo) +
     2 2.80e-9*h2plus + hmrate(6.70e-10,0.6,1.63e5)*eden
      c(ico,ico) = c(ico,ico) - cocop
*     co + hE+ => o + c+ + hE
      cocp = 1.70e-9 * heii * 1.1
      c(ico,ico) = c(ico,ico) - cocp
*     CO + e => C + O  + e
      cocn = hmrate(8.1e-10,-0.50, 1.14e5)*eden
*     estra factor is enhancement due to light
      cocn = cocn + csupra*20.
      c(ico,ico) = c(ico,ico) - cocn
*     CO + hnu => C + O, from Teilens and Hollenback, Table 5
      phodco = GammaHabing * 1.4e-11
      c(ico,ico) = c(ico,ico) - phodco
*     O + CO => C + O2
      c(ico,ico) = c(ico,ico) - coo2
*     CO + H => C + OH
      c(ico,ico) = c(ico,ico) - cooh
*     CO + H => CH + O
      c(ico,ico) = c(ico,ico) - coch
*     O + CH => CO + H
      c(ico,ich) = c(ico,ich) + choco
*     C + OH => CO + H
      c(ico,ioh) = c(ico,ioh) + ohco
*     O2 + C+ => CO + O+
      o2co = 6.14e-10 * otwo
      c(ico,icp) = c(ico,icp) + o2co
*     C + O2 => CO + O
      c(ico,io2) = c(ico,io2) + co2co
*     CO+ + H => CO + H+
      copco = 1.90e-10 * hi
      c(ico,icop) = c(ico,icop) + copco
*     CO + H3+ => H2 + CO+
      h3pcop = 1.70e-9 * h3plus
      c(ico,ico) = c(ico,ico) - h3pcop
*
*     remember longest CO timescale
      if( -c(ico,ico).gt.1e-25 ) then
        AgeCOMoleForm = -1./c(ico,ico)
        BigCOMoleForm = max( BigCOMoleForm , AgeCOMoleForm )
      endif
*666  write(QQ,'('' dest co: '',1p,10e10.2)') c(ico,ico),
*    1 -phodco/c(ico,ico), -cocp/c(ico,ico) , -h3pcop/c(ico,ico),
*    2 -cocop/c(ico,ico) , -cocn/c(ico,ico) , -coo2/c(ico,ico) ,
*    3 -cooh/c(ico,ico) , -coch/c(ico,ico)
*
*--------------------------------------------------------------------
*
*     CO+ balance equation
*
*     e + CO+ => C + O
      coprm = hmrate(1.80e-7 , -0.5 , 0. ) * eden
      c(icop,icop) = c(icop,icop) - coprm
*     CO+ + H => CO + H+
      c(icop,icop) = c(icop,icop) - copco
*     co + h+ => h + co+, ALSO co + h+ => co+ +
      c(icop,ico) = c(icop,ico) + cocop
*     OH + C+ => H + CO+
      ohcop = 7.70e-10 * oh
      c(icop,icp) = c(icop,icp) + ohcop
*     H2O + C+ => H2 + CO+
      wacop = 2.70e-9 * cp
      c(icop,ih2o) = c(icop,ih2o) + wacop
*     CO + H3+ => H2 + CO+
      c(icop,ico) = c(icop,ico) + h3pcop
*     o + ch2+ => h + co+
      ch2pco = 7.50e-10 * oatmic
      c(icop,ich2p) = c(icop,ich2p) + ch2pco
*     O2 + C+ => O + CO+
      o2cop = 3.76e-10 * cp
      c(icop,io2) = c(icop,io2) + o2cop
*
*--------------------------------------------------------------------
*
*     water H2O balance
*
*     processes converting wat to wap
      wawap = 8.20e-9*hii +hmrate(7.55e-14,0.45,1.47e5)*(hi+htwo+hii) +
     1 3.90e-9*h2plus  + hmrate(4.40e-10,0.45,1.47e5)*eden +
     2 6.05e-11 * heii
      c(ih2o,ih2o) = c(ih2o,ih2o) - wawap
*     h2o => oh+
      c(ih2o,ih2o) = c(ih2o,ih2o) - waohp
*     water into OH
      c(ih2o,ih2o) = c(ih2o,ih2o) - waoh
*     H2O + C => CH + OH
      c(ih2o,ih2o) = c(ih2o,ih2o) - wachoh
*     H2O + O => OH + OH
      c(ih2o,ih2o) = c(ih2o,ih2o) - wa2oh
*     h2o + c+ => h2 + co+
      c(ih2o,ih2o) = c(ih2o,ih2o) - wacop
      if(c(ih2o,ih2o).eq.0.) then
*       possible for zero water destruction, this is an error
        c(ih2o,ih2o) = -1e-35
        lgH2Ozer = .true.
      endif
*     end of water destruction mechanisms
*     CH + OH => H2O + C
      chohwa = 1e-10 * oh
      c(ih2o,ich) = c(ih2o,ich) + chohwa
*     OH + stuff => water
      c(ih2o,ioh) = c(ih2o,ioh) + oh2wat + ohohwa
*     ionized water into water
      wapwa = hmrate(8.20e-9,0.,1.15e4)*hi +
     1 hmrate(3.90e-9,0.,3.27e4)*htwo
      c(ih2o,ih2op) = c(ih2o,ih2op) + wapwa
*     H2 + H3O => H2O + H3+
      h3oh3p = hmrate( 5.90e-9 , 0. , 3.28e4 ) * htwo
      c(ih2o,ih3op) = c(ih2o,ih3op) + h3oh3p
*     H2O + H2+ => H + H3O+
      wah3op = 3.40e-9 * h2plus
      c(ih2o,ih2o) = c(ih2o,ih2o) - wah3op
*     H + H3O+ => H2O + H2+
      h3opwa = hmrate( 5.90e-9 , 0. , 3.28e4 ) * htwo
      c(ih2o,ih3op) = c(ih2o,ih3op) + h3opwa
*     e- + H3O+ => H2O + H
      e3opwa = hmrate( 1.00e-6 , -0.5 , 0. ) * eden
      c(ih2o,ih3op) = c(ih2o,ih3op) + e3opwa
*     H2O + H3P => H2 + H3OP
      h3pwai = 5.90e-9 * h3plus
      c(ih2o,ih2o) = c(ih2o,ih2o) - h3pwai
*
*--------------------------------------------------------------------
*     H2O+ balance
*
*     removes ionized water from network
      waprm = hmrate( 2e-7,-0.5,0.) * eden
      c(ih2op,ih2op) = c(ih2op,ih2op) - waprm
*     H + H2O+ => H2 + OH+
      c(ih2op,ih2op) = c(ih2op,ih2op) - wapohp
*     ionized water into water
      c(ih2op,ih2op) = c(ih2op,ih2op) - wapwa
*     ionized water into OH
      c(ih2op,ih2op) = c(ih2op,ih2op) - wapoh
*     H2 + OH+ => H + H2O
      c(ih2op,iohp) = c(ih2op,iohp) + ohpwap
*     processes converting wat to wap
      c(ih2op,ih2o) = c(ih2op,ih2o) + wawap
*     OH + H3P => H2 + H2O+
      h3pwap = 1.0e-9 * h3plus
      c(ih2op,ioh) = c(ih2op,ioh) + h3pwap
*     H2 + H2O+ => OH + H3+
      c(ih2op,ih2op) = c(ih2op,ih2op) - waph3p
*     H2 + H2O+ => H + H3O+
      waiwai = 6.10e-10 * htwo
      c(ih2op,ih2op) = c(ih2op,ih2op) - waiwai
*     H + H3O+ => H2 + H2O+
      h3owai = hmrate( 6.00e-9 , 0.390 , 1.98e4 ) * hi
      c(ih2op,ih3op) = c(ih2op,ih3op) + h3owai
*
*--------------------------------------------------------------------
*     H3O+ balance
*     H2O + H3P => H2 + H3OP
      c(ih3op,ih2o) = c(ih3op,ih2o) + h3pwai
*     H2 + H3O+ => H2O + H3+
      c(ih3op,ih3op) = c(ih3op,ih3op) - h3oh3p
*     H2O + H2+ => H + H3O+
      c(ih3op,ih2o) = c(ih3op,ih2o) + wah3op
*     H2 + H2O+ => H + H3O+
      c(ih3op,ih2op) = c(ih3op,ih2op) + waiwai
*     H + H3O+ => H2 + H2O+
      c(ih3op,ih3op) = c(ih3op,ih3op) - h3owai
*     H + H3O+ => H2O + H2+
      c(ih3op,ih3op) = c(ih3op,ih3op) - h3opwa
*     e- + H3O+ => H2O + H
      c(ih3op,ih3op) = c(ih3op,ih3op) - e3opwa
*     e- + H3O+ => OH + H3
      c(ih3op,ih3op) = c(ih3op,ih3op) - e3opoh
*
*--------------------------------------------------------------------
*     CH2+ balance
*     e- + CH2+ => C + H2, there is no carbon balance eqn
      ch2pc = hmrate( 2.50e-7 , -0.5 , 0. ) * eden
      c(ich2p,ich2p) = c(ich2p,ich2p) - ch2pc
*     e- + CH2+ => CH + H
      c(ich2p,ich2p) = c(ich2p,ich2p) - ch2pch
*     H + CH2+ => H2 + CH+
      c(ich2p,ich2p) = c(ich2p,ich2p) - h2pchp
*     H2 + CH2+ => CH + H3+
      c(ich2p,ich2p) = c(ich2p,ich2p) - ch2ph3
*     O + CH2+ => H + CO+
      c(ich2p,ich2p) = c(ich2p,ich2p) - ch2pco
*     H2 + C+ => CH2+
      cpch2p = hmrate( 4.00e-16 , -0.20 , 0. ) * htwo
      c(ich2p,icp) = c(ich2p,icp) + cpch2p
*     H2 + CH+ => H + CH2+
      c(ich2p,ichp) = c(ich2p,ichp) + chphch
*
*--------------------------------------------------------------------
*     C+ balance
*     atomic processes changing C+ into Co, calculated in car bal
      c(icp,icp) = c(icp,icp) - create(6,1)
*     atomic processes changing Co into C+, calculated in car bal
      c(icp,icatm) = c(icp,icatm) + destroy(6,1)
*     CO + He+ => C + C+ + He
      c(icp,ico) = c(icp,ico) + cocp
*     H2 + C+ => H + CH+
      c(icp,icp) = c(icp,icp) - cpchp
*     H2 + C+ => CH2+
      c(icp,icp) = c(icp,icp) - cpch2p
*     OH + C+ => H + CO+
      ohcop = 7.70e-10 * oh
      c(icp,icp) = c(icp,icp) - ohcop
*     CH+ + H => H2 + C+
      c(icp,ichp) = c(icp,ichp) + chph
*     O2 + C+ => O + CO+
      o2cop = 3.76e-10 * otwo
      c(icp,icp) = c(icp,icp) - o2cop
*     O2 + C+ => CO + O+
      o2co = 6.14e-10 * otwo
      c(icp,icp) = c(icp,icp) - o2co
*
*--------------------------------------------------------------------
*
      if( lgTrace.and.lgTrMole ) then
         write(qq,'('' COMOLE matrix''/9X,14(2X,A4,3X))') (chLab(i),i=1,
     1   min(nmole,8))
         do j=1,nmole
           write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),(c(j,i),i=1,
     1     min(nmole,8))
         end do
*
         if( nmole.ge.9 ) then
           write(qq,'('' COMOLE matrix''/9X,14(2X,A4,3X))')(chLab(i),
     1     i=9, nmole)
           do j=1,nmole
             write(qq,'(1X,A4,1X,1P,14E9.1)')chLab(j),(c(j,i),i=9,nmole)
           end do
         endif
         write(qq,'('' COMOLE H2 den:'',1P,E10.3,'', H2,3+='',2E9.2,
     1   '' Carb sum='',E10.3,
     1   '' Oxy sum='',E10.3)') htwo , h2plus, h3plus, c(icatm,nmole+1),
     2   c(ioatm,nmole+1)
      endif
*
*     invert matrix
      do i=1,nmole
        do j=1,nmole
          csav(i,j) = c(i,j)
        end do
      end do
*
      call matin1(c,nmole+1,nmole,1,merror)
      if( merror.ne.0 ) then
        write(qq,'('' COMOLE matrix inversion error, MERROR='',
     1  i5,'' zone='',i5)') merror, nzone
        call ShowMe
        write(qq,'('' Product matrix''/9X,14(2X,A4,3X))')(chLab(i),i=1,
     1  min(nmole,8))
        do j=1,nmole
          write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),
     1    (csav(j,i)*c(i,nmole+1),i=1,min(nmole,8) )
        end do
        if( nmole.ge.9 ) then
          write(qq,'('' COMOLE matrix''/9X,14(2X,A4,3X))')(chLab(i),i=9
     1    ,nmole)
          do j=1,nmole
            write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),
     1      (csav(j,i)*c(i,nmole+1),i=9,nmole)
          end do
        endif
        write(qq,'('' Molecular densities relative to H2''/
     1  1P,8(1X,A4,'':'',E10.2)/8(1X,A4,'':'',E10.2))')
     2  (chLab(j),c(j,nmole+1),j=1,nmole)
        stop
      endif
*
      if( lgTrace.and.lgTrMole ) then
        write(qq,'('' Product matrix''/9X,14(2X,A4,3X))')(chLab(i),i=1,
     1  min(nmole,8))
        do j=1,nmole
          write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),
     1    (csav(j,i)*c(i,nmole+1),i=1,min(nmole,8) )
        end do
*
        if( nmole.ge.9 ) then
          write(qq,'('' COMOLE matrix''/9X,14(2X,A4,3X))')(chLab(i),i=9
     1    ,nmole)
          do j=1,nmole
            write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),
     1      (csav(j,i)*c(i,nmole+1),i=9,nmole)
          end do
        endif
        write(qq,'('' Molecular densities relative to H2''/
     1  1P,8(1X,A4,'':'',E10.2)/8(1X,A4,'':'',E10.2))')
     2  (chLab(j),c(j,nmole+1),j=1,nmole)
      endif
*
*     (1,n) is C atomic
      catmic = c(icatm,nmole+1)
*     (2,n) is O atomic
      oatmic = c(ioatm,nmole+1)
*     (3,n) is CH
      ch = c(ich,nmole+1)
*     (4,n) is CHP
      chp = c(ichp,nmole+1)
*     (5,n) is OH
      oh = c(ioh,nmole+1)
*     (6,n) is OHP
      ohp = c(iohp,nmole+1)
*     (9,n) is CO
      co = c(ico,nmole+1)
*     (10,n) is COP
      cop = c(icop,nmole+1)
*     (11,n) is H2O
      h2o = c(ih2o,nmole+1)
*     (12,n) is H2OP
      h2op = c(ih2op,nmole+1)
*     (14,n) is H3OP
      h3op = c(ih3op,nmole+1)
*     (15,n) is CH2P
      ch2p = c(ich2p,nmole+1)
*     (16,n) is CP
      cp = c(icp,nmole+1)
*     (7,n) is OTWO
      otwo = c(io2,nmole+1)
*     (8,n) is O2P
      o2p = c(io2p,nmole+1)
*
*     rememeber largest fraction of carbon in molecules
      cf = (ch + chp + co + cop + ch2p ) / xIonFracs(6,0)
      CarMolFrac = max( CarMolFrac , cf )
*     call PrtMolDif('prnt',66)
*
*     heating due to CO photodissociation
      CODissHeat = phodco * co * 1e-12
*666  write(6,'('' codish phodco, GammaHabing'',1p,3e10.2)') CODissHeat,
*    1 phodco , GammaHabing
      heating(1,10) = CODissHeat
*
*     cooling due to coll excit of vib-rot levels
*     from Hollenbach and McKee 1979
      crden = 1.9e3 * sqrte
*     this is their cooling coefficent, per H2, and CO
      COVibCool = 1.94e-23 * te * te /(htwo+crden+1.5*(htwo*crden)**0.5)
*     this is total cooling per unit vol
      COVibCool = COVibCool * htwo * co * 0.3
*     its derivative
      dCOVdT = COVibCool *2./te
*
      lgNegPop = .false.
      lgZerPop = .false.
      if( catmic.le.0. ) then
         if(catmic.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
         catmic = abs( catmic/2. )
         if( co.gt.ch ) then
            co = max( co/2. , co-catmic )
         else
            ch = max( ch/2. , ch-catmic )
         endif
      endif
      if( oatmic.le.0. ) then
*        WRITE(QQ,'('' WARNING; O population is negative or 0.'',1P,
*    1   E10.2)') OATMIC
         oatmic = 0.
         if(oatmic.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( ch.le.0. ) then
*        WRITE(QQ,'('' WARNING; CH population is negative or 0.'',1P,
*    1   E10.2)') CH
         ch = -ch/2.
         if(ch.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( chp.le.0. ) then
*        WRITE(QQ,'('' WARNING; CH+ population is negative or 0.'',1P,
*    1   E10.2)') CHP
         chp = -chp / 2.
         if(chp.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( oh.le.0. ) then
*        WRITE(QQ,'('' WARNING; OH population is negative or 0.'',1P,
*    1   E10.2)') OH
         oh = 0.
         if(oh.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( ohp.le.0. ) then
*        WRITE(QQ,'('' WARNING; OH+ population is negative or 0.'',1P,
*    1   E10.2)') OHP
         ohp = 0.
         if(ohp.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
*     IF( OTWO.LE.0. ) THEN
*        WRITE(QQ,'('' WARNING; O2 population is negative or 0.'',1P,
*    1   E10.2)') OTWO
*        OTWO = 0.
*        lgNegPop = .TRUE.
*     ENDIF
*     IF( O2P.LE.0. ) THEN
*        WRITE(QQ,'('' WARNING; O2+ population is negative or 0.'',1P,
*    1   E10.2)') O2P
*        O2P = 0.
*        lgNegPop = .TRUE.
*     ENDIF
      if( co.le.0. ) then
*        WRITE(QQ,'('' WARNING; CO population is negative or 0.'',1P,
*    1   E10.2)') CO
         co = 0.
         if(co.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( cop.le.0. ) then
*        WRITE(QQ,'('' WARNING; CO+ population is negative or 0.'',1P,
*    1   E10.2)') COP
         cop = 0.
         if(cop.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( h2o.le.0. ) then
*        WRITE(QQ,'('' WARNING; H2O population is negative or 0.'',1P,
*    1   E10.2)') H2O
         h2o = 0.
         if(h2o.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( h2op.le.0. ) then
*        WRITE(QQ,'('' WARNING; H2O+ population is negative or 0.'',1P,
*    1   E10.2)') H2OP
         h2op = 0.
         if(h2op.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( h3op.le.0. ) then
*        WRITE(QQ,'('' WARNING; H3O+ population is negative or 0.'',1P,
*    1   E10.2)') H3OP
         h3op = 0.
         if(h3op.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( ch2p.le.0. ) then
*        WRITE(QQ,'('' WARNING; CH2+ population is negative or 0.'',1P,
*    1   E10.2)') CH2P
         ch2p = -ch2p/2.
         if(ch2p.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( cp.le.0. ) then
*        WRITE(QQ,'('' WARNING; C+ population is negative or 0.'',1P,
*    1   E10.2)') CP
         cp = -cp/2.
         if(cp.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
*
*     if( lgDriveMole ) go to999
*     only continues if modrv set, used to query routines by user
      end do
*
      end
