******************************************************************************
      subroutine CrCol
      implicit none
*compute chromium cooling
      include "limelm.par"
      include "nta.par"
      include "dcool.com"
      include "TePowers.com"
      include "phycon.com"
      include "IonFracs.com"
      include "coolcr.com"
      include "TLineEXP.com"
*
*     local variables
      real a21, a31 , a32 , pop3, p3, p2 , popexc
*
*     Cr Chromium cooling
*
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21
*     [Cr III] 5828, multiplet average
      Cr3l21 = popexc(25.,25.,9.,0.05,2.47e4,xIonFracs(24,3))*
     1 3.41e-12
      call coladd( 'Cr 3' , 5828 , Cr3l21  )
*
*     Cr IV
*     these are 2 lines estimated by Jim Kingdon
*     a's are bad, collision strengths just one
      a21 = 0.053
      a31 = 0.102
      a32 = 0.00
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( 28.,12.,18., 28. ,12.,18., a21 ,a31,a32,
     1  19795., 1356., p2, xIonFracs(24,4),0.)
*     multiplet at roughly 6801 A
      Cr4l31 = p3 * a31 * 2.92E-12
*     multiplet at roughly 7267 A
      Cr4l21 = p2 * a21 * 2.74E-12
      call coladd( 'Cr 4' , 6801 , Cr4l31  )
      call coladd( 'Cr 4' , 7267 , Cr4l21  )
*
*     Cr V
*     these are 3 lines estimated by Jim Kingdon
*     a's are bad, collision strengths just one
      a21 = 0.157
      a31 = 0.048
      a32 = 0.016
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( 21.,5.,9., 21. ,5.,9., a21 ,a31,a32,
     1  18028., 3842., p2, xIonFracs(24,5),0.)
*     multiplet at roughly 6577 A
      Cr5l31 = p3 * a31 * 3.02E-12
*     multiplet at roughly 7979 A
      Cr5l21 = p2 * a21 * 2.49E-12
*     multiplet at roughly 3.74 microns
      Cr5l32 = p2 * a32 * 5.31E-13
      call coladd( 'Cr 5' , 6577 , Cr5l31  )
      call coladd( 'Cr 5' , 37 , Cr5l32  )
      call coladd( 'Cr 5' , 7979 , Cr5l21  )
*
*     [Cr VIII] 1.0106 mic
*     Y(ik) from 
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 1.76 , Cr08101 )
      call level2( Cr08101 )
*
*     [Cr 16] 1410.60, cs from 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.11 , Cr16141 )
      call level2( Cr16141 )
*
      end
