********************************************************************
      subroutine dcharg
      implicit none
*compute grains charge
      include "ndust.par"
      include "ncell.par"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "TePowers.com"
      include "dqs.com"
      include "phycon.com"
      include "yn.com"
      include "rfield.com"
      include "limcrs.par"
      include "dust.com"
      include "evryd.par"
      include "GrainPot.com"
      include "ipdpot.com"
      include "trace.com"
      include "dstbug.com"
      include "dnu.com"
      include "dstfac.com"
      include "dstlab.com"
      include "dwork.com"
      include "search.com"
      include "idwork.com"
      include "IOqq.com"
*
*     local variables
      real slope(ndust) , oldpot(ndust) , oldpht(ndust),oldrec(ndust)
      save slope , oldpot , oldpht , oldrec
      real toler , dmaxx
      parameter (toler=0.005 , dmaxx=0.05)
      integer nd , luplim , ipoint , lopbig
      logical lgBigError
      real thres,grngam,drecom,phtion,recom,rerror,dnew,error,
     1 change , xxx
*
      if( lgTrace.and.lgDustBug) then
        write(qq,'(''    dcharg called lgSearch'',l2)') lgSearch
      endif
*
      do nd=1,ndust
      if( lgDustOn1(nd) ) then
        if( lgSearch ) then
          if( lgTrace.and.lgDustBug)
     1    write(qq,'(''    dchar search '',a10)') chDstLab(nd)
          luplim = 100
          dstpot(nd) = 0.
*         DustWorkFcn is neutral surface work function in ryd
*         DSTPOT is floating grain pot in Ryd
          thres = max( DustWorkFcn(nd),DustWorkFcn(nd)+dstpot(nd) )
*         idwork is the actualy pointer to threshold generated
*         by calling ipContSafe in setup - it could be a few cells
*         to either side to the correct cell if several grains
*         share the same ip, making max necessary below
          ipdpot(nd) = max( idwork(nd) , ipoint( thres ) )
          oldpot(nd) = dstpot(nd)
          oldpht(nd) = grngam(nd)
*         if(nd.eq.1.and.dstpot(1).eq.0.)write(QQ,'('' GRNGAM='',
*    1    1p,e10.2)') oldpht(1)
          oldrec(nd) = drecom(nd)
          dstpot(nd) = dstpot(nd) + 0.05
        else
          luplim = 10
        endif
*
*       find dust charge; do sum over photon number
        lopbig = 0
        lgBigError = .true.
*     >>chng 97 feb 28, from label to do while loop
        do while ( lopbig.le.luplim .and. lgBigError )
          lopbig = lopbig + 1
          thres = max( DustWorkFcn(nd),DustWorkFcn(nd)+dstpot(nd) )
          ipdpot(nd) = ipoint( thres )
          phtion = grngam( nd )
          recom = drecom( nd )
          error = phtion - recom
*     >>chng 97 feb 28, crashed when both phtion and recom zero - which
*happens when no ionizing radiation
          rerror = abs( error / ( 0.5*max(1e-35,phtion+recom) ) )
          if( rerror.gt.toler ) then
            if( dstpot(nd).ne.oldpot(nd) ) then
*             only re-estimate slope if new continuum
*     >>chng 96 apr 26, as per Peter van Hoof comment that div by zero can occur
              xxx =  (phtion-oldpht(nd)) - (recom-oldrec(nd))
              if(xxx.ne.0.) slope(nd) = xxx/(dstpot(nd)-oldpot(nd))
            endif
            oldpot(nd) = dstpot(nd)
            oldpht(nd) = phtion
            oldrec(nd) = recom
*           here is reason for above xxx, do not want zero slope:
*           really the change should be here not above??
            dnew = -error / slope(nd)
            change = abs( dnew )
            change = min( change , dmaxx*thres )
            change = sign( change , dnew ) 
*           write(QQ,'(i4,'' chan pot from'',1p,e10.2,'' to'',e10.2)')
*    1      nd, dstpot(nd) , dstpot(nd) + change
            dstpot(nd) = dstpot(nd) + change
            lgBigError = .true.
          else
            oldpot(nd) = dstpot(nd)
            oldpht(nd) = phtion
            oldrec(nd) = recom
            lgBigError = .false.
          endif
          if( lgTrace.and.lgDustBug) then
            write(qq,'(''    dcharg loop '',i3,a10,
     1      '' pot'',1p,e10.2,'' error'',e10.2,'' Pho rec Rate'',2e9.1)'
     1      )lopbig, chDstLab(nd),dstpot(nd),rerror,phtion,recom
          end if
        end do
*
        dstq(nd) = (dstpot(nd)*evryd) / 0.0048
        if(lgTrace.and.lgDustBug) then
          write(qq,'(5X,''Grain potential:'',a10,1P,
     1    E9.2,''Ryd, gamma:'',E9.2,'' recom:'',E9.2,
     2    '' Threshold:'',E9.2,''Ryd'')')
     3    chDstLab(nd),dstpot(nd),phtion ,recom ,
     1    DustWorkFcn(nd)+dstpot(nd)
        endif
        endif
      end do
*
      if( lgTrace .and. (.not.lgDustBug) ) then
        write(qq,'(5X,''Grain potentials:'',1P,10E10.2)')
     1  (dstpot(nd),nd=1,ndust)
      endif
*
      end
