********************************************************************
      subroutine ddrift
      implicit none
*compute grains drift velocity
      include "limcrs.par"
      include "ndust.par"
      include "en1ryd.par"
      include "ncell.par"
      include "evryd.par"
      include "sqrne.com"
      include "dust.com"
      include "rfield.com"
      include "ots.com"
      include "dqs.com"
      include "GrainPot.com"
      include "dstdft.com"
      include "phycon.com"
      include "TePowers.com"
      include "h.com"
      include "he.com"
      include "negdrg.com"
      include "trace.com"
      include "dstbug.com"
      include "dstfac.com"
      include "nhlvl.par"
      include "nh.com"
      include "IOqq.com"
*
*     local variables
      integer nd , i , loop
      real dmomen , fac, psi,rdust,alam,phi2lm,vdold,si,g0,g2,volmom,
     1 corr , fdrag
*
      do nd=1,ndust
        if( lgDustOn1(nd) ) then
*         find momentum absorbed by grain
          dmomen = 0.
          do i=1,nflux
            dmomen = dmomen + (flux(i)+outcon(i)+outlin(i))* anu(i) *
     1      (dqabs(i,nd)+dqscat(i,nd))
          end do
          dmomen = dmomen * en1ryd
*         now find force on grain, and drift velocity
*         factor is 2*k
          fac = 2.7612e-16 * te
*         now PSI defined by Draine and Salpeter 79 Ap.J. 231, 77 (1979)
          psi = (dstpot(nd)*evryd) * 1.1606e4 / te
          if( psi.gt.0. ) then
            rdust = 1e-6
            alam = log( 20.702 / rdust / psi * sqrte / SqrtEden )
          else
            alam = 0.
          endif
          phi2lm = psi**2 * alam
          corr = 2.
          loop = 0.
          do while( loop.lt.10 .and. abs(corr-1.).gt.0.03 )
*  7      if( loop.lt.10 ) then
*     >>chng 19 oct 95 to do while
            loop = loop + 1
            vdold = DustDftVel(nd)
*           interactions with protons
            si = DustDftVel(nd) / sqrte * 7.755e-5
            g0 = 1.5045 * si * sqrt(1.+0.4418*si*si)
            g2 = si / (1.329 + si**3 )
*           drag force due to protons, both linear and square in velocity
*           equation 4 from D+S Ap.J. 231, p77.
            fdrag = fac * hii * (g0 + phi2lm*g2)
*           drag force due to interactions with electrons
            si = DustDftVel(nd) / sqrte * 1.816e-6
            g0 = 1.5045 * si * sqrt(1.+0.4418*si*si)
            g2 = si / (1.329 + si**3 )
            fdrag = fdrag + fac * eden * (g0 + phi2lm*g2)
*           drag force due to collisions with hydrogen and helium atoms
            si = DustDftVel(nd) / sqrte * 7.755e-5
            g0 = 1.5045 * si * sqrt(1.+0.4418*si*si)
            fdrag = fdrag + fac * (hi + 1.1*hei) * g0
*           drag force due to interactions with helium ions
            si = DustDftVel(nd) / sqrte * 1.551e-4
            g0 = 1.5045 * si * sqrt(1.+0.4418*si*si)
            g2 = si / (1.329 + si**3 )
            fdrag = fdrag + fac * heii*(g0+phi2lm*g2) 
*           this term does not work
*    2      HEIII*(G0+4.*PSI**2*(ALAM-0.693)*G2) )
*           this is total momentum absorbed by dust per unit vol
            volmom = dmomen / 2.998e10
            if( fdrag.gt.0. ) then
              corr = sqrt( volmom / fdrag )
              DustDftVel(nd) = vdold * corr
            else
              corr = 1.
              lgNegGrnDrg = .true.
            endif
            if(lgTrace.and.lgDustBug ) write(qq,'(5X,I2,'' new drift '',
     1      ''velocity:'',1P,E10.2,'' momentum absorbed:'',E10.2)')
     2      loop,DustDftVel(nd),volmom
          end do
        endif
      end do
*
      end
