******************************************************************************
      subroutine diffem
      implicit none
*fill in DiffCont and ThrowOut arrays, with diffuse emission for this zone
      include "te1ryd.par"
      include "pi4.par"
      include "SpeedLgt.par"
      include "pi.par"
      include "ndust.par"
      include "itrdim.par"
      include "fr1ryd.par"
      include "ncell.par"
      include "nopsv.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "en1ryd.par"
      include "opsv.com"
      include "tff.com"
      include "facexp.com"
      include "ffsum.com"
      include "maxcor.com"
      include "trace.com"
      include "trdiff.com"
      include "dstfac.com"
      include "dstop.com"
      include "tedust.com"
      include "gaunts.com"
      include "iphmin.com"
      include "em2nu.com"
      include "iphl.com"
      include "hlvcol.com"
      include "he1blt.com"
      include "he2blt.com"
      include "phlevl.com"
      include "he.com"
      include "TePowers.com"
      include "widflx.com"
      include "rfield.com"
      include "diffus.com"
      include "corind.com"
      include "dif2nu.com"
      include "h.com"
      include "phycon.com"
      include "nh.com"
      include "hcaseb.com"
      include "nhe1.com"
      include "nhe2.com"
      include "thlo.com"
      include "iphmra.com"
      include "ioptri.com"
      include "iphmop.com"
      include "iphop.com"
      include "iophe1.com"
      include "iophe2.com"
      include "hstat.com"
      include "he1stat.com"
      include "he2stat.com"
      include "HNIonRyd.com"
      include "He1NIonRyd.com"
      include "He2NIonRyd.com"
      include "difher.com"
      include "iphe1l.com"
      include "iphe2l.com"
      include "phe2lv.com"
      include "phe1lv.com"
      include "DiffLumn.com"
      include "he2bn.com"
      include "ThroOut.com"
      include "hhe2phtots.com"
      include "exptau.com"
      include "radius.com"
      include "GrainEmis.com"
      include "IOqq.com"
*
*     local variables
      integer nd , n , i
      real bfac , f , bolt,factor,facff,fache2,fach,sum2ex,sum2gr,
     1 sum1ex,sum1gr,sumtri,sumhex,arg,photon,bolt2,fac,gion,gn,
     1 gamma,sumh1,dwid,cor , sexp
*
*     this routine evaluates the local diffuse fields
*     it fills in the vector DiffCont
*
      do i=1,ncell
        ThrowOut(i) = 0.
        DiffCont(i) = 0.
        Diff2Pht(i) = 0.
      end do
*
*     hydrogen Lyman continuum (free-bound) emission
      fac = eden * hii
      gion = 1.
      gn = 2.
      gamma = 2.0618684e11 * gn/gion / te / sqrte
      sumh1 = 0.
*     DWID is used to adjust where within WIDFLX exp is evaluated
      dwid = 0.2
      cor = hcbolt(1)
*     following is boltz fac for second cell, check not zero
      bolt2 = 1.57890e5*widflx(ipHn(1)+1) /te
      if( cor.gt.0. ) then
*       MAXCOR is highest energy with non-zero ContBoltz
        do i=ipHn(1),maxcor
*         flux is in photons per sec per ryd
*         ContBoltz is ratio of Boltz fac for each freq
          photon = gamma * ContBoltz(i)/cor *
     1    widflx(i)* OpacStack(i-ipHn(1)+iphop(1)) *anu2(i)
          sumh1 = sumh1 + photon
          DiffCont(i) = DiffCont(i) + photon * fac
          ThrowOut(i) = ThrowOut(i) + photon * fac*hrec(1,3)
        end do
*     following if gas not too cold
      else if( bolt2.lt.3. ) then
        do i=ipHn(1),maxcor
          arg = max(0.,1.57890e5*( anu(i)-1.+widflx(i)*dwid ) /te )
*         flux is in photons per sec per ryd
          photon = gamma * sexp( arg ) * widflx(i)*
     1    OpacStack(i-ipHn(1)+iphop(1))*anu2(i)
          sumh1 = sumh1 + photon
          DiffCont(i) = DiffCont(i) + photon * fac
          ThrowOut(i) = ThrowOut(i) + photon * fac*hrec(1,3)
        end do
      endif
*
*     ionized hydrogen free-bound recombination continua
      fac = eden * hii
      sumhex = 0.
      gion = 1.
      do n=2,nhlvl
*       MAX is to get 2s+p right
        gn = max(8., hstat(n) )
        gamma = 2.0618684e11 * gn/gion / te / sqrte
        cor = hcbolt(n)
        bolt2 = 1.57890e5*widflx(ipHn(n)+1)/te
        if( ContBoltz(ipHn(n)).gt.0. ) then
          do i=ipHn(n),ipHn(1)
*           flux is in photons per sec per ryd
*           ContBoltz is ratio of Boltz fac for each freq
            photon = gamma * ContBoltz(i)/cor *
     1      widflx(i)* OpacStack(i-ipHn(n)+iphop(n)) *anu2(i)
            sumhex = sumhex + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*hrec(n,3)
          end do
        else if( bolt2.lt.3. ) then
          do i=ipHn(n),ipHn(1)
            arg = max(0.,1.57890e5*( anu(i)-HLevNIonRyd(n)+
     1      widflx(i)*dwid ) /te )
*           flux is in photons per sec per ryd
            photon = gamma * sexp( arg ) *
     1      widflx(i)* OpacStack(i-ipHn(n)+iphop(n))*anu2(i)
            sumhex = sumhex + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*hrec(n,3)
          end do
        endif
      end do
*
*     following is check on self-consistency
      CaseBCheck = max( CaseBCheck , sumhex/HRecRad )
*
*     neutral helium triplets hei
      fac = eden * heii
      sumtri = 0.
      if( fac.gt.0. ) then
        gion = 2.
        gn = 3.
        gamma = 2.0618684e11 * gn/gion / te / sqrte
        bolt2 = 1.57890e5*widflx(nhei3) /te
        if( ContBoltz(nhei3).gt.0. ) then
          do i=nhei3,nhe1(1)
            photon = gamma * ContBoltz(i)/ContBoltz(nhei3) *
     1      widflx(i)* OpacStack(i-nhei3+ioptri)* anu2(i)
            sumtri = sumtri + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac
          end do
        else if( bolt2.lt.4. ) then
          do i=nhei3,nhe1(1)
            arg = max(0.,1.57890e5*( anu(i)-anu(nhei3) ) /te )
            photon = gamma * sexp( arg ) *
     1      widflx(i)*OpacStack(i-nhei3+ioptri)* anu2(i)
            sumtri = sumtri + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac
          end do
        endif
      endif
*
*     singlet neutral helium free-bound recombination continua
*
*     ground state from Milne relation
      fac = eden * heii
      sum1gr = 0.
      if( fac.gt.0. ) then
        gion = 2.
        gn = 1.
        gamma = 2.0618684e11 * gn/gion / te / sqrte
        cor = he1cbt(1)
        if( cor.gt.0. ) then
          do i=nhe1(1),maxcor
*           flux is in photons per sec per ryd
*           ContBoltz is ratio of Boltz fac for each freq
            photon = gamma * ContBoltz(i)/cor *
     1      widflx(i)* OpacStack(i-nhe1(1)+iophe1(1))*anu2(i)
            sum1gr = sum1gr + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*he1rec(1,3)
          end do
        else
          do i=nhe1(1),maxcor
            arg = max(0.,1.57890e5*( anu(i)-He1IonRyd(1) ) /te )
*           flux is in photons per sec per ryd
            photon = gamma * sexp( arg ) * widflx(i)*
     1      OpacStack(i-nhe1(1)+iophe1(1))*anu2(i)
            sum1gr = sum1gr + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*he1rec(1,3)
          end do
        endif
      endif
*
      sum1ex = 0.
      fac = eden * heii
      if( fac.gt.0. ) then
        gion = 2.
        do n=2,nhe1lvl
          bolt2 = 1.57890e5*widflx(nhe1(n)) /te
*         this is trick to do 2p, 2s correctly
          gn = max(4., he1stat(n) )
          gamma = 2.0618684e11 * gn/gion / te / sqrte
*         Milne relation for excited states
          if( ContBoltz(nhe1(n)).gt.0. ) then
            do i=nhe1(n),min(nhe1(1),nflux)
              photon = gamma * ContBoltz(i)/ ContBoltz(nhe1(n))*
     1        widflx(i)*OpacStack(i-nhe1(n)+iophe1(n))* anu2(i)
              sum1ex = sum1ex + photon
              DiffCont(i) = DiffCont(i) + photon * fac
              ThrowOut(i) = ThrowOut(i) + photon * fac*he1rec(n,3)
            end do
          else if( bolt2.lt.3. ) then
            do i=nhe1(n),min(nhe1(1),nflux)
              arg = max(0.,1.57890e5*(anu(i)-He1IonRyd(n)) /te )
              photon = gamma * sexp( arg ) *
     1        widflx(i)*OpacStack(i-nhe1(n)+iophe1(n))*anu2(i)
              sum1ex = sum1ex + photon
              DiffCont(i) = DiffCont(i) + photon * fac
              ThrowOut(i) = ThrowOut(i) + photon * fac*he1rec(n,3)
            end do
          endif
        end do
      endif
*
*     ionized He++=>He+ Helium free-bound recombination continua
*     continuum emission from Milne relation
      fac = eden * heiii
      sum2gr = 0.
      sum2ex = 0.
      if( fac.gt.0. ) then
        gion = 1.
        gn = 2.
        gamma = 2.0618684e11 * gn/gion / te / sqrte
        cor = he2cbt(1)
        if( cor .gt.0. ) then
          do i=nhe2(1),maxcor
*           flux is in photons per sec per ryd
*           ContBoltz is ratio of Boltz fac for each freq
            photon = gamma * ContBoltz(i)/cor *
     1      widflx(i)* OpacStack(i-nhe2(1)+iophe2(1))*anu2(i)
            sum2gr = sum2gr + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*he2rec(1,3)
          end do
        else
          do i=nhe2(1),maxcor
            arg = max(0.,1.57890e5*( anu(i)-4. ) /te )
*           flux is in photons per sec per ryd
            photon = gamma * sexp( arg ) * widflx(i)*
     1      OpacStack(i-nhe2(1)+iophe2(1))*anu2(i)
            sum2gr = sum2gr + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*he2rec(1,3)
          end do
        endif
*
        do n=2,nhe2lvl-1
*         this is trick to do 2p, 2s correctly
          gn = max( 8., he2stat(n) )
          gamma = 2.0618684e11 * gn/gion / te / sqrte
          if( ContBoltz(nhe2(n)).gt.0. ) then
            do i=nhe2(n),min(nhe2(1),maxcor)
              photon = gamma *ContBoltz(i)/ContBoltz(nhe2(n))*
     1        widflx(i)* OpacStack(i-nhe2(n)+iophe2(n))*anu2(i)
              sum2ex = sum2ex + photon
              DiffCont(i) = DiffCont(i) + photon * fac
              ThrowOut(i) = ThrowOut(i) + photon * fac*he2rec(n,3)
            end do
          else
            do i=nhe2(n),min(nhe2(1),maxcor)
              arg = max(0.,1.57890e5*( anu(i)-He2IonRyd(n) ) /te )
              photon = gamma * sexp( arg ) * widflx(i)*
     1        OpacStack(i-nhe2(n)+iophe2(n))*anu2(i)
              sum2ex = sum2ex + photon
              DiffCont(i) = DiffCont(i) + photon * fac
              ThrowOut(i) = ThrowOut(i) + photon * fac*he2rec(n,3)
            end do
          endif
        end do
      endif
*
*     trace diffuse triggers this print
      if( lgTrace.and.lgTrDiff ) then
        write(qq,'('' DIFFEM: Hgrd;'',1P,E10.2,'' Ex;'',E9.2,'' He3;'',
     1  E9.2,'' He1g;'',E9.2,'' Ex;'',E9.2,'' He2g;'',E9.2,'' Ex;'',
     2  E9.2)')
     3  sumh1 , sumhex , sumtri , sum1gr , sum1ex, sum2gr , sum2ex
      endif
*
*     hydrogen two photon emission
*     in all following the factor of two is because a single
*     decay produces two photons
      fac =  2. * hn2s * hii
      H12phtOTS = 0.
*     f = 0.
      do i=1,iphl(2,1)
*       >>chng 97 july 17, bring factors together into fach
        fach = Hy2nu(i)*fac
        DiffCont(i) = DiffCont(i) + fach
        Diff2Pht(i) = fach
*       >>chng 96 jan 26 from above to below
*       ThrowOut(i) = ThrowOut(i) + Hy2nu(i)*fac*ExpZone(i)
        ThrowOut(i) = ThrowOut(i) + fach *ExpmTau(i)
*       f = f + fach*ExpmTau(i)
*       >>chng 96 jan 26 from above to below
*       H12phtOTS = H12phtOTS + Hy2nu(i)*fac*(1.-ExpZone(i))
        H12phtOTS = H12phtOTS + fach *(1.-ExpmTau(i))
      end do
*666  write(66,'(1p,3e10.2)') H12phtOTS, f,ExpmTau(iphl(2,1))
*
*     HeI two photon emission
      fac =  2. * he12s * heii
      do i=1,ipHn(1)
        DiffCont(i) = DiffCont(i) + he12nu(i)*fac
        Diff2Pht(i) = Diff2Pht(i) + he12nu(i)*fac
*       >>chng 96 jan 26 from ExpZone to below
        ThrowOut(i) = ThrowOut(i) + he12nu(i)*fac*ExpmTau(i)
      end do
      He12phtOTS = 0.
      do i=ipHn(1)+1,iphe1l(2,1)
        DiffCont(i) = DiffCont(i) + he12nu(i)*fac
        Diff2Pht(i) = Diff2Pht(i) + he12nu(i)*fac
*       ThrowOut(i) = ThrowOut(i) + he12nu(i)*fac*ExpZone(i)
*       >>chng 96 jan 26 from above to below
        ThrowOut(i) = ThrowOut(i) + he12nu(i)*fac*ExpmTau(i)
*       He12phtOTS = He12phtOTS + he12nu(i)*fac*(1.-ExpZone(i))
*       >>chng 96 jan 26 from above to below
        He12phtOTS = He12phtOTS + he12nu(i)*fac*(1.-ExpmTau(i))
      end do
*
*     HeII two photon emission
      fac =  2. * he22s * heiii
      do i=1,ipHn(1)
        DiffCont(i) = DiffCont(i) + he22nu(i)*fac
        Diff2Pht(i) = Diff2Pht(i) + he22nu(i)*fac
*       >>chng 96 jan 26 from ExpmTau to below
        ThrowOut(i) = ThrowOut(i) + he22nu(i)*fac*ExpmTau(i)
      end do
      He22phtOTS = 0.
      do i=ipHn(1)+1,iphe2l(2,1)
        DiffCont(i) = DiffCont(i) + he22nu(i)*fac
        Diff2Pht(i) = Diff2Pht(i) + he22nu(i)*fac
*       >>chng 96 jan 26 from above to below
*       ThrowOut(i) = ThrowOut(i) + he22nu(i)*fac*ExpZone(i)
        ThrowOut(i) = ThrowOut(i) + he22nu(i)*fac*ExpmTau(i)
*       >>chng 96 jan 26 from above to below
*       He22phtOTS = He22phtOTS + he22nu(i)*fac*(1.-ExpZone(i))
        He22phtOTS = He22phtOTS + he22nu(i)*fac*(1.-ExpmTau(i))
      end do
*
*     H, He, heavy element, brems free-free
      fach = eden * 1.032e-11 * (hii+heii) / sqrte
      fache2 = eden * 1.032e-11 * 4.*heiii / sqrte
      facff = eden * 1.032e-11 * EdenFFSum*5./ sqrte
*     ntff is pointer to energy where gas goes 
*     optically thin to brems
      do i=1,ntff-1
        fac =
     1  ( fach*gff(i)*(1.+OpacStack(i-1+iphmra)*hn(1)) +
     2  fache2*gffhe2(i) + facff*gff(i) ) *
     2  widflx(i)* ContBoltz(i)/ anu(i)
        DiffCont(i) = DiffCont(i) + fac
*       do not add to outward beam since self absorbed
*       >>chng 96 feb 27, put back into outward beam since do not integrate
*       over it anyway.
        ThrowOut(i) = ThrowOut(i) + fac
      end do
      do i=ntff,maxcor
        fac =
     1  ( fach*gff(i)*(1.+OpacStack(i-1+iphmra)*hn(1)) +
     2  fache2*gffhe2(i) + facff*gff(i) ) *
     2  widflx(i)* ContBoltz(i)/ anu(i)
        DiffCont(i) = DiffCont(i) + fac
        ThrowOut(i) = ThrowOut(i) + fac
      end do
*
*     grain dust emission
*
      if( lgDustOn ) then
*       add grain dust emission in IR
        do i=1,nflux
          GrainEmission(i) = 0.
        end do
        do nd=1,ndust
          if( lgDustOn1(nd) ) then
            factor = 2.*pi4 * ((fr1ryd/SpeedLight)**2) * fr1ryd
            bolt = te1ryd / tedust(nd)
            f = 1.
            i = 1
*           >>chng 96 apr 26 upper limt chng from 15 to 75 Peter van Hoof 
            do while ( i.lt.nflux .and. f.lt.75. )
              f = bolt * anu(i)
              if( f.gt.75. ) then
                bfac = 1e33
              else if( f.gt..01 ) then
                bfac = exp(f) - 1.
              else
                bfac = f
              endif
*             >>chng 96 july 13, save grain emission array
*             >>chng 97 feb 28, GrainEmission was set to last evaluated grain,
*             zeroed out above, and now increment grain instead of setting it
              cor = factor*(dstab1(i,nd)*hden*dstAbund(nd))*
     1        anu2(i)*widflx(i)/bfac
*666       call broken
*          kill emission from highly ionized regions
*          if( (nd.eq.9 .or. nd.eq.10) .and. hii/hden.gt.0.5)cor=0.
              GrainEmission(i) = GrainEmission(i) + cor
              DiffCont(i) = DiffCont(i) + cor
              ThrowOut(i) = ThrowOut(i) + cor
              i = i + 1
            end do
          endif
        end do
      endif
*
*     hminus emission
      fac = eden * hi
      gn = 1.
      gion = 2.
      gamma = 2.0618684e11 * gn/gion / te / sqrte
      cor = ContBoltz(iphmin)
      if( cor.gt.0. ) then
        do i=iphmin,min( nhe1(1) , nflux )
*         flux is in photons per sec per ryd
*         ContBoltz is ratio of Boltz fac for each freq
          factor = gamma * ContBoltz(i)/cor *
     1    widflx(i)* OpacStack(i-iphmin+iphmop)*anu2(i) * fac
          DiffCont(i) = DiffCont(i) + factor
          ThrowOut(i) = ThrowOut(i) + factor
        end do
      else
        do i=iphmin,min( nhe1(1) , nflux )
          arg = max(0.,1.57890e5*( anu(i)-0.05544 ) /te )
*         flux is in photons per sec per ryd
          factor = gamma * sexp( arg ) * widflx(i)*
     1    OpacStack(i-iphmin+iphmop)*anu2(i) * fac
          DiffCont(i) = DiffCont(i) + factor
          ThrowOut(i) = ThrowOut(i) + factor
        end do
      endif
*
*     get total luminosity of diffuse fields
      DiffLumin = 0.
      do i=1,nflux
        DiffLumin = DiffLumin + DiffCont(i) * anu(i)
      end do
      DiffLumin = DiffLumin * en1ryd
*
      end
