*********************************************************************
      subroutine drvary
      implicit none
*main driver for optimization runs
*     Drives cloudy to optimize variables;
*
*     code originally written by R.F. Carswell, IOA Cambridge
*
*     Also called directly is 'Numerical Recipes' POWELL, but this
*     does not work very well, so POWELL (and the subsidiary routines
*     it uses) should be dropped perhaps.
*     (Bob's advice was followed).
*
      include "ncollm.par"
      include "limext.par"
      include "limpar.par"
      include "nlines.par"
      include "nobslm.par"
      include "nkrd.par"
      include "obsint.com"
      include "obscol.com"
      include "vparm.com"
      include "limfal.com"
      include "obslin.com"
      include "itoptm.com"
      include "rincrm.com"
      include "nvfpnt.com"
      include "varmax.com"
      include "varang.com"
      include "noptim.com"
      include "vformt.com"
      include "input.com"
      include "ninput.com"
      include "nvary.com"
      include "faint.com"
      include "oprout.com"
      include "called.com"
      include "whtopm.com"
      include "iooptm.com"
      include "vtoler.com"
      include "date.com"
      include "IOqq.com"
      include "OptmFlow.com"
      include "sum.com"
      include "troptm.com"
*
*     local variables
      integer i,j,ival,np,ii,iflag,mode,need,iteram,
     1 nint,nplxmx
      real fret,fx,func,ymn
      character chNote*7
      real p(21,20),y(21),xi(20,20)
      character chK1*80
*     equivalence the POWELL & AMOEBA workspaces
      equivalence (p(1,1),xi(1,1))
      external func
      real param(limpar) , ptem(limpar)
*     Stuff for Subplex
      parameter (nplxmx=200)
      real worke(nplxmx)
      integer iworke(nplxmx) , nfe
*
*     free statement labels  >=20
*
      lgTalk = .false.
*     zero out lots of variables
      call zero
*
*     necessary to do this to keep all lines in
      lgFaintOn = .false.
      limfal = 1000
*
*     call READR the first time to scan off all variable options
      call readr
*
      nvary = nparm
*
      if( lgOptLum ) then
        nint = 1
      else
        nint = 0
      endif
*
      if( (nlobs+nint+ncobs).lt.1 ) then
        write(qq,'('' The input stream has vary commands, but'')')
        write(qq,'('' no observed quantities were entered.  Whats up?''
     1  )')
        write(qq,'('' Use the NO VARY command to input vary options''
     1  ,'' but not try to perform this.'')')
        stop
      else if( nvary.lt. 1 ) then
        write(qq,'('' No parameters to vary were entered. Whats up?'')'
     1  )
        stop
      endif
*
*     lgTrOptm set with trace optimize command
      if( lgTrOptm ) then
        do i=1,nvary
          write(qq,'(a80)')chVarFmt(i)
          write(chK1,chVarFmt(i)) (vparm(i,ii),ii=1,nvarxt(i))
          write(qq,'(a80)')chK1
        end do
      endif
*
*     option to change default increments; if zero then leave as is
      do i=1,limpar
        if( rincrm(i).ne.0. ) then
          vincr(i) = rincrm(i)
        endif
      end do
*
*     say who we are
      write(qq,'(54X,''Optimization  Driver'')')
      write(qq,'(57X,''Cloudy '',a7//23X,38(''*''),A7,
     1 38(''*''),/23X,''*'',81X,''*'')') chVersion , chDate
*
*     now echo initial input quantities with flag for vary
      do i=1,nSave
        chNote = '       '
        do j=1,nvary
          if( i.eq.nvfpnt(j) ) then
            chNote = 'VARY>>>'
          endif
        end do
        write(qq,'(15X,A7,'' *'',1X,A80,''*'')') chNote,chCardSav(i)
      end do
      write(qq,'(23X,''*'',81X,''*''/23X,83(''*'')//)')
*
*     option to trace logical flow within this sub
      if( lgOptimFlow ) then
        do j=1,nvary
          i = nvfpnt(j)
          write(qq,'('' trace:'',a80)') chCardSav(i)
          write(qq,'(a80)') chVarFmt(j)
          write(qq,'('' number of variables on line:'',i4)') nvarxt(j)
          write(qq,'('' Values:'',1p,10e10.2)')
     1    (vparm(j,ii),ii=1,nvarxt(j))
        end do
      endif
*
      write(qq,'('' Up to'',I5,'' iterations will be performed,'')')
     1 itoptm
      write(qq,'('' and the final version of the input file will be'',
     1'' written on Fortran I/O unit'',I3)') iooptm
      if( chOptRtn.eq.'AMOE' ) then
        write(qq,'('' The amoeba method will be used.'')')
      else if( chOptRtn.eq.'POWE' ) then
        write(qq,'('' Powells method will be used.'')')
      else if( chOptRtn.eq.'SUBP' ) then
        write(qq,'('' Subplex method will be used.'')')
      else
        write(qq,'('' I dont understand what method to use.'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
      write(qq,'(/I4,'' parameters will be varied.  The first lines, '',
     1''and the increments are:'')') nvary
      do i=1,nvary
         varmax(i) = -1e37
         varmin(i) = 1e37
*        write formatted to output using the format held in chVarFmt(np)
         write(chK1,chVarFmt(i)) (vparm(i,ii),ii=1,nvarxt(i))
         write(qq,'(/1X,A80)') chK1
         write(qq,'('' Initial increment is'',F6.3,'', the limits are'',
     1   1P,E10.2,'' to '',E10.2)') vincr(i), varang(1,i), varang(2,i)
      end do
*
*     this will be number of times optimizer calls cloudy
      noptim = 0
*
      if( chOptRtn.eq.'POWE' ) then
*        Powell's method
         do j=1,nvary
           ptem(j) = vparm(j,1)
           do i=1,nvary
             xi(i,j) = 0.0
           end do
           xi(j,j) = vincr(j)
         end do
         call powell(ptem,xi,nvary,20,OptGlobalErr,iteram,fret)
         do j=1,nvary
           vparm(j,1) = ptem(j)
         end do
*
      else if( chOptRtn.eq.'SUBP' ) then
         write(qq,'('' Begin optimization with SUBPLEX'')')
         need = 2*nvary + nvary*(nvary+4)+1
         if( need.gt.nplxmx) then
           write(qq,'('' Increase size of NPLXMX in parameter '',
     1     ''statements to handle this many variables.'')')
           write(qq,'('' I need at least '',I5)') need
           stop
         endif
         do j=1,nvary
           ptem(j) = vparm(j,1)
         end do
*
*        The subrouting SUBPLX input into cloudy 8/4/94.
*        The program itself is very well commented.
*        The mode must set to 0 for the default values.
*        The switch iflag tells if the program terminated normally.  
         mode = 0
         call subplx(func,nvary,OptGlobalErr,itoptm,mode,vincr,ptem,fx,
     1      nfe,worke,iworke,iflag)
         if(iflag.eq.-1) then
           write(qq, '('' SUBPLEX exceeding maximum iterations.''/
     $    '' This can be reset with the OPTIMZE ITERATIONS command.'')')
         endif
*
         do j=1,nvary
           vparm(j,1) = ptem(j)
         end do
         if( lgOptimFlow ) then
           write(qq,'('' trace return subplx:'')')
           do j=1,nvary
             write(qq,'('' Values:'',1p,10e10.2)')
     1       (vparm(j,ii),ii=1,nvarxt(j))
           end do
         endif
*
      else if( chOptRtn.eq.'AMOE' ) then
*        AMOEBA
*        set up the two-dimensional array of values for the parameters
*        required by AMOEBA, NVARY+1 of them.
         do j=1,nvary
            do i=1,nvary+1
              p(i,j) = vparm(j,1)
            end do
         end do
*        set the single values in each which are different from the
*        first guess
         do i=2,nvary+1
           j = i - 1
           p(i,j) = vparm(j,1) + vincr(j)
         end do
*        initialize y, the value to be minimized
         do i=1,nvary+1
            do j=1,nvary
              vparm(j,1) = p(i,j)
              param(j) = p(i,j)
            end do
*           FUNC calls CLOUDY with the variable parameters in VPARM,
*           returning the equivalent of chi**2 as FUNC
            y(i) = func(param)
         end do
*
*       AMOEBA is the standard 'Numerical Recipes' routine, which
*       minimizes the function FUNC(param)
*       where param is the array of parameters
*       dimensional array of parameters for the model. It is described
*       on pages 402 - 406 of the book. [Press et al., Numerical
*       Recipes (Fortran version), Cambridge U.P., 1992]
        call amoeba(p,y,21,20,nvary,OptGlobalErr,func,iteram)
*       print summary of results
        ival = 1
        ymn = 1.0e34
*       keep pointer to minimum value
        do i=1,nvary+1
           if(y(i).lt.ymn) then
             ymn = y(i)
             ival = i
           endif
        end do
*       end set variable values to those which gave the minimum Y
        do j=1,nvary
          vparm(j,1) = p(ival,j)
        end do
      endif
      write(qq,'(1X,50(''*''))')
      write(qq,'(1X,50(''*''))')
      write(qq,'(1X,50(''*''))')
      write(qq,'(/'' Cloudy was called '',i4,'' times.''/)') noptim
      do i=1,nvary
        vparm(i,1) = min( vparm(i,1) , varang(2,i) )
        vparm(i,1) = max( vparm(i,1) , varang(1,i) )
        param(i) = vparm(i,1)
        np = nvfpnt(i)
        write(chCardSav(np),chVarFmt(i)) (vparm(i,ii),ii=1,nvarxt(i))
        write(qq,'(1X,''Optimal command: '',A80)') chCardSav(np)
        write(qq,'(''  Smallest value:'',1P,E10.2,'' Largest value:'',
     1  E10.2,'' Allowed range '',E10.2,'' to '',E10.2)')
     2  varmin(i) , varmax(i) , varang(1,i) , varang(2,i)
      end do
      lgTalk = .true.
      lgFaintOn = .true.
*
*     though a page eject
      write(qq,'(''1'')')
*
*     punch optimal parameters on unit iooptm
      do i=1,nSave
        write(iooptm,'(A80)') chCardSav(i)
      end do
*
*     recalculate values in cloudy for the best fit, and print out
*     all the information
      fret = func(param)
*
      end
