**************************************************************************
      subroutine dustop
      implicit none
*initialize grains opacity at start of calculation
      include "ndems.par"
      include "limcrs.par"
      include "ndust.par"
      include "ncell.par"
      include "dustems.com"
      include "dnu.com"
      include "dust.com"
      include "dstlab.com"
      include "dstop.com"
      include "dstfac.com"
      include "dstbug.com"
      include "trace.com"
      include "rfield.com"
      include "NumUpper.com"
      include "dqs.com"
      include "yn.com"
      include "idwork.com"
      include "dwork.com"
      include "grmetl.com"
      include "ndston.com"
      include "IOqq.com"
*
*     local variables
      real ydheat , y0 , y1
      parameter (ydheat=0.5 , y0=0.5 , y1=0.2)
      integer nd , i , j , k
      character chLab(ndust)*10
      real fac,crsdst,tdust,dintg , dst1(ndust), dst2(ndust) ,
     1 GrnVryDpth
*
*     free statement numbers >=19
*
      if( lgDustBug.and.lgTrace ) then
        write(qq,'(5X,''DUSTOP called with log grain depletion '',
     1  ''factors, dstfactor='')')
        write(qq,'(1p,10e10.2)') dstfactor
        write(qq,'(5X,''lgDustVary flag for depth dependence.'')')
        write(qq,'(1p,10l2)') lgDustVary
      endif
*
      ndston = 0.
      if( lgDustOn ) then
        do nd=1,ndust
          if( lgDustOn1(nd) ) then
*           counter for those dusts which are actually on
            ndston = ndston + 1
            ipdon(ndston) = nd
*           this is total grain depletion factor, GrainMetal is depletion
*           set with metals command, normally one
            dstfactor(nd) = dstfactor(nd) * GrainMetal
*           this will be actual abundance of grains used in calculation
            dstAbund(nd) = dstfactor(nd) * GrnVryDpth(nd)
*           this is effective area per proton, scaled by depletion
*           dareff(nd) = darea(nd) * dstAbund(nd)
            do i=idwork(nd),nupper
              DustPhotoE(i,nd) = anu(i) - DustWorkFcn(nd)
*             dust photo yield, from Draine 78
              yn(i,nd) = min( y1 , y0 *
     1        max( 0. , ( 1.-DustWorkFcn(nd)/anu(i) )))
            end do
            do i=1,nupper
*             absorption part of total dust opacity, then efficiency
              dstab1(i,nd) = crsdst( anu(i) , nd , 'ABSO' )
              dqabs(i,nd) = dstab1(i,nd) * 4. / darea(nd)
            end do
*
            do i=1,nupper
*             scttering  part of total dust opacity, then efficiency
              dstsc1(i,nd) = crsdst( anu(i) , nd , 'SCAT' )
              dqscat(i,nd) = dstsc1(i,nd) * 4. / darea(nd)
            end do
          else
*           >>chng 96 apr 26, zero out non-present species for safety
            do i=1,nupper
              dstab1(i,nd) = 0.
              dstsc1(i,nd) = 0.
            end do
          endif
        end do
      else
*        this branch dust not on - zero opacities
         do nd=1,ndust
            do i=1,nupper
               dstab1(i,nd) = 0.
               dstsc1(i,nd) = 0.
            end do
         end do
         do i=1,nupper
            dstab(i) = 0.
            dstsc(i) = 0.
         end do
         return
      endif
*
*
      do i=1,nupper
        dstab(i) = 0.
        dstsc(i) = 0.
      end do
*
      do nd=1,ndust
        if( lgDustOn1(nd) ) then
          do i=1,nupper
*           these are total absorption and scattering cross sections
            dstab(i) = dstab(i) + dstab1(i,nd) * dstAbund(nd)
            dstsc(i) = dstsc(i) + dstsc1(i,nd) * dstAbund(nd)
          end do
        endif
      end do
*
      if( lgDustBug.and.lgTrace ) then
*        >>chng 96 nov 30, two line format since soo many grains
         nd = 0
         do i=1,ndust
           if( lgDustOn1(i) )then
             nd = nd + 1
             chLab(nd) = chDstLab(i)
           endif
         end do
         write(qq,'('' There are'',i3,'' possible forms of grains in'',
     1   '' the calculation, and'',i3'' are turned on.  Their names '',
     2   '' are:'')') ndust, nd
         write(qq,'(10(1x,a10,'':'',l1))')
     1   (chDstLab(i),lgDustOn1(i),i=1,ndust)
         write(qq,'(5X,''NU(Ryd), Cross sec per proton, yield'')')
         write(qq,'(''    Ryd  '',6(A10,8X))') (chLab(i),i=1,nd)
         do i=1,nupper,40
           nd = 0
           do j=1,ndust
             if( lgDustOn1(j) )then
               nd = nd + 1
               dst1(nd) = dstab1(i,j)
               dst2(nd) = yn(i,j)
             endif
           end do
*          write(qq,'(1P,14E9.2)') anu(i),(dstab1(i,k),yn(i,k),k=1,
*    1     ndust) , dstab(i)
           write(qq,'(1P,14E9.2)') anu(i),(dst1(k),dst2(k),k=1,nd),
     1     dstab(i)
         end do
         write(qq,'(5X,''NU(Ryd), Cross sec per proton, total sct'')')
         write(qq,'(''    Ryd  '',9A10)') (chLab(i),i=1,nd)
         do i=1,nupper,40
           nd = 0
           do j=1,ndust
             if( lgDustOn1(j) )then
               nd = nd + 1
               dst1(nd) = dstsc1(i,j)
             endif
           end do
           write(qq,'(1P,10E9.2)') anu(i),(dst1(k),k=1,nd),dstsc(i)
         end do
         write(qq,'(5X,''NU(Ryd), Q abs, scat'')')
         write(qq,'(''    Ryd    '',6(A10,10X))') (chLab(i),i=1,nd)
         do i=1,nupper,40
           nd = 0
           do j=1,ndust
             if( lgDustOn1(j) )then
               nd = nd + 1
               dst1(nd) = dqabs(i,j)
               dst2(nd) = dqscat(i,j)
             endif
           end do
           write(qq,'(1P,13E10.3)') anu(i),(dst1(k) , dst2(k),k=1,nd)
         end do
      endif
*
*     now find dust emissivity from Kirchoff's law
      fac = 10.**( log10(1.2e9 / 2.) / float(ndems-1) )
      tdust = 2. / fac
      if(lgTrace.and.lgDustBug) write(qq,'(4X,''ND'',3X,''Tdust'',5X,
     1 ''Emis'',5X,''Emis/BB/sigma'')')
      do i=1,ndems
        tdust = tdust * fac
        dsttmp(i) = log10( tdust )
        do nd=1,ndust
          if( lgDustOn1(nd) ) then
*           >>chng 97 apr 25, protect against underflow when very small opacity
            dstems(i,nd) = log10( max(1e-30,dintg( tdust , nd , i ) ) )
          endif
        end do
      end do
*
*     now find slopes form spline fit
      do nd=1,ndust
        if( lgDustOn1(nd) ) then
*       set up coefficients for spline
          call spline( dstems(1,nd) , dsttmp , ndems , 2e31,2E31, 
     1    dstslp(1,nd) )
        endif
      end do
*
      if(lgTrace.and.lgDustBug) write(qq,'(4X,''DustOp returns'')')
*
      end
