******************************************************************************
      subroutine fe2ovr
      implicit none
*compute FeII overlap with Lya
      include "ncell.par"
      include "nhlvl.par"
      include "nfeii.par"
      include "limelm.par"
      include "nta.par"
      include "itrdim.par"
      include "wlal.par"
      include "DoppVel.com"
      include "IonFracs.com"
      include "corind.com"
      include "exptau.com"
      include "ipfe2.com"
      include "fe2pmp.com"
*     include "fe2pop.com"
      include "fe2tau.com"
      include "phycon.com"
      include "newion.com"
      include "hwidth.com"
      include "phlevl.com"
      include "h.com"
      include "dstfe2.com"
      include "fe2on.com"
      include "TLineEXP.com"
      include "ZoneCnt.com"
      include "FeIIAtom.com"
      include "IOqq.com"
*
*     local variables
      real oldrat , rate , fe2par , displa , hopc , weight ,
     1 BigHWidth , BigFeWidth , Fe2Partn
      integer i , nhits , nZoneEval
      save oldrat , BigHWidth , BigFeWidth , nZoneEval
*
*     compute efficiency of FeII emission overlapping with Ly-alpha
*     implemented with Fred Hamann
*
*     make Ly-a width monotonically increasing to avoid oscillation
*     in deep regions of x-ray ionized clouds.
*
*     do nothing if Verner FeII atom is used
      if( chFeIIAtom.eq.'Verner' ) return
*
      if( nzone.le.1 ) then
        BigHWidth = HLineWidth(1)
        BigFeWidth = doppler(26)
        nZoneEval = nzone
      endif
      if( xIonFracs(26,2).le.0. .or. .not.lgFe2On .or.HLineWidth(1).le.
     1  0. ) then
        Fe2Partn = 0.
        oldrat = 0.
        dstfe2lya = 0.
        escfe2 = 0.
        do i=1,nfeii
          Fe2PopLte(i) = 0.
        end do
        return
      else if( .not.lgNewIon ) then
        return
      endif
*     only evaluate this one time per zone to avoid oscillations
*     deep in x-ray ionized clouds
      if( nZoneEval.eq.nzone .and.nzone.gt.1 ) return
      BigHWidth = max( BigHWidth , HLineWidth(1) )
      BigFeWidth = max( BigFeWidth , doppler(26) )
      nZoneEval = nzone
*
*begin sanity check
      if( fe2lam(1).le.0. ) then
        write(qq,'('' Insane value for fe2lam array.'')')
        write(qq,'('' Was block data fe2dat linked in?'')')
        stop
      endif
*end sanity check
*
      nhits = 0
      rate = 0.
      Fe2Partn = fe2par(te)
      do i=1,nfeii
*       this is displacement from line center in units of Lya width
        displa = abs(fe2lam(i)-wlal)/wlal*3e10 / BigHWidth
        if( displa.lt.1.333 ) then
*         have variable weighting factor depending on distance away
*         this comes form the Verner's fits to Adam's results
          if( displa .le. 0.66666 ) then
            weight = 1.
          else
            weight = max(0., 1. - (displa-0.666666)/0.66666 )
          endif
          nhits = nhits + 1
          Fe2PopLte(i) = fe2gs(i) / Fe2Partn * ContBoltz(ipfe2(i)) *
     1    xIonFracs(26,2)
          feopc(i) = Fe2PopLte(i) * fe2osc(i) * 0.0150*(fe2lam(i)*1e-8)/
     1    BigFeWidth
*         Ly-alpha line-center opacity
          if( hn(1)*hii.gt.0. ) then
            hopc = 7.60e-8 * hn(1)*hii/doppler(1)
          else
            hopc = 7.60e-8 * hi/doppler(1)
          endif
          rate = rate + (feopc(i)/(feopc(i)+hopc) ) *
     1    (BigFeWidth /doppler(1))*
     1    (1. - 1./(1.+1.6* Fe2TauLte(i) ) ) * weight
        endif
      end do
*
*     dstfe2lya is total Lya deexcitation probability due to line overlap
*     damper is to stop feedback between here and hydrogen ionization sln
      dstfe2lya = ( rate + oldrat ) / 2.
      oldrat = dstfe2lya
*     ESCFE2 is that part of dstfe2lya that escapes from the cloud as FeII
*     exctau is exp(-tau) inward
      escfe2 = dstfe2lya * ExpmTau(int(tuv3(7)))
*
      end
