******************************************************************************
      real function fhummr( beta )
      implicit none
*evaluate Hummer's F(beta) function
      real beta
*
*     local variables
      real x
*
*     evaluates Hummer's F(beta) function for case where damping
*     constant is zero, are returns beta*F(beta)
*     fit to Table 1, page 80, of Hummer MNRAS 138, 73-108.
*     beta is ratio of continuum to line opacity; FUMMER is
*     product of his F() times beta; the total destruction prob
*     this beta is Hummer's normalization of the Voigt function
      if( beta.le.0. ) then
         fhummr = 0.
      else
         x = log10( beta )
         if( x.lt. -5.5 ) then
            fhummr = 3.8363 - 0.56329*x
         else if( x.lt.-3.5 ) then
            fhummr = 2.79153 - 0.75325 * x
         else if( x.lt. -2. ) then
            fhummr = 1.8446 - 1.0238*x
         else
            fhummr = 0.72500 - 1.5836 * x
         endif
         fhummr = fhummr * beta
      endif
*
      end
