******************************************************************************
      subroutine fill( enlo , enhi , resolv , n0 , ipnt )
      implicit none
*define the continuum energy grid over a specified range
      real enlo , enhi , resolv 
      integer n0 , ipnt
*
      include "nfill.par"
      include "ncell.par"
      include "trace.com"
      include "PltTrace.com"
      include "conbug.com"
      include "rfield.com"
      include "widflx.com"
      include "fillnu.com"
      include "IOqq.com"
*
*     local variables
      integer i , nbin
      real widtot
*
*     nrange is number of ranges 
      ipnt = ipnt + 1
      if( ipnt.gt.1 .and.enlo.ne. filbnd(ipnt) ) then
        write(qq,'('' FILL improper bounds.'')')
        stop
      endif
      nrange = max( nrange , ipnt )
*
      if( ipnt.gt.nfill ) then
        write(qq,'('' The limit to the number of FILL ranges is'',
     1  i4)') nfill
        stop
      endif
      ifill0(ipnt) = n0 - 1
      filbnd(ipnt) = enlo
      filbnd(ipnt+1) = enhi
      nbin = log( 10. ) * log10( enhi / enlo ) / resolv + 1
      fildel(ipnt) = log10( enhi/enlo ) / nbin
      if( fildel(ipnt).lt.0.01 ) then
        filres(ipnt) = log(10.) * fildel(ipnt)
      else
        filres(ipnt) = (10.**(2.*fildel(ipnt)) - 1.)/
     1  2. / 10.**fildel(ipnt)
      endif
      if( n0+nbin.gt.ncell ) then
        write(qq,'('' Fill would need'',I4,'' cells to get to an'',
     1  '' energy of'',1P,E10.3)') n0+nbin , enhi
        write(qq,'('' Increase NCELL in all parameter statements.'',
     1  ''  The current value is'',i6)') ncell
        stop
      endif
*
      widtot = 0.
      do i=1,nbin
        anu(i+ifill0(ipnt)) = enlo * 10.**(fildel(ipnt)*(float(i)-0.5))
        widflx(i+ifill0(ipnt)) = anu(i+ifill0(ipnt)) * filres(ipnt)
        widtot = widtot + widflx(i+ifill0(ipnt))
      end do
*
      n0 = n0 + nbin
      if( lgTrace.and.(lgConBug.or.lgPtrace) ) then
        write(qq,'('' FILL range'',I2,'' from'',1P,E10.3,'' to'',
     1  E10.3,''R in'',I4,'' cell; ener res='',E10.3,'' WIDTOT='',E10.3
     2  )') ipnt , anu(ifill0(ipnt)+1)-widflx(ifill0(ipnt)+1)/2. ,
     3  anu(ifill0(ipnt)+nbin)+widflx(ifill0(ipnt)+nbin)/2.,nbin,
     4  filres(ipnt),widtot
        write(qq,'('' The requested range was'',1P,2E10.3,'' The '',
     1  ''requested resolution was'',E10.3)') enlo , enhi , resolv
      endif
*
      end
