******************************************************************************
      subroutine firebl( z , nqh , ar1 )
      implicit none
*parse parameters from fireball command
      integer nqh
      real z, ar1
*
      include "itrdim.par"
      include "limspc.par"
      include "range.com"
      include "spec.com"
      include "sptype.com"
      include "spnorm.com"
      include "radius.com"
      include "bounds.com"
      include "rdfalt.com"
      include "IOqq.com"
*
*     local variables 
      real a , rlogl
*
*     check that stack of shape and luminosity specifications
*     is parallel, stop if not - this happens is background comes
*     BETWEEN another set of shape and luminosity commands
      if( nspec.ne.nqh ) then
        write(qq,'('' This command has come between a previous ''
     1  ,''ordered pair of continuum shape and luminosity commands.''/
     2  ,'' Reorder the commands to complete each continuum '',
     3  ''specification before starting another.'')')
        write(qq,'('' sORRY.'')')
        stop
      endif
*
      nspec = nspec+1
      nqh = nqh + 1 
      if( nqh.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
*     put in a black body
      chSpType(nspec) = 'BLACK'
      slope(nspec) = 2.756 * ( 1. + z )
      cutoff(nspec,1) = 0.
      cutoff(nspec,2) = 0.
      chSpNorm(nqh) = 'LUMI'
      a = log10(slope(nspec))
      rlogl = log10( 2.99792e10 * 7.56464e-15) + 4.*a
      chRSpec(nqh) = 'SQCM'
      range(nqh,1) = emm
      range(nqh,2) = egamry
      totpow(nqh) = rlogl
*
*     set radius to very large value if not already set
      if( radius.eq.0. ) then
        ar1 = rdfalt
        radius = 10. ** ar1
      endif
*
      end
