******************************************************************************
      real function fosc(xLower,Upper)
      implicit none
*computes hydrogenic oscillator strengths, Johnson L.C., 1972 ApJ 174 227
*     Used in the function hdexct.
      real xLower,Upper
*
      include "IOqq.com"
*
*     local variables
      real x , gnt0 , gnt1 , gnt2 , gaunt
      real pi
*
*begin sanity check
      if( xLower.gt.Upper .or. xLower*Upper.lt.0. ) then
        write(qq,'('' fosc called with insane indices,='',1p,2e10.2)')
     1  xLower,Upper
        stop
      endif
*end sanity check
      pi=3.141592654
      x = 1.0 - (xLower/Upper)**2 
      if(xLower.ge.3) then
        gnt0 = 0.9935 + 0.2328/xLower - 0.1296/xLower/xLower
        gnt1 = -(0.6282 - 0.5598/xLower + 0.5299/xLower/xLower)/xLower
        gnt2 = (0.3887 - 1.181/xLower + 
     1  1.470/xLower/xLower)/xLower/xLower
      elseif(xLower.eq.2) then
        gnt0 = 1.0785
        gnt1 = -.2319
        gnt2 = 0.02947
      else
        gnt0 = 1.1330
        gnt1 = -.4059
        gnt2 = 0.07014
      endif  
      gaunt = gnt0 + gnt1/x + gnt2/x/x
      fosc = 32./3./pi /sqrt(3.) * xLower/Upper**3 * gaunt /x/x/x
      end
