******************************************************************************
      subroutine getmod(temp,alogg,modnum,tval,gval,ierr,wl)
      implicit none
*get a single Werner PN atmosphere, by K Volk
      include "ncell.par"
      include "called.com"
      include "rfield.com"
      include "StarSize.com"
      include "IOqq.com"
      integer modnum,ierr,j,j1,i1,ivals
      real temp,alogg,tval,gval,wl,flux1,fr1,fr2,fr3,fr4,flux2,
     1 fact1,fact2
*     parameter (ndata=865)
      dimension tval(7),gval(4),modnum(7,4),wl(ncell)
      dimension flux1(ncell),flux2(ncell),ivals(ncell)
      ierr=1
*
*     this subroutine gets stellar atmospheres from the Werner file
*     and interpolates on them, returning the flux in FLUX as
*     F_nu
*
      do j=1,6
        if( tval(j).le.temp.and.tval(j+1).gt.temp) j1=j
      end do
*
      i1=int(alogg)-4
      if (i1.eq.4) i1=3
      if (temp.eq.200000.) j1=6
      if (j1.lt.1.or.j1.gt.6.or.i1.lt.1.or.i1.gt.3) return
*     >>chng 97 may 13, get rid of branch to 1000
*     read(93,'(4000I7)',err=1000,rec=modnum(j1,i1))
      read(93,'(4000I7)',iostat=ierr,rec=modnum(j1,i1))
     1 (ivals(j),j=1,nWerner)
      if( ierr.ne.0 ) return
*     following must change if GetWerner changes
*999  FORMAT(4000i7)
*
      do j=1,nWerner
        flux1(j)=3.-float(ivals(j))/100000.
      end do
*
*     >>chng 97 jan 5, get rid of statement number
      if(lgTalk) then
        write(qq,'(''<<<< Klaus Werner stellar model '',i2,
     1  '' read in.  T_eff = '',F8.1,'' log(g) = '',F6.3,
     1  '' >>>>'')') modnum(j1,i1)-1,tval(j1),gval(i1)
      endif
*     >>chng 97 may 13, get rid of branch to 1000
*     read(93,'(4000I7)',err=1000,rec=modnum(j1,i1+1))
      read(93,'(4000I7)',iostat=ierr,rec=modnum(j1,i1+1))
     1 (ivals(j),j=1,nWerner)
      if(ierr.ne.0 ) return
      if(lgTalk) then
        write(qq,'(''<<<< Klaus Werner stellar model '',I2,
     1  '' read in.  T_eff = '',F8.1,'' log(g) = '',F6.3,
     1  '' >>>>'')') modnum(j1,i1+1)-1,tval(j1),gval(i1+1)
      endif
*     >>chng 97 jan 5, get rid of statement number
*     if(lgTalk)write(qq,960) modnum(j1,i1+1)-1,tval(j1),gval(i1+1)
      fr1=alogg-gval(i1)
      fr2=1.-fr1
      fr3=(temp-tval(j1))/(tval(j1+1)-tval(j1))
      fr4=1.-fr3
*
      do j=1,nWerner
        flux2(j)=3.-float(ivals(j))/100000.
      end do
*
      do j=1,nWerner
*       this is the interpolation between the two read in so far
        flux(j)=fr2*flux1(j)+fr1*flux2(j)
      end do
*
*     >>chng 97 may 13, get rid of branch to return
*     read(93,'(4000i7)',err=1000,rec=modnum(j1+1,i1))
      read(93,'(4000i7)',iostat=ierr,rec=modnum(j1+1,i1))
     1 (ivals(j),j=1,nWerner)
      if( ierr.ne.0 ) return
*
      do j=1,nWerner
        flux1(j)=3.-float(ivals(j))/100000.
      end do
*
      if(lgTalk) then
        write(qq,'(''<<<< Klaus Werner stellar model '',I2,
     1  '' read in.  T_eff = '',F8.1,'' log(g) = '',F6.3,
     1  '' >>>>'')') modnum(j1+1,i1)-1,tval(j1+1),gval(i1)
      endif
*     >>chng 97 jan 5, get rid of statement number
*     if(lgTalk)write(qq,960) modnum(j1+1,i1)-1,tval(j1+1),gval(i1)
*     >>chng 97 may 13, get rid of branch to return
*     read(93,'(4000i7)',err=1000,rec=modnum(j1+1,i1+1))
      read(93,'(4000i7)',iostat=ierr,rec=modnum(j1+1,i1+1))
     1 (ivals(j),j=1,nWerner)
      if( ierr.ne.0 ) return
*
      do j=1,nWerner
        flux2(j)=3.-float(ivals(j))/100000.
      end do
*
      if(lgTalk) then
        write(qq,'(''<<<< Klaus Werner stellar model '',I2,
     1  '' read in.  T_eff = '',F8.1,'' log(g) = '',F6.3,
     1  '' >>>>'')') modnum(j1+1,i1+1)-1,tval(j1+1),gval(i1+1)
      endif
*     >>chng 97 jan 5 get rid of statement numbers
*     if(lgTalk)write(qq,960) modnum(j1+1,i1+1)-1,tval(j1+1),gval(i1+1)
*
      do j=1,nWerner
        flux1(j)=flux1(j)*fr2+flux2(j)*fr1
      end do
*
*     NOW, ALLOW FOR THE TOTAL FLUX BEING SIGNIFICANTLY DIFFERENT BETWEEN THE
*     TWO SET OF FLUXES SINCE THE T_EFF VALUES ARE SIGNIFICANTLY DIFFERENT.
*     SCALE THINGS BY THE 4TH POWER OF T_EFF
*
      fact1=alog10(temp/tval(j1))*4.
      fact2=alog10(temp/tval(j1+1))*4.
*
      do j=1,nWerner
        flux(j)=fr4*(flux(j)+fact1)+fr3*(flux1(j)+fact2)
      end do
*
      call renor(wl,temp)
*     THIS CHECKS THE TOTAL FLUX AND SCALES IT TO MATCH THE SPECIFIED T_EFF
*     VALUE (ORDER 1% CHANGE AT WORST FROM MY TEST RUNS)
      ierr=0
*1000 return
      end
