******************************************************************************
      subroutine GetPunch( chCard )
      implicit none
*parse the punch command
      character*80 chCard
*
      include "limpun.par"
      include "nkrd.par"
      include "itrdim.par"
      include "cpunch.com"
      include "pnunit.com"
      include "input.com"
      include "punlst.com"
      include "ipdr.com"
      include "iph2.com"
      include "PunDef.com"
      include "levery.com"
      include "ZoneCnt.com"
      include "ioreco.com"
      include "optype.com"
      include "ioVerner.com"
      include "date.com"
      include "PunConv.com"
      include "PunPoint.com"
      include "Exemplar.com"
      include "PunRltType.com"
      include "IOqq.com"
*
*     local variables
*     warning!!! i is used as the fread pointer when if's begin
*     this MUST NOT be reset
      integer i , j
      real fread 
      integer ipu , nLabel , ierr
      character*4 chDst , chLabel*80
      logical lgEOL , lgMatch , lgOK , lgFile
*
*     this routine reads in the punch commands
*
      npunch = npunch + 1
      if( npunch.gt.limpun ) then
        write(qq,'(''(The limit to the number of PUNCH options is'',
     1  i3,''.  Increase LIMPUN if more are needed.'')') limpun
        stop
      endif
*     
*     option to only punch on last iteration
      if( lgMatch( 'LAST' , chCard ) ) then
        lgPunLstIter(npunch) = .true.
      else
        lgPunLstIter(npunch) = .false.
      endif
*
*     >>chng 96 dec 19, added following open
*     >>chng 97 july 1, move to before getting unit number so that
*clearing file name happens before unit scanned off
*     option to get file name to punch to, after opening it
      if( lgMatch( 'FILE' , chCard ) ) then
        call GetQuote( chLabel , nLabel, lgOK , chCard )
        lgFile = .true.
        if( .not.lgOK ) then
          write(qq,'('' name specified but no quotes encountered'')')
          stop
        endif
*       must end string with zero character
        chLabel(nLabel+1:nLabel+1) = char(0)
      else
        lgFile = .false.
      endif
*
      i = 5
      ipPnunit(npunch) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
*       iPunDef is set to 11 in ZERO, this prevents overwriting punch files
*       iPunDef points to next file
*       can be reset with set 'iPunDef' command
        ipPnunit(npunch) = iPunDef
        iPunDef = iPunDef + 1
      else
        ipu = ipPnunit(npunch)
        if( ipu.eq.5 .or. ipu.eq.6 ) then
          write(qq,'(''  This unit conflicts with standard '',
     1    ''FORTRAN IO'')')
          stop
        else if( ipu.le.0 ) then
          write(qq,'(''  Unit numbers <= 0 not allowed in Fortran'')')
          stop
        else if( ipu.ge.90 ) then
          write(qq,'(''  Unit numbers 90 not allowed by cloudy.'')')
          write(qq,'(''  These are needed for internal matters'')')
          write(qq,'(''  Sorry.'')')
          stop
        endif
      endif
*
*     we now have the io unit, and maybe the file name, let's open it
      if( lgFile ) then
*       open the file with the name generated above
        open( ipPnunit(npunch) , file=chLabel , iostat=ierr )
        if( ierr.ne.0 ) then
          write(qq,'('' GetPunch: some error encountered trying to'',
     1    '' open file '',a10,'' unit '',i3)') chLabel, ipPnunit(npunch)
          stop
        endif
      else
*       file name not specified
*       open the file, this line may need to be modified on some systems
*       exemplar has a bug
        if( .not.lgExemplar ) open( ipPnunit(npunch) )
      endif
*
*     put title of model on unit
      write(ipPnunit(npunch),'(a7,a75)') chVersion, chTitle
*
*     this must come first since elements appear as sub-keywords
      if( lgMatch( 'OPAC' , chCard ) ) then
        chPunch(npunch) = 'OPAC'
        if( lgMatch('TOTA' , chCard ) ) then
*         DoPunch will call popac to parse the subcommands
*         punch total opacity
          chOpcTyp = 'TOTL'
          write(ipPnunit(npunch),'(''     nu,       tot opac,    '',
     1''abs opac,     scat,      albedo'')')
        else if( lgMatch( 'FIGU' , chCard ) ) then
*         do figure for hazy
          chOpcTyp = 'FIGU'
          write(ipPnunit(npunch),'('' nu, H, He, tot opac'')')
        else if( lgMatch( 'GRAI' , chCard ) ) then
          chPunch(npunch) = 'DUSO'
*         punch grain opacity command in twice, here and above in opacity
          chDst = 'OPAC'
          write(ipPnunit(npunch),'(''   grain nu,  total,  absorpt,'',
     1    ''  scat'')')
        else if( lgMatch( 'SHEL' , chCard ) ) then
          chPunch(npunch) = 'OPAC'
*         punch subshell cross sections
          chOpcTyp = 'SHEL'
*         this is element
          punarg(npunch,1) = fread( chCard , i , 76 , lgEOL )
*         this is ion
          punarg(npunch,2) = fread( chCard , i , 76 , lgEOL )
*         this is shell
          punarg(npunch,3) = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) then
            write(qq,'('' there must be io unit, atom wght, ion, '',
     1      ''shell'')')
            stop
          endif
          write(ipPnunit(npunch),'('' sub shell cross section'')')
*       all of following produce n fort.n files, one for each stage of 
*       ionization.  The code stops after these files are produced.
        else if( lgMatch('HYDR' , chCard ) ) then
          chOpcTyp = 'HYDR'
        else if( lgMatch('HELI' , chCard ) ) then
          chOpcTyp = 'HELI'
        else if( lgMatch('LITH' , chCard ) ) then
          chOpcTyp = 'LITH'
        else if( lgMatch('BERY' , chCard ) ) then
          chOpcTyp = 'BERY'
        else if( lgMatch('BORO' , chCard ) ) then
          chOpcTyp = 'BORO'
        else if( lgMatch('CARB' , chCard ) ) then
          chOpcTyp = 'CARB'
        else if( lgMatch('NITR' , chCard ) ) then
          chOpcTyp = 'NITR'
        else if( lgMatch('OXYG' , chCard ) ) then
          chOpcTyp = 'OXYG'
        else if( lgMatch('FLUO' , chCard ) ) then
          chOpcTyp = 'FLUO'
        else if( lgMatch('NEON' , chCard ) ) then
          chOpcTyp = 'NEON'
        else if( lgMatch('SODI' , chCard ) ) then
          chOpcTyp = 'SODI'
        else if( lgMatch('MAGN' , chCard ) ) then
          chOpcTyp = 'MAGN'
        else if( lgMatch('ALUM' , chCard ) ) then
          chOpcTyp = 'ALUM'
        else if( lgMatch('SILI' , chCard ) ) then
          chOpcTyp = 'SILI'
        else if( lgMatch('PHOS' , chCard ) ) then
          chOpcTyp = 'PHOS'
        else if( lgMatch('SULF' , chCard ) ) then
          chOpcTyp = 'SULF'
        else if( lgMatch('SULP' , chCard ) ) then
          chOpcTyp = 'SULF'
        else if( lgMatch('CHLO' , chCard ) ) then
          chOpcTyp = 'CHLO'
        else if( lgMatch('POTA' , chCard ) ) then
          chOpcTyp = 'POTA'
        else if( lgMatch('ARGO' , chCard ) ) then
          chOpcTyp = 'ARGO'
        else if( lgMatch('CALC' , chCard ) ) then
          chOpcTyp = 'CALC'
        else if( lgMatch('SCAN' , chCard ) ) then
          chOpcTyp = 'SCAN'
        else if( lgMatch('TITA' , chCard ) ) then
          chOpcTyp = 'TITA'
        else if( lgMatch('VANA' , chCard ) ) then
          chOpcTyp = 'VANA'
        else if( lgMatch('CHRO' , chCard ) ) then
          chOpcTyp = 'CHRO'
        else if( lgMatch('MANG' , chCard ) ) then
          chOpcTyp = 'MANG'
        else if( lgMatch('IRON' , chCard ) ) then
          chOpcTyp = 'IRON'
        else if( lgMatch('COBA' , chCard ) ) then
          chOpcTyp = 'COBA'
        else if( lgMatch('NICK' , chCard ) ) then
          chOpcTyp = 'NICK'
        else if( lgMatch('COPP' , chCard ) ) then
          chOpcTyp = 'COPP'
        else if( lgMatch('ZINC' , chCard ) ) then
          chOpcTyp = 'ZINC'
        else
          write(qq,'('' There must be a second keyword on the'',
     1    '' opacity command.  Sorry.'')')
          write(qq,'('' Options are total, figure, grain, or element'',
     1    '' name.'')')
          stop
        endif
*
      else if( lgMatch( 'ABUN' , chCard ) ) then
        chPunch(npunch) = 'ABUN'
        write(ipPnunit(npunch),'('' abundances'')')
*
      else if( lgMatch( 'AGES' , chCard ) ) then
        chPunch(npunch) = 'AGES'
        write(ipPnunit(npunch),'('' ages'')')
*
      else if( lgMatch( 'ASSE' , chCard ) ) then
*       punch assert command does not function in this version  
        chPunch(npunch) = 'ASSE'
*
      else if( lgMatch( 'CHAR' , chCard ) ) then
        chPunch(npunch) = 'CHAR'
        write(ipPnunit(npunch),'('' charge exchange rate coefficnt'')')
*
      else if( lgMatch( 'COMP' , chCard ) ) then
        chPunch(npunch) = 'COMP'
        write(ipPnunit(npunch),'('' nu, comup, comdn'')')
*
      else if( lgMatch( 'COOL' , chCard ) ) then
        chPunch(npunch) = 'COOL'
        write(ipPnunit(npunch),'('' heat, cool, frac coolant '')')
*
      else if( lgMatch( 'CONT' , chCard ) ) then
*       option to set units for continuum energy in punch output
        if( lgMatch( 'NITS' , chCard ) ) then
          if( lgMatch( 'MICR' , chCard ) ) then
            chConPunEnr(npunch) = 'micr'
          else if( lgMatch( ' KEV' , chCard ) ) then
            chConPunEnr(npunch) = ' kev'
          else if( lgMatch( ' EV ' , chCard ) ) then
            chConPunEnr(npunch) = ' ev '
          else if( lgMatch( 'ANGS' , chCard ) ) then
            chConPunEnr(npunch) = 'angs'
          else if( lgMatch( 'RYDB' , chCard ) ) then
            chConPunEnr(npunch) = 'rydb'
          else
            write(qq,'('' I did not recognize units on this line.'')')
            write(qq,'('' Units are keV, eV, Angstroms, microns'')')
            stop
          endif
        else
          chConPunEnr(npunch) = 'ryd '
        endif
        if( lgMatch( 'BINS' , chCard ) ) then
*         continuum binning
          chPunch(npunch) = 'CONB'
          write(ipPnunit(npunch),'('' Continuum binning, energy, '',
     1    ''width of cells'')')
        else if( lgMatch( 'DIFF' , chCard ) ) then
*         diffuse continuum
          chPunch(npunch) = 'COND'
          write(ipPnunit(npunch),'('' Diffuse Continuum'')')
        else if( lgMatch( 'EMIT' , chCard ) ) then
*         emitted continuum
          chPunch(npunch) = 'CONE'
          write(ipPnunit(npunch),'(''     Enr      reflec '',
     1    ''    outward     total'')')
        else if( lgMatch( 'INCI' , chCard ) ) then
*         incident continuum
          chPunch(npunch) = 'CONC'
          write(ipPnunit(npunch),'('' Incident Continuum, Enr nFn '')')
        else if( lgMatch( 'INTE' , chCard ) ) then
*         continuum interactions
          chPunch(npunch) = 'CONi'
          write(ipPnunit(npunch),'('' Continuum interactions, inc, '',
     1    ''otslin. otscon, outcon, outlin '')')
*         this is option for lowest energy, if nothing then zero
          punarg(npunch,1) = fread( chCard , i , 76 , lgEOL )
        else if( lgMatch( 'IONI' , chCard ) ) then
*         ionizing continuum
*         optional number is lowest energy, 0 if no number
*         do not reset pointer since we want to scan off second number
*         this is option for lowest energy, if nothing then zero
          punarg(npunch,1) = fread( chCard , i , 76 , lgEOL )
*         this is option for smallest interaction to punch, 1 percent
          punarg(npunch,2) = fread( chCard , i , 76 , lgEOL )
	    if( lgEOL ) then
             punarg(npunch,2) = 0.01
	    endif
          chPunch(npunch) = 'CONI'
          write(ipPnunit(npunch),'('' Ionizing Continuum, nu, totl '',
     1    ''flux, flx*cs, frac(inc, otsl, otsc, out) rate/total, '',
     2    ''int so far'')')
        else if( lgMatch( 'OUTW' , chCard ) ) then
*         outward only continuum
          if( lgMatch('LOCA' , chCard ) ) then
            chPunch(npunch) = 'COLO'
            write(ipPnunit(npunch),'(''Local Out   SavOutCon  ''
     1      ,''outcon+line SvOt*opc pass*opc'')')
          else
            chPunch(npunch) = 'CONO'
            write(ipPnunit(npunch),'(''Out Con      OutIncid  OutConD'',
     1      ''   OutLinD   OutConS'')')
          endif
        else if( lgMatch( 'TRAN' , chCard ) ) then
*         transmitted continuum
          chPunch(npunch) = 'CONT'
          write(ipPnunit(npunch),'('' Transmitted Continuum'')')
        else if( lgMatch( ' RAW' , chCard ) ) then
*         "raw" continua
          chPunch(npunch) = 'CORA'
          write(ipPnunit(npunch),'(''Raw Con anu    flux, '',
     1    ''    otslin     otscon,    refcon     outcon     outlin'',
     2    ''     ContDiff '')')
        else if( lgMatch( 'REFL' , chCard ) ) then
*         reflected continuum
          chPunch(npunch) = 'CONR'
          write(ipPnunit(npunch),
     1    '('' Reflected      cont       line  '',
     1    ''     total        albedo    ConID'')')
        else
          chPunch(npunch) = 'CON '
          write(ipPnunit(npunch),'('' Cont nu    incident   trans'',
     1    ''    DiffOut  net trans   reflc     total   line cont'')')
        endif
*
      else if( lgMatch( 'CONV' , chCard ) ) then
*       punch reason model declared not converged
*       not a true punch command, since done elsewhere
        ipPunConv = ipPnunit(npunch)
        lgPunConv = .true.
        write(ipPunConv,'('' reason for continued iterations'')')
*       this does not count as a punch option (really)
        npunch = npunch - 1
*
      else if( lgMatch( 'CTHE' , chCard ) ) then
*       numbers about the local charge transfer heating/cooling
        chPunch(npunch) = 'CTHE'
        write(ipPunConv,
     1  '('' local charge transfer heating and cooling'')')
*
      else if( lgMatch( ' DR ' , chCard ) ) then
        ipDRout = ipPnunit(npunch)
        lgDROn = .true.
*       set punch last flag to whatever it was above
        lgDRPLst = lgPunLstIter(npunch)
        write(ipDRout,'('' Choice of zone thickness. '')')
*       this does not count as a punch option (really)
        npunch = npunch - 1
*
      else if( lgMatch( 'ELEM' , chCard ) ) then
        chPunch(npunch) = 'ELEM'
        call GetElem( chCard , j )
*       this will be the atomic number
        punarg(npunch,1) = j
        write(ipPnunit(npunch),'('' element structure, nelem='',i3)')j
*
      else if( lgMatch( 'FEII' , chCard ) ) then
*       punch out some stuff for Fred's FeII atom
        write(ipPnunit(npunch),'('' FeII rates '')')
        chPunch(npunch) = 'FEII'
*
      else if( lgMatch( 'GAMM' , chCard ) ) then
*       punch all photoionizaiton rates for all subshells
        write(ipPnunit(npunch),'('' Photoionization rates '')')
        chPunch(npunch) = 'GAMM'
*
      else if( lgMatch( 'GRAI' , chCard ) ) then
*       punch grains
        chDst = 'NONE'
        if( lgMatch( 'OPAC' , chCard ) ) then
          chPunch(npunch) = 'DUSO'
*         punch grain opacity command in twice, here and above in opacity
          chDst = 'OPAC'
          write(ipPnunit(npunch),'('' grain ext, abs, scat'')')
        else if( lgMatch('PHYS' , chCard ) ) then
          chPunch(npunch) = 'DUSP'
          chDst = 'PHYS'
          write(ipPnunit(npunch),'('' grain temp, charge,'',
     1    '' drift, frc heat, cool'')')
        else
          write(qq,'('' There must be a second key; they are '',
     1    '' OPAC and PHYS'')')
          stop
        endif
*
      else if( lgMatch( 'GAUN' , chCard ) ) then
        chPunch(npunch) = 'GAUN'
        write(ipPnunit(npunch),'('' Gaunt factors.'')')
*
      else if( lgMatch( 'HTWO' , chCard ) ) then
        ipPunH2 = ipPnunit(npunch)
        lgPunH2 = .true.
        write(ipPnunit(npunch),'('' H2 creation, destruction. '')')
*       this does not count as a punch option (really)
        npunch = npunch - 1
*
      else if( lgMatch( 'HEAT' , chCard ) ) then
        chPunch(npunch) = 'HEAT'
        write(ipPnunit(npunch),'('' htot, ctot, heat fracs'')')
*
      else if( lgMatch( 'HELI' , chCard ) ) then
        if( lgMatch('SING' , chCard ) ) then
          chPunch(npunch) = 'HEL1'
          write(ipPnunit(npunch),'(''he1    level,   simple,  ''
     1    ,''clhe2ov1  smhe2ov1   rec,     ioniz,    hei3 '')')
        else if( lgMatch(' ION' , chCard ) ) then
          chPunch(npunch) = 'HEL2'
          write(ipPnunit(npunch),
     1    '(''  z     HeII/a    simple    rec, '',
     1    ''    P ioniz,    coll     csupra '')')
        else if( lgMatch('TRIP' , chCard ) ) then
          chPunch(npunch) = 'HEL3'
          write(ipPnunit(npunch),'('' he3    level,    simple,    '',
     1    ''rec,     ioniz,    coll '')')
        else
          write(qq,'('' did not find a keyword on this '',
     1  '' line.  Keys are SING, _ION, and TRIP.'')')
         stop
        endif
*
      else if( lgMatch( 'HUMM' , chCard ) ) then
        chPunch(npunch) = 'HUMM'
        write(ipPnunit(npunch),'('' input to DHs routine.'')')
*
      else if( lgMatch( 'HYDR' , chCard ) ) then
*       punch hydrogen physical conditions
        if( lgMatch( 'COND' , chCard ) ) then
          chPunch(npunch) = 'HYDc'
          write(ipPnunit(npunch),'('' Hyd, DR,     Te,     HDEN,'',
     1    ''    EDEN,   HI/H,    ''
     1    ,''HII/H,   H2/H,     H2+/H,   H3+/H,   H-/H'')')
*       punch hydrogen ionization
        else if( lgMatch( 'IONI' , chCard ) ) then
          chPunch(npunch) = 'HYDi'
          write(ipPnunit(npunch),'(''   gam1    RecEff   HRecRad    '',
     1    ''hii/hi Shii/hi   hrec(13) dec grd  GamEff   ColEff'')')
*       punch hydrogen populations
        else if( lgMatch( 'POPU' , chCard ) ) then
          chPunch(npunch) = 'HYDp'
          write(ipPnunit(npunch),
     1   '(''   depth      HI      HII       HN'',51x,''2s       2p'')')
        else
          write(qq,'('' Punch hydrogen has options: CONDitions '',
     1    ''POPUlations and IONIzation.'')')
          stop
        endif
*
      else if( lgMatch( ' IP ' , chCard ) ) then
        chPunch(npunch) = ' IP '
        write(ipPnunit(npunch),
     1  '('' ionization potentials, valence shell'')')
*
      else if( lgMatch( 'LINE' , chCard ) ) then
*       options are punch line structure, line intensity, line array,
*       and line data
        if( lgMatch( 'STRU' , chCard ) ) then
*         this will be line structure, emissivity vs depth
          chPunch(npunch) = 'LINS'
          write(ipPnunit(npunch),'('' Emission line structure.'')')
*         read in the list of lines to examine
          call punlin( ipPnunit(npunch) , 'READ' , .false. )
        else if( lgMatch( 'CUMU' , chCard ) ) then
*         this will be integrated line intensity, fcn of depth
          chPunch(npunch) = 'LINC'
*         option for either relative intensity or abs luminosity
          if( lgMatch('RELA' , chCard ) ) then
            lgEOL = .true.
            write(ipPnunit(npunch),'('' Cumulative emission line '',
     1      ''relative intensity.'')')
          else
            write(ipPnunit(npunch),'('' Cumulative emission line '',
     1      ''absolute intensity.'')')
            lgEOL = .false.
          endif
*         read in the list of lines to examine
          call punlin( ipPnunit(npunch) , 'READ' , lgEOL )
        else if( lgMatch( 'DATA' , chCard ) ) then
*         punch line data
          chPunch(npunch) = 'LIND'
          write(ipPnunit(npunch),'('' Emission line data.'')')
        else if( lgMatch( 'ARRA' , chCard ) ) then
*         punch energies and luminosities of transferred lines
          chPunch(npunch) = 'LINA'
          write(ipPnunit(npunch),'('' Emission line array'')')
        else if( lgMatch( 'LABE' , chCard ) ) then
*         punch line labels
          chPunch(npunch) = 'LINL'
          write(ipPnunit(npunch),'('' Emission line array'')')
        else if( lgMatch( 'INTE' , chCard ) ) then
*         this will be full set of line intensities
          chPunch(npunch) = 'LINI'
          write(ipPnunit(npunch),'('' Emission line intensities'',
     1    '' per unit inner area'')')
          if( lgMatch( 'COLU' , chCard ) ) then
*           column is key to punch single column
            chPunRltType = 'column'
          else
*           array is key to punch large array
            chPunRltType = 'array '
          endif
          if( lgMatch( 'EVER' , chCard ) ) then
            LinEvery = fread( chCard , i , 76 , lgEOL )
            lgLinEvery = .true.
            if( lgEOL ) then
              write(qq,'('' There must be a second number,'',
     1        '' the number of zones to print.'')')
              stop
            endif
          else
            LinEvery = nend(1)
            lgLinEvery = .false.
          endif
        else
          write(qq,'('' This option for PUNCH LINE is something'',
     1    '' that I dont understand.  Line image follows.  Sorry.'')')
          write(qq,*) chCard
          stop
        endif
*
      else if( lgMatch( 'LYMA' , chCard ) ) then
        chPunch(npunch) = 'LYMA'
        write(ipPnunit(npunch),'('' Tau, N2/N1, Texc, Te, Tex/x'')')
*
      else if( lgMatch( ' MAP' , chCard ) ) then
        chPunch(npunch) = 'MAP '
        write(ipPnunit(npunch),'('' te, heating, cooling.'')')
*
      else if( lgMatch( 'MOLE' , chCard ) ) then
        chPunch(npunch) = 'MOLE'
        write(ipPnunit(npunch),'('' dr, h2/h CO/H, H2O/H, OH/H, CH/H''
     1  ,''O2/H'')')
*
      else if( lgMatch( 'OPTI' , chCard ) ) then
        chPunch(npunch) = 'OPTI'
        write(ipPnunit(npunch),'('' total, absorp, scat taus'')')
*
      else if( lgMatch( ' OTS' , chCard ) ) then
        chPunch(npunch) = ' OTS'
        write(ipPnunit(npunch),'('' otscon, lin, conOpac LinOpc'')')
*
      else if( lgMatch( 'OVER' , chCard ) ) then
*       punch overview of model results
        chPunch(npunch) = 'OVER'
        write(ipPnunit(npunch),'(''  depth     Te     Htot   '',
     1'' hden   eden   HI   HII   HeI  HeII  HeIII   C1    C2    C3'',
     1''    C4    O1  O2    O3    O4    O5    O6'')')
*
      else if( lgMatch( ' PDR' , chCard ) ) then
        chPunch(npunch) = ' PDR'
        write(ipPnunit(npunch),'('' depth   H colden   AV       Te   ''
     1  ,''   HI/HDEN  H2/HDEN   CI/C    CO/C    H2O/O'')')
*
      else if( lgMatch( 'PHYS' , chCard ) ) then
        chPunch(npunch) = 'PHYS'
        write(ipPnunit(npunch),'('' PhyC    Depth       Te,'',
     1  ''       HDEN,       Ne,       HTOT,      accel'')')
*
      else if( lgMatch( 'POIN' , chCard ) ) then
*       punch out the pointers
        ipPoint = ipPnunit(npunch)
        lgPunPoint = .true.
        write(ipPnunit(npunch),'('' pointers. '')')
*       this does not count as a punch option (really)
        npunch = npunch - 1
*
      else if( lgMatch( 'PRES' , chCard ) ) then
        chPunch(npunch) = 'PRES'
        write(ipPnunit(npunch),'('' pressure; depth, p(g+l) '',
     1  ''PresInit+pinteg  pgas(r0)  pgas  prad     integ,  conv?'')')
*
      else if( lgMatch( ' QS ' , chCard ) ) then
        chPunch(npunch) = ' QS '
        write(ipPnunit(npunch),'('' grain abs, scat, qs'')')
*
      else if( lgMatch( 'RADI' , chCard ) ) then
        chPunch(npunch) = 'RADI'
        write(ipPnunit(npunch),'('' NZONE, radius, r-r0, dr.'')')
*
      else if( lgMatch( 'RECO' , chCard ) ) then
        if( lgMatch( 'COEF' , chCard ) ) then
*         recombination coefficients for everything
*         ioreco set to zero in routine zero, non-zero value
*         is flag to punch recombination coefficients.
          ioreco = ipPnunit(npunch)
*     >>chng 96 nov 24, added following
*         this does not count as a punch option (really)
          npunch = npunch - 1
*
*     >>chng 96 nov 24, moved to subbrance of recom command
        else if( lgMatch( 'EFFI' , chCard ) ) then
*         punch recombination efficiency
          chPunch(npunch) = 'RECE'
          write(ipPnunit(npunch),'('' Recomn effic H, Heo, He+'')')
        else
          write(qq,'('' No option recognized on this punch '',
     1    ''recombination command'')')
          write(qq,'('' Valid options are COEFFICIENTS and '',
     1    ''EFFICIENCY'')')
          stop
        endif
*
      else if( lgMatch( 'RESU' , chCard ) ) then
        chPunch(npunch) = 'RESU'
        if( lgMatch( 'COLU' , chCard ) ) then
*         column is key to punch single column
          chPunRltType = 'column'
        else
*         array is key to punch large array
          chPunRltType = 'array '
        endif
*       do not change following, is used as flag in getlines
        write(ipPnunit(npunch),'('' results of calculation'')')
*
      else if( lgMatch( 'SOUR' , chCard ) ) then
        if( lgMatch( 'DEPT' , chCard ) ) then
*         print continuum source function as function of depth
          chPunch(npunch) = 'SOUD'
          write(ipPnunit(npunch),'('' continuum source function'',
     1    '' vs depth'')')
        else if( lgMatch( 'SPEC' , chCard ) ) then
*         print spectrum continuum source function at 1 depth
          chPunch(npunch) = 'SOUS'
          write(ipPnunit(npunch),'('' continuum source function'')')
        else
          write(qq,'('' A second keyword must appear on this line.'')')
          write(qq,'('' They are DEPTH and SPECTRUM.'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
*
      else if( lgMatch( 'SPEC' , chCard ) ) then
*       punch special, will call routine PunSpec
        chPunch(npunch) = 'SPEC'
        write(ipPnunit(npunch),'('' Special.'')')
*
      else if( lgMatch( 'TEGR' , chCard ) ) then
*       punch tegrid
        chPunch(npunch) = 'TEGR'
        write(ipPnunit(npunch),'('' zone, te, heat, cool.'')')
*
      else if( lgMatch( 'TEMP' , chCard ) ) then
        chPunch(npunch) = 'TEMP'
        write(ipPnunit(npunch),'('' DEPTH, te, dt/dr.'')')
*
      else if( lgMatch( 'TPRE' , chCard ) ) then
        chPunch(npunch) = 'TPRE'
        write(ipPnunit(npunch),'('' old temp, guess Tnew, new temp'')')
*
      else if( lgMatch( 'VERN' , chCard ) ) then
*       set punch last flag to whatever it was above
        lgFe2PLst = lgPunLstIter(npunch)
*       punch intensities from Verner FeII atom
        chPunch(npunch) = 'VERN'
        ioVerner = ipPnunit(npunch)
        ipHiVernFe2 = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
*         will reset downstream to number of current levels
          ipHiVernFe2 = 0
        else
          if( ipHiVernFe2.lt.1 ) then
            write(qq,'('' limit less than 1 now possible.'')')
            stop
          endif
        endif
*       short keyword makes punch half as big
        if( lgMatch( 'SHOR' , chCard ) ) then
          lgShortFe2 = .true.
        else
          lgShortFe2 = .false.
        endif
*       these results are actually created by the Fe2Lines routine
*       that lives in the KatyaFe2 file
        write(ioVerner,'('' Results from Verner FeII atom.'')')
*
      else if( lgMatch( 'WIND' , chCard ) ) then
        chPunch(npunch) = 'WIND'
        write(ipPnunit(npunch),'('' radius, DEPTH,vel, accel, '',
     1  ''force mul'')')
*
      else
        write(qq,'('' GetPunch cannot find a recognized keyword on '',
     1  ''this PUNCH command line.'')')
        stop
      endif
*
      end
