******************************************************************************
      subroutine GetTable( nqh , chCard , ar1 , nTabRead)
      implicit none
*parse the table read command
      character chCard*80
      integer nqh , nTabRead
      real ar1
*
      include "itrdim.par"
      include "ncfl.par"
      include "ncell.par"
      include "limspc.par"
      include "limext.par"
      include "limpar.par"
      include "nhlvl.par"
      include "HIonPot.par"
      include "bounds.com"
      include "conbug.com"
      include "trace.com"
      include "cflow.com"
      include "conism.com"
      include "genagn.com"
      include "crabcn.com"
      include "akn120.com"
      include "conrbn.com"
      include "terp.com"
      include "spec.com"
      include "sptype.com"
      include "rdfalt.com"
      include "spnorm.com"
      include "radius.com"
      include "range.com"
      include "varon.com"
      include "varang.com"
      include "nvary.com"
      include "vparm.com"
      include "vformt.com"
      include "nvfpnt.com"
      include "ninput.com"
      include "IOqq.com"
*
*     local variables
      logical lgLogSet , lgMatch , lgEOL , lgHit
      integer i , nstar , j , io, iabund
      real fac , fread , par1 , par2  , break,scale,alpha,
     1 brakmm,slopir,brakxr,slopxr
*
*     free statement numbers >=18
*
      nspec = nspec + 1
      if( nspec.gt.limspc) then
        write(qq,'(1X,I4,'' is too many spectra entered.'',
     1  ''  Increase LIMSPC'')') nspec
        stop
      endif
*
*     set flag telling interpolate
      chSpType(nspec) = 'INTER'
*
*     when adding more keys also change the comment at the end
*
      if( lgMatch('AGN ',chCard) ) then
*       do Mathews and Ferland generic AGN continuum
        do i=1,nagn
          tnu(nspec,i) = tnuagn(i)
          tslop(nspec,i) = tslagn(i)
        end do
        j = nagn - 1
*       optional keywork, to adjust IR cutoff
        if( lgMatch('BREA',chCard) ) then
           i = 4
           break = fread( chCard , i , 76 , lgEOL )
           if( lgEOL) then
             if( lgMatch(' NO ',chCard) ) then
               break = 1.02e-5
             else
               write(qq,'('' There must be a number for the break.'')')
               stop
             endif
           endif
           if( break.eq.0. ) then
             write(qq,'('' The break must be greater than 0.2 Ryd.'')')
             stop
           endif
           if( lgMatch('MICR',chCard ) ) then
*             optional keyword, ``microns'', convert to Rydbergs
              break = 0.0912 / break 
           endif
           if( break.lt.0. ) then
*             option to enter break as log10
              break = 10.** break
           else if( break.eq.0. ) then
              write(qq,'('' An energy of 0 is not allowed.'')')
              stop
           endif
           if( break.ge.tnu(nspec,3) ) then
              write(qq,'('' The energy of the break cannot be greater''
     1        ,'' than'',1P,E9.2,'' Ryd.'')') tnu(nspec,3)
              stop
           else if( break.le.tnu(nspec,1) ) then
              write(qq,'('' The energy of the break cannot be less'',
     1        '' than'',1P,E9.2,'' Ryd.'')') tnu(nspec,1)
              stop
           endif
           tnu(nspec,2) = break
           tslop(nspec,2) = tslop(nspec,3) +
     1     log10( tnu(nspec,3)/tnu(nspec,2) )
           tslop(nspec,1) = tslop(nspec,2) -
     1     2.5*log10( tnu(nspec,2)/tnu(nspec,1) )
        endif
*
      else if( lgMatch('AKN1',chCard) ) then
*       AKN120 continuum from Brad Peterson's plot
        do i=1,nkn120
          tnu(nspec,i) = tnuakn(i)
          tslop(nspec,i) = log10( fnuakn(i) )
        end do
        j = nkn120 - 1
*
      else if( lgMatch('CRAB',chCard) ) then
*       Crab Nebula continuum from Davidson and Fesen 1985 Ann Rev article
        do i=1,ncrab
          tnu(nspec,i) = tnucrb(i)
          tslop(nspec,i) = log10( fnucrb(i) )
        end do
        j = ncrab - 1
*
      else if( lgMatch('COOL',chCard) ) then
*       cooling flow from Johnstone et al. 1992, MN 255, 431.
        do i=1,ncfl
          tnu(nspec,i) = cfle(i)
          tslop(nspec,i) = cflf(i)
        end do
        j = ncfl - 1
*
      else if( lgMatch(' ISM',chCard) ) then
*       local ISM radiation field from Black 1987, Interstellar Processes
        do i=1,nism
          tnu(nspec,i) = tnuism(i)
          tslop(nspec,i) = fnuism(i) - tnuism(i)
        end do
        j = nism - 1
        i = 5
*       optional scale factor to change default luminosity
*       from observed value
*       assumed to be log if negative, and linear otherwise
        scale = fread( chCard , i , 76 , lgEOL )
        if( scale.gt.0. ) scale = log10( scale )
        nqh = nqh + 1 
        if( nqh.gt.limspc ) then
           write(qq,'(1X,I4,'' is too many continua entered.'',
     1     '' Increase LIMSPC'')') nqh
           stop
        endif
*       check that stack of shape and luminosity specifications
*       is parallel, stop if not - this happens is background comes
*       BETWEEN another set of shape and luminosity commands
        if( nspec.ne.nqh ) then
           write(qq,'('' This command has come between a previous '',
     1     ''ordered pair of continuum shape and luminosity commands.''
     2     ,/'' Reorder the commands to complete each continuum '',
     3     ''specification before starting another.'')')
           write(qq,'('' Sorry.'')')
           stop
        endif
        chRSpec(nqh) = 'SQCM'
        chSpNorm(nqh) = 'FLUX'
*       this will be flux density at 1 Ryd
*       >>chng 96 dec 18, from 1 ryd to H mass rydberg
*       >>chng 97 jan 10, had HLevNIonRyd but not defined yet
        range(nqh,1) = HIonPot
*       interpolted from Black 1987
        totpow(nqh) = -18.517 + scale
*       set radius to very large value if not already set
        if( radius.eq.0. ) then
          ar1 = rdfalt
          radius = 10.**ar1
        endif
*
      else if( lgMatch('POWE',chCard ) ) then
*        simple power law continuum between 10mincron and 50 kev
*        option to read in any slope for the intermediate continuum
         i = 5
         alpha = fread( chCard , i , 76 , lgEOL )
         if( lgEOL ) alpha = -1.
*        this is low energy for code
         tnu(nspec,1) = emm
         tslop(nspec,1) = -5
*
         lgLogSet = .false.
*        option to adjust sub-millimeter break
         brakmm = fread( chCard , i , 76 , lgEOL )
*        default is 10 microns
         if( lgEOL ) then
            lgLogSet = .true.
            brakmm = 9.115e-3
         else if( brakmm.eq.0. ) then
*           if second number on line is zero then set lower limit to
*           low-energy limit of the code.  Also set linear mode,
*           so that last number will also be linear.
            lgLogSet = .false.
            brakmm = tnu(nspec,1) * 1.001
         else if( brakmm.lt.0. ) then
*           if number is negative then this and next are logs
            lgLogSet = .true.
            brakmm = 10.** brakmm
         endif
         tnu(nspec,2) = brakmm
*        this is energy slope between low energy limit and this break
         slopir = 5./2.
         tslop(nspec,2) = tslop(nspec,1) +
     1      slopir * log10( tnu(nspec,2)/tnu(nspec,1) )
*
*        this is high energy limit to code
         tnu(nspec,4) = egamry
*
*        option to adjust hard X-ray break
         brakxr = fread( chCard , i , 76 , lgEOL )
*        default is 50 keV
         if( lgEOL ) then
            brakxr = 3676.
         else if( brakxr.eq.0. ) then
            brakxr = tnu(nspec,4) / 1.001
         else if( lgLogSet ) then
*           first number was negative this is a logs
            brakxr = 10.** brakxr
         endif
         tnu(nspec,3) = brakxr
*        alpha was first option on line, is slope of mid-range
         tslop(nspec,3) = tslop(nspec,2) +
     1     alpha*log10( tnu(nspec,3)/tnu(nspec,2) )
*
*        high energy range is nu^-2
         slopxr = -2.
         tslop(nspec,4) = tslop(nspec,3) +
     1     slopxr*log10( tnu(nspec,4)/tnu(nspec,3) )
*        following is number of portions of continuum
         j = 3
*
      else if( lgMatch('READ' , chCard ) ) then
        nTabRead = nTabRead + 1
        if( nTabRead.gt.1 ) then
          write(qq,'('' It is not possible to have more than 1 '',
     1    ''TABLE READ commands.'')')
          stop
        endif
*       set up eventual read of table of points previously punched by code
        i = 5
        io = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) io = 7
*       set flag saying really just read in continuum exactly as punched
        chSpType(nspec) = 'READ '
*       this will be flag saying continuum not read in here
        tslop(nspec,1) = 0.
        tslop(nspec,2) = io
*       nothing left to do here, better return
*       this file is actually read in by routine ReadTable
        return
*
      else if( lgMatch('RUBI',chCard) ) then
*       do Rubin modified theta 1 ori c
        do i=1,nrubin
          tnu(nspec,i) = tnurbn(i)
          tslop(nspec,i) = log10( fnurbn(i) )
        end do
        j = nrubin - 1
*
      else if( lgMatch('STAR',chCard ) ) then
*       TABLE STAR, numbers are temperature and log(g)
        i = 5
        par1 = fread( chCard , i , 76 , lgEOL )
*       option for log if less than or equal to 10
        if( par1.le.10. ) par1 = 10.**par1
        if( lgEOL ) then
          write(qq,'('' The stellar temperature MUST be entered.'')')
          stop
        endif
*       lgEOL is used in following logic to check whether grav set
        par2 = fread( chCard , i , 76 , lgEOL )
        if (lgMatch('ATLA',chCard)) then
*         this sub-branch added by Kevin Volk, to read in large
*         1991 grid of Kurucz atmospheres
*         default log(g) is 5 since all T_eff values have a model
*         for this log(g)
          if( lgEOL ) par2 = 5.0
          if( lgMatch('TRAC',chCard) ) then
            lgEOL = .true.
          else
            lgEOL = .false.
          endif
          call atlas(nstar,par1,par2,nspec,lgEOL)
*         set flag saying really just read in continuum exactly as punched
          chSpType(nspec) = 'VOLK '
          j=nstar-1
        else if (lgMatch('WERN',chCard)) then
*         this subbranch added by Kevin Volk, to read in large
*         grid of Kurucz atmospheres computer by Klaus Werner.
*         default log(g) is 8 since all T_eff values have a model
*         for this log(g)
          if( lgEOL ) par2 = 8.0
          call werne(nstar,par1,par2,nspec)
*         set flag saying really just read in continuum exactly as punched
          chSpType(nspec) = 'VOLK '
          j=nstar-1
*         >>chng 97 Aug 23, K Volk added Rauch stellar atmospheres
        else if (lgMatch('RAUC',chCard)) then
          if( lgEOL ) par2 = 8.0
          if (lgMatch('HALO',chCard)) then
            iabund=1
          else
            iabund=0
          end if
          call RauchMod(nstar,par1,par2,nspec,iabund)
*         set flag saying really just read in continuum exactly as punched
          chSpType(nspec) = 'VOLK '
          j=nstar-1
*         End of block (K Volk)
        else if( lgMatch('KURU',chCard ) ) then
*         only log(g) = 4 supported now in Kurucz
          if( lgEOL ) par2 = 4.
          call kurucz79( nstar , par1 , par2 , nspec )
          j = nstar - 1
        else if( lgMatch('MIHA',chCard ) ) then
*         only log(g) = 4 supported now in Mihalas
          if( lgEOL ) par2 = 4.
          call mihals( nstar , par1 , par2 , nspec )
          j = nstar - 1
        else
          write(qq,'('' There must be a second key on TABLE STAR; '',
     1    '' the options are ATLAS, KURUCZ, MIHALAS, RAUCH, and '',
     2    ''WERNER.'')')
          stop
        endif
*       vary option
         if( lgVarOn ) then
           nparm = nparm + 1
           if( lgMatch('ATLA',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 2
             chVarFmt(nparm) =
     1       '(''TABLE STAR ATLAS'',F9.5,'' log(g)='',F6.3)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10( 3500. )
             varang(2,nparm) = log10( 50000. )
           else if( lgMatch('WERN',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 2
             chVarFmt(nparm) =
     1       '(''TABLE STAR WERNER'',F9.5,'' log(g)='',F6.3)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10( 80000. )
             varang(2,nparm) = log10( 200000. )
           else if( lgMatch('RAUC',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 2
             chVarFmt(nparm) =
     1       '(''TABLE STAR RAUCH'',F9.5,'' log(g)='',F6.3)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10(  50000. )
             varang(2,nparm) = log10( 500000. )
           else if( lgMatch('KURU',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 1
             chVarFmt(nparm) =
     1       '(''TABLE STAR KURUCZ'',F9.5)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10( 30000. )
             varang(2,nparm) = log10( 50000. )
           else if( lgMatch('MIHA',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 1
             chVarFmt(nparm) =
     1       '(''TABLE STAR MIHALAS'',F9.5)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10( 30000. )
             varang(2,nparm) = log10( 55000. )
           endif
*          pointer to where to write
           nvfpnt(nparm) = nRead
*          log of temp will be pointer
           vparm(nparm,1) = log10( par1 )
           vparm(nparm,2) = par2
           vincr(nparm) = 0.1
         endif
      else
         write(qq,'('' There MUST be a keyword on this line. The keys ''
     1   ,''are: AGN, AKN120, _ISM, COOL, CRAB, '',
     2   ''POWERlaw, RUBIN, and STAR.  Sorry.'')')
         stop
      endif
*
*     table star werner and table star atlas are special
*     cases put in by Kevin Volk - they are not really tables
*     at all, so return if sptype is Volk
      if( chSpType(nspec) .eq. 'VOLK ' ) return
*
*     convert from log(Hz) to Ryd if first nu>5
      if( tnu(nspec,1).ge.5. ) then
         do i=1,j+1
           tnu(nspec,i) = 10.** (tnu(nspec,i)-15.51718)
         end do
      else if( tnu(nspec,1).lt.0. ) then
*        energies entered as logs
         do i=1,j+1
           tnu(nspec,i) = 10.**tnu(nspec,i)
         end do
      endif
*
*     tfac will be log(fnu) at that spot, read into tslop
      do i=1,j+1
        tfac(nspec,i) = tslop(nspec,i)
      end do
      do i=1,j
        tslop(nspec,i) = (tslop(nspec,i+1)-tslop(nspec,i)) /
     1  log10(tnu(nspec,i+1) / tnu(nspec,i))
      end do
*
      if( j+2.lt.ncell ) then
*        zero out remainder of array
         do i=j+2,ncell
           tnu(nspec,i) = 0.
         end do
      endif
*
      if( lgConBug.and.lgTrace ) then
         write(qq,'('' Table for this continuum; TNU, TFAC, TSLOP'')')
         write(qq,'(1P,3E12.4)')(tnu(nspec,i),tfac(nspec,i),
     1   tslop(nspec,i),i=1,j+1)
      endif
*
*     renormalize continuum so that quantity passes through unity
*     at 1 Ryd
      lgHit = .true.
      do i=1,j+1
        if( tnu(nspec,i).gt.1. ) then
          fac = tfac(nspec,i)
          lgHit = .false.
*         go to15
        endif
      end do
      if( lgHit ) then
        write(qq,'('' TABLE fails sanity test in table'')')
        stop
      endif
*15   continue
*
*     do the renormalization
      do i=1,j+1
        tfac(nspec,i) = tfac(nspec,i) - fac
      end do
*
      end
