******************************************************************************
      subroutine GrainRateDr( grfreqm, gropacm )
      implicit none
*called by nextdr to find grains heating rate dr
      real grfreqm , gropacm
      include "ncell.par"
      include "nhlvl.par"
      include "limelm.par"
      include "ndust.par"
      include "nh.com"
      include "opac.com"
      include "ots.com"
      include "widflx.com"
      include "rfield.com"
      include "Heavy.com"
      include "dstop.com"
      include "phycon.com"
      include "ffheat.com"
      include "tff.com"
      include "heat.com"
      include "IOqq.com"
*
*     local variables
      real xMax
      integer i , iplow
*
*     in all following changed from anu2 to anu  july 25 95
*
*     find maximum continuum interaction rate
*
*     not every continuum extends beyond C edge-this whole loop can add to zero
*     use total opacity here
*     test is to put in fir continuum if free free heating is important
      if( FreeFreeHeat/htot.gt.0.05 ) then
*       this is pointer to energy where cloud free free optical depth is unity
        iplow = ntff
      else
        iplow = ipHeavy(6,1)
      endif
      xMax = 0.
*     integrate up to heii edge
      do i=iplow,ipHeavy(2,2)
        if( anu(i)*flux(i)/widflx(i)*opac(i).gt.xMax)
     1    then
          xMax = anu(i)*flux(i)/widflx(i)*opac(i)
          grfreqm = anu(i)
          gropacm = opac(i)
        endif
      end do
*
*666  write(13,'(1p,3e10.2)') xMax , grfreqm , gropacm
*
*begin sanity check
      if( gropacm.le.0. .or. grfreqm.le.0. ) then
        write(qq,'('' GrainRateDr found non positive interaction, or '',
     1  ''energy.'')')
        write(qq,'('' This is impossible.'')')
        call ShowMe
        stop
      endif
*end sanity check
*
      end
