******************************************************************************
      subroutine hatom( chCard )
      implicit none
*parse information from the hydrogen command line
      character chCard*80
      include "nhlvl.par"
      include "dampon.com"
      include "TypMatrx.com"
      include "physok.com"
      include "redis.com"
      include "hydata.com"
      include "HTopOff.com"
      include "thlo.com"
      include "IOqq.com"
*
      logical lgMatch , lgEOL , lgTopSet
      save lgTopSet
      integer i
      real fread
      data lgTopSet/.false./
*
      if( lgMatch('COLL',chCard) ) then
*       option to turn hydrogen collisions off
        if( lgMatch(' OFF',chCard) ) then
          HColOn = 0.
          lgPhysOK = .false.
        endif
*
      else if( lgMatch('DAMP' , chCard ) ) then
*       turn off absorption due to lyalpha damping wings
        DampOnFac = 0.
*
      else if( lgMatch( 'LEVE',chCard)) then
*       number of levels for hydrogen at, 2s is this plus one
        i = 5
        nhlvl = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
*         must be a number, or key maximum
*         if no number but MAXIMUM or LIMIT or LARGE then set to parameter set
          if( lgMatch( 'MAXI',chCard).or.lgMatch( 'LIMI',chCard).or.
     1      lgMatch( 'LARG',chCard)) then
            nhlvl = lmhlvl
          else
*           punch out if no number
            call NoNumb(chCard)
          endif
        endif
        if( nhlvl.lt.4 ) then
          write(qq,'('' This would be too few levels.'')')
          stop
        else if( nhlvl.gt.lmhlvl ) then
          write(qq,'('' This would be too many levels.'')')
          write(qq,'('' The limit is set by LMHLVL='',i3)')lmhlvl
          stop
        endif
       if( .not. lgTopSet ) then
*        user did not set top off levels
         nHTopOff = nhlvl - 5
       endif
        if( nhlvl.lt.nHTopOff ) then
          write(qq,'('' Not possible to set nhlvl to less than '',
     1   ''top off='',i4)') nHTopOff
         stop
        endif
*
      else if( lgMatch( 'LOWE',chCard)) then
*       set lowest temp for departure coef
        i = 5
        thlo = fread( chCard , i , 76 , lgEOL )
        if( thlo.le.10. ) thlo = 10.**thlo
*
      else if( lgMatch( 'MATR',chCard)) then
*       which matrix inversion routine to use
        if( lgMatch( 'MATI',chCard)) then
*         this is matin1, the default
          chMatrix = 'matin1 '
        else if( lgMatch( 'LINP',chCard)) then
          chMatrix = 'linpack'
        else if( lgMatch( 'VECL',chCard)) then
          chMatrix = 'veclib '
        else
          write(qq,'('' The matrix inversion routines I know about'',
     1    '' are LINPACK, VECLIB, and MATIN1.'')')
          stop
        endif
*
      else if( lgMatch('REDI',chCard) ) then
*       set redistribution function either wind, incompl (default), or compl
        if( lgMatch(' COM',chCard) ) then
*         complete redistribution for la and all others
          chRedis = 'COMP'
        else if( lgMatch('INCO',chCard) ) then
*         incomplete redistribution for all resonance lines
          chRedis = 'INCO'   
        else
          write(qq,'('' MUST be either COMPLETE or INCOMPL'')')
          stop
        endif
*
      else if( lgMatch('TOPO',chCard) ) then
*       set lowest level for hydrogen atom top off
        i = 5
        nHTopOff = fread( chCard , i , 76 , lgEOL )
        if( nHTopOff.gt.nhlvl ) then
          write(qq,'('' Not possible to set nHTopOff to more than '',
     1    ''nhlvl='',i4)') nhlvl
          stop
        endif
        lgTopSet = .true.
        if( lgEOL ) call NoNumb(chCard)
        if( lgMatch( ' ADD',chCard)) then
*         add extra part
          chHTopType = ' add'
        else if( lgMatch( 'SCAL',chCard)) then
*         use scale factors
          chHTopType = 'scal'
        else
*         this is the default
          chHTopType = 'scal'
        endif
*
      else
        write(qq,'('' There should have been a keyword - STOP'')')
        stop
      endif
*
      end
