******************************************************************************
      subroutine hcolst
      implicit none
*evaluate collision rate for model hydrogen atom
      include "nhlvl.par"
      include "te1ryd.par"
      include "TePowers.com"
      include "c2pson.com"
      include "casbhs.com"
      include "hbug.com"
      include "trace.com"
      include "phycon.com"
      include "hlvcol.com"
      include "hydata.com"
      include "hcbr.com"
      include "hcolrt.com"
      include "phlevl.com"
      include "hstat.com"
      include "HPhoto.com"
      include "thlo.com"
      include "logte.com"
      include "IOqq.com"
      include "called.com"
      include "HdeltaT.com"
      include "HlteOk.com"
*
*     local variables
      integer level , lower , upper
      integer i,n,ilow,ihigh,iup,j
      real smeets,cs12s,cs12p,hsfac,hdexct,sum,
     1 told,f , cs2s,cs2p , cs
*
*     free statement labels, >=10
*
      data told/0./
*
*     define boltz facs between adjacent levels
      do iup=2,nhlvl
*       HdeltaTe is array of line temps, upper to lower
*       their boltzmann factors for this temp
        hlbolt(iup-1,iup) = exp(-dble(HdeltaTe(iup,iup-1)/te))
      end do
*     this is 1s-2s collision
      hlbolt(1,nhlvl+1) = hlbolt(1,2)
*
*     the highest level, up to the continuum
      hcbolt(nhlvl) = exp( -dble(HCionTe(nhlvl)/te) )
*
*     define remaining Boltzmann factors
      do j=1,nhlvl-2
        do i=j+2,nhlvl
          hlbolt(j,i) = hlbolt(j,i-1) * hlbolt(i-1,i)
        end do
      end do
      do i=1,nhlvl-1
        hcbolt(i) = hlbolt(i,nhlvl) * hcbolt(nhlvl)
      end do
*     2S to continuum
      hcbolt(nhlvl+1) = hcbolt(2)
*
*-------------------------------------------------------------
*
*     following factor is actually 4.14158E-16, but e- stat weight is in
      f = 2.0708e-16 / te32
      do i=1,nhlvl+1
        if( hcbolt(i).gt.1d-100 ) then
          hlte(i) = hstat(i) /  hcbolt(i) * f
        else
          hlte(i) = 0.
        endif
      end do
*
*     define HLTE(I) = lte population (cm^3) / Ne Np
*     only used in HLEVEL if Te>2500K, default value of THLO
      if( te.ge.thlo ) then
*       also 2s, thie n+1 level
*       induced recombination rate
        do i=1,nhlvl+1
*         induced recombination rate
          rinduc(i) = finduc(i) * hlte(i) 
*         coooing due to induced recombination
          cinduc(i) = cind(i) * hlte(i)
        end do
      else
        do i=1,nhlvl+1
          cinduc(i) = 0.
          rinduc(i) = 0.
        end do
      endif
*
*     now check for any zeros - if present then matrix cannot be used
      lgHlteOk = .true.
      do i=1,nhlvl+1
        if( hlte(i).le.0. ) lgHlteOk = .false.
      end do
*
*-----------------------------------------------------------------------
*     evaluate all needed collisional and rad rates
*     Johnson data set chosen, HD = 0.5, 
*     Vriems+Smeet data HD=1
*     collisions turned off, both =0.
*----------------------------------------------------------------------
*
*     collisional ionization, used for three body recombination
*     Vriens and Smeets collisional ionization data set
      do i=2,nhlvl
*       HColOn is option to turn off collisions, "hydrogen collis off" comnd
        hcolnc(i) = smeets(i) * HColOn
      end do
*     call colfit(1,1,0,te,hcolnc(1) )
*     >>chng 97 mar 19, to new data set
      call cfit(1,1,te,hcolnc(1) )
      hcolnc(1) = hcolnc(1) * HColOn
      hcolnc(nhlvl+1) = hcolnc(2) * HColOn
      if( lgCasBhs ) then
        hcolnc(1) = 0.
        hcolnc(2) = 0.
        hcolnc(nhlvl+1) = 0.
      endif
*
*     don't reevaluate downward coll if dT/T not large
      if( abs(te-told)/te .lt.0.002 .and.hcol(2,1).gt.0. ) then
        if( lgTrace ) write(qq,'(7X,''HCOLST called-no reval Cul'')')
*       (but still eval col below)
      else
        if( lgTrace ) write(qq,'(7X,''HCOLST called-will reeval Cul'')')
        told = te
*
        if ( lgC2psOn ) then
*         from Osterbrock's book, fit to 10,000K - 20,000K
*         >>chng 97 aug 5, broke electrons and protons apart using DEO's book
          hc2p2se = 5.738e-4 / ( te20*te20/te03 )
          hc2p2sp = 6.290e-4 /(te10*te05)
        else
          hc2p2se = 0.
          hc2p2sp = 0.
        endif
*
*       option to turn off  collisions frrom ground and n=2
        if( lgCasBhs .or. (HColOn.eq.0.) ) then
          hsfac = 0.
        else
          hsfac = 1.
        endif
*
*       new code via Kirk
        call h1cs123(1,2,te,cs12s)
        call h1cs123(1,3,te,cs12p)
*
*       C1N is deexcitation rate
*       following is 2P - 1S only
        hcol(2,1) = cs12p / sqrte * 8.629e-6 / 6. * hsfac
*       following is 2S - 1S only
        hc2s1s = cs12s / sqrte * 8.629e-6 / 2. * hsfac
*
*       hcol(u,l) is de-excitation rate from u to l
        call h1cs123(1,4,te,cs)
        hcol(3,1) = cs * hsfac * 8.629e-6/sqrte/18.
*       hcol2n(i) is rate from i to both 2s and 2p
        call h1cs123(2,4,te,cs2s)
        call h1cs123(3,4,te,cs2p)
        hcol(3,2) = (cs2s+cs2p) * hsfac * 8.629e-6/sqrte/18.
*
        do ihigh=4,nhlvl
          do ilow=1,ihigh-1
*           fill in with vriens and smeets data for collisional deexcitation
            hcol(ihigh,ilow) = hdexct(ihigh,ilow) * HColOn
          end do
        end do
*
*       case b hs does not include any collisions from n=1 or 2
        if( lgCasBhs ) then
          do ilow=1,2
*           do ihigh=ilow+1,nhlvl
*           >>chng 96 apr 25, for neg lev pops
            do ihigh=3,nhlvl
              hcol(ihigh,ilow) = 0.
            end do
          end do
        endif
*
        if( lgTrace.and.lgHBugFull) then
           write(qq,'(7X,''HCOLST rate n->n-1:'',1P,8E10.3,'' 2S1'',
     1     e9.2)') (hcol(i+1,i),i=1,8),hc2s1s
           write(qq,'(7X,''HCOLST col ion cof:'',1P,10E10.3)')
     1     (hcolnc(i),i=1,nhlvl+1)
           write(qq,'(7X,''HCOLST rate down 1:'',1P,9E10.3)') 
     1     (hcol(i,1),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 2:'',1P,9E10.3)')
     1     (hcol(i,2),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 3:'',1P,9E10.3)')
     1     (hcol(i,3),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 4:'',1P,9E10.3)')
     1     (hcol(i,4),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 5:'',1P,9E10.3)')
     1     (hcol(i,5),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 6:'',1P,9E10.3)')
     1     (hcol(i,6),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 7:'',1P,9E10.3)')
     1     (hcol(i,7),i=1,nhlvl)
           write(qq,'(7X,''HCOLST boltz fac c:'',1P,9E10.3,''2s'',
     1     e9.3)') (hcbolt(i),i=1,nhlvl+1)
           write(qq,'(7X,''Induce rec cooling:'',1P,9E10.3)')
     1     (cinduc(i),i=1,nhlvl)
           write(qq,'(7X,''HCOLST HLTE(i):    '',1P,10E10.3)')
     1     (hlte(i),i=1,nhlvl+1)
           write(qq,'(7X,''HCOLST       C2P2S='',1P,2E10.3)')
     1     hc2p2se+hc2p2sp
        endif
      endif
*
      if( hlte(1).gt.0. ) then
*
        hcoldn(1) = (hc2s1s*hlte(nhlvl+1) + hcol(2,1)*hlte(2))/hlte(1)
        do upper=3,nhlvl
          hcoldn(1) = hcoldn(1) + hcol(upper,1) * hlte(upper)/hlte(1)
        end do
        sum = 0.
*       logic for stat weights rechecked 95 nov 9
        do upper=3,nhlvl
          sum = sum + hcol(upper,2) * hlte(upper) /
     1    ( hlte(2) + hlte(nhlvl+1) )
        end do
        hcoldn(2) = sum + hcol(2,1)
        hcoldn(nhlvl+1) = sum + hc2s1s
        do level=3,nhlvl
          hcoldn(level) = 0.
          do lower=1,level-1
            hcoldn(level) = hcoldn(level) + hcol(level,lower)
          end do
          do upper=level+1,nhlvl
            hcoldn(level) = hcoldn(level) + 
     1      hcol(upper,level)* hlte(upper)/hlte(level)
          end do
        end do
*
        if( lgTrace.and.lgHBugFull) then
           write(qq,'(7X,''HCOLST hcoldn(i)      '',1P,10E10.3)')
     1     (hcoldn(i),i=1,nhlvl+1)
        endif
      else
        do n=1,nhlvl+1
          hcoldn(n) = 0.
        end do
      endif
*
      end
