******************************************************************************
      subroutine he3lev( he2ov3 )
      implicit none
*compute ionization balance level populations for helium triplets
      double precision he2ov3
*
      include "nhlvl.par"
      include "nta.par"
      include "nhe1lvl.par"
      include "nhe3lvl.par"
      include "itrdim.par"
      include "ncell.par"
      include "ipLnArry.par"
      include "iphl.com"
      include "ots.com"
      include "herec.com"
      include "ioptri.com"
      include "he3lte.com"
      include "he3c.com"
      include "phe1lv.com"
      include "he3bn.com"
      include "che2sn.com"
      include "edsqte.com"
      include "hetrpEXP.com"
      include "TePowers.com"
      include "he3as.com"
      include "d10830.com"
      include "he3rr.com"
      include "he3tuEXP.com"
      include "phycon.com"
      include "he.com"
      include "called.com"
      include "heinwd.com"
      include "he3n.com"
      include "he3gams.com"
      include "r2s3bd.com"
      include "he12on.com"
      include "trace.com"
      include "hebug.com"
      include "he3pht.com"
      include "he3hsv.com"
      include "cionhe.com"
      include "radius.com"
      include "he3rate.com"
      include "ZoneCnt.com"
      include "IOqq.com"
*
*     local variables
      logical lgNegPop
      integer i,j,nerror
      real out2,csphot,sum,dest,hlgam
*
      double precision zz(6,6) , ratio
*     free statement labels >= 9
*
*     NOTATION;
*     1-2S  2-2P  3-3S  4-3P  5-3D
*
      if( lgTrace.and.lgHe3Bug ) write(qq,'('' HE3LEV called.  HeI, '',
     1''HeII, HeIII='',1P,3E10.2)') hei , heii , heiii
*     last number was 1e-15 before 95 nov 14, changed to get ldl.in to work
*     several bugs present in following code, he3n was pop cm^-3, not rel
*     to ion
*
*     estimate simple he triplet population
      if( eden.gt.0. ) then
*       estimate of HeII/He3I
*       >>chng 96 oct 27, to exact expression from hazy
*    1  ( 0.365/(te*te10*te10) )
        she2ov3 = (1.+3110.*(te/1e4)**(-0.51)/eden) /
     1  (  5.79e-6*(te/1e4)**(-1.18) )
      else
        she2ov3 = 0.
      endif
      if(.not.lgHe1ON .or. heii.lt.1e-20 ) then
        do i=1,nhe3lvl
          he3n(i) = 0.
*         >>chng 96 july 16, was set to 0, change to 1
          he3bn(i) = 1.
        end do
        he2ov3 = she2ov3
        hei3 = heii/he2ov3
        he3local = 0.
        he3relax = 1.
*       >>chng 96 july 12, following ratio was inverted, fixed 90.01
*       he3n(1) = he2ov3
        if( he2ov3.gt.1e-25 ) then
*         this is ratio of 23S to ion
          he3n(1) = 1./he2ov3
        else
          he3n(1) = 0.
        endif
        he3hsv(1) = 0.
        he3hsv(2) = 0.
        He3IonCool = 0.
        p2s = he3n(1) * heii
        p2p = 0.
        p3s = 0.
        p3p = 0.
        p3d = 0.
        p10830 = 0.
        he10in = 0.
        p5876 = 0.
        p7065 = 0.
        p3889 = 0.
        he3clx = 0.
        if(lgTrace.and.lgHe3Bug) then
          write(qq,'('' HE3LEV return, all neutral, ''
     1    ,''hei3, he3n(1)='',1p,2e10.2)') hei3,he3n(1)
        end if
        return
      endif
*
*     following are recombination to various levels
      zz(1,nhe3lvl+1) = (r2s+r2s3bd)*eden + he1n(1)*csg2s +
     1 he12s*cs2s2s + he12p*cs2p2s
*
      zz(2,nhe3lvl+1) = (r2p+r2p3bd)*eden + he1n(1)*csg2p +
     1 he12s*cs2s2p + he12p*cs2p2p
*
      zz(3,nhe3lvl+1) = r3s*eden
      zz(4,nhe3lvl+1) = r3p* eden
      zz(5,nhe3lvl+1) = r3d* eden
*
*     level 1= 2s balance equation
      zz(1,1) = c2s2p+c2s3s+c2s3p+c2s3d+he3gam(1)+c2sg+a2sg+
     1 c2sion + c2ss2s + c2ss2p
      out2 = he3gam(1)+c2sg+a2sg+c2sion + c2ss2s + c2ss2p
*     fix simple estimate by this factor
*     >>chng 96 oct 21, c2sion had been in he3relax and not in he3local
      he3local = (he3gam(1)+c2sion)/out2
      he3relax = (c2sg+a2sg + c2ss2s + c2ss2p) / out2
      she2ov3 = she2ov3 / he3relax
      collhe3 = out2 - he3gam(1)
      if( he3local .gt.he3pht ) then
*       remember fraction of exits due to photoionizatino, Lya
        he3pht = he3local
        he3lya = csphot( iphl(2,1) , nhei3 , ioptri )*otslin(iphl(2,1))/
     1  (he3gam(1)+c2sion)
      endif
      zz(1,2) = -( r10830 + c2p2s )
      zz(1,3) = -c3s2s
      zz(1,4) = -(a3889+c3p2s)
      zz(1,5) = -c3d2s
*
*     level 2=2p balance equation
      zz(2,2) = c2p2s+r10830+a591+he3gam(2)+c2p3s+c2p3d+c2p3p+
     1 c2pg + c2pion + c2ps2s + c2ps2p
      zz(2,1) = -c2s2p
      zz(2,3) = -(a7065+c3s2p)
      zz(2,4) = -c3p2p
      zz(2,5) = -(a5876+c3d2p)
*
*     level 3=3s balance equation
      zz(3,3) = (a7065 + c3s2p + c3s2s )
      zz(3,1) = -c2s3s
      zz(3,2) = -c2p3s
      zz(3,4) = -a4
      zz(3,5) = 0.
*
*     LEVEL 4=3P BALANCE EQUATION
      zz(4,4) = (a4 + a3889 + c3p2s + c3p2p )
      zz(4,1) = -c2s3p
      zz(4,2) = -c2p3p
      zz(4,3) = 0.
      zz(4,5) = -a19
*
*     LEVEL 5=3D BALANCE EQUATION
      zz(5,5) = (c3d2s + c3d2p + a5876 + a19 )
      zz(5,1) = -c2s3d
      zz(5,2) = -c2p3d
      zz(5,3) = 0.
      zz(5,4) = 0.
*
      do j=1,nhe3lvl
        ratio = 1. / zz(j,j)
        do i=1,nhe3lvl+1
          zz(j,i) = zz(j,i) * ratio
        end do
      end do
*
      call matin1( zz,6,5,1,nerror)
      if(nerror.ne.0) then
        if( lgCalled ) then
          lgBusted = .true.
          return
        else
          write(qq,'('' he i matrix error.'')')
          stop
        endif
      endif
*
*     HE3N(i) must always be population/HeII
      he3n(1) = zz(1,6)
      p2s = he3n(1) * heii
*
      he3n(2) = zz(2,6)
      p2p = he3n(2) * heii
      he3n(3) = zz(3,6)
      p3s = he3n(3) * heii
      he3n(4) = zz(4,6)
      p3p = he3n(4) * heii
      he3n(5) = zz(5,6)
      p3d = he3n(5) * heii
*
      sum = 0.
      lgNegPop = .false.
      do i=1,nhe3lvl
        if( he3n(i).le.0. ) lgNegPop = .true.
        sum = sum + he3n(i)
        if(he3lte(i).gt.0. ) then
          he3bn(i) = he3n(i) / he3lte(i) / eden
        else
          he3bn(i) = 1.
        endif
      end do
*
*     make sure all pops are positive
      if( lgNegPop ) then
        write(qq,'('' negative helium triplet populations, zone'',i4)')
     1  nzone
        write(qq,'('' pops are'',i4)')he3n
        call ShowMe
      endif
*
      if( sum.gt.0. ) then
        he2ov3 =  1. / sum
      else
        he2ov3 = 0.
      endif
*
      p10830 = p2p*a10830*1.84e-12
      he10in = p10830 * t10830(ipLnInwd)
      p5876 = p3d*a5876 * 3.39e-12
      p7065 = p3s*a7065*2.82e-12
      p3889 = p3p*a3889*5.12e-12
*
*     total collisional excitation cooling of triplet lines
      he3clx = (p2s*c2s2p-p2p*c2p2s)*1.84e-12
     1 + (p2s*(c2s3s+c2s3p+c2s3d)- p3s*c3s2s-p3p*c3p2s-p3d*c3d2s)*5e-12
     1 + (p2p*(c2p3s+c2p3d)-p3s*c3s2p-p3d*c3d2p) * 3e-12
*
*     collisional ionization cooling
*     c2sion, c2pion, both already have eden included
*     >>chng 96 july 15, added cor for 3 body heating
      He3IonCool = p2s*c2sion*(1.-1./he3bn(1))*7.735e-12 +
     1          p2p*c2pion*(1.-1./he3bn(2)) * 5.8018e-12
*
      if( lgTrace.and.lgHeBug ) then
        write(qq,'(5X,''HeI tri gam'',1P,E9.2,'' rec'',E9.2,'' 3bd'',
     1  E9.2,'' cion2S'',E9.2,'' col 23S-sin'',E9.2)')
     2  he3gam(1) , rectri, r2s3bd+r2p3bd , c2sion ,
     3  (c2ss2s+c2ss2p)/eden
        if(lgHe3Bug)write(qq,'(5X,''HeI tri lev'',1P,10e8.1)') he3n,
     1  (he3n(i)/he3n(1),i=1,5)
*
        dest = c2sion + he3gam(1) + c2ss2s + c2ss2p + a2sg
        if( dest.gt.0. ) then
          hlgam = otslin(iphl(2,1))
          write(qq,'(5X,''HeI3 dest frc; col-ion'',1P,E9.2,'' H Ly-a''
     2    ,E9.2,'' C+A to sing'',E9.2)')
     3    c2sion/dest,hlgam*1.97e-18/dest,(c2ss2s+c2ss2p+a2sg)/dest
        else
          write(qq,'(5X,''HeI3 no dest rates'')')
        endif
      endif
      if( he2ov3.le.0. ) then
        write(qq,'('' HE3LEV finds relative population <=0;'',1P,
     1  e10.3)') he2ov3
        stop
      endif
      if( lgTrace.and.lgHeBug ) then
        write(qq,'(5X,''HE3LEV returns; HE2OV3='',1P,E9.2,'' simple='',
     1  e9.2,'' relx'',e9.2,'' pops'', 6e9.1)')
     1 he2ov3,she2ov3,he3relax,he3n
      endif
*
      end
