******************************************************************************
      subroutine hlevel( h2ovh1 , simhii , csupeff)
      implicit none
*solve for ionization balance level populations of model hydrogen atom
      double precision h2ovh1
      real simhii , csupeff
*
      include "en1ryd.par"
      include "nhlvl.par"
      include "limelm.par"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "hnet.com"
      include "hlvcol.com"
      include "bowoi.com"
      include "hrc2sp.com"
      include "hcolrt.com"
      include "x12.com"
      include "shullc.com"
      include "colion.com"
      include "hipop2.com"
      include "hionon.com"
      include "HPhoto.com"
      include "called.com"
      include "hbug.com"
      include "chrex.com"
      include "trace.com"
      include "TePowers.com"
      include "h.com"
      include "htau.com"
      include "phycon.com"
      include "phlevl.com"
      include "hex.com"
      include "hcbr.com"
*     include "hbn.com"
      include "hstat.com"
      include "thlo.com"
      include "rin2ph.com"
      include "htotrc.com"
      include "hcaseb.com"
      include "hgdist.com"
      include "logte.com"
      include "HNIonRyd.com"
      include "HdeltaT.com"
      include "dcool.com"
      include "TrConvg.com"
      include "HlteOk.com"
      include "HColRec.com"
      include "DestCrt.com"
      include "TypMatrx.com"
      include "HRateDest.com"
      include "BigSec.com"
      include "totnuc.com"
      include "rcota.com"
      include "HCTOnOff.com"
      include "MtrxOff.com"
      include "LevTrace.com"
      include "IOqq.com"
*
*     local variables
      real colfac,h2s,phtfrc,topoff,above,below,
     1 x12p,x12s,x13,x14,edp,r2p2s,edhi,rfac, colfrc
      real colsup(lmhlvl+1)
      integer i,nerror,j,lev,iup,low , job
      integer level, lower , upper , ipiv(lmhlvl+1)
      real totcap(lmhlvl+1) , hexx(lmhlvl+1) , RadSum , secfrc 
      double precision z(lmhlvl+2,lmhlvl+2),c,rm1 , save ,
     1 SaveZ(lmhlvl+2,lmhlvl+2) , error(lmhlvl+1) ,
     2 amat(lmhlvl+1,lmhlvl+1), bvec(lmhlvl+1) , rcond, work(lmhlvl+1)
      integer nzUsed
      save nzUsed
      data nzUsed/-1/
*
*     2S LEVEL IS LEVEL TEN; Z(2,I) IS 2P, Z(10,I) = 2S, HN(2) IS SUM
*     free statement labels >=12
*
*-----------------------------------------------------------------------
      lgHColionImp = .false.
      lgHColRec = .false.
*     charge transfer charge exchange
      if( nzone.le.1 .or. CTHrec(2)*CTHion(2).eq.0. ) then
        if( nzUsed.ne.nzone ) then
*         this is zone 0, the first time hydro is called
*         ct rates have not been evaluated yet by the heavies
          CTHrec(2) = 0.
          CTHion(2) = 0.
        else
          CTHrec(2) = CTHrec(1) * HCTOn
          CTHion(2) = CTHion(1) * HCTOn
        endif
      else if( nzone.ne.nzUsed ) then
*     >>chng 96 May 17 bring back into main loop
        CTHrec(2) = CTHrec(2)*0.75 + 0.25*CTHrec(1) * HCTOn
        CTHion(2) = CTHion(2)*0.75 + 0.25*CTHion(1) * HCTOn
      endif
*
*     if(cthion(2).gt.0. .and. nzUsed.ne.nzone ) then
*       write(70,'(i4,1p,12e10.2)') nzone, cthrec(2),cthion(2),
*    1  (cthionAgnt(i)/cthion(2),i=1,3)
*     endif
      nzUsed = nzone
      if( lgTrConvg .and.nLevTrace.eq.0 ) then
        write(qq,'(7x,''hlevel, te:'',1p,e9.3,'' eden:'',e9.3)') te,eden
      endif
*     check how low temperature is; departure coef tend to infinity
*     as TE goes to zero; matrix formalism won't work on a 32-bit machine
*     if EXP(H NU/KT) > 1E38 for 13.6EV.
*     the recombination coefficient is effect radiative (only) rec
*     coef (optical depths in)
*     this is first eval of destroy, not with balmer cont since hn(2)/hnn(1)
*     may div by 0 - a second evaluation occurs after solun of matrix
*     with this term
*     code will not get to that evaluation if low te used
*     csupeff is effective suprathermal ionizaiton rate
*     deep in x-ray illuminated clouds most sec ion are result of
*     O k-shell photoionization.  Cannot reevalute this directly
*     when ne changes slightly, so use simple scaling
*     csuEfrac was elec frac when csupra last evaluated
*     >>chng 97 aug 26, get rid of following since now only 1 eval per ion loop
*     csupeff = csupra * ((eden/totnuc)/csuEfrac)**(-0.42)
*     no longer necessary since within eden loop
      csupeff = csupra
*     the above did not work, since H got out of sync
*     with current value of csupra
*
      csupeff = csupra
*
*     total 2p2s rate
*     r2p2s = hc2p2s * edp
      r2p2s = hc2p2se * eden + hc2p2sp * hii
*
      destroy(1,1) = hgamnc(1)+csupeff+hcolnc(1)*eden 
      create(1,1) = eden * htotrc
      edhi = eden + hi * 1.7e-4
*
*     sum up decays
      do level=1,nhlvl
        RadSum = 0.
        do lower=1,level-1
          RadSum = RadSum + hnet(level,lower)
        end do
        hradn(level) = RadSum
      end do
*
      simhii = (hgamnc(1)+csupeff+hcolnc(1)*edhi+CTHion(2)) /
     1 (eden*(htotrc+CotaRate(1)) +CTHrec(2))
      if( simhii.gt.0. ) then
        phtfrc = hgamnc(1)/((eden*(htotrc+CotaRate(1))+
     1  CTHrec(2))*simhii)
        colfrc = (hcolnc(1)*edhi+CTHion(2))/
     1  ((eden*(htotrc+CotaRate(1))+CTHrec(2))*simhii)
        secfrc = csupeff/
     1  ((eden*(htotrc+CotaRate(1))+CTHrec(2))*simhii)
        if(secfrc.gt.0.2 ) then
*         flag to say that sec ioniz is a big deal, do not
*         let eden change by much
          lgBigSec = .true.
        else
          lgBigSec = .false.
        endif
*       override above logic, which should probably be removed.
*       sec rate now changes with elec density
        lgBigSec = .false.
      else
      lgBigSec = .false.
        phtfrc = 0.
        colfrc = 0.
        secfrc = 0.
      endif
      if( lgHBug.and.lgTrace ) then
        write(qq,'(5x,''HLEVEL called, simple II/I=''
     1  ,1P,E10.4,'' PhotFrc:'',E10.4,'' ColFrc:'',E10.4,'' SecFrc'',
     2  e10.4,'' Te:'',e10.4,'' eden:'',e10.4)') simhii,phtfrc,colfrc,
     3  secfrc,te , eden
      end if
*     don't bother if no ionizing radiation
      if( simhii.lt.1e-30 ) then
        lgHMtrxOff = .true.
        if(lgHBug.and.lgTrace ) then
          write(qq,'(5X,''HLEVEL simple II/I='',1P,
     1    E10.2,'' so not doing equilibrium.'')') simhii
        end if
        lgHIonON = .false.
        do i=1,nhlvl+1
          hbn(i) = 1.
          hn(i) = 0.
        end do
        hn2p = 0.
        hn2s = 0.
        HRecEffec = 0.
        hex = 0.
        dhexdt = 0.
        h2ovh1 = 0.
        return
      endif
*
*     sec term added May 93 for cr ionized, mostly neutral, warm gas
*     originally was 1e-9, change to 1e-7 for pdr non-convergence
*     last one is check that HLTE pops are non-zero
*     >>chng 96 may 8, for dense models close to lte all ionizations can be from
*     excited states, and simple and actual pops are very different.
*     code used simple all the time, caused catastrophe for Kingdon nova model.
*     now use actual pops if we are into model
      if( nzone.gt.2 ) then
        rfac = h2ovh1
      else
        rfac = simhii
      endif
*     if( te.le.thlo .or. simhii.lt.1e-7 .or. (.not.lgHlteOk) ) then
*     >>chng 96 may 8, from simhii to rfac
*     >>chng 96 aug 22, added test on lgHMtrxOff, whether or not matrix ever turned off
*     this avoids possible discontinuity where approximations change
      if( te.le.thlo .or. rfac.lt.1e-7 .or. (.not.lgHlteOk) .or.
     1 lgHMtrxOff ) then
        if( lgHBug.and.lgTrace ) then
          if(te.le.thlo)write(qq,'('' H matrix not used, te too low'')')
          if(rfac.lt.1e-7)write(qq,'('' H matrix not used, H too '',
     1    ''neutral'')')
          if(.not.lgHlteOk)write(qq,'('' H matrix not used, Hlte '',
     1    ''not ok'')')
          if(.not.lgHMtrxOff)write(qq,'('' H matrix turned off '')')
          if(.not.lgHMtrxOff)write(qq,*)' h matrix turned off2, simhii',
     1    simhii
        endif
        lgHMtrxOff = .true.
        nhlo = nhlo + 1
*       following is case b rec coef
        HRecEffec = hrec(1,1)*hrec(1,2) + HRecRad + CotaRate(1)
*
*       do radiative only cascades
        topoff = 0.
        do lev=nhlvl,3,-1
*         radiative rec plus three body rec
          above = (hrec(lev,1)*hrec(lev,2) +
     1    hcolnc(lev)*hlte(lev)*eden )*eden
          topoff = topoff + above
          do iup=lev+1,nhlvl
*           hlev(lev,low) is A * esc prob
            above = above + hn(iup)*(hnet(iup,lev) + hcol(iup,lev)*eden)
          end do
          below = 0.
          do low=1,lev-1
            below = below + hnet(lev,low) + hcol(lev,low)*eden
          end do
          if( below.gt.1e-25 ) then
            hn(lev) = above / below
          else
            hn(lev) = 0.
          endif
          if( hlte(lev).gt.1e-25 ) then 
            hbn(lev) = hn(lev) / (hlte(lev) * eden )
          else
            hbn(lev) = 0.
          endif
        end do
*
        topoff = topoff + 
     1   (hrec(2,1)*hrec(2,2) + hcolnc(2)*hlte(2) )* eden +
     1   (hrec(nhlvl+1,1)*hrec(nhlvl+1,2) +
     1   hcolnc(nhlvl+1)*hlte(nhlvl+1) )* eden +
     1   (hrec(1,1)*hrec(1,2) + hcolnc(1)*hlte(1) )* eden
*
*       do simple two level for hydrogen, then fill in HN(i) for rest
*       above in below is tot rec
        hn(1) = (topoff+CTHrec(2))/(hgamnc(1)+csupeff+hcolnc(1)*
     1  (eden+hi/1e4)+CTHion(2))
*       H beta recombination, assuming case B
*       HN(4) = (HRecRad*0.0912) * EDEN / HEMIS(4,2)
*       hbeta = (10.**(-20.89-0.10612*(alogte-4.4)**2))/te*eden
*       hn(4) = hbeta / hemis(4,2) / 4.093e-12
*       const = hn(4) * hemis(4,2)
*       renormalized to agree with matrix at 1000K
*       hn(3) = const * 14.5 / te10/te03/te03*te01 / hemis(3,2)*0.6645
*       hn(5) = const * 0.291 * te03 * te01 / hemis(5,2)*1.2645
*       hn(6) = const * 0.138 * te03*te01*te01 / hemis(6,2)*1.516
        x12p = x12 * 2. / 3. / 1.261
        x12s = x12 * 1. / 3. / 1.261
        x13 = x12 * 0.165 / 1.261
        x14 = x12 * 0.059 / 1.261
* 666 error! put this in above
*       hn(3) = hn(3) + hn(1)*x13/(hemis(3,2)+hemis(3,1))
*       hn(4) = hn(4) + hn(1)*x14/(hemis(4,3)+hemis(4,2)+
*    1  hemis(4,1))
        edp = (eden * 0.1  +  hii * 0.9 )
        hn2s = (HRecRad*0.33*eden + hn(1)*x12s + hn2p*r2p2s ) /
     1  (8.23+hc2s1s*edhi + r2p2s*6. ) 
        hn2p = ( HRecRad*0.67*eden + hn(1)*x12p + hn2s*r2p2s*6. ) /
     1  ( hnet(2,1) + hcol(2,1)*eden + r2p2s )
        hn(2) = hn2s + hn2p
        h2ovh1 = 1. / ( hn(1)+hn(2)+hn(3)+hn(4)+hn(5)+hn(6) )
*       following used for collisional ioniz cooling
*       hex will be multiplied by HII in coolr
        hex = en1ryd * hcolnc(1) * (eden+hi*1.7e-4) * hn(1)
        dhexdt = 0.
*
        if( lgHBug.and.lgTrace ) then
          write(qq,'(7X,''LOW TE,='',1P,E10.3,
     1    '' HN(1)='',E10.3,'' rec='',E10.3,'' Hgamnc(1)='',E10.3
     2    )') te , hn(1) , HRecEffec , hgamnc(1)
        endif
        if( lgTrace ) then
          write(qq,'(7X,''HLEVEL return, LOW TE used, HII/HI='',1P,
     1    e10.3,'' simple='',E10.3,'' IonRate='',E10.2,'' RecCo=''
     2    ,e9.2,'' chrex,d'',2e9.2)') h2ovh1 , simhii ,
     3    hgamnc(1)+csupeff+hcolnc(1)*eden,topoff,CTHrec(2),
     4    CTHion(2)
        endif
        return
      endif
*-------------------------------------------------------------------
*
*     radiative and three body rec, fix 2s and 2p first
*     HLTE(i) is only LTE pop when mult by Ne Nh
*
      HRecEffec = 0.
      do i=1,nhlvl+1
        z(i,nhlvl+2) = (dble(hrec(i,1)*hrec(i,2))+
     1  dble(rinduc(i)))/hlte(i) + dble(hcolnc(i)*edhi)
*       >>chng 97 july 25, had been eden changed to edhi, since coll ionize
*       is edhi, caused slight departures from true lte in very dense models
*    1  dble(rinduc(i)))/hlte(i) + dble(hcolnc(i)*eden)
        totcap(i) = z(i,nhlvl+2) * hlte(i)
        HRecEffec = HRecEffec + totcap(i)
      end do
*
*     add on charge transfer recombination
      z(1,nhlvl+2) = z(1,nhlvl+2) + CTHrec(2)/hlte(1)/eden
      totcap(1) = z(1,nhlvl+2) * hlte(1)
*
*     following electron density has approximate correction for neutrals
*     corr of hi*1.7e-4 accounts for col ion by HI; Drawin Zs Phys 225, 483.
*     eden changed to edhi June 25 93 for pdr getting very hot
      edhi = eden + hi * 1.7e-4
*
*     hcol(u,l), etc, are rates for downward collisions (cm^3 s^-1)
*     extra 1.261 renorm to all lyman photons, x12 is this sum
*     energy branching ratios fomr xu and mccray, apj 375, 190
      x12p = x12 * 2. / 3. / 1.261
      x12s = x12 * 1. / 3. / 1.261
*     factor mul X12 is high te limit for C13/C12 from Agarwall
      x13 = x12 * 0.165 / 1.261
      x14 = x12 * 0.059 / 1.261
      colsup(2) = x12 * 2. / 3. / 1.261
      colsup(nhlvl+1) = x12 * 1. / 3. / 1.261
      colsup(3) = x12 * 0.165 / 1.261
      colsup(4) = x12 * 0.059 / 1.261
      do level=5,nhlvl
        colsup(level) = colsup(level-1) / 3. 
      end do
*
      edp = (eden * 0.1  +  hii * 0.9 )
*
*---------------------------------------------------------------------
*
*     master balance equation
      do level=1,nhlvl
*       all process depopulating level
*       hradn(level) is sum of spontaneous decays to lower levels
*       hradn(level) is sum of hnet, hnet is net A down
*       hbul(n) is sum of induced exits from level n, both up and down
        RadSum = 0.
*       no loop for level=1
        do lower=1,level-1
          RadSum = RadSum + hnet(level,lower)
        end do
        hradn(level) = RadSum
        z(level,level) = hgamnc(level) + RadSum +
     1  (hcoldn(level)+hcolnc(level))*edhi + hbul(level) + csupeff
*
*       all processes populating level from below
        do lower=1,level-1
*         hcont is sum of induced trans from upper to lower
          z(level,lower) = -hcol(level,lower) * edhi -
     1    hcont(level,lower)/hlbolt(lower,level)
        end do
*
*       all processes populating level from above
        do upper=level+1,nhlvl
          z(level,upper) = -(hnet(upper,level)+hcont(upper,level)+
     1    hcol(upper,level)*edhi)*hlte(upper)/hlte(level)
        end do
      end do
*
*     fix 2s-1s
      z(1,nhlvl+1) = -( 8.23+ri2s1s+hc2s1s*edhi ) * hlte(nhlvl+1)/ 
     1  hlte(1)
*
*     level 2p balance
      c = 0.75 / hlte(2)
      rfac = 0.32 - 0.07 * eden / ( eden + 1e7 )
      rm1 = ( 1. - rfac )
*
      z(2,1) = -( hcol(2,1)*edhi + hcont(2,1)/hlbolt(1,2) )
*
      z(2,2) = hgamnc(2)+ hnet(2,1) + (hcoldn(2)+hcolnc(2))*edhi +
     1 r2p2s + hbul(2)  + csupeff
*
*     hbul(nhlvl+1) with induced two photon
      z(nhlvl+1,nhlvl+1) = 8.23 + hgamnc(nhlvl+1) +
     1 (hcoldn(nhlvl+1)+hcolnc(nhlvl+1))*edhi +
     1 r2p2s *3. + hbul(nhlvl+1) + csupeff
*
*     now fix routes into 2s and 2p from above
      do upper=2+1,nhlvl
        save = -hcol(upper,2)*edhi - hcont(upper,2)/hlbolt(2,upper)
        z(upper,2) = save * 0.75
*       hnet is total decays to 2p and 2s
        z(2,upper) = -(hnet(upper,2)*rm1/hlte(2)+(hcont(upper,2)+
     1  hcol(upper,2)*edhi)*0.75/hlte(2) ) *hlte(upper)
*       hcont must always be multiplied by 0.25 to cancel ratio
*       of stat weights
        z(upper,nhlvl+1) =
     1   -(hcol(upper,2)*edhi + hcont(upper,2)/hlbolt(2,upper))*0.25
        z(nhlvl+1,upper) = -(hnet(upper,2)*rfac/hlte(nhlvl+1)+
     1  (hcont(upper,2)+hcol(upper,2)*edhi)*0.25/hlte(nhlvl+1)) *
     2  hlte(upper)
      end do
      z(2,nhlvl+1) = -r2p2s
*
*     level 2s balance equation - define 2s as lower energy than 2p
*
      z(nhlvl+1,1) = -( ri2s1s/hlbolt(1,2) + hc2s1s*edhi )
      z(nhlvl+1,2) = -r2p2s  * hlte(2)/hlte(nhlvl+1)
*
*     now add on supra thermal excitation
*     upper level is 2s, all works out
      do level=2,nhlvl+1
        z(1,1) = z(1,1) + colsup(level)
        z(1,level) = z(1,level) - colsup(level)*hstat(1)/hstat(level)*
     1  hlte(level)/hlte(1)
        z(level,1) = z(level,1) - colsup(level)*hstat(1)/hstat(level)/
     1  hlbolt(1,level)
        z(level,level) = z(level,level) + colsup(level)*2./hstat(level)
      end do
*
*     chrage transfer ionization
      z(1,1) = z(1,1) + CTHion(2)
*
*     remember ground state destruction rate
      hgdist = z(1,1)
      HRateDestGnd(1) = z(1,1)
      HRateDestGnd(2) = hgamnc(1)/z(1,1)
      HRateDestGnd(3) = hcolnc(1)*edhi /z(1,1)
      HRateDestGnd(4) = hcoldn(1)*edhi /z(1,1)
      HRateDestGnd(5) = csupeff /z(1,1)
      HRateDestGnd(6) = colsup(2)*9. /z(1,1)
      HRateDestGnd(7) = hbul(1) /z(1,1)
      HRateDestGnd(8) = CTHion(2) /z(1,1)
*
      if( lgTrace.and.lgHBugFull ) then
        write(qq,'(6X,''level     others => '')')
        do i=1,nhlvl+1
          write(qq,'(7x,''HII'',i2,1p,13e9.1/12x,10E9.1)') i,(z(i,j),
     1    j=1,nhlvl+2)
        end do
      endif
*
*     save matrix
      do j=1,nhlvl+2
        do i=1,nhlvl+2
          SaveZ(j,i) = z(j,i)
        end do
      end do
*
*     scale to largest number of order unity
      do j=1,nhlvl+1
        do i=1,nhlvl+2
          z(j,i) = z(j,i) * hlte(j)
        end do
      end do
*
*     this is the usual matrix inversion method, slightly faster
      if( chMatrix.eq.'matin1 ' ) then
        call matin1( z,lmhlvl+2,nhlvl+1,1,nerror)
        if(nerror.ne.0 ) then
          write(qq,'('' hydrogen matrix error, stop.'')')
          stop
        endif
*     this one may be more robust
      else if( chMatrix.eq.'linpack' ) then
        do j=1,nhlvl+1
          do i=1,nhlvl+1
            amat(j,i) = z(j,i)
          end do
          bvec(j) = z(j,nhlvl+2)
        end do
        call DGETRF(nhlvl+1,nhlvl+1,amat,lmhlvl+1,ipiv,nerror)
        call DGETRS( 'N',nhlvl+1,1,amat,lmhlvl+1,ipiv,bvec,lmhlvl+1,
     1  nerror)
*       now put results back into z so rest of code treates only
*       one case - as if matin1 had been used
        do i=1,nhlvl+1
          z(i,nhlvl+2) = bvec(i)
        end do
*     Jason found this one on the Exemplar, distributed source just stops
      else if( chMatrix.eq.'veclib ' ) then
        do j=1,nhlvl+1
          do i=1,nhlvl+1
            amat(j,i) = z(j,i)
          end do
          bvec(j) = z(j,nhlvl+2)
        end do
        job = 0
        call dgeco(amat,lmhlvl+1,nhlvl+1,ipiv,rcond,work)
        call dgesl(amat,lmhlvl+1,nhlvl+1,ipiv,bvec,job)
*       now put results back into z so rest of code treates only
*       one case - as if matin1 had been used
        do i=1,nhlvl+1
          z(i,nhlvl+2) = bvec(i)
        end do
      else
        write(qq,'('' chMatrix type insane in hydrogen, was'',a7)')
     1  chMatrix
        stop
      endif
*
*     check whether solution is valid
      do level=1,nhlvl+1
        error(level) = 0.
        do i=1,nhlvl+1
          error(level) = error(level) +
     1    SaveZ(level,i) * z(i,nhlvl+2)
        end do
        if( SaveZ(level,nhlvl+2).gt.0. ) then
          error(level) = (error(level)-SaveZ(level,nhlvl+2))/
     1    SaveZ(level,nhlvl+2)
        else
          error(level) = 0.
        endif
      end do
*
*     convert from departure coef in Z(I) to level pop rel to HII
*     HEX is net cooling rate due to col ionization-three body rec (s-1 here)
*     dHEXdt is derivative of this wrt temperature
*
      hbn(1) = z(1,nhlvl+2)
      hn(1) = hbn(1) * hlte(1) * eden
      hex = hcolnc(1) * edhi * (hn(1)-hlte(1)*eden)
      hexx(1) = hex
      dhexdt = hex * (HCionTe(1)*tsq1-halfte)
*
*     2p by itself
      hbn(2) = z(2,nhlvl+2)
      hn(2) = hbn(2) * hlte(2) * eden
      hn2p = hn(2)
      hexx(2) = HLevNIonRyd(2) * hcolnc(2) * edhi * (hn2p-hlte(2)*eden)
      hex = hex + hexx(2)
      dhexdt = dhexdt + hexx(2) * (HCionTe(2) * tsq1-halfte)
*
*     2s by itself
      hbn(nhlvl+1) = z(nhlvl+1,nhlvl+2)
      hn2s = hbn(nhlvl+1) * hlte(nhlvl+1) * eden
      hn(nhlvl+1) = hn2s
      hn(2) = hn(2) + hn2s
      h2s = HLevNIonRyd(2) * hcolnc(2)*edhi*(hn2s-hlte(nhlvl+1)*eden)
      hex = hex + h2s
      hexx(nhlvl+1) = h2s
      dhexdt = dhexdt + hexx(nhlvl+1) * (HCionTe(2) * tsq1-halfte)
*
*     highest level is fastest collision by far, its coupling to
*     continuum can overwhelm heating
      do i=3,nhlvl
        hbn(i) = z(i,nhlvl+2)
*       hn(I) are pop per level rel to HII; i.e., N(n)/N(HII)
        hn(i) = hbn(i) * hlte(i) * eden
*       units of HEX are erg/cm^3/s
*       min enters since excited levels can have departure coef >1
*       due to putting all very excit stat captures into nhlvl
*                 HLevNIonRyd is ionization energy in Rydbergs
*       hexx(i) = HLevNIonRyd(i) * hcolnc(i) * eden * 
*    1  min( 0., hn(i)-real(hlte(i)*eden) )
*       >>chng 95 dec 18 cooling due to collis ioniz only counted for n=1,2
*       >>chng now in all levels except highest two
*       >>chng 96 feb 20, eden to edhi, rm real on real(hlte(i)*eden)
        hexx(i) = HLevNIonRyd(i) * hcolnc(i) * edhi * 
     1  ( hn(i)-hlte(i)*eden )
*       factor in min should always be negative when bn<1
*       do not do highest level, with flaky departure coef
        if( i.le.nhlvl-2 ) then
          hex = hex + hexx(i)
          dhexdt = dhexdt + hexx(i) * (HCionTe(i) * tsq1-halfte)
        endif
      end do
*666  write(66,'(20f5.2)') (hexx(i)/hex,i=1,nhlvl)
      hex = hex * en1ryd
      dhexdt = dhexdt * en1ryd
*
*     now get real effective rec coef
      HRecNet = 0.
      HRecCol = 0.
      HRecInd = 0.
      do i=2,nhlvl+1
        HRecInd = HRecInd + rinduc(i)
        HRecCol = HRecCol + hcolnc(i)*eden * hlte(i)*(1.-hbn(i) )
        HRecNet = HRecNet + 
     1  hrec(i,1)*hrec(i,2)+rinduc(i)  +
     1  hcolnc(i)*eden * hlte(i)*(1.-hbn(i) )
      end do
*
*     destruction, creation, for level n
*     level = nhlvl+1
*     write(qq,'('' destruction level'',i3,'' rad:'',f5.3,
*    1 '' Gam:'',f5.3,'' col:'',f5.3,'' colnc:'',f5.3,
*    2 '' 2p2s:'',f5.3,'' bul:'',f5.3,'' csup:'',f5.3)')
*    1 level , hradn(level) / SaveZ(level,level) ,
*    2 hgamnc(level)/ SaveZ(level,level) ,
*    2 hcoldn(level)*edhi/ SaveZ(level,level) ,
*    2 hcolnc(level)*edhi/ SaveZ(level,level) ,
*    2 r2p2s*3./ SaveZ(level,level) ,
*    2 hbul(level)/ SaveZ(level,level) ,
*    2 csupeff/ SaveZ(level,level)
*     now do creation processes
*     level = nhlvl+1
*     rfac = 0.
*     doi=1,nhlvl
*       rfac = rfac - SaveZ(level,i) * hbn(i)
*     end do
*     rfac = rfac + SaveZ(level,nhlvl+2)
*     write(qq,'('' creation    level'',i3,'' from '',
*    1 10(i3,f6.3))') level, (i,-SaveZ(level,i)*hbn(i)/rfac,i=1,nhlvl),
*    2 0, SaveZ(level,nhlvl+2)/rfac
*
*     write(QQ,'(1p,14e9.2)') hcolnc(2), hcolnc(3), hn(2),hn(3),
*    1 hlte(2),hlte(3), hexx(2),hexx(3)
*
*     this is the ratio of ionized to heutral hydrogen
*     neutral hydrogen is defined as total population in first 6 levels
*     hn(2) is 2s and 2p together
      h2ovh1 = 0.
      do level=1,nhlvl+1
        h2ovh1 = h2ovh1 + hn(level)
      end do
      h2ovh1 = 1. / h2ovh1
*     above, why was colsup(1)  always 0 while csupeff large
*     following used til 12 june 95
*     H2OVH1 = 1. / ( HN(1)+HN(2)+HN(3)+HN(4)+HN(5)+HN(6) )
*
      if( lgHBugFull.and.lgTrace ) then
        write(qq,'(7X,''HLEV HGAMNC'',1P,E9.3,9E9.2)') 
     1  (hgamnc(i),i=1,nhlvl+1)
        write(qq,'(7X,''HLEV TOTCAP'',1P,10E9.2,'' tot='',E9.2)') 
     1  (totcap(i),i=1,nhlvl+1) , HRecNet
        write(qq,'(7X,''HLEV IND Rc'',1P,10E9.2)')
     1  (rinduc(i),i=1,nhlvl+1)
        write(qq,'(7X,''IND Rc LTE '',1P,10E9.2)')
     1  (hgamnc(i)*hlte(i),i=1,nhlvl+1)
        write(qq,'(7X,''HLEV IND As'',1P,10E9.2)') 
     1  (hbul(i),i=1,nhlvl+1)
        write(qq,'(7X,''HLEV   HLTE'',1P,10E9.2)') 
     1  (hlte(i),i=1,nhlvl+1)
*       fraction of total ionization due to photo from given level
        write(qq,'(7X,''HLEVfr cion'',1P,10E9.2)') (
     1  hcolnc(i)*hn(i)*eden/(HRecEffec*eden),i=1,nhlvl)
*       fraction of total ionization due to photoionization from given level
        write(qq,'(7X,''HLEVfrPhIon'',1P,10E9.2)') (
     1  hgamnc(i)*hn(i)/(HRecEffec*eden),i=1,nhlvl)
        if( hex.gt.0. ) then
        write(qq,'(7X,''HLEVfr Heat'',1P,10E9.2)') (
     1  hexx(i)*en1ryd/abs(hex),i=1,nhlvl)
        endif
        write(qq,'(7X,''HLEV     HN'',1P,9E9.2,'' HN2s,p'',2E9.2)') 
     1  (hn(i),i=1,nhlvl),hn2s,hn2p
        write(qq,'(7X,''HLEV   b(n)'',1P,9E9.2,''   2s,p'',2E9.2)')
     1  (hbn(i),i=1,nhlvl) , hbn(nhlvl+1) , hbn(2)
        write(qq,'(7X,''HLEV   X12'',1P,E9.2,
     1  '' Heat Exc'',E9.2,'' Grn dest:'',E9.2)')
     2  x12,hex,hgdist
      endif
*
      if( hn(2)/hn(1).gt.0.1 ) then
        lgHiPop2 = .true.
        pop2mx = max( hn(2)/hn(1) , pop2mx )
      endif
*
*     set flag to tell IONTE whether photo or coll ioniz
      colfac = hcol(2,1)*hlte(2)/hlte(1)*eden * ( hgamnc(2)+hcolnc(2)+
     1 hcol(3,2)*hlte(3)/hlte(2)) / (hcol(2,1)*eden+hnet(2,1))
*     >>chng 96 nov 8, what in the world was the above?  very small, test worthless
*     ratio of collisions to photo
      if( hgamnc(1)+csupeff.gt.1e-30 ) then
        colfac = hcolnc(1)*edhi / (hgamnc(1)+csupeff)
      else
        colfac = 0.
      endif
*
*     colfac added mar 93 to stop too large te change
      if( colfac.gt.0.2 )  then
        lgHColionImp = .true.
      else
        lgHColionImp = .false.
      endif
*
      do level=1,nhlvl+1
        if( hn(level).le.0. ) then
          write(qq,'(1X,''HLEVEL finds negative hydrogen level '',
     1    ''population for level '',i3,1P,E10.3,
     1    '' simple='',E10.3,'' TE='',E10.3,'' ZONE='',I4)')
     2    level,hn(level) , simhii , te , nzone
          write(qq,'(1X,''level popa are:'',1p,16e9.1)')
     1    (hn(i),i=1,nhlvl+1)
          call negcon
          call ShowMe
        endif
      end do
*
*     is hydrogen atom in condition of collisional rec? if so then
*     only very small dT's can be tolerated
*     HRecEffec is sum of totcap(i), htotrc is sum of radiative recombination
*     >>chng 97 aug 10, from HRecEffec which is total rec, to HRecCol which
*     is really three body - needed because strong induced rec tricked test
*     if( HRecEffec/htotrc.gt.100. ) then
      if( HRecCol/htotrc.gt.100. ) then
        lgHColRec = .true.
      else
        lgHColRec = .false.
      endif
*
      if( lgTrace ) then
*       HRecEffec is gross rec coef, computed here while filling in matrix
*       elements, all physical processes included.  htotrc is radiavive only
         write(qq,'(7X,''HLEVEL retrn mtrx te='',1p,e9.3,'' HII/HI='',
     1   E9.3,'' simple='',E9.3,'' b1='',e8.2,'' ion rate='',E8.2,
     2   '' TotRec'',E8.2,'' RadRec'',E8.2)')te,
     3   h2ovh1 , simhii , hbn(1), hgamnc(1)+csupeff , HRecEffec,htotrc
      endif
*
*     update destruction rate
      destroy(1,1) = hgamnc(1)+csupeff+hcolnc(1)*eden
*
      end
