******************************************************************************
      subroutine ionte( nThLoop , nCall )
      implicit none
*determine ionization and temperature, called by PIonte
*     nCall tells routine which call this is, 0 for first one, not changed here
*     nThLoop controlled here, indicates how many loops performed
      integer nThLoop , nCall
      include "nhlvl.par"
      include "itrdim.par"
      include "hmi.com"
      include "tehigh.com"
      include "newion.com"
      include "shullc.com"
      include "iontot.com"
*     include "MapPar.com"
      include "h.com"
      include "ZoneCnt.com"
      include "tcool.com"
      include "tusedcom.com"
      include "colion.com"
      include "tseton.com"
      include "iondun.com"
      include "called.com"
      include "trace.com"
      include "phycon.com"
      include "heat.com"
      include "toler.com"
      include "DoPhoto.com"
      include "nustbl.com"
      include "dcneg.com"
      include "dCmHdT.com"
      include "dtemp.com"
      include "tfail.com"
      include "TrConvg.com"
      include "InCvgRsn.com"
      include "phlevl.com"
      include "Trimed.com"
      include "HColRec.com"
      include "bit32.com"
      include "holod.com"
      include "IOqq.com"
*
*     local variables
      integer limtry , limdef
*     this is default limit to number of iterations
      parameter (limdef=10)
      real dtl , dtsave , Damper
      real fneut,DCoolngDT,DerivNumer , OldCmHdT,
     1 CoolMHeat
      save OldCmHdT
      character chDEType*1 , chdTCap
      data OldCmHdT/0./
*
*     free statement label =>4
*
      if( lgTrace ) write(qq,'(/'' ionte called'')')
*
*     main routine to find ionization and temperature
*     following is flag to check for temp oscillations
*     it could be set true in main temp loop
      lgTOscl = .false.
*     scale factor for changes in temp - make smaller if oscillations
      Damper = 1.
*     flag for d(cool - heat)/dT changing sign, an internal error
*     >>chng 97 Sep 3, only turn false one time, remains true if ever true
      if( nzone.lt.1 ) lgCmHOsc = .false.
      call MakeDeriv('zero',0.,0.,DerivNumer)
*     this is will initial limit to number of tries at temp
      limtry = limdef
*     used to keep track of sign of dt, to check for oscillations
      dtl = 0.
*
*     this counts how may thermal loops we go through
*     used in calling routine to make sure that at least
*     two solutions are performed
      nThLoop = 0
*     this flag says evaluate photo rates and opacity each time,
*     will do this first convergence of ionization, but not after
      if(nCall.eq.0.)then
        lgDoPhoto = .true.
*       tell it to do whole new ionization solution
        lgNewIon = .true.
*       write(qq,'('' ionte lgdophoto true init'')')
      endif
*     this is the heating-cooling match loop
      do while (nThLoop.lt.limtry )
        if( lgTrConvg ) then
          write(qq,'(''   ionte enter heating cooling loop'',I4,'' Te:''
     1    ,1P,E11.4,'' Htot:'',E11.4,'' Ctot:'',E11.4,'' eden:'',e10.3)'
     1    ) nThLoop,te, htot,ctot,eden
        endif
*       converge the ionization; this calls ionize until lgIonDone is true
        call ConvIoniz
*       check on neutral fracs
        if( lgTrimed ) then
*         this means an heavy element has had its ionization stages
*         trimed down - must redo all rates
          lgNewIon = .true.
          lgDoPhoto = .true.
*         write(qq,'('' lgDoPhoto true ionte something trimed'')')
*       else if( eden/hden.lt.0.95 .and.eden/hden.gt.0.05 ) then
*         not safe to not redo ionization when near i-front or neutral zone
*         when secondary ionization is important
*         lgNewIon = .true.
*         lgDoPhoto = .true.
*         write(qq,'('' lgDoPhoto true ionte near -ifront'')')
        else
*         dont redo photoionization rates
          lgNewIon = .false.
          lgDoPhoto = .false.
*         write(qq,'('' lgDoPhoto false ionte '')')
        endif
        if( htot.lt.0. ) then
          write(qq,'('' Total heating is <0; is this model ''
     1    ,''collisionally ionized?'')')
        else if( htot.eq.0. ) then
          write(qq,'('' Total heating is 0; is the density small?'')')
        endif
        fneut = (hi+2.*htwo) / hden
*
*       now find total cooling
        call coolr( ctot , DCoolngDT )
*
*       remember this temp, heating, and cooling
        call PutHetCol( te , htot , ctot )
*
        if( DCoolngDT.lt.0. ) then
          lgdCNeg = .true.
        else
          lgdCNeg = .false.
        endif
        iontot = iontot + 1
        nThLoop = nThLoop + 1
*
        if( lgTSetOn ) then
*         constant temp - declare this a success
          CoolMHeat = 0.
        else
*         we will try to make the following zero
          CoolMHeat = ctot - htot
        endif
*
*       get numerical derivative, but we may not use it
        call MakeDeriv('incr',ctot-htot ,te ,DerivNumer)
*
*       save old deriv to check for oscillations
        if( nzone.lt.1 ) then
*         >>chng 96 june 7, was set to dCoolmHeatdT, is not defined initially
          OldCmHdT = ctot / te
        endif
*
        if( (te.lt.1e4.and.DCoolngDT.lt.0.) ) then
*         use numerical guess, HTOT nearly equal to CTOT, drive Te lower
*         this is to overcome thermal inflection points
          dCoolmHeatdT = dble(htot) / te * 2.
          chDEType = 'd'
        else
*         >>chng 97 mar 18, all below growth code just did the following
          dCoolmHeatdT = DCoolngDT - dHTotDT
          chDEType = 'a'
        endif
*       else if( nthLoop.lt.3 ) then
*         use computed derivative, including change in heating
*         two implic neg signs in following heat deriv
*         if( abs(dHTotDT).lt.0.3*abs(DCoolngDT) ) then
*           dCoolmHeatdT = DCoolngDT - dHTotDT
*           chDEType = 'a'
*         else
*           SIGN: sign of sec arg and abs val of first
*           dCoolmHeatdT = DCoolngDT - sign( abs(DCoolngDT)*0.3 , DHTotDT )
*           dCoolmHeatdT = DCoolngDT - DHTotDT
*           chDEType = 'c'
*         endif
*       else
*         if( abs(dHTotDT).lt.0.3*abs(DCoolngDT) ) then
*           dCoolmHeatdT = DCoolngDT - dHTotDT
*           chDEType = 'a'
*         else
*           SIGN: sign of sec arg and abs val of first
*           dCoolmHeatdT = DCoolngDT - sign( abs(DCoolngDT)*0.3 , DHTotDT )
*           dCoolmHeatdT = DCoolngDT - DHTotDT
*           chDEType = 'c'
*         endif
*       endif
*
*       >>chng 96 Aug 15, alphas with fast compile underflow at low densities
        if( dCoolmHeatdT.eq.0. ) then
          chDEType = 'z'
          dCoolmHeatdT = ctot / te
          if( dCoolmHeatdT.eq.0. .and.ctot.eq.0. ) then
            write(qq,'('' ionte the cooling and its derivitive '',
     1      ''are zero.'')')
            write(qq,'('' ionte I cannot perform the energy '',
     1      ''balance.'')')
            if( hden.le.1e-3 .and. lgBit32) write(qq,'('' Due to '',
     1      ''very low density on a 32-big cpu?'')')
            call ShowMe
            stop
          else if( dCoolmHeatdT.eq.0. .and. ctot.ne.0. ) then
            write(qq,'('' ionte the cooling derivitive '',
     1      ''is zero.'')')
            write(qq,'('' ionte I cannot perform the energy '',
     1      ''balance.'')')
            if( hden.le.1e-3 .and. lgBit32) write(qq,'('' Due to '',
     1      ''very low density on a 32-big cpu?'')')
            call ShowMe
            stop
          endif
        endif
*
*       check whether deriv changing sign - an internal error or
*       numerical instability
        if( OldCmHdT*dCoolmHeatdT.lt.0. ) lgCmHOsc = .true.
        OldCmHdT = dCoolmHeatdT
*
*       derivative can change sign when heating and cooling balance,
*       and processes have exactly same temp dependence
*       happened in mods of ism.in test
*       >>chng 97 sep 02, added following test for oscillating derivs
        if( lgCmHOsc ) then
          dCoolmHeatdT = ctot / te
          chDEType = 'o'
        endif
*
*       required change in temperature, this may be too large
        dTemper = CoolMHeat / dCoolmHeatdT
*       try to stop numerical oscillation if dTemper is changing sign
        if( dtl*dTemper .lt. 0.) then
          lgTOscl = .true.
*         make DT smaller and smaller
          Damper = Damper * 0.5
        endif
*
*       save temp so we can check if it is capped
        dtsave = dTemper
*
*       SIGN: sign of sec arg and abs val of first
*       >>chng 96 nov 8, from 0.1 to 0.08 in fneut
        if( fneut.gt.0.08 .and. lgHColionImp ) then
*         lgHColionImp is true if model collisionally ionized
*         dont let TE change by too much if lgHColionImp is set by HLEVEL
          dTemper = sign( min( abs(dTemper),0.005*te ) , dTemper )
        else if( nThLoop.gt.5.and. .not.lgTOscl ) then
*         need several changes but te not oscillating, increase dT
          dTemper = sign( min( abs(dTemper),0.06*te ) , dTemper )
        else if( nThLoop.gt.3.and. .not.lgTOscl ) then
*         need several changes but te not oscillating, increase dT
          dTemper = sign( min( abs(dTemper),0.04*te ) , dTemper )
        else
*         do not let temp change by more than 2 percent
          dTemper = sign( min( abs(dTemper),0.02*te ) , dTemper )
        endif
*
*       check if model in collisional recombination equilibirum
*       if so then small change in temp causees big change in equilibrium
*       lgHColRec set in hlevel, only true is totl rec >> rad rec
        if( lgHColRec ) then
          if( lgHCoolng) then
            if( lgTOscl ) then
              dTemper = sign( min( abs(dTemper),0.002*te ) , dTemper )
            else
*             not oscillating
              dTemper = sign( min( abs(dTemper),0.005*te ) , dTemper )
            endif
          else
            dTemper = sign( min( abs(dTemper),0.01*te ) , dTemper )
          endif
        endif
*
        dTemper = dTemper * Damper
        dtl = dTemper
*       THIS IS IT!!! this is the place where te changes.
        te = te - dTemper
*
*       if te falls below 3K quit now
        if( te.le.3. ) then
*         these will force all routines out to quit
*         when lowest temp read in values below 3 were not allowed
          te = 2.9998
          CoolMHeat = 0.
          lgIonDone = .true.
        endif
        if( lgTrConvg ) then
*         this is flag to say if te change is capped
          if( dTemper.eq.dtsave ) then
            chdTCap = ' '
          else
            chdTCap = 'c'
          endif
          write(qq,'(''   ionte chgTE'',1P,e8.2,'' dt:'',a1,
     1    E8.1,'' C:'',e9.2,'' H:'',e9.2,'' CoolMHeat:'',E9.2,0p,
     2    f7.1,1p,''% dCoolmHeatdT'',a1,E9.2,'' dCdT'',e9.2,
     3    '' dHdT'',e9.2,l2)')
     3    te,chdTCap,dTemper, ctot,htot,CoolMHeat,CoolMHeat/htot*100.,
     3    chDEType,  dCoolmHeatdT, DCoolngDT , dHTotDT, lgCmHOsc
*         dCoolmHeatdT is the actual number used for getting dT
*         DCoolngDT is just cooling
        endif
*
        if( lgTrace ) write(qq,'('' ionte TE:'',1P,E11.5,'' dT'',E10.3
     1  ,'' HTOT:'',E11.5,'' CTOT:'',E11.5,'' dCoolmHeatdT:'',a1,E11.4,
     2  '' C-H'',E11.4,'' lgHColionImp:'',L1,'' HDEN'',E9.2)')
     3   te,dTemper,htot,ctot,chDEType,dCoolmHeatdT,CoolMHeat,
     4   lgHColionImp,hden
*
*       lgIonDone = true if ionization routines got OK solution
*       lgIonDone = false if problems
*       TOLER can be set in READR, normally=0.02
        if( abs(CoolMHeat/(htot+feheat)).lt.toler .and. lgIonDone ) then
          if( lgTrace ) write(qq,'('' ionte returns ok.'')')
          thist = max( te , thist )
          tlowst = min( te , tlowst )
*         test for thermal stability
*         >>chng 97 jul 31, set flag if unstable, increment only once per zone
*         if( lgdCNeg ) nustbl = nustbl + 1
          if( lgdCNeg ) then
            lgUnstable = .true.
          else
            lgUnstable = .false.
          endif
          lgTeFail = .false.
          if( lgTrConvg ) then
            write(qq,'(''   IONTE heating cooling loop converged. Te:'',
     1      1P,E11.4,'' Htot:'',E11.4,'' Ctot:'',E11.4,'' error:'',
     2      e9.1,''%, eden='',e11.4)') te,htot,ctot,
     3      (htot-ctot)*100./max(1e-36,htot), eden
          endif
          return
        endif
*       this is option to increase limit to number of iterations
*       if the solution is not oscillating
*       nThLoop is number of times through heating-cooling-ionization loop
        if( nThLoop.eq.limdef .and. .not.lgTOscl ) then
*         limdef is set to 10 in a data statement above
*         >>chng 97 aug 10, from 2 to 4 to let keep going when not oscillation
*         this helped in getting over huge jumpts in temperature at metal fronts
          limtry = limdef * 4
          if(lgTrConvg)write(qq,'(''   IONTE increases limtry to'',i3)')
     1    limtry
        endif
      end do
*
*     no temperature convergence
      lgTeFail = .true.
*
      end
