******************************************************************************
      integer function ipConSafe( energy , chLabel )
      implicit none
*generate unique pointer to energy within continuum array
*     continuum energy in Rydbergs
      real energy
*     4 char label for continuum, like those returned by chLineLbl
      character chLabel*4
*
      include "rydlam.par"
      include "ncell.par"
      include "rfield.com"
      include "flxsav.com"
      include "MaxSafe.com"
      include "IOqq.com"
      include "LineLabl.com"
*
*     function to set pointer to cont energy confirming no overlap
*     NB!!!
*     this will only work if the FluxSave array has previously been zeroed out
*     at the start of routine DoPoint
*
*     local variables
      integer ipoint , iOffSet , limit , i
      data limit/60/
*
      ipConSafe = ipoint( energy )
      if( FluxSave(ipConSafe).gt.0. ) then
*       there already is something at the correct energy
        do iOffSet = 1,limit
*begin sanity check
          if( ipConSafe-iOffSet.le.0 ) then
            write(qq,'('' ipConSafe: ipConSafe-iOffset lt 0'')')
            call ShowMe
            stop
          endif
          if( ipConSafe+iOffSet.gt.ncell ) then
            write(qq,'('' ipConSafe: ipConSafe+iOffset gt ncell'')')
            call ShowMe
            stop
          endif
*end sanity check
          if( FluxSave(ipConSafe+iOffSet).eq.0. ) then
*     >>chng 96 feb 17, was neg offset first, change to pos so heii 911
*           is higher energy than H
            ipConSafe = ipConSafe + iOffSet
            FluxSave(ipConSafe) = FluxSave(ipConSafe) + 1
            chContLabel(ipConSafe) = chLabel
            nMaxSafe = max( iOffSet , nMaxSafe )
            EnergySafe = anu(ipConSafe)
            return
          else if( FluxSave(ipConSafe-iOffSet).eq.0. ) then
            ipConSafe = ipConSafe - iOffSet
            FluxSave(ipConSafe) = FluxSave(ipConSafe) + 1
            chContLabel(ipConSafe) = chLabel
            nMaxSafe = max( iOffSet , nMaxSafe )
            EnergySafe = anu(ipConSafe)
            return
          endif
        end do
        write(qq,'('' ipConSafe needs too large an offset. Problems??'',
     1  1x,a4)') chLabel
        write(qq,'('' ipConSafe: Cont energy='',1p,e10.3,'' Ryd.'')')
     1  energy
        write(qq,'('' ipConSafe: range'',1p,2e10.3,'' Ryd.'')')
     1  anu(ipConSafe-limit),anu(ipConSafe+limit)
        do i=ipConSafe-limit,ipConSafe+limit
          write(qq,'(i4,1p,e11.3,a4)') i,anu(i),chContLabel(i)
        end do
        stop
      endif
*
      FluxSave(ipConSafe) = FluxSave(ipConSafe) + 1
      chContLabel(ipConSafe) = chLabel
*
      end
