******************************************************************************
      integer function ipLinSafe( energy , chLabel )
      implicit none
*generate unique pointer to line energy within energy mesh
*     line energy in Rydbergs
      real energy
*     4 char label for  line, like those returned by chLineLbl
      character chLabel*4
*
      include "rydlam.par"
      include "ncell.par"
      include "LineLabl.com"
      include "MaxSafe.com"
      include "rfield.com"
      include "IOqq.com"
*
*     function to set pointer to line energy confirming no overlap
*     NB!!!
*     this will only work if the flux array has previously been zeroed out
*     at the start of routine DoPoint
*
*     local variables
      integer ipoint , iOffSet , limit
      data limit/60/
*
      ipLinSafe = ipoint( energy )
      if( flux(ipLinSafe).gt.0. ) then
        do iOffSet = 1,limit
*begin sanity check
          if( ipLinSafe-iOffSet.le.0 ) then
            write(qq,'('' ipLinSafe: ipLinSafe-iOffset lt 0'')')
            call ShowMe
            stop
          endif
          if( ipLinSafe+iOffSet.gt.ncell ) then
            write(qq,'('' ipLinSafe: ipLinSafe+iOffset gt ncell'')')
            call ShowMe
            stop
          endif
*end sanity check
          if( flux(ipLinSafe-iOffSet).eq.0. ) then
            ipLinSafe = ipLinSafe - iOffSet
            flux(ipLinSafe) = flux(ipLinSafe) + 1
            chLineLabel(ipLinSafe) = chLabel
            nMaxSafe = max( iOffSet , nMaxSafe )
            EnergySafe = anu(ipLinSafe)
            return
          else if( flux(ipLinSafe+iOffSet).eq.0. ) then
            ipLinSafe = ipLinSafe + iOffSet
            flux(ipLinSafe) = flux(ipLinSafe) + 1
            chLineLabel(ipLinSafe) = chLabel
            nMaxSafe = max( iOffSet , nMaxSafe )
            EnergySafe = anu(ipLinSafe)
            return
          endif
        end do
        write(qq,'('' ipLinSafe needs too large an offset. Problems??'')
     1  ')
        write(qq,'('' ipLinSafe: Line energy='',1p,e10.3,'' Ryd.'')')
     1  energy
        write(qq,'('' ipLinSafe: range'',1p,2e10.3,'' Ryd.'')')
     1  anu(ipLinSafe-limit),anu(ipLinSafe+limit)
        stop
      endif
*
      flux(ipLinSafe) = flux(ipLinSafe) + 1
      chLineLabel(ipLinSafe) = chLabel
*
      end
