******************************************************************************
      subroutine level3( t10,t21,t20)
      implicit none
*compute three level atom with radiative transfer
      include "nta.par"
      real t10(nta) , t21(nta) , t20(nta)
      include "ipLnArry.par"
      include "limelm.par"
      include "limLevelN.par"
      include "ncell.par"
      include "IonFracs.com"
      include "TePowers.com"
      include "edsqte.com"
      include "teinv.com"
      include "phycon.com"
      include "occnum.com"
*     include "corind.com"
      include "dcool.com"
      include "PopLevls.com"
      include "Lev3Fail.com"
      include "IOqq.com"
*
*     compute three level atom, 10, 21, and 20 are line
*     arrays for 10, 21, and 20 transitions.
*     one can be a dummy
*
*     local variables
      real g0, g1, g2 , AbunxIon,p0,p1,p2,o10,o21,o20
      real g010,g110,g121,g221,g020,g220
      real a,b,c,pump01,pump12,a21,a10,bolt01,bolt12
      real beta , bolt02 , a20 , pump02
      double precision alpha , alpha1 , alpha2
      double precision r01 , r10 , r20 , r02 , r12 , r21
      double precision c01 , c10 , c20 , c02 , c12 , c21
      real ener20,ener21,ener10
*     >>chng 96 dec 6, to double precision due to round off problems below
      double precision cool02 , cool12 , cool01 , TotCool , TotInten
      double precision heat20 , heat21 , heat10
      double precision pump10 , pump21 , pump20
      double precision temp12 , temp02 , temp01
      double precision cnet02, hnet02, cnet12, hnet12, cnet01, hnet01 ,
     1 TotHeat
      character chLab*4  , chIonLbl*4 , chLab10*10 , chLineLbl*10
*
*     generalized three level atom for any ion
*     sum of three levels normalized to total abundance
*
*     stat weights of all three lines
*     sanity check will confirm ok
      g010 = t10(ipLnGl)
      g110 = t10(ipLnGu)
*
      g121 = t21(ipLnGl)
      g221 = t21(ipLnGu)
*
      g020 = t20(ipLnGl)
      g220 = t20(ipLnGu)
*
*     these are statistical weights
      if( g010.gt.0. ) then
        g0 = g010
      else if( g020.gt. 0. ) then
        g0 = g020
      else
        chLab10 = chLineLbl( t10 )
        write(qq,'('' level3: insane stat weights g0 :'',1p,
     1  2e10.2,1x,a10)') g010,g020,chLab10
        call insane
        call ShowMe
      endif
      if( g110.gt.0. ) then
        g1 = g110
      else if( g121.gt. 0. ) then
        g1 = g121
      else
        chLab10 = chLineLbl( t10 )
        write(qq,'('' level3: insane stat weights g1 :'',1p,
     1  2e10.2,1x,a10)') g010,g020,chLab
        call insane
        call ShowMe
        stop
      endif
      if( g220.gt.0. ) then
        g2 = g220
      else if( g221.gt. 0. ) then
        g2 = g221
      else
        chLab10 = chLineLbl( t20 )
        write(qq,'('' level3: insane stat weights g2 :'',1p,
     1  2e10.2,1x,a10)') g010,g020,chLab10
        call insane
        call ShowMe
        stop
      endif
*
*     abundances from the elements grid
*     one of these must be a true line
      if(g010.gt.0.) then
        chLab = chIonLbl( t10 )
        AbunxIon = xIonFracs( int(t10(ipLnNelem)+0.1) , 
     1  int(t10(ipLnIonStg)+0.1) )
      else if( g121.gt.0. ) then
        chLab = chIonLbl( t21 )
        AbunxIon = xIonFracs( int(t21(ipLnNelem)+0.1) , 
     1  int(t21(ipLnIonStg)+0.1) )
      endif
*
      a = t10(ipLnBolt)/te
      b = t21(ipLnBolt)/te
      c = t20(ipLnBolt)/te
      if( c.eq.0. ) then
        c = a + b
      endif
*
*     if still neg at end, then success!, in common so possible to
*     to check why zero returned
      nLev3Fail = -1
      if( AbunxIon.le.1e-30 .or. c.gt.60. ) then
        nLev3Fail = 0
*       all populations are zero
        PopLevels(0) = AbunxIon
        PopLevels(1) = 0.
        PopLevels(2) = 0.
*
* 666 error! these pops ARE NOT defined below
        DepLTELevels(0) = 1.
        DepLTELevels(1) = 0.
        DepLTELevels(2) = 0.
*
*       level populations
        t21(ipLnPopOpc) = 0.
        t10(ipLnPopOpc) = AbunxIon
        t20(ipLnPopOpc) = AbunxIon
        t21(ipLnPopl) = 0.
        t10(ipLnPopl) = AbunxIon
        t20(ipLnPopl) = AbunxIon
        t21(ipLnPopu) = 0.
        t10(ipLnPopu) = 0.
        t20(ipLnPopu) = 0.
*
*       line heating
        t20(ipLnHeat) = 0.
        t21(ipLnHeat) = 0.
        t10(ipLnHeat) = 0.
*
*       intensity of line
        t21(ipLnInten) = 0.
        t10(ipLnInten) = 0.
        t20(ipLnInten) = 0.
*
*       line cooling
        t20(ipLnCool) = 0.
        t21(ipLnCool) = 0.
        t10(ipLnCool) = 0.
*
*       local ots rates
        t20(ipLnOTS) = 0.
        t21(ipLnOTS) = 0.
        t10(ipLnOTS) = 0.
*
*       number of photons in line zero
        t21(ipLnNPhots) = 0.
        t10(ipLnNPhots) = 0.
        t20(ipLnNPhots) = 0.
*
*       fraction that produced lines zero
        t21(ipLnAovTOT) = 1.
        t10(ipLnAovTOT) = 1.
        t20(ipLnAovTOT) = 1.
*
*       ratio coll over total excitation
        t21(ipLnColovTOT) = 0.
        t10(ipLnColovTOT) = 0.
        t20(ipLnColovTOT) = 0.
*
*       add zero to cooling
        call coladd( chLab(1:4) , INT(t21(ipLnWlAng)),0.)
        call coladd( chLab(1:4) , INT(t10(ipLnWlAng)),0.)
        call coladd( chLab(1:4) , INT(t20(ipLnWlAng)),0.)
*
*       now add zero to ots field
*       one of these could be a dummy line
        if(t21(ipLnIpCont) .gt. 0. .and.t21(ipLnCS1).eq.0.)
     1    call AddOTSLin( 0. , int(t21(ipLnIpCont) ) ,1.0 )
        if(t10(ipLnIpCont) .gt. 0. .and.t10(ipLnCS1).eq.0.)
     1    call AddOTSLin( 0. , int(t10(ipLnIpCont) ) ,1.0 )
        if(t20(ipLnIpCont) .gt. 0. .and.t20(ipLnCS1).eq.0.)
     1    call AddOTSLin( 0. , int(t20(ipLnIpCont) ) ,1.0 )
        return
      endif
*
*     collision strengths
      o10 = t10(ipLnCS)
      o21 = t21(ipLnCS)
      o20 = t20(ipLnCS)
*
*begin sanity checks
      if(g010*g020.gt.0. .and. g010.ne.g020 ) then
        write(qq,'('' level3: insane stat weights 020 010:'',1p,
     1  2e10.2,1x,a4)') g010,g020,chLab
        call insane
        call ShowMe
        stop
      endif
      if(g110*g121.gt.0. .and. g110.ne.g121 ) then
        write(qq,'('' level3: insane stat weights 121 110:'',1p,
     1  2e10.2,1x,a4)') g110,g121,chLab
        call insane
        call ShowMe
        stop
      endif
      if(g221*g220.gt.0. .and. g221.ne.g220 ) then
        write(qq,'('' level3: insane stat weights 220 221:'',1p,
     1  2e10.2,1x,a4)') g221,g220,chLab
        call insane
        call ShowMe
        stop
      endif
*
*     both abundances must be same, equal abundance
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      if( t10(ipLnIonStg)*t21(ipLnIonStg).gt.0. .and. 
     1  t10(ipLnIonStg).ne.t21(ipLnIonStg) ) then
        write(qq,'('' level3: insane IonStg, given, array2='',1p,
     1  2e10.2,1x)') AbunxIon 
        call insane
        call ShowMe
        stop
      endif
      if( t20(ipLnIonStg)*t21(ipLnIonStg).gt.0. .and. 
     1  t20(ipLnIonStg).ne.t21(ipLnIonStg) ) then
        write(qq,'('' level3: insane IonStg, given, array2='',1p,
     1  2e10.2,1x)') AbunxIon 
        call insane
        call ShowMe
        stop
      endif
      if( t10(ipLnNelem)*t21(ipLnNelem).gt.0. .and. 
     1  t10(ipLnNelem).ne.t21(ipLnNelem) ) then
        write(qq,'('' level3: insane nelem, given, array2='',1p,
     1  2e10.2,1x)') AbunxIon 
        call insane
        call ShowMe
        stop
      endif
      if( t20(ipLnNelem)*t21(ipLnNelem).gt.0. .and. 
     1  t20(ipLnNelem).ne.t21(ipLnNelem) ) then
        write(qq,'('' level3: insane nelem, given, array2='',1p,
     1  2e10.2,1x)') AbunxIon 
        call insane
        call ShowMe
        stop
      endif
      if( o10.le.0. .or. o21.le.0. .or. o20.le.0. ) then
        write(qq,'('' level3 called with non-positive collision'',
     1  '' strength, ='',1P,E10.2)') o10,o21,o20
        write(qq,'('' label='',a10)') chLab
        call insane
        call ShowMe
        stop
      endif
*end sanity checks
*
*     net loss of line escape and destruction
      a21 = t21(ipLnAul) * ( t21(ipLnEscP)+t21(ipLnDesP) )
      a10 = t10(ipLnAul) * ( t10(ipLnEscP)+t10(ipLnDesP) )
      a20 = t20(ipLnAul) * ( t20(ipLnEscP)+t20(ipLnDesP) )
*
*     find energies of all transitions - one line could be a dummy
*     also find boltzmann factors
      if( a10.eq.0. ) then
        ener20 = t20( ipLnEnrErg)
        ener21 = t21( ipLnEnrErg)
        ener10 = ener20 - ener21
        bolt12 = exp( -t21(ipLnBolt) / te )
        bolt02 = exp( -t20(ipLnBolt) / te )
        bolt01 = bolt02 / bolt12
        temp12 = t21(ipLnBolt)
        temp02 = t20(ipLnBolt)
        temp01 = temp02 - temp12
      else if( a21.eq.0. ) then
        ener10 = t10( ipLnEnrErg)
        ener20 = t20( ipLnEnrErg)
        ener21 = ener20 - ener10
        bolt01 = exp( -t10(ipLnBolt) / te )
        bolt02 = exp( -t20(ipLnBolt) / te )
        bolt12 = bolt02/bolt01
        temp02 = t20(ipLnBolt)
        temp01 = t10(ipLnBolt)
        temp12 = temp02 - temp01
      else if( a20.eq.0. ) then
        ener10 = t10( ipLnEnrErg)
        ener21 = t21( ipLnEnrErg)
        ener20 = ener21 + ener10
        bolt01 = exp( -t10(ipLnBolt) / te )
        bolt12 = exp( -t21(ipLnBolt) / te )
        bolt02 = bolt01*bolt12
        temp01 = t10(ipLnBolt)
        temp12 = t21(ipLnBolt)
        temp02 = temp01 + temp12
      else
*       all lines are ok
        ener10 = t10( ipLnEnrErg)
        ener20 = t20( ipLnEnrErg)
        ener21 = t21( ipLnEnrErg)
        bolt01 = exp( -t10(ipLnBolt) / te )
        bolt12 = exp( -t21(ipLnBolt) / te )
        bolt02 = bolt01*bolt12
        temp02 = t20(ipLnBolt)
        temp01 = t10(ipLnBolt)
        temp12 = t21(ipLnBolt)
      endif
*
*begin sanity check
*     check all energies positive
      if( ener10.lt.0. .or. ener20.lt.0. .or. ener21.lt.0. ) then
        write(qq,'('' level3 called with insane energy scale0'',
     1  '' EN(10,21,20) ='',1P,3E10.2)') ener10,ener21,ener20
        write(qq,'('' label='',a10)') chLab
        call insane
        call ShowMe
        stop
      endif
*     check if energy order is ok
      if( ener10.gt.ener20 .or. ener21.gt.ener20 ) then
        write(qq,'('' level3 called with insane energy scale1'',
     1  '' EN(10,21,20) ='',1P,3E10.2)') ener10,ener21,ener20
        write(qq,'('' label='',a10)') chLab
        call insane
        call ShowMe
        stop
      endif
*     check if energy scale is ok
      if( abs( (ener10+ener21)/ener20 -1.) .gt.1e-4 ) then
        write(qq,'('' level3 called with insane energy scale2'',
     1  '' EN(10,21,20) ='',1P,3E10.2)') ener10,ener21,ener20
        write(qq,'('' label='',a10)') chLab
        call insane
        call ShowMe
        stop
      endif
*end sanity check
*
      pump01 = t10( ipLnPump )
      pump10 = pump01 * g0/g1
      pump12 = t21( ipLnPump )
      pump21 = pump12 * g1/g2
      pump02 = t20( ipLnPump )
      pump20 = pump02 * g0/g2
*
*     cdsqte is 8.629E-6 / sqrte * eden
      c01 = o10*bolt01*cdsqte/g0
      r01 = c01 + pump01
      c10 = o10*cdsqte/g1
      r10 = c10 + a10 + pump10
      c20 = o20*cdsqte/g2
      r20 = c20 +a20 + pump20
      c02 = o20*bolt02*cdsqte/g0
      r02 = c02 + pump02
      c12 = o21*bolt12*cdsqte/g1
      r12 = c12 + pump12
      c21 = o21*cdsqte/g2
      r21 = c21 + a21 + pump21
*
      alpha1 = dble(AbunxIon) * dble(r01+r02)/dble(r10+r01+r02) 
      alpha2 = dble(AbunxIon) * dble(r01)/dble(r10+r12+r01) 
      alpha = alpha1 - alpha2
*    1( dble(r01+r02)/dble(r10+r01+r02) - dble(r01)/dble(r10+r12+r01) )
*     beta is factor with n2
      beta =
     1 (r21-r01)/(r10+r12+r01) + (r20+r01+r02)/(r10+r01+r02) 
*
      if( alpha/max(alpha1,alpha2) .lt. 1e-11 ) then
*       this catches both negative and round off
        p2 = 0.
        alpha = 0.
        nLev3Fail = 1
      else
        p2 = alpha / beta
      endif
      PopLevels(2) = p2
*
      if( alpha.lt.0. .or. beta.lt.0. ) then
        write(qq,'('' level3: insane n2 pop alf, bet, p2='',1p,
     1  3e10.2,1x,a10,'' t='',e10.2)') alpha , beta, p2,chLab,te
        write(qq,'('' gs are'',3f5.1)') g0,g1,g2
        write(qq,'('' Bolts are'',1p,9e10.2)') bolt01,bolt12,bolt02
        write(qq,'('' As are'',1p,9e10.2)') a10,a21,a20
        write(qq,'('' Energies are'',1p,9e10.2)') ener10,ener21,ener20
        write(qq,'('' 2 terms, dif of alpha are'',1p,3e15.6)')
     1  (r01+r02)/(r10+r01+r02) , r01/(r10+r12+r01)
        call ShowMe
        stop
      endif
*
      alpha = dble(AbunxIon)*dble(r01+r02) - dble(p2)*dble(r20+r01+r02)
*     guard against roundoff - this should really have been zero
*     >>chng 96 nov 14, protection against round-off to zero
*     >>chng 96 dec 3, made r01, etc, double, and changed limit to 1e-9
      if( abs(alpha)/(max( AbunxIon*(r01+r02),p2*(r20+r01+r02) ) )
     1 .lt.1e-9) then
        alpha = 0.
        nLev3Fail = 2
      endif
      beta = r10+r01+r02
      p1 = alpha / beta
      PopLevels(1) = p1
      if( p1.lt.0. ) then
        if( p1.gt.-1e-37 ) then
*         slightly negative solution, probably just round-off, zero it
          p1 = 0.
          PopLevels(1) = p1
          nLev3Fail = 3
        else
*         very negative solution, better punt
          write(qq,'('' level3: insane n1 pop alf, bet, p1='',1p,
     1    3e10.2,1x,a10,i5)') alpha , beta, p1,chLab,int(t10(ipLnWlAng))
          write(qq,'('' local electron density and temperature were'',
     1    1p,2e10.2)') eden , te
          call ShowMe
          stop
        endif
      endif
*
      p0 = AbunxIon - p2 - p1
*     population of lowest level
      PopLevels(0) = p0
      if( p0.le.0. ) then
        write(qq,'('' level3: insane n0 pop p1, 2, abun='',1p,
     1  3e10.2,1x)') p1,p2,AbunxIon
        call ShowMe
        stop
      endif
*
*     level populations for line opacities
      t21(ipLnPopl) = p1
      t10(ipLnPopl) = p0
      t20(ipLnPopl) = p0
      t21(ipLnPopOpc) = p1 - p2*g1/g2
      t10(ipLnPopOpc) = p0 - p1*g0/g1
      t20(ipLnPopOpc) = p0 - p2*g0/g2
      t21(ipLnPopu) = p2
      t10(ipLnPopu) = p1
      t20(ipLnPopu) = p2
*
*     line emission - net emission in line
      t21(ipLnNPhots) = t21(ipLnAul)*t21(ipLnEscP) *p2
      t21(ipLnInten) = t21(ipLnNPhots)*t21(ipLnEnrErg)
      t20(ipLnNPhots) = t20(ipLnAul)*t20(ipLnEscP) *p2
      t20(ipLnInten) = t20(ipLnNPhots)*t20(ipLnEnrErg)
      t10(ipLnNPhots) = t10(ipLnAul)*t10(ipLnEscP) *p1
      t10(ipLnInten) = t10(ipLnNPhots)*t10(ipLnEnrErg)
*     total intensity used to divide line up - one may be 0
      TotInten = t21(ipLnInten)+ t20(ipLnInten)+ t10(ipLnInten)
*
*>>>>>chng 97 dec 27, r02 was zero on ultra sparc, crashed
*     fraction that was collisionally excited
      if( r12.gt.0. ) then
        t21(ipLnColovTOT) = c12 / r12
      else
        t21(ipLnColovTOT) = 0.
      endif
      if( r01.gt.0. ) then
        t10(ipLnColovTOT) = c01 / r01
      else
        t10(ipLnColovTOT) = 0.
      endif
      if( r02.gt.0. ) then
        t20(ipLnColovTOT) = c02 / r02
      else
        t20(ipLnColovTOT) = 0.
      endif
*
*     heating or cooling due to each line
      heat20 = p2*c20 * ener20
      cool02 = p0*c02 * ener20
      heat21 = p2*c21 * ener21
      cool12 = p1*c12 * ener21
      heat10 = p1*c10 * ener10
      cool01 = p0*c01 * ener10
*
*     now get net heating or cooling
      cnet02 = cool02 - heat20*t20(ipLnColovTOT)
      hnet02 = heat20 * (1.-t20(ipLnColovTOT))
      cnet12 = cool12 - heat21*t21(ipLnColovTOT)
      hnet12 = heat21 * (1.-t21(ipLnColovTOT))
      cnet01 = cool01 - heat10*t10(ipLnColovTOT)
      hnet01 = heat10 * (1.-t10(ipLnColovTOT))
*     >>chng 96 nov 22, very dense cool models, roundoff error
*could cause [OI] 63 mic to be dominant heating, cooling, or
*just zero
*     >>chng 96 dec 6, above change caused o iii 1666 cooling to
*be zeroed when important in a model in kirk's grid.  was at 1e-6,
*     >>chng to 1e-7
*     >>chng 96 dec 17, from 1e-7 to 1e-8, caused temp fail
      if( abs(cnet01/max(1d-30,cool01)).lt.1e-8 ) then
        nLev3Fail = 4
        cnet02 = 0.
        hnet02 = 0.
        cnet12 = 0.
        hnet12 = 0.
        cnet01 = 0.
        hnet01 = 0.
      endif
*
      TotCool = cnet02 + cnet12 + cnet01
      TotHeat = hnet02 + hnet12 + hnet01
*
      if( TotInten.gt.0. ) then
        t20(ipLnCool) = TotCool * (t20(ipLnInten) / TotInten)
        t21(ipLnCool) = TotCool * (t21(ipLnInten) / TotInten)
        t10(ipLnCool) = TotCool * (t10(ipLnInten) / TotInten)
        t20(ipLnHeat) = TotHeat * (t20(ipLnInten) / TotInten)
        t21(ipLnHeat) = TotHeat * (t21(ipLnInten) / TotInten)
        t10(ipLnHeat) = TotHeat * (t10(ipLnInten) / TotInten)
      else
        nLev3Fail = 5
        t20(ipLnCool) = 0.
        t21(ipLnCool) = 0.
        t10(ipLnCool) = 0.
        t20(ipLnHeat) = 0.
        t21(ipLnHeat) = 0.
        t10(ipLnHeat) = 0.
      endif
*
*     fraction that produced lines
      t21(ipLnAovTOT) = t21(ipLnAul)*t21(ipLnEscP) / r21
      t10(ipLnAovTOT) = t10(ipLnAul)*t10(ipLnEscP) / r10
      t20(ipLnAovTOT) = t20(ipLnAul)*t20(ipLnEscP) / r20
*
*     add cooling due to each line
      call coladd( chLab(1:4) , INT(t21(ipLnWlAng)),t21(ipLnCool))
      call coladd( chLab(1:4) , INT(t10(ipLnWlAng)),t10(ipLnCool))
      call coladd( chLab(1:4) , INT(t20(ipLnWlAng)),t20(ipLnCool))
*
*     destroyed part of line
*     one of these could be a dummy line
      if(t21(ipLnIpCont) .gt. 0. ) then
        t21(ipLnOTS) =  p2*t21(ipLnAul)*t21(ipLnDesP)
        call AddOTSLin( t21(ipLnOTS) , int(t21(ipLnIpCont)),1.0 )
      endif
      if(t10(ipLnIpCont) .gt. 0. ) then
        t10(ipLnOTS) =  p1*t10(ipLnAul)*t10(ipLnDesP)
        call AddOTSLin( t10(ipLnOTS) , int(t10(ipLnIpCont)),1.0 )
      endif
      if(t20(ipLnIpCont) .gt. 0. ) then
        t20(ipLnOTS) = p2*t20(ipLnAul)*t20(ipLnDesP)
        call AddOTSLin( t20(ipLnOTS) , int(t20(ipLnIpCont)),1.0 )
      endif
*
*     derivative of cooling function
*     dC/dT = Cooling * ( T(excitation)/T_e^2 - 1/(2T) )
*     in following I assume that a 1-2 exciation will have the 0-2
*     expnential in the dcdt term = NOT A TYPO
      dCooldT = dCooldT +
     1 t10(ipLnCool)* (temp01 *tsq1-halfte) +
     2 (t20(ipLnCool)+t21(ipLnCool) ) * (temp02 *tsq1-halfte)
*     two t20's above are not a typo!
*
      end
