******************************************************************************
      logical function lgConverg(nelem)
      implicit none
*check whether ionization of element nelem has converged
      integer nelem
      include "limelm.par"
      include "itrdim.par"
      include "IonFracs.com"
      include "opacon.com"
      include "ZoneCnt.com"
      include "IOqq.com"
*
*     local variables
*     following is ionzation tolerance for considered converged
      real delta
      real OldFracs(limelm,0:limelm+1)
      save OldFracs
*     args are atomic number, ionization stage
*     OldFracs(nelem,0) is abundances of nelem (cm^-3)
      parameter (delta=0.15)
      real change , Abund
      integer nstage
*
*     this function returns true if ionization of element
*     with atomic number nelem has not changed by more than delta,
*     the variable in the parameter above
*     needed since method of Auger elec uses previous estimate
*
*     check whether abundances exist yet
      if( nzone.gt.0 ) then
        change = 0.
        Abund = xIonFracs(nelem,0)
*       write(qq,'('' convg old'',1p,10e9.1)') (OldFracs(nelem,nstage),
*    1   nstage=1,nelem+1)
        do nstage=1,nelem+1
          if( OldFracs(nelem,nstage)/Abund.gt.1e-4 .and.
     1      xIonFracs(nelem,nstage)/Abund.gt.1e-4 ) then
*           check change in old to new value
            change = max( change , 
     1      abs(xIonFracs(nelem,nstage)-OldFracs(nelem,nstage) ) /
     2      OldFracs(nelem,nstage) )
          endif
*         now set new value
          OldFracs(nelem,nstage) = xIonFracs(nelem,nstage)
        end do
*
        if( change.lt.delta ) then
          lgConverg = .true.
        else
          lgConverg = .false.
        endif
*       write(qq,'('' convg '',l3,1p,10e9.1)') lgConverg,
*    1   (OldFracs(nelem,nstage), nstage=1,nelem+1)
      else
        do nstage=1,nelem+1
          OldFracs(nelem,nstage) = xIonFracs(nelem,nstage)
        end do
        lgConverg = .true.
      endif
*
      end
