******************************************************************************
      subroutine lines
      implicit none
*main routine to put emission line intensities into line stack
      include "ipLnArry.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nhlvl.par"
      include "ndust.par"
      include "nlines.par"
      include "en1ryd.par"
      include "nwindline.par"
      include "ncell.par"
      include "limelm.par"
      include "bltzman.par"
      include "itrdim.par"
      include "nta.par"
      include "condif.com"
      include "ZoneCnt.com"
      include "edsqte.com"
      include "ots.com"
      include "coolng.com"
      include "tautot.com"
      include "nsumtt.com"
      include "cover.com"
      include "diffus.com"
      include "heating.com"
      include "IonFracs.com"
      include "DiffHeav.com"
      include "popoi.com"
      include "hetmet.com"
      include "he2ex.com"
      include "dustheat.com"
      include "iphl.com"
      include "htau.com"
      include "rin2ph.com"
      include "embesq.com"
      include "trace.com"
      include "sphere.com"
      include "bowoi.com"
      include "heots.com"
      include "ffheat.com"
      include "he1tau.com"
      include "dtrans.com"
      include "TLineEXP.com"
      include "dsum.com"
      include "hesc.com"
      include "hfrcin.com"
      include "mev.com"
      include "smbeta.com"
      include "logte.com"
      include "pmp2s.com"
      include "hextra.com"
      include "dhla.com"
      include "phlevl.com"
      include "phe2lv.com"
      include "hyas.com"
      include "workf.com"
      include "s3727.com"
      include "comptn.com"
      include "hmihet.com"
      include "tcool.com"
      include "TePowers.com"
      include "heat.com"
      include "rfield.com"
      include "reflec.com"
      include "occnum.com"
      include "widflx.com"
      include "he.com"
      include "sum.com"
      include "hem.com"
      include "phycon.com"
      include "h.com"
      include "dRdVeff.com"
      include "o3exc.com"
      include "dphoht.com"
      include "nh.com"
      include "dstfe2.com"
      include "pbowen.com"
      include "r1r0sq.com"
      include "supprs.com"
      include "heatlmax.com"
      include "WindData.com"
      include "ExtraMax.com"
      include "chrex.com"
      include "HTopOff.com"
      include "holod.com"
      include "IonStage.com"
      include "ElmntSym.com"
      include "RecCNO.com"
      include "HPhoto.com"
      include "linsum.com"
      include "IOqq.com"
*
*     major routines used here:
*
*     PutLine( tarray )
*     this uses information in tarray to give various
*     contributions to lines, and their intensities
*
*     PutExtra( extra )
*     extra is some extra intensity to add to the line
*     it will go into the totl contribution put out by PutLine,
*     and this contriibution should be indicated by independent
*     call to linadd
*
*     local variables
      character chLabel*4
      real BigstExtra 
      logical lgRecOn
      real sum,slope,bhead, below,bac,f0,f1,f3, ExtraCool , flow,f2
      integer i0,i1,i3,i2, i , ipnt
      save lgRecOn
*
*     free statement labels, >=2
*
      if( lgTrace ) write(qq,'('' lines called'')')
*
      workft = workft + workfz*dVeff*en1ryd
      power = power + htot * dVeff
      dstpow = dstpow + dstotl * dVeff
      comtot = comtot + cmheat * dVeff 
      hmitot = hmitot + hmihet * dVeff
      totcol = totcol + ctot * dVeff
      GrossHeat = GrossHeat + feheat * dVeff
      cintot = cintot + crcind * dVeff
*     nsum is line pointer within large stack of line intensities
      nsum = 0
      ndsum = 0.
*
*     last arg in call to lindst and linadd is info on line
*     info is char variable indicating type of line this is
*     'c' cooling
*     'h' heating
*     'i' information only
*     'r' recombination line
*
*     all components of lines are entered into the main line stack here
*     when printing, filters exist to not print Inwd component
*
*     initialize routine that can generate pointers for forbidden lines 
      call PntForLine( 0. , 'FILL' , i )
*
*     evaluate rec coef for rec lines of C, N, O
*     some will be used in LineSet2 and then zeroed out,
*     others left alone and used below
      call LineFit( te , RecCoefCNO )
*
*     punch energetics, H and He lines
      call LineSet1
*
*     do heavies, lithium through neon
      call LineSet2
*
*     do heavies, sodium through argon
      call LineSet3
*
*     do heavies, potasium through zinc
      call LineSet4
*
      call rdsum( sum , ' SUM' )
      sumlin(nsum+1) = 0.
*     optional sum of certain emission lines, set with "print sum"
      call linadd( sum/dVeff , 0 , 'Stoy','i')
*
*     stuff in Bac ratio
*     extrapolated continuum above the BJ
      i0 = ipHn(2) + 1
*     reflec continuum is different from others since relative to inner
*     radius, others for for this radius
*     remove ContDiff
*     ContDiff was in here, removed july 95 - I do not think this
*     will work with ots continuum
      f0 = (outcon(i0)+refcon(i0)/r1r0sq)/widflx(i0)
      i1 = ipHn(2)
      f1 = (outcon(i1)+refcon(i1)/r1r0sq)/widflx(i1)
      slope = ( f1 - f0 ) / ( anu(i1)-anu(i0) )
      bhead = f1 + (0.250-anu(i1))* slope
*
*     extrapolated continuum below head
      i2 = ipHn(2)-1
      f2 = (outcon(i2)+refcon(i2)/r1r0sq)/widflx(i2)
      i3 = ipHn(2)-2
      f3 = (outcon(i3)+refcon(i3)/r1r0sq)/widflx(i3)
      slope = ( f3 - f2 ) / ( anu(i3)-anu(i2) )
      below = f2 + (0.250-anu(i2))* slope
*     extrapolate to point above Balmer continuum
      flow = f2 + (f2-f3)
      bac = f1 - flow
*
*     convert to nuFnu units
      bhead = f1
      below = f2
      bac = (bhead-below) * 0.250*0.250 *en1ryd*r1r0sq
      sumlin(nsum+1) = 0.
*     residual flux at head of Balmer continuum, nuFnu
      call linadd( max(0.,bac)/dVeff , 3646 , 'BaC ','i')
*
      f1 = (ContDiff(i1))/widflx(i1)
      f2 = (ContDiff(i2))/widflx(i2)
      bac = (f1-f2) * 0.250*0.250 *en1ryd*r1r0sq
      sumlin(nsum+1) = 0.
*     residual flux in Balmer continuum, nuFnu
      call linadd( max(0.,bac)/dVeff , 3646 , 'cdif','i')
*
      f1 = (outcon(i1))/widflx(i1)*r1r0sq
      f2 = (outcon(i2))/widflx(i2)*r1r0sq
      bac = (f1-f2) * 0.250*0.250 *en1ryd
      sumlin(nsum+1) = 0.
*     residual flux in Balmer continuum, nuFnu
      call linadd( max(0.,bac)/dVeff , 3646 , 'cout','i')
*
      f1 = refcon(i1)/widflx(i1)
      f2 = refcon(i2)/widflx(i2)
      bac = (f1-f2) * 0.250*0.250 *en1ryd
      sumlin(nsum+1) = 0.
*     residual flux in Balmer continuum, nuFnu
      call linadd( max(0.,bac)/dVeff , 3646 , 'cref','i')
*
      f1 = DiffCont(i1)/widflx(i1)
      f2 = DiffCont(i2)/widflx(i2)
      bac = (f1-f2) * 0.250*0.250 *en1ryd
*     residual flux in Balmer continuum, nuFnu
      call linadd( max(0.,bac) , 3646 , 'thin','i')
*
*     large number of C, N, and O recombination lines
      if( ipass.eq.0 ) lgRecOn = .true.
      do i=1,471
        chLabel(1:2) = chElementSym(int(RecCoefCNO(i,1)))
        chLabel(3:4) = chIonStage(int(RecCoefCNO(i,1)-
     1  RecCoefCNO(i,2)+1.01))
*       number of rec per unit vol
*       >>chng 97 aug 28, do not predict rec intensities at high densities
*       blr.in and oldblr.in go nuts if this is added in outward beam
        if( eden.lt.1e8 .and. lgRecOn ) then
          f2 = RecCoefCNO(i,4)*eden*xIonFracs(int(RecCoefCNO(i,1)) ,
     1    int(RecCoefCNO(i,1)-RecCoefCNO(i,2)+2) )
*         convert to intensity
          f2 = f2 * 1.99e-8 / RecCoefCNO(i,3)
        else
          lgRecOn = .false.
          f2 = 0.
        endif
        call PntForLine( RecCoefCNO(i,3) , chLabel , ipnt )
        call lindst(f2,int(RecCoefCNO(i,3)+.5),chLabel,ipnt,'r',.true.)
*       call linadd(f2,int(RecCoefCNO(i,3)+.5),chLabel     ,'r')
      end do
*
*     add in all the other lines
*     Dima'a 6k lines
      ExtraCool = 0.
      BigstExtra = 0.
      do i=1,NWINDLINE*nWindOn
        call PutLine( WindLine(1,i) )
        if( WindLine( ipLnCool,i).gt.BigstExtra ) then
          BigstExtra = WindLine(ipLnCool,i)
          ipMaxExtra = i
        endif
        ExtraCool = ExtraCool + WindLine(ipLnCool,i)
      end do
      GBarMax = max( GBarMax , ExtraCool/ctot )
*
      nsumtt = nsum
      if( lgTrace ) write(qq,'('' lines returns'')')
*
      end
