******************************************************************************
      subroutine LineSet2
      implicit none
*place lines of elements lithium through neon into lines storage stack
      include "limelm.par"
      include "nhlvl.par"
      include "nta.par"
      include "nwindline.par"
      include "ipLnArry.par"
      include "raten3.com"
      include "DiffHeav.com"
      include "turb.com"
      include "coolng.com"
      include "pmp2s.com"
      include "supprs.com"
      include "r1335.com"
      include "coolne.com"
      include "coolox.com"
      include "cooln.com"
      include "coolc.com"
      include "phycon.com"
      include "TePowers.com"
      include "popoi.com"
      include "s3727.com"
      include "iphl.com"
      include "embesq.com"
      include "h.com"
      include "he.com"
      include "edsqte.com"
      include "TLineEXP.com"
      include "IonFracs.com"
      include "augro3.com"
      include "o3exc.com"
      include "trace.com"
      include "oii.com"
      include "WindData.com"
      include "IOqq.com"
*
*     local variable
      integer nelem , ipnt
      real rp386,rp300,xlila,bela,bola,corr,
     1 ctRate, efficn2,cs5200,r6584,fac,rec , t4 ,sum , colfac,
     2 rnii , p386,cla,rn3tot,rn3mor,flla,rb,ct4363,r4363,
     3 efac,effec,ola,xnela , xnla , GetLineRec
*
      if( lgTrace ) write(qq,'(''   LineSet2 called'')')
*
      t4 = te / 1e4
*
*     cooling due to collisional ionization of heavy elements
      call linadd( colmet , 0 , 'Mion' ,'c')
*
*     lithium
*     recombination from fully stripped ion
      nelem = 3
*     these lines added to outlin in metdif - following must be false
      xlila = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( xlila*1.05E-9 , 19 , 'Li3r','i')
*
*     beryllium
*     recombination from fully stripped ion
      nelem = 4
*     these lines added to outlin in metdif - following must be false
      bela = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( bela*1.05E-9 , 19 , 'Be4r','i')
*
*     boron
*     recombination from fully stripped ion
      nelem = 5
*     these lines added to outlin in metdif - following must be false
      bola = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( bola*1.05E-9 , 19 , 'Bo5r','i')
*
*     carbon
*
*     >>chng 97 may 2, added better rec coef
*     C I 1656 recombination, all agents
      rec = GetLineRec( 4, 1657 ) * t1656(ipLnAovTOT)
      call PutExtra( rec )
*
*     C 1 1656, collision strength from van Regemoter
      call PutLine( t1656 )
*
*     C 1 1656 recomb; n.b. coll deexcitation not in
      call linadd( rec ,1656, 'REC ','i')
*
*     C 1 9850, coll excit
      call linadd( c9850 , 9850 , 'C Ic','c')
*
*     >>chng 97 may 2, added better rec coef
*     C 1 9850, recom contribution rec coef from apj sup 73, 513.
*     r9850 is correction for collisional deexcitation as in carb cool
*     >>chng 97 aug 2, had factor of rec, changed to r9850, this
*     was a big mistake
      rec = (GetLineRec(2,9088)+GetLineRec(3,9658)) * r9850
      call linadd( rec , 9850 , 'C Ir','i')
*
*     total intensity, all processes, C I 9850
      call PntForLine( 9850. , 'C  1' , ipnt )
      call lindst( rec+c9850, 9850,'TOTL',ipnt,'i', .true.)
*     call linadd( rec+c9850, 9850 , 'TOTL','i')
*
*     C 1 8727; equivalent to 4363
      call PntForLine( 8727. , 'C  1' , ipnt )
      call lindst( c8727, 8727,'C  1',ipnt,'c', .true.)
*     call linadd( c8727, 8727, 'C  1','c')
*
*     1S - 3P
      call linadd(c8727*1.22E-6, 4621, 'C  1','c')
*
*     C 1 610 micron
      call PutLine( t610 )
*
*     C 1 370 micron
      call PutLine( t370 )
*
*     C 2 158 micron, both e- and H0, H2 in excitation
      call PutLine( t157 )
*
*     C 2  2326
*     total CII] 2326 with correction for Balmer continuum abs
      call PutExtra( p2326*8.6e-12 )
      call PutLine( t2326 )
*
*     photoproduction, Helfand and Trefftz
      call linadd( p2326*8.6E-12 , 2326 , 'Phot' ,'i')
*
*     >>chng 97 may 2, better rec coef
      rec = GetLineRec(12,1335) * t1335(ipLnAovTOT)
*
*     total intensity of C 2 1335
      call PutExtra( max(0.,rec) )
      call PutLine( t1335 )
*
*     C 2 1335 recombination,
      call linadd(rec,1335,'REC ','i')
*
*     C 2 intercombination line with same upper state as 1335
      call linadd( c3134 , 3134 , 'C II','c')
*
*     *****************************************
*     C 3 977
*     recombinaton contribution from nussbaumer and story 84
      rec = GetLineRec( 180, 977 ) * t977(ipLnAovTOT)
*
*     continuum pumped C 3 977 by continuum near 386A
      rp386 = t386(ipLnPump) *t386(ipLnPopOpc)
*
*     higher lines, same process
      rp300 =
     1 t310(ipLnPump)*t310(ipLnPopOpc) +
     2 t291(ipLnPump)*t291(ipLnPopOpc) +
     3 t280(ipLnPump)*t280(ipLnPopOpc) +
     4 t274(ipLnPump)*t274(ipLnPopOpc) +
     5 t270(ipLnPump)*t270(ipLnPopOpc)
*
*     total line intensity due to pumping
      p386 = (rp386 + rp300) *2.03e-11 * t977(ipLnAovTOT)
*
*     total C 3 977 including recombination and pumping
      call PutExtra( p386+max(0.,rec))
*
*     total C 3] 977, recombination + collisional + pumped excitation
      call PutLine( t977 )
*
*     dielectronic recombination contribution to C 3 977
      call linadd( rec  , 977 , 'C3 R' ,'i')
*
*     C 3 977 pumped by continuum near 386A
      call linadd( p386 , 977 , 'P386' ,'r')
*
*     C 3  1909 collision, both lines together
      fac = em1908+t1909(ipLnInten)
      call linadd( fac , 1909 , 'TOTL','i')
*
      call PutLine(t1909 )
*
*     C 3 1908 j-2 to ground
      call PntForLine( 1907. , 'C  3' , ipnt )
      call lindst( em1908 , 1907 ,'C  3',ipnt,'i', .true.)
*     call linadd( em1908 , 1907 , 'C  3','i')
*
      corr = t1909(ipLnAovTOT)
      fac = eden * xIonFracs(6,4)/(te/te10)*supprs(3,2)
*
*     C 3 1909 recombination from Storey
      call linadd( 3.1E-19*fac*corr,  1909  ,  'C3 R' ,'i')
*
*     C 3 1909 following relax following inner shell photoionization
      call linadd( p1909*corr*1.05E-11 , 1909 , 'Phot' ,'i')
*
*     >>chng 97 may 2, better rec ocef
      rec = GetLineRec( 179,1176)*c31175(ipLnAovTOT)
      call PutExtra( max(0.,rec) )
*
*     C 3* 1175, excited state line, above 1909
      call PutLine( c31175 )
*
*     dielectronic recombination contribution to C 3 1175
      call linadd( max(0., rec ) , 1175, 'Rec ', 'i' )
*
*     recombination C 4 1549 from C 5
*     >>chng 97 may 2, better rec coef
      rec = GetLineRec( 26, 1549 ) * t1550(ipLnAovTOT)
*
*     total intensity of C 4 1549, all processes
      call linadd(t1550(ipLnInten)+t1548(ipLnInten)+rec,1549,'TOTL','i')
      sum = t1550(ipLnInten)*t1550(ipLnInwd) +
     1 t1548(ipLnInten)*t1548(ipLnInwd)
*
*     inward part of C 4
      call linadd(sum+rec*t1550(ipLnInwd),1549,'Inwd','i')
      call PutExtra( rec*.3333 )
      call PutLine( t1550 )
      call PutExtra( rec*.6666 )
      call PutLine( t1548 )
*
*     part of line destroyed by photoionization of Balmer continuum
      call linadd( (t1550(ipLnOTS)+t1548(ipLnOTS))*t1548(ipLnEnrErg) ,
     1 1549 , 'DEST' ,'i')
*
*     recombination C 4 1549 from CV
      call linadd( rec ,1549, 'C4 r','i')
*
*     Li seq 2s 3p Li seq transition
      call PutLine( t312 )
*
*     K-alpha due to recombination of stripped ion
*     these lines added to outlin in metdif - following must be false
      cla = xLyaHeavy(6,6)*xIonFracs(6,7)*5.90E-10 
      call PntForLine( 33.7 , 'C 6r' , ipnt )
      call lindst( cla, 34,'C 6r',ipnt,'i', .false.)
*     call linadd( cla , 34 , 'C 6r','i')
*
*     nitrogen
*
*     5200 rec, both rad+di, 1/3 of total to doublets
      colfac = 8.629e-6/sqrte*eden
      cs5200 = 7.28e-5 * te / te10
*     this is recombination with quenching
      rec = GetLineRec( 33 , 1200 ) * 
     1 1.24e-5 / (1.24e-5 + cs5200*colfac / 10. )
*
*     N 1 5200, both 5198, 5200, collisions and recombination
      call PntForLine( 5200. , 'N  1' , ipnt )
      call lindst(c5200+rec,5200,'N  1', ipnt,'i',.true.)
*     call linadd(c5200+rec,5200,'N  1','i')
*
*     N 1 5200, both 5198, 5200, collisions and recombination
      call linadd(c5200,5200,'Coll','c')
*
*     recombination contributon to [NI] 5200
      call linadd( rec , 5200 , 'REC ','i')
*
*     [N 1] 3466, 3 - 1 transition, whole multiplet
      call PntForLine( 3466. , 'N  1' , ipnt )
      call lindst(c3466 , 3466,'N  1', ipnt,'c',.true.)
*     call linadd(c3466 , 3466 , 'N  1','c')
*
*     [N 1] 10400 3 - 2 transition, whole multiplet
      call PntForLine( 10400. , 'N  1' , ipnt )
      call lindst( c10400 , 10400,'N  1', ipnt,'c',.true.)
*     call linadd( c10400 , 10400,'N  1','c')
*
*     collisionally excited part
      call PutLine( t1200 )
*
*     N 2 6584 alone
      call PntForLine( 6584. , 'N  2' , ipnt )
      call lindst(c6584/(1.+1./2.951) ,6584,'N  2', ipnt,'c',.true.)
*
*     N 2 6548 alone
      call PntForLine( 6548. , 'N  2' , ipnt )
      call lindst(c6584/(1.+2.951) ,6548,'N  2', ipnt,'c',.true.)
*
*     N 2 6584 alone, recombination contribution
      efficn2 = 4e-3/(4e-3+5.18e-6*eden/sqrte)
      r6584 = 8e-22/(te70/te03/te03)* efficn2
      call linadd( r6584 * xIonFracs(7,3) * eden , 6584 , 'REC ' ,'i')
*
*     helium charge transfer form Sun Sadeghpour, Kirby Dalgarno and Lafyatis,
*     cfa preprint 4208
      ctRate = 1.8e-11 * hei * xIonFracs(7,3)*1.146/
     1 (1.146 + 0.87*cdsqte) * 3.46e-12
*
*     N 2 5755  total, collisions plus charge transfer
      call PntForLine( 5755. , 'N  2' , ipnt )
      call lindst( c5755+ctRate, 5755 , 'N  2' , ipnt ,'i',.true.)
*     call linadd( c5755+ctRate, 5755 , 'N  2','i')
*
*     N 2 5755  collisional contribution
      call linadd( c5755 , 5755 , 'Coll','c')
*
*     N 2 5755  charge transfer contribution
      call linadd( ctRate , 5755 , 'C T ','c')
*
*     N 2 fine structure line
      call PutLine( t122 )
*
*     N 2 fine structure line
      call PutLine( t205 )
*
*     N 2 2140 intercombination line
      call PutLine( t2140 )
*
*     >>chng 97 may 2, better rec contribution
      rec = GetLineRec( 202 , 1085 ) * t1085(ipLnAovTOT)
      call PutExtra( max(0.,rec) )
*
*     N 2 1084, CS guess from g-bar
      call PutLine( t1085 )
*
*     dielectronic recombination contribution to N 2 1085
      call linadd( max(0., rec ) , 1085, 'Rec ', 'i' )
*
*     continuum puming of N 2 intersystem transition
      rnii = t671(ipLnPump) * t671(ipLnPopOpc)
*
*     continuum pumped N 2 6584
      call linadd(  rnii*0.377*0.75*3.02E-12*efficn2  ,  6584  , 
     1 'N2cn', 'i')
*
*     continuum pumped N 2 5755
      efficn2 = 1. /(1. +8.6e-6*eden/sqrte)
      call linadd(rnii*0.0117*3.46E-12*efficn2 ,5755,'N2cn', 'i')
*
*     continuum pumped contribution to CII 4267 (not N)
      rnii = WindLine(ipLnPump,180)*WindLine(ipLnPopOpc,180)*0.00187 
*     intensity of line, with collisional deexcitation
      rnii = rnii * 3.50e-12 /(1.+eden/1e12 )
      call linadd(rnii ,4267,'pump', 'i')
*
*     continuum pumped contribution to CII 3920
      rnii = WindLine(ipLnPump,187)*WindLine(ipLnPopOpc,187)*0.385
*	write(qq,'(''tauline2'' 1p,2e10.2)')WindLine(ipLnTauIn,187),rnii 
*     intensity of line, with collisional deexcitation
      rnii = rnii * 5.08e-12 /(1.+eden/1e12 )
      call linadd(rnii ,3920,'pump', 'i')
*
*     continuum pumped contribution to NII 5680
      rnii = WindLine(ipLnPump,266)*WindLine(ipLnPopOpc,266)*0.236 + 
     1 WindLine(ipLnPump,271)*WindLine(ipLnPopOpc,271)*0.193 +
     1 WindLine(ipLnPump,277)*WindLine(ipLnPopOpc,277)*0.189
*     intensity of line, with collisional deexcitation
      rnii = rnii * 4.66e-12 /(1.+eden/1e12 )
      call linadd(rnii ,5680,'pump', 'i')
*
*     continuum pumped contribution to OII 4651 (not nitrogen)
      rnii = 
     1 WindLine(ipLnPump,388)*WindLine(ipLnPopOpc,388)*0.336 + 
     1 WindLine(ipLnPump,392)*WindLine(ipLnPopOpc,392)*0.268 +
     1 WindLine(ipLnPump,393)*WindLine(ipLnPopOpc,393)*0.249 +
     1 WindLine(ipLnPump,397)*WindLine(ipLnPopOpc,397)*0.259
*     intensity of line, with collisional deexcitation
      rnii = rnii * 4.28e-12 /(1.+eden/1e12 )
      call linadd(rnii ,4341,'pump', 'i')
*
*     continuum pumped contribution to OII 4651 (not nitrogen)
      rnii = 
     1 WindLine(ipLnPump,388)*WindLine(ipLnPopOpc,388)*0.147 + 
     1 WindLine(ipLnPump,392)*WindLine(ipLnPopOpc,392)*0.128 +
     1 WindLine(ipLnPump,393)*WindLine(ipLnPopOpc,393)*0.125 +
     1 WindLine(ipLnPump,397)*WindLine(ipLnPopOpc,397)*0.134
*     intensity of line, with collisional deexcitation
      rnii = rnii * 4.28e-12 /(1.+eden/1e12 )
      call linadd(rnii ,4651,'pump', 'i')
*
*     N 3] 1750, collisionally excited
      call PutLine( t1750 )
*
*     [N 3] 57 micron fine structure line
      call PutLine( t57 )
*
*     continuum pumped "Bowen" N 3
*     rate system a is populated 
      raten3 = t374x(ipLnPopOpc) * t374x(ipLnPump)
*
*     rate system b is populated
      if( TurbVel.lt.200. ) then
        rb = t374x(ipLnPopOpc) * t374x(ipLnPump) + t374g(ipLnPopOpc) *
     1  t374g(ipLnPump)
      else
*       only one line if both fully overlap due to large turb
        rb = t374g(ipLnPopOpc) * t374g(ipLnPump)
      endif
      rn3mor = t315(ipLnPopOpc)*t315(ipLnPump)*0.448 + t324(ipLnPopOpc)*
     1 t324(ipLnPump)*0.78 +
     1  t333(ipLnPopOpc)*t333(ipLnPump)* 0.434
*
*     pumping of optical N 3 bowen lines
      rn3tot = ( rb + raten3 ) * 0.439 + rn3mor
*
*     continuum pumped "Bowen" N 3, optically thin excited line
      sum = raten3*4.29E-12
      call PntForLine( 4640. , 'N3cn' , ipnt )
      call lindst( sum  , 4640 , 'N3cn' , ipnt ,'i',.true.)
*     call linadd( raten3*4.29E-12, 4640, 'N3cn' , 'i' )
*
*     continuum pumped "Bowen" N 3, optically thin excited line
      sum = rb*4.29E-12*0.834
      call PntForLine( 4634. , 'N3cn' , ipnt )
      call lindst( sum  , 4634 , 'N3cn' , ipnt ,'i',.true.)
*     call linadd( rb*4.29E-12*0.834, 4634, 'N3cn' , 'i' )
*
*     continuum pumped "Bowen" N 3, optically thin excited line
      sum = rb*4.29E-12*(1.-0.834)
      call PntForLine( 4642. , 'N3cn' , ipnt )
      call lindst( sum  , 4642 , 'N3cn' , ipnt ,'i',.true.)
*     call linadd( rb*4.29E-12*(1.-0.834), 4642, 'N3cn' , 'i' )
*
*     total rate for N 3 990
*     correction factor for collisional deexcitation
      fac = t990(ipLnAovTOT)
*
*     >>chng 97 may 2, better rec coef
      rec = GetLineRec(217 , 991)*t990(ipLnAovTOT)
      call PutExtra( max(0.,rec)+ rn3tot*2.01e-11*fac )
*
*     N 3 990, all processes
      call PutLine( t990 )
*
*     total N 3 990, both electron excitation and continuum pumping
      call linadd( rec+rn3tot*2.01e-11*fac , 990 , 'extr','i')
*
*     part of N 3 990 due to recombination
      call linadd( rec , 990 , 'rec ','i')
*
*     N 3 989.8, continuum pumped
      call linadd( rn3tot*2.01e-11 , 990 , 'N 3p','r')
*
*     N 4] 1486, total intensity of both lines
      call linadd( em1486+t1486(ipLnInten) , 1486 , 'TOTL','i')
      call PutLine( t1486 )
*
*     the N 4] slow transition by itself
      call linadd( em1486 , 1485 , 'N  4','i')
*
*     >>chng 97 may 2, better expression for dielectronic recombination
      rec = GetLineRec( 288 , 765 )*t765(ipLnAovTOT)
*
*     dielectronic recom contribution from Nussbaumer and Storey 1984
      call PutExtra(rec )
*
*     N 4 765, collisionally excited
      call PutLine( t765 )
*
*     N 4 765 recombination,
      call linadd(max(0.,rec),765,'rec ','i')
*
*     continuum pumping of NV 1240
*     N 5 1240, total emission, collisions plus pumping
      call linadd( t1243(ipLnInten)+t1239(ipLnInten),1240,'TOTL','i')
      sum = t1243(ipLnInten)*t1243(ipLnInwd) +
     1 t1239(ipLnInten)*t1239(ipLnInwd)
*
*     inward part of N 5
      call linadd( sum,1240,'Inwd','i')
      call PutLine( t1243 )
      call PutLine( t1239 )
*
*     N 5 209, 2s-3p li seq
      call PutLine( t209 )
*
*     recombination K-alpha from fully stripped ion
*     these lines added to outlin in metdif - following must be false
      xnla = xLyaHeavy(7,7)*xIonFracs(7,8)
      call PntForLine( 24.8 , 'N 7r' , ipnt )
      call lindst( xnla*8.03E-10, 25 , 'N 7r' , ipnt ,'i',.false.)
*     call linadd( xnla*8.03E-10, 25 , 'N 7r','i')
*
*     oxygen
*     total Oxygen I  6300, including line optical depth
      call PntForLine( 6300. , 'O  1' , ipnt )
      call lindst( c6300  , 6300 , 'O  1' , ipnt ,'c',.true.)
*
*     total Oxygen I  6363, including line optical depth
      call PntForLine( 6363. , 'O  1' , ipnt )
      call lindst( c6363  , 6363 , 'O  1' , ipnt ,'c',.true.)
*
*     auroral OI
      call PntForLine( 5577. , 'O  1' , ipnt )
      call lindst( c5577 , 5577 , 'O  1' , ipnt ,'c',.true.)
*     call linadd( c5577 , 5577 , 'O  1','c')
*
*     O I fine structure line
      call PutLine( t63 )
*
*     O I fine structure line
      call PutLine( t146 )
*
*     total collisional cooling due to 6-level OI atom
      call linadd( max(0.,coolOi) , 0, 'TOIc','c')
*
*     total collisional heating due to 6-level OI atom
      call linadd( max(0.,-coolOi) , 0, 'TOIh','h')
*
*     OI 8446 from six level atom
      sum = popoi(5)*t8446(3)*3.28E7*2.36E-12
      call PntForLine( 8446. , 'O  1' , ipnt )
*666 error!  these are actually in the optical depth arrays, should
*     be moved to call PutLine
      call lindst( sum , 8446 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(5)*t8446(3)*3.28E7*2.36E-12,8446,'6lev','i')
*
*     OI 1304 from six level atom
      call PntForLine( 1304. , 'O  1' , ipnt )
      sum = popoi(2)*t1304(3)*6.04E8*1.53E-11
      call lindst( sum , 1304 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(2)*t1304(3)*6.04E8*1.53E-11,1304,'6lev','i')
*
*     OI 1039 from six level atom
      call PntForLine( 1039. , 'O  1' , ipnt )
      sum = popoi(4)*t1039(3)*1.69E8*1.92E-11
      call lindst( sum , 1039 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(4)*t1039(3)*1.69E8*1.92E-11,1039,'6lev','i')
*
*     OI 4368 from six level atom
      call PntForLine( 4368. , 'O  1' , ipnt )
      sum = popoi(6)*t4368(3)*8.97E6*4.55E-12
      call lindst( sum , 4368 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(6)*t4368(3)*8.97E6*4.55E-12,4368,'6lev','i')
*
*     OI 1.3 micron from six level atom
      call PntForLine( 13100. , 'O  1' , ipnt )
      sum = popoi(4)*tOI13(3)*2.12E7*1.52E-12
      call lindst( sum , 13 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(4)*tOI13(3)*2.12E7*1.52E-12,  13,'6lev','i')
*
*     OI 1.1 micron from six level atom
      call PntForLine( 11300. , 'O  1' , ipnt )
      sum = popoi(5)*tOI11(3)*3.03E7*1.76E-12
      call lindst( sum , 11 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(5)*tOI11(3)*3.03E7*1.76E-12,  11,'6lev','i')
*
*     OI 2.9 micron from six level atom
      call PntForLine( 29000. , 'O  1' , ipnt )
      sum = popoi(6)*tOI29(3)*4.00E6*6.86E-13
      call lindst( sum , 29 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(6)*tOI29(3)*4.00E6*6.86E-13,  29,'6lev','i')
*
*     OI 4.6 micron from six level atom
      call PntForLine( 46000. , 'O  1' , ipnt )
      sum = popoi(6)*tOI46(3)*9.73E5*4.32E-13
      call lindst( sum , 46 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(6)*tOI46(3)*9.73E5*4.32E-13,  46,'6lev','i')
*
*     OI 1641 intercombination line from six level atom
*     OI line aadded to follow up Martin Gaskell's suggestion that 
*     this could be an important contributor to the HeII 1640 feature
      call PntForLine( 1640. , 'O  1' , ipnt )
      sum = popoi(2)*1800.*1.21E-12
      call lindst( sum , 1641 , '6lev' , ipnt ,'i',.false.)
*
*     O II 3727 produced by photoionization OF O0
      s3727 = (s3727+s7325*0.5) * 5.34e-12 * 9.7e-5 / (9.7e-5 +
     1 eden * 1.15e-6 / sqrte )
*
*     O II 3727, all lines of multiplet together
      call PntForLine( 3727. , 'O  2' , ipnt )
      call lindst( c3727+s3727 , 3727 , 'TOTL' , ipnt,'c',.true.)
*
*     O II 7325, all lines of multiplet together
      call PntForLine( 7325. , 'O  2' , ipnt )
      call lindst( c7325 , 7325 , 'TOTL',ipnt,'c',.true.)
*
*     line produced by photoionization of Oo; already in TOTL
      call linadd( s3727 , 3727 , 'IONZ' ,'i')
      s7325 = s7325 * 2.72E-12 * 0.34 / (0.34+eden*6.04e-6/sqrte)
*
*     line produced by photoionization of Oo; already in TOTL
      call linadd( s7325 , 7325 , 'IONZ' ,'i')
*
*     five level atom calculations; D5/2 - S3/2
      call linadd(O3730,3729,'O II','i')
*
*     D3/2 - S3/2 transition
      call linadd(O3727,3726,'O II','i')
*
*     both 2P 1/2 and 3/2 to ground
      call linadd(O2471,2471,'O II','c')
*
*     P1/2-D5/2 and P3/2-D5/2 together
      call linadd(O7323,7323,'O II','i')
*
*     P1/2-D3/2 and P3/2-D3/2 together
      call linadd(O7332,7332,'O II','i')
*
*     O II 833.8 coll excit
      call PutLine( t834 )
*
*     >>chng 97 july 24, following three lines are also in Dima's list
*     coef = 34.9E-14*t4**(-0.749)*(1.+0.023*(1.-t4)+0.074*(1.-t4)**2)*
*    1 supprs(2,2)
*     O II 4651 - whole multiplet, from Storey Ast Ap 282, 999 (1994).
*     call linadd( eden*oxy(3)*coef*4.28e-12,4651,'O  2','i')
*
*     OII 4075 - Storey AstAp 282, 999 (1994)
*     coef = 24.5e-14*t4**(-0.770)*(1.+0.096*(1.-t4)+0.039*(1.-t4)**2)
*     call linadd( eden*oxy(3)*coef*4.88e-12,4075,'O  2','i')
*
*     OII 4341 - Storey AstAp 282, 999 (1994)
*     coef = 10.4e-14 * t4**(-0.721)*(1.+0.073*(1.-t4)+0.072*(1.-t4)**2)
*     O II 4341 - whole multiplet, from Storey Ast Ap 282, 999 (1994).
*     call linadd( eden*oxy(3)*coef*4.58e-12,4341,'O  2','i')
*
*     O III 1661+1666
      efac = (t1666(ipLnAovTOT)+t1661(ipLnAovTOT) )* 0.5
*
*     total intensity of OIII] 1665, all processes
      call linadd(t1666(ipLnInten)+t1661(ipLnInten),1665,'TOTL','i')
      call PutLine( t1661 )
*
      call PutLine( t1666 )
*
*     contribution to OIII 1665 due to inner shell (2s^2) ionization
      call linadd(p1666*1.20e-11*efac , 1665 , 'Phot' ,'i')
*
*     contribution to OIII 1665 due to K-shell ionization
      call linadd(AugerO3*1.20e-11*efac*0.27 , 1665 , 'Augr' ,'i')
*
*     O III  5007 alone, collisions, tot OIII is this times 1.333
*     fac = c5007/(1.+1./2.887)
      call PntForLine( 5007. , 'O  3' , ipnt )
      call lindst(c5007/(1.+1./2.887), 5007 , 'O  3',ipnt,'c',.true.)
*
*     O III  4959 alone, collisions, tot OIII is this times 4
      call PntForLine( 4959. , 'O  3' , ipnt )
      call lindst(c5007/(1.+2.887) , 4959 , 'O  3' , ipnt,'c',.true.)
*
*     O III 5007 lost through excit photo
      call linadd( d5007t / 1.25 , 5007 , 'LOST','i')
*
*     collisional quenching ratio
      effec = 1.6 / ( 1.6 + 0.9*colfac)
*
*     O III 4363 recombination, coef from Burgess and Seaton
      r4363 = 6.3e-21 / (te70*te10) *  eden * xIonFracs(8,4)*effec
*
*     charge exchange, Dalgarno+Sternberg ApJ Let 257, L87.
*     scalled to agree with Gargaud et al AA 208, 251, (1989)
      ct4363 = sqrte*1.3e-12*4.561e-12*hi*xIonFracs(8,4)*effec
*
*     O III 4363, sum of rec, coll, ct excitation
      fac = c4363+r4363+ct4363
      call PntForLine( 4363. , 'O  3' , ipnt )
      call lindst(fac, 4363 , 'TOTL' , ipnt ,'i', .true.)
*
*     O III 4363,collisions from five level atom
      call linadd( c4363 , 4363 , 'Coll' , 'c')
*
*     O III 4363 recombination, coef from Burgess and Seaton
      call linadd( r4363 , 4363 , 'Rec ','i')
*
*     collisional excitation of 2321, 5-level atom
      call PntForLine( 2321. , 'O  3' , ipnt )
      call lindst( c4363*0.236 , 2321 , 'O  3' , ipnt ,'c', .true.)
*     call linadd( c4363*0.236 , 2321 , 'O  3','c')
*
*     charge exchange, Dalgarno+Sternberg ApJ Let 257, L87.
      call linadd(ct4363,4363,'C EX','i')
*
*     charge exchange rate, D+S
      call linadd( hi*xIonFracs(8,4)*0.225*3.56e-12*1.34e-11*sqrte ,
     1 5592 , 'C EX','i')
*
*     O III 88 micron, collisionally excited
      call PutLine( tO88 )
*
*     O III 52 micron, collisionally excited
      call PutLine( t52 )
*
*     >>chng 97 may 2, better rec contribution
      rec = GetLineRec(332, 835 ) * t835(ipLnAovTOT)
      call PutExtra( max(0.,rec) )
*
*     O III 834A, collisions and dielectronic recombination
      call PutLine( t835 )
*
*     O III 834A, dielectronic recombination only
      call linadd(max(0.,rec),835,'rec ','i')
*
*     O IV 26 micron
      call PutLine( t26 )
*
*     O IV 1402, collisions
      call PutLine( t1402 )
*
*     inner shell photoionization, relaxation
      call linadd(p1401*1.42E-11 , 1401 , 'InSh' ,'i')
*
*     >>chng 97 may 2, better rec contribution
      rec = GetLineRec( 379 , 789 ) * t789(ipLnAovTOT)
      call PutExtra( max(0.,rec) )
*
*     O IV 789A
      call PutLine( t789 )
*
*     O IV 789A, dielectronic recombination only
      call linadd(max(0.,rec),789,'rec ','i')
*
*     >>chng 97 may 2, better rec contribution
      rec = GetLineRec( 467 , 630 )
      call PutExtra( max(0.,rec) )
*
*     O V 630, collisional excitation and dielectonic recombination
      call PutLine( t630 )
*
*     O V 630A, dielectronic recombination only
      call linadd(max(0.,rec),630,'rec ','i')
*
*     O V 1218], total intensity of both lines
      call linadd( em1218+t1214(ipLnInten), 1218,'TOTL','i')
      call PutLine( t1214 )
*
*     the slow transition by itself
      call linadd( em1218 , 1211,'O  5','i')
*
*     BS O V 5112, recombination
      call linadd(1.4E-21/te70*eden*xIonFracs(8,6)*t1214(ipLnAovTOT),
     1 5112 , 'O  5','i')
*
*     O VI 1035, total of pumping and collisional excitation
      call linadd( t1032(ipLnInten)+t1037(ipLnInten),1035,'TOTL','i')
      sum = t1032(ipLnInten)*t1032(ipLnInwd) +
     1 t1037(ipLnInten)*t1037(ipLnInwd)
*
*     inward part of OVI line
      call linadd( sum,1035,'Inwd','i')
      call PutLine( t1032 )
      call PutLine( t1037 )
*
*     O VI 150, li seq 2s 3p
      call PutLine( t150 )
      nelem = 8
*     these lines added to outlin in metdif - following must be false
      ola = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.05E-9
*
*     recombination from fully stripped ion
      call PntForLine( 19.0 , 'O 8r' , ipnt )
      call lindst( ola         , 19 , 'O 8r',ipnt,'i',.false.)
*     call linadd( ola*1.05E-9 , 19 , 'O 8r','i')
*
*     fluorine
*     [F II] 29.33 microns
      call PutLine( F0229 )
*
*     [F II] 67.2 microns
      call PutLine( F0267 )
*
*     F IV 44.07 micron
      call PutLine( F444 )
*
*     F IV 25.83 micron
      call PutLine( F425 )
*     recombination from fully stripped ion
      nelem = 7
*     these lines added to outlin in metdif - following must be false
      flla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( flla*1.05E-9 , 19 , 'Fl7r','i')
*
*     neon
*     Neon II 12.8 micron
      call PutLine( tNe13 )
*
*     Ne III fine structure line
      call PutLine( tNe16 )
*
*     Ne III fine structure line
      call PutLine( tNe36 )
*
*     Ne III  3869, of 3968+3869 doublet
      call PntForLine( 3869. , 'Ne 3' , ipnt )
      call lindst(c3869/(1.+1./3.318) , 3869 , 'Ne 3',ipnt,'c',.true.)
*     call linadd(c3869/(1.+1./3.318) , 3869 , 'Ne 3','c')
*
*     Ne III  3968, of 3968+3869 doublet
      call PntForLine( 3968. , 'Ne 3' , ipnt )
      call lindst(c3869/(1.+3.318) , 3968 , 'Ne 3',ipnt,'c',.true.)
*     call linadd(c3869/(1.+3.318) , 3968 , 'Ne 3','c')
*
*     NeIII auroral line
      call PntForLine(     3343., 'Ne 3' , ipnt )
      call lindst( c3343 , 3343 , 'Ne 3',ipnt,'c',.true.)
*     call linadd( c3343 , 3343 , 'Ne 3','c')
*
*     NeIII auroral line
      call PntForLine(         1815., 'Ne 3' , ipnt )
      call lindst( c3343*1.38, 1815 , 'Ne 3',ipnt,'c',.true.)
*     call linadd( c3343*1.38, 1815 , 'Ne 3','c')
*
*     Ne IV 2424, collisional excitation
      call PntForLine(     2424., 'Ne 4' , ipnt )
      call lindst( c2424 , 2424 , 'Ne 4',ipnt,'c',.true.)
*     call linadd( c2424 , 2424 , 'Ne 4','c')
*
*     Ne IV N=3 lines, three level atom approx
      call PntForLine(    4720., 'Ne 4' , ipnt )
      call lindst(c4720 , 4720 , 'Ne 4',ipnt,'c',.true.)
*     call linadd(c4720 , 4720 , 'Ne 4','c')
*
*     Ne IV N=3 lines, three level atom approx
      call PntForLine(        1602., 'Ne 4' , ipnt )
      call lindst(c4720*4.34, 1602 , 'Ne 4',ipnt,'c',.true.)
*     call linadd(c4720*4.34, 1602 , 'Ne 4','c')
*
*     Ne V 3426 of 3426, 3346 doublet
      call PntForLine(                  3426., 'Ne 5' , ipnt )
      call lindst(c3426/(1.+1./2.738) , 3426 , 'Ne 5',ipnt,'c',.true.)
*     call linadd(c3426/(1.+1./2.738) , 3426 , 'Ne 5','c')
*
*     Ne V 3346 of 3426, 3346 doublet
      call PntForLine(               3346., 'Ne 5' , ipnt )
      call lindst(c3426/(1.+2.738) , 3346 , 'Ne 5',ipnt,'c',.true.)
*     call linadd(c3426/(1.+2.738) , 3346 , 'Ne 5','c')
*
*     auroral line
      call PntForLine(     2976., 'Ne 5' , ipnt )
      call lindst( c2975 , 2976 , 'Ne 5',ipnt,'c',.true.)
*     call linadd( c2975 , 2976 , 'Ne 5','c')
*
*     collisionally excited
      call PntForLine(     1575., 'Ne 5' , ipnt )
      call lindst( c1565 , 1575 , 'Ne 5',ipnt,'c',.true.)
*     call linadd( c1565 , 1575 , 'Ne 5','c')
*
*     Ne V 24.2, 14.3 micron
      call PutLine( tNe24 )
*
*     Ne V 24.2, 14.3 micron
      call PutLine( tNe14 )
*
*     both components of 5S-3P 1146.1, 1137.0 doublet
      call PntForLine(     1141., 'Ne 5' , ipnt )
      call lindst( c1134 , 1141 , 'Ne 5',ipnt,'c',.true.)
*     call linadd( c1134 , 1141 , 'Ne 5','c')
*
*     [Ne VI] 7.6 microns
      call PutLine( xNe0676 )
*
*     Ne VII 895, collisionally excited, both lines
      call linadd( em895+t895(ipLnInten) , 895 , 'TOTL','i')
*
*     Ne VII 895, only fast transition
      call PutLine( t895 )
*
*     Ne VII 890, single line
      call linadd( em895 , 890 , 'Ne 7','i')
*
*     Ne VIII 774, collisionally excited
      call linadd( t770(ipLnInten)+t780(ipLnInten),774,'TOTL','i')
*
*     inward part of NeVIII 774 line
      sum = t770(ipLnInten)*t770(ipLnInwd) +
     1 t780(ipLnInten)*t780(ipLnInwd)
      call linadd( sum,774,'Inwd','i')
*
*     the NeVIII 770 780 doublet
      call PutLine( t770 )
      call PutLine( t780 )
*
*     Ne VIII 88 2s 3p, collisionally excited
      call PutLine( t88 )
*
*     Ne Ly-alpha recombination from fully stripped ion
      nelem = 10
*     these lines added to outlin in metdif - following must be false
      xnela = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.65E-9
      call PntForLine(     12., 'NeLr' , ipnt )
      call lindst( xnela , 12 , 'NeLr',ipnt,'i',.false.)
*     call linadd( xnela , 12 , 'NeLr','i')
*
      if( lgTrace ) write(qq,'(''   LineSet2 returns'')')
*
      end
