*****************************************************************
      subroutine MakeCS( t )
      implicit none
*compute collision strength by g-bar approximations
      include "nta.par"
      real t(nta)
*
      include "ipLnArry.par"
      include "WavNRyd.par"
      include "limelm.par"
      include "IonFracs.com"
      include "IOqq.com"
*
*     routine to get cs from various approximations
*
*     local variables
      real Abun , cs , gbar
      integer ion
*
*     check if abundance greater than 0
      ion = t(ipLnIonStg)
      Abun = xIonFracs( int(t(ipLnNelem)) , ion )
      if( Abun.le.0. ) then
        gbar = 1.
      else
*       check if neutral or ion
        if( ion .eq.1 ) then
*         neutral - compute gbar for evantual cs
          call gbar0(t(ipLnBolt) , gbar )
        else 
*         ion - compute gbar for evantual cs
          call gbar1(t(ipLnBolt) , gbar )
        endif
      endif
*
*     above was g-bar, convert to cs
      cs = gbar * (14.5104/WavNRyd) * t(ipLnGF)/ t(ipLnEnrWN)
*
*     stuff the cs in place
      t( ipLnCS ) = cs
*
      end
