      subroutine MakeHydro
      implicit none
*make data for hydrogen and helium, 1 per coreload
      include "limelm.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nhe3lvl.par"
      include "nhetau.par"
      include "rydlam.par"
      include "te1ryd.par"
      include "ipLnArry.par"
      include "nta.par"
      include "HIonPot.par"
      include "LyaExT.com"
      include "hydata.com"
      include "he3bn.com"
      include "he3n.com"
      include "he3tuARR.com"
      include "he3pht.com"
      include "he2dmp.com"
      include "he1dmp.com"
      include "taumin.com"
      include "he2as.com"
      include "ophf.com"
      include "heopfr.com"
      include "he1as.com"
      include "AsSav.com"
      include "hlife.com"
      include "hyas.com"
      include "hstat.com"
      include "he1stat.com"
      include "he2stat.com"
      include "htau.com"
      include "htnext.com"
      include "HPhoto.com"
      include "he2tau.com"
      include "he1tau.com"
      include "he1nxt.com"
      include "he2nxt.com"
      include "thlo.com"
      include "the1lo.com"
      include "the2lo.com"
      include "hetrpARR.com"
      include "phlevl.com"
      include "phe2lv.com"
      include "phe1lv.com"
      include "he1bn.com"
      include "he2bn.com"
      include "he1ind.com"
      include "he2ind.com"
      include "he1cin.com"
      include "he2cin.com"
      include "HdeltaT.com"
      include "He1deltaT.com"
      include "He2deltaT.com"
      include "HEnrRyd.com"
      include "He1EnrRyd.com"
      include "He2EnrRyd.com"
      include "HNIonRyd.com"
      include "He1NIonRyd.com"
      include "He2NIonRyd.com"
*
*     local variables
      real EinstA , scrhe1 , test
      integer i , j , n , iup , lo
*
*     upper level 4 and above, goind to lower level 2 and above,
*     come from the hlife and branch product formed in routine pesc
*     all other values come from here
*
*     fill in A's with Jason's routine
      do lo=1,nhlvl-1
        do iup=lo+1,nhlvl
          hyas(iup,lo) = EinstA(iup,lo)
          hemis(iup,lo) = EinstA(iup,lo)
        end do
      end do
*
*     2p 1s is special since do not assume 2s 2p mixed
      hyas(2,1) = 6.265E8
      hdamp(2) = hyas(2,1)* 7.958e-6/0.75
*
*NB NB hdamp is only dimensioned up through nhlvl, so 2s-1s has no damp cnst
      hlife(2) = hyas(2,1)
      do iup=3,nhlvl
        hlife(iup) = 0.
        do lo=2,iup-1
*         array of damping constants for hydrogen
          hlife(iup) = hlife(iup) + hyas(iup,lo)
        end do
        hdamp(iup) = (hlife(iup)+hyas(iup,1)) * 7.958e-6/(1.-1./
     1  float(iup*iup))
      end do
*     level not possible
      hdamp(1) = 0.
*
*     define excitation and ionization temperatures for hydrogen
*
      do iup=1,nhlvl
*     >>chng 96 aug 22, had been 1 ryd in below, off by 3 cells for 1 ryd
*       HLevNIonRyd(iup) = 0.99946 / float(iup**2) 
*     >>chng 96 dec 18, put 0.99946 in parameter statement
        HLevNIonRyd(iup) = HIonPot / float(iup**2) 
        HCionTe(iup) = te1ryd* HLevNIonRyd(iup)
*       fill in stat weights for hydrogen
        hstat(iup) = 2.*(iup**2)
      end do
      hstat(2) = 6.
*     this is 2s, the "highest" level in model atom
      hstat(nhlvl+1) = 2.
      HLevNIonRyd(nhlvl+1) = HLevNIonRyd(2)
*
*     statistical weights for helium singlet atom and ion
      do iup=1,nhe1lvl
        He1IonRyd(iup) = 1. / float(iup**2) 
        He1CionTe(iup) = te1ryd* He1IonRyd(iup)
        he1stat(iup) = iup**2
      end do
*     ground and n=2 not hydrogenic
      He1IonRyd(1) = 1.80802
      He1IonRyd(2) = 0.2478
      He1IonRyd(nhe1lvl+1) = He1IonRyd(2)
      he1stat(nhe1lvl+1) = 1.
      he1stat(2) = 3.
*
*     helium ion He II HeII
      do iup=1,nhe2lvl
        he2stat(iup) = 2.*(iup**2)
        He2IonRyd(iup) = 4. / float(iup**2) 
        He2CionTe(iup) = te1ryd* He2IonRyd(iup)
      end do
      he2stat(2) = 6.
      he2stat(nhe2lvl+1) = 2.
      He2IonRyd(nhe2lvl+1) = He2IonRyd(2)
*
      do iup=2,nhlvl
        do lo=1,iup-1
          HEnerRyd(iup,lo) = HLevNIonRyd(lo) - HLevNIonRyd(iup)
          HdeltaTe(iup,lo) = te1ryd * HEnerRyd(iup,lo)
        end do
      end do
*
      do iup=2,nhe1lvl
        do lo=1,iup-1
          He1EnerRyd(iup,lo) = He1IonRyd(lo) - He1IonRyd(iup)
          He1deltaTe(iup,lo) = te1ryd * He1EnerRyd(iup,lo)
        end do
      end do
*
      do iup=2,nhe2lvl
        do lo=1,iup-1
          He2EnerRyd(iup,lo) = He2IonRyd(lo) - He2IonRyd(iup)
          He2deltaTe(iup,lo) = te1ryd * He2EnerRyd(iup,lo)
        end do
      end do
*
      do i=1,nhlvl+1
        hbn(i) = 1.
      end do
*
      do i=1,nhlvl+1
        cinduc(i) = 0.
        finduc(i) = 0.
        rinduc(i) = 0.
      end do
      do i=1,nhe1lvl+1
        he1qin(i) = 0.
        he1rin(i) = 0.
      end do
      do i=1,nhe2lvl+1
        he2qin(i) = 0.
        he2rin(i) = 0.
      end do
*
      do i=1,nhetau
        he3tau(ipLnTauIn,i) = taumin
        he3tau(ipLnTauTot,i) = 1e20
        he3tau(ipLnEscP,i) = 1.
        he3tau(ipLnInwd,i) = 1.
      end do
*
      do i=1,nhlvl+1
        hgamnc(i) = 0.
        hn(i) = 1e-35
        hcolnc(i) = 0.
        hrec(i,1) = 0. 
        hrec(i,2) = 1. 
        hrec(i,3) = 1. 
        do j=i+1,nhlvl
          hcol(j,i) = 0.
        end do
      end do
      do i=1,nhlvl
        do j=i+1,nhlvl
          hdest(j,i) = 0.
          hdest(i,j) = 0.
          hemis(i,j) = 0.
          htlim(i,j) = 0.
        end do
      end do
      hn2s = 1e-30
      hn2p = 1e-30
*
*     this is hydrogenic screening factor for HeI singlet ground state
      scrhe1 = 1.808
      do i=1,nhe1lvl-1
*       damping constant scales as A*lambda, or z
        he1dmp(i) = hdamp(i)
        he1gam(i) = 0.
        he1n(i) = 1e-35
        he1clc(i) = 0.
        he1rec(i,1) = 0. 
        he1rec(i,2) = 1. 
        he1rec(i,3) = 1. 
        do j=i+1,nhe1lvl
          he1cll(j,i) = 0.
*         scale HeII A's from hydrogen
          He1EinA(j,i) = scrhe1 * HeAsSav(j,i)
*         destruction probabilities
          he1dst(j,i) = 0.
          he1mis(j,i) = 0.
        end do
        scrhe1 = 1.
      end do
*
      do i=1,nhe2lvl-1
*       damping constant scales as A*lambda, or z
        he2dmp(i) = hdamp(i) * 4.
        he2gam(i) = 0.
        he2n(i) = 1e-35
        he2clc(i) = 0.
        he2rec(i,1) = 0. 
        he2rec(i,2) = 1. 
        he2rec(i,3) = 1. 
        do j=i+1,nhe2lvl
          he2cll(j,i) = 0.
*         scale HeII A's from hydrogen, A's go as Z^4,
*         Wiese et al. viiii
          he2as(j,i) = 16. * HeAsSav(j,i)
*         destruction probabilities
          he2dst(j,i) = 0.
          he2mis(j,i) = 0.
        end do
      end do
      do n=1,nhlvl
        ophf(n) = 0.
      end do
      do n=1,nhe1lvl
        ophe1f(n) = 0.
      end do
      do n=1,nhe2lvl
        ophe2f(n) = 0.
      end do
*
*     self consistent opacity from hydrogen A's
*     ok to use hstat(2) for upper stat weight of Lya since special
*     when lower level is 2 must use stat weight of 8
      do lo=1,nhlvl-1
        if( lo.eq.2 ) then
          test = 8.
        else
          test = hstat(lo)
        endif
*       HeAsSav is dimensioned 10,9 so will not work for arbitrary
*       levels - but hopac will be fixed when As set with branch
        do iup=lo+1,nhlvl
          hopac(iup,lo) = hyas(iup,lo) * 2.24484e-26 * 
     1    hstat(iup)/test * (rydlam/HEnerRyd(iup,lo))**3
        end do
      end do
*
*     >>chng 96 may 31, big mistake in HeII opacities
*     >>chng 96 june 4, smaller big mistake in HeII opacities
      do lo=1,nhe2lvl-1
        if( lo.eq.2 ) then
          test = 8.
        else
          test = he2stat(lo)
        endif
        do iup=lo+1,nhe2lvl
          he2opc(iup,lo) = he2as(iup,lo) * 2.24484e-26 * 
     1    he2stat(iup)/test * (rydlam/He2EnerRyd(iup,lo))**3
*         scale HeII opacities from hydrogen
*         he2opc(iup,lo) = hopac(iup,lo) / 4.
        end do
      end do
*
*     scrhe1 = 1.808
*     >>chng 96 may 31, big mistake in HeI opacities
*     >>chng 96 june 4, smaller big mistake in HeI opacities
      do lo=1,nhe1lvl-1
        if( lo.eq.2 ) then
          test = 8.
        else
          test = he1stat(lo)
        endif
        do iup=lo+1,nhe1lvl
          he1opc(iup,lo) = He1EinA(iup,lo) * 2.24484e-26 * 
     1    he1stat(iup)/test * (rydlam/He1EnerRyd(iup,lo))**3
*         he1opc(j,i) = hopac(j,i) / scrhe1
        end do
*       scrhe1 = 1.
      end do
*     HeI ground state is special
      he1opc(2,1) = 2.42e-8
      He1EinA(2,1) = 17.99e8
      he1dmp(2) = he1dmp(2) * 1.37
      he1n(nhe1lvl) = 1e-30
      he2n(nhe2lvl) = 1e-30
      hgamnc(nhlvl) = 0.
      he1gam(nhe1lvl) = 0.
      he2gam(nhe2lvl) = 0.
      hcolnc(nhlvl) = 0.
      he1clc(nhe1lvl) = 0.
      he2clc(nhe2lvl) = 0.
      he1rec(nhe1lvl,1) = 0.
      he2rec(nhe2lvl,1) = 0.
      he1rec(nhe1lvl,2) = 1.
      he2rec(nhe2lvl,2) = 1.
      he1rec(nhe1lvl,3) = 1.
      he2rec(nhe2lvl,3) = 1.
      he2dmp(nhe2lvl) = hdamp(9) * 16.
      he1dmp(nhe1lvl) = hdamp(9)
      he22s = 1e-30
      he22p = 1e-30
      he12s = 1e-30
      he12p = 1e-30
*
*     zero out inner optical depths
      do i=1,nhlvl-1
        do j=1,nhlvl
          htnext(j,i) = taumin
          htau(j,i) = taumin
        end do
      end do
      do i=1,nhe1lvl-1
        do j=1,nhe1lvl
          he1nxt(j,i) = taumin
          he1tau(j,i) = taumin
        end do
      end do
      do i=1,nhe2lvl-1
        do j=1,nhe2lvl
          he2nxt(j,i) = taumin
          he2tau(j,i) = taumin
        end do
      end do
      t206(ipLnTauIn) = taumin
      t206(ipLnTauTot) = taumin
      t206(ipLnEscP) = 1.
      t206(ipLnInwd) = 0.5
      t206(ipLnAul) = 1.976e6
*
      end
