******************************************************************************
      subroutine matin1 (a,dim1,n1,n2,nerror)
      implicit none
*matrix inversion routine used throughout the code
*     real determ
*
*     MATRIX INVERSION WITH ACCOMPANYING SOLUTION OF LINEAR EQUATIONS.
*     SOLVES THE MATRIX EQUATION A*X = B FOR THE VECTOR X
*     CALLING SEQUENCE-
*     CALL MATIN1(E,NDIM,N,MDIM,M,NERROR,DETERM)
*
*     parameters
*     A a two dimensional array with ndim as column size,containing
*       the matrix of order n in its first n columns. the matrix of
*       constant5vectors , b, is stored in columns n+1 through n+m of e
*     ndim - first dimension parameter of e as decl red in the c lling
*     program
*     n   - the order of the matrix a - called n1 in declare
*     MDIM  - NOT USED ( USED IN EARLIER VERSIONS  )
*     M - NUMBER OF COLUMN VECTORS IN MATRIX B. ID M = 0, ONLY THE
*     INVERSE OF A AND THE COMPUTATION OF THE DETERMINANT IS CARRIE
*     OUT
*     INDEX- A ONE DIMENSIONAL ARRAY CONTAINING N LOCATIONS, USED BY
*     MATIN1 FOR BOOK KEEPING. SPACE MUST BE PROVIDED BY THE CALLIN
*     ROUTINE
*     change - index now here, dim=100, so n1 .lt.100
*     NERROR  - OUTPUT PARAMETER WHICH IS SET ON RETURN TO NON ZERO, IF
*     AT ANY ELIMINATION STEP THE CORRESPONDING COLUMN OF A CONTAINED
*     ONLY ZEROES. A PRINTED MESSAGE IS GIVEN ON FILE TAPE2
*     INDICATING THE COLUMN.
*     DETERM - A SINGLE PRECISSION VARIABLE CONTATINIG ON RETURN THE
*     DETERMINANT OF A
*     ON RETURN, E WILL, IF NERROR = 0 CONTAIN THE INVERSE OF A IN
*     ITS FIRST N COLUMNS AND IF M NOT =  0 THE S LUTI N MATRIX IN
*     THE NEXT FOLLOWING  (N+1) TO (N+M) COLUMNS.
*
      double precision deter,swap,pivot
      integer dim1,dim,emat,pivcol,pivcl1,pivcl2
      integer n1,n2,nerror,mn,nmin1,i,lpiv,icol,i3,i2,i1,
     1 jcol,n
      include "IOqq.com"
      double precision a(*)
*
      integer dimIndex
      parameter (dimIndex=100)
      integer index(dimIndex)
*     DATA(LGUNIT=2)
*
      deter=1.0
      n=n1
      if( n.gt.dimIndex ) then
        write(qq,'('' matin1 called with dimIndex exceeded'')')
        stop
      endif
      emat=n+n2
      dim=dim1
      nmin1=n-1
*     the routine does its own evaluation for doubLE SUBSCRIPTING OF
*     array a.
      pivcol=1-dim
*     main loop to invert the matrix
      do 11 mn=1,n
      pivot=0.0
      pivcol=pivcol+dim
*     search for next pivot in column main.
      pivcl1=pivcol+mn-1
      pivcl2=pivcol +nmin1
      do 2 i=pivcl1,pivcl2
      if(dabs(a(i))-dabs(pivot)) 2,2,1
    1 pivot=a(i)
      lpiv=i
    2 continue
*     is pivot different from zero
      if(pivot) 3,15,3
*     get the pivot-line indicator and swap lines IF NECESSARY
    3 icol=lpiv-pivcol+1
      index(mn)=icol
      if(icol-mn) 6,6,4
*     complement the determinant
    4 deter=-deter
*     pointer to line pivot found
      icol=icol-dim
*     pointer to exact pivot line
      i3=mn-dim
      do 5 i=1,emat
      icol=icol+dim
      i3=i3+dim
      swap=a(i3)
      a(i3)=a(icol)
    5 a(icol)=swap
*     compute determinant
    6 deter=deter*pivot
      pivot=1.d0/pivot
*     transform pivot column
      i3=pivcol+nmin1
      do 7 i=pivcol,i3
    7 a(i)=-a(i)*pivot
      a(pivcl1)=pivot
*     pivot element transformed
*
*     now convert rest of the matrix
      i1=mn-dim
*     pointer to pivot line elements
      icol=1-dim
*     general column pointer
      do 10 i=1,emat
      icol=icol+dim
      i1=i1+dim
*     pointers moved
      if(i-mn) 8,10,8
*     pivot column excluded
    8 jcol=icol+nmin1
      swap=a(i1)
      i3=pivcol-1
      do 9 i2=icol,jcol
      i3=i3+1
    9 a(i2)=a(i2)+swap*a(i3)
      a(i1)=swap*pivot
   10 continue
   11 continue
*     now rearrange the matrix to get right invers
      do 14 i1=1,n
      mn=n+1-i1
      lpiv=index(mn)
      if(lpiv-mn) 12,14,12
   12 icol=(lpiv-1)*dim+1
      jcol=icol+nmin1
      pivcol=(mn-1)*dim+1-icol
        do i2=icol,jcol
          i3=i2+pivcol
          swap=a(i2)
          a(i2)=a(i3)
          a(i3)=swap
        end do
   14 continue
*
*     determ=deter
      nerror=0
      return
*
   15 nerror=-1
*     determ=deter
      return
      end
