******************************************************************************
      subroutine metdif
      implicit none
*add diffuse fields to local reflected and outward radiation fields
      include "nta.par"
      include "ncell.par"
      include "limelm.par"
      include "itrdim.par"
      include "ipLnArry.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "nwindline.par"
      include "phe1lv.com"
      include "phe2lv.com"
      include "h.com"
      include "he.com"
      include "opac.com"
      include "tmn.com"
      include "rfield.com"
      include "reflec.com"
      include "condif.com"
      include "he2blt.com"
      include "phycon.com"
      include "TePowers.com"
      include "SummdCon.com"
      include "radius.com"
      include "cover.com"
      include "r1r0sq.com"
      include "heots.com"
      include "ip626.com"
      include "trace.com"
      include "hebug.com"
      include "DiffHeav.com"
      include "IonFracs.com"
      include "Heavy.com"
      include "pbowen.com"
      include "fekems.com"
      include "ZoneCnt.com"
      include "iphe1l.com"
      include "iphe2l.com"
      include "hhe2phtots.com"
      include "phlevl.com"
      include "iophe2.com"
      include "nh.com"
      include "nhe1.com"
      include "iphl.com"
      include "ots.com"
      include "dif2nu.com"
      include "diffus.com"
      include "dRdVeff.com"
      include "dtrans.com"
      include "filfac.com"
      include "TLineARR.com"
      include "FeIIAtom.com"
      include "WindData.com"
*     include "facexp.com"
      include "nhe2.com"
      include "exptau.com"
      include "ThroOut.com"
      include "SumOutInc.com"
      include "hetrpEXP.com"
      include "VolRef.com"
      include "hfrcin.com"
      include "GrainEmis.com"
      include "tff.com"
      include "plasnu.com"
      include "KatyaDat.com"
      include "IOqq.com"
*
*     local variables
      real factor
*     character*10 char , chLineLbl
      parameter (factor=0.5)
      integer ihi,ilo,i,ip,nelem,ipla , i1
      real outwrd,bf,esc,diffuse,ots, difflya,xInWrd
*     real save1(9) , save2(9)
*
*     many tmn added to conserve energy in very high Z models
*     rerun highZ qso model if any tmn ever deleted here
*
*     free statement number >= 45
*
*     use duffuse lines and continuum to add flux to outward beam
*
*     NB!!!  this routine adds flux to the outward beam
*            it can only be called once per zone
*
*     covrt is radiative transfer covering factor
*     covrt = 0 for open geometry
*     covrt = 1 for closed geometry
*
*     outwrd is fraction that goes outward, of the escaping line radiation
*     default covrt is zero for open geometry, is 1 for closed
*     outwrd is 1/2 for opten, 1 for closed
      outwrd = (1.+covrt)/2.
*
      if( lgTrace ) write(qq,'('' metdif called.'')')
*
*     >>chng 96 nov 19, do not consider energies below plasma freq
*     i1 points to lowest energy thin to brems and plas freq
      i1 = max( ipPlasma,1)
*
*     radius is the outer edge of the current zone
*     OutFac = outwrd * dreff
*     >>chng 95 nov 16
*     OutFac = outwrd * dreff * ( radius/(radius+drad) )**2
*     dreff in upper since fill fac enters, but not in lower
*     >>chng 96 may 8, moved to zonsrt
*     OutFac = outwrd * radius * dreff / (radius + 2.*drad)
*
*     save contents of outcon for checking how much was added
      do i=1,nflux
        SavOutCon(i) = outcon(i) + outlin(i)
      end do
*
*     following used for beamed fields, which have already taken accout of
*     inward vs outward escape, only count out if sphere
*     dreff is drad * FillFac
      bf = covrt * radius * dReff / (radius + 2.*drad)
*     >>chng 96 may 8, moved to zonsrt
*     RefFac = (1.-outwrd) * dReff * r1r0sq
*     OutFac = outwrd * radius * dReff / (radius + 2.*drad)
*
*     continuum interaction arrays that occur here:
*
*     ContDiff - not counted in internal energy budget
*     of the cloud, used to get pretty plots afterwards
*
*     outcon, outward only continuum, inc in heating rates
*     otscon, otslin, loc ots rates, inc in heating
*
*  HI   HI   HI   HI    HI   HI   HI   HI   HI   HI
*
*     Ly-alpha special since 2s2p resolved
*     >>chng 96 july 11, did not use computed fractions, assumed 50-50 before
      xInWrd = hn2p*hii*hemis(2,1)*hfrcin(2,1)
      reflin(iphl(2,1)) = reflin(iphl(2,1)) + xInWrd*BeamInIn
*     inward beam that goes out since sphere set
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(iphl(2,1)) = outlin(iphl(2,1)) + xInWrd*BeamInOut*
     1 tmn(iphl(2,1))
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(iphl(2,1)) = outlin(iphl(2,1)) + hn2p*hii*hemis(2,1)*
     1 (1.-hfrcin(2,1)) * BeamOutOut*
     1 tmn(iphl(2,1))
*
*     hydrogen lyman lines
*     >>chng 96 july 11, did not use computed fractions, assumed 50-50 before
*     >>chng 96 july 16, had top level
      do ihi=3,min(25,nhlvl-1)
        xInWrd = hn(ihi)*hii*hemis(ihi,1)*hfrcin(ihi,1)
        reflin(iphl(ihi,1)) = reflin(iphl(ihi,1)) + xInWrd*BeamInIn
*       >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
        outlin(iphl(ihi,1)) = outlin(iphl(ihi,1)) + xInWrd*BeamInOut*
     2  tmn(iphl(ihi,1))
        outlin(iphl(ihi,1)) = outlin(iphl(ihi,1)) +
     1  hn(ihi)*hii*hemis(ihi,1)*(1.-hfrcin(ihi,1))*BeamOutOut*
     2  tmn(iphl(ihi,1))
      end do
*
*     hydrogen lines
      do ilo=2,nhlvl-2
        do ihi=ilo+1,min(25,nhlvl-1)
*         outlin(iphl(ihi,ilo)) = outlin(iphl(ihi,ilo)) +
*    1    hn(ihi)*hii*hemis(ihi,ilo)*OutFac*tmn( iphl(ihi,ilo) )
*         reflin(iphl(ihi,ilo)) = reflin(iphl(ihi,ilo)) +
*    1    hn(ihi)*hii*hemis(ihi,ilo)*RefFac
*         >>chng 96 july 11, did not use computed fractions, assume 50-50 before
          xInWrd = hn(ihi)*hii*hemis(ihi,ilo)*hfrcin(ihi,ilo)
          reflin(iphl(ihi,ilo)) = reflin(iphl(ihi,ilo))+xInWrd*BeamInIn
*         >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
          outlin(iphl(ihi,ilo)) = outlin(iphl(ihi,ilo))+xInWrd*BeamInOut
     2    *tmn(iphl(ihi,ilo))
*         >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
          outlin(iphl(ihi,ilo)) = outlin(iphl(ihi,ilo)) +
     1    hn(ihi)*hii*hemis(ihi,ilo)*(1.-hfrcin(ihi,ilo))*BeamOutOut*
     2    tmn(iphl(ihi,ilo))
        end do
      end do
*
*     all locally destroyed two photon continua of H, HeI, HeII
      if( H12phtOTS.lt.0. ) then
        write(qq,'('' metdif found negative OTS CON, H12phtOTS'',
     1  '' val='',1p,e10.1)')H12phtOTS
        call ShowMe
        stop
      endif
*     ots = H12phtOTS / opac(ipH12pht)
      call AddOTSCon( H12phtOTS , ipH12pht )
*
      if( He12phtOTS.lt.0. ) then
        write(qq,'('' metdif found negative OTS CON, He12phtOTS'',
     1  '' val='',1p,e10.1)')He12phtOTS
        call ShowMe
        stop
      endif
      call AddOTSCon( He12phtOTS , ipHe12pht )
*
      if( He22phtOTS.lt.0. ) then
        write(qq,'('' metdif found negative OTS CON, He22phtOTS'',
     1  '' val='',1p,e10.1)')He22phtOTS
        call ShowMe
        stop
      endif
      call AddOTSCon( He22phtOTS , ipHe22pht )
*
* He II   He II   He II    He II   He II  He II   He II
*
*     He II Ly-alpha special since 2s2p resolved
*     and bowen gets much of line (reason for fac of 0.5)
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(iphe2l(2,1)) = outlin(iphe2l(2,1)) + 
     1 esc304 *OutFac * tmn(iphe2l(2,1))
      reflin(iphe2l(2,1)) = reflin(iphe2l(2,1)) +
     1 heiii*he22p*he2mis(2,1)*RefFac
*
*     HeII higher lyman lines
*     >>chng 96 july 16, had only gone up to 6
      do ihi=3,nhe2lvl-1
*       >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
        outlin(iphe2l(ihi,1)) = outlin(iphe2l(ihi,1)) +
     1  heiii*he2n(ihi)*he2mis(ihi,1)*OutFac*tmn(iphe2l(ihi,1))
        reflin(iphe2l(ihi,1)) = reflin(iphe2l(ihi,1)) +
     1  heiii*he2n(ihi)*he2mis(ihi,1)*RefFac
      end do
*
*     He II ionized helium lines
*     >>chng 96 july 16, had only gone up to 6
      do ilo=2,nhe2lvl-2
        do ihi=ilo+1,nhe2lvl-1
*       >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
          outlin(iphe2l(ihi,ilo)) = outlin(iphe2l(ihi,ilo)) +
     1    heiii*he2n(ihi)*he2mis(ihi,ilo)*OutFac*tmn(iphe2l(ihi,ilo))
          reflin(iphe2l(ihi,ilo)) = reflin(iphe2l(ihi,ilo)) +
     1    heiii*he2n(ihi)*he2mis(ihi,ilo)*RefFac
        end do
      end do
*
*  HeI  He I   He I   He I   He I   He I   He I   He I
*     outward part of escaping He I Ly alpha hei lya
      reflin(iphe1l(2,1) ) = reflin(iphe1l(2,1) ) + RefFac*esc584
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(iphe1l(2,1) ) = outlin(iphe1l(2,1) ) +
     1 OutFac*esc584*tmn(iphe1l(2,1))
*     95 nov 2 removed tmn from last term
*    1 bf*esc584
*
*     HeI higher lyman lines
*     >>chng 96 july 16, had only gone up to 6
      do ihi=3,nhe1lvl-1
*       >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
        outlin(iphe1l(ihi,1)) = outlin(iphe1l(ihi,1)) +
     1  heii*he1n(ihi)*he1mis(ihi,1)*OutFac*tmn(iphe1l(ihi,1))*
     1  tmn(iphe1l(ihi,1))
        reflin(iphe1l(ihi,1)) = reflin(iphe1l(ihi,1)) +
     1  heii*he1n(ihi)*he1mis(ihi,1)*RefFac
      end do
*
*     helium 1 triplet lines
      outlin(ipHe3l(1)) = outlin(ipHe3l(1)) + p10830/1.84e-12 *
     1 OutFac*tmn(ipHe3l(1))
      outlin(ipHe3l(2)) = outlin(ipHe3l(2)) + p5876/3.39e-12 *
     1 OutFac*tmn(ipHe3l(2))
      outlin(ipHe3l(3)) = outlin(ipHe3l(3)) + p7065/2.82e-12 *
     1 OutFac*tmn(ipHe3l(3))
      outlin(ipHe3l(4)) = outlin(ipHe3l(4)) + p3889/5.12e-12 *
     1 OutFac*tmn(ipHe3l(4))
*
      reflin(ipHe3l(1)) = reflin(ipHe3l(1)) + p10830/1.84e-12 *
     1 RefFac*tmn(ipHe3l(1))
      reflin(ipHe3l(2)) = reflin(ipHe3l(2)) + p5876/3.39e-12 *
     1 RefFac*tmn(ipHe3l(2))
      reflin(ipHe3l(3)) = reflin(ipHe3l(3)) + p7065/2.82e-12 *
     1 RefFac*tmn(ipHe3l(3))
      reflin(ipHe3l(4)) = reflin(ipHe3l(4)) + p3889/5.12e-12 *
     1 RefFac*tmn(ipHe3l(4))
*
*     He I ionized helium singlet lines
*     >>chng 96 july 16, had only gone up to 6
      do ilo=2,nhe1lvl-2
        do ihi=ilo+1,nhe1lvl-1
*         >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
          outlin(iphe1l(ihi,ilo)) = outlin(iphe1l(ihi,ilo)) +
     1    heii*he1n(ihi)*he1mis(ihi,ilo)*OutFac*tmn(iphe1l(ihi,ilo))
          reflin(iphe1l(ihi,ilo)) = reflin(iphe1l(ihi,ilo)) +
     1    heii*he1n(ihi)*he1mis(ihi,ilo)*RefFac
        end do
      end do
*
*     95 nov 2 removed tmn
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(ipHe23sGrnd) = outlin(ipHe23sGrnd) +
     1  OutFac*out626*tmn(ipHe23sGrnd)
      reflin(ipHe23sGrnd) = reflin(ipHe23sGrnd) + RefFac*out626
*
      outlin(ip660) = outlin(ip660) + OutFac*esc660*tmn(ip660)
      reflin(ip660) = reflin(ip660) + RefFac*esc660
*
      if( chDffTrns.eq.'OTS' ) then
*       pick up these continua here if we are not doing outward only
*       hydrogen two photon emission
*       if outward only then add two photon to outcon, and
*       subtract it from diffuse field since this is added
*       just below
        do i=i1,iphe2l(2,1)
          outcon(i) = outcon(i) + Diff2Pht(i) * OutFac*tmn(i)
          refcon(i) = refcon(i) + Diff2Pht(i) * RefFac*tmn(i)
        end do
*
        do i=i1,nflux
*         continuum not used for heating, just pretty pictures
*         add it here - outward approximation will do it in outcon
          ContDiff(i) = ContDiff(i) + DiffCont(i)*OutFac*tmn(i)
        end do
*
*     option for outward only continuum
      else if( chDffTrns(1:2).eq.'OU' ) then
*       continuum is zero below i1
        do i=i1,nflux
*         outcon is the interactive continuum
*         ExpZone is attenuation across one zone
*         ThrowOut is amount throun into outward beam
          outcon(i) = outcon(i) + ThrowOut(i)*OutFac*tmn(i)
        end do
        do i=1,nflux
*         >>chng 96 july 13, add extra grain emiss to save out, so it is
*         not counted in effective sum - benign source of radiation
          SavOutCon(i) = SavOutCon(i) + GrainEmission(i)*OutFac*tmn(i)
        end do
*
      else
*       dtrans was neither one nor other, this is impossible
        write(qq,'('' chDffTrns='',A3,'' in METDIF.  This is '',
     1  ''impossible.'')') chDffTrns
        stop
      endif
*
*begin sanity check
      do i=1,nTauLines
        if( TauLines(ipLnNPhots,i)*TauLines(ipLnColovTOT,i).lt.0.)then
          write(qq,'('' METDIF finds insane NPohts*ColovTot for '',
     1    ''level 1 line, vals='',1p,2e10.1)') 
     2    TauLines(ipLnNPhots,i),TauLines(ipLnColovTOT,i)
          call DumpLine( TauLines(1,i) )
          call ShowMe
          stop
        endif
      end do
*end sanity check
*
*     outward line photons
      do i=1,nTauLines
*       pointer to line energy in continuum array
        ip = TauLines(ipLnIpCont,i)
*       last factor does not accout for frac of lines pumped
*       ExpZone => tmn 95 nov 2
*       >>chng 96 july 11, did not use computed fractions, assumed 50-50 before
        xInWrd = TauLines(ipLnNPhots,i)*TauLines(ipLnInwd,i)
        reflin(ip) = reflin(ip) + xInWrd*BeamInIn
*       inward beam that goes out since sphere set
        outlin(ip) = outlin(ip) + xInWrd*BeamInOut* tmn(ip)*
     1  TauLines(ipLnColovTOT,i)
*       >>chng 96 july 16, added ipLnColovTOT
        outlin(ip) = outlin(ip) + 
     1  TauLines(ipLnNPhots,i)*(1.-TauLines(ipLnInwd,i)) * BeamOutOut*
     2  tmn(ip) * TauLines(ipLnColovTOT,i)
*       >>chng 96 july 16, added ipLnColovTOT
      end do
*
*begin sanity check
      do i=1,NWINDLINE*nWindOn
        if( WindLine(ipLnNPhots,i)*WindLine(ipLnColovTOT,i).lt.0.)then
          write(qq,'('' METDIF finds insane NPohts*ColovTot for '',
     1    ''level 2 line, vals='',1p,2e10.1)') 
     2    WindLine(ipLnNPhots,i),WindLine(ipLnColovTOT,i)
          call DumpLine( WindLine(1,i) )
          call ShowMe
          stop
        endif
      end do
*end sanity check
*
*     outward line photons
      do i=1,NWINDLINE*nWindOn
*       NB if this changes, then EmitFe2 in KatyaFe2 (Fe2 sub dir)
*       probably needs to change too
*       pointer to line energy in continuum array
        ip = WindLine(ipLnIpCont,i)
*       last factor does not accout for frac of lines pumped
*       ExpZone => tmn 95 nov 2
*       >>chng 96 july 11, did not use computed fractions, assumed 50-50 before
        xInWrd = WindLine(ipLnNPhots,i)*WindLine(ipLnInwd,i)
        reflin(ip) = reflin(ip) + xInWrd*BeamInIn
*       inward beam that goes out since sphere set
        outlin(ip) = outlin(ip) + xInWrd*BeamInOut*tmn(ip)*
     1  WindLine(ipLnColovTOT,i)
*       >>chng 96 july 16, added ipLnColovTOT to above
*       >>chng 96 july 16, need tmn to stop outward line from dominating
*       deep in thick cloud
        outlin(ip) = outlin(ip) + 
     1  WindLine(ipLnNPhots,i)*(1.-WindLine(ipLnInwd,i)) * BeamOutOut*
     2  tmn(ip) * WindLine(ipLnColovTOT,i)
*       >>chng 96 july 16, added ipLnColovTOT
      end do
*
      if( chFeIIAtom.eq.'Verner' ) then
*       this will do the above, adding FeII to reflected, outward beam
        if( xIonFracs(26,2).gt.0..and..not.lgSimKatya)
     1  call EmitFe2( OutFac , RefFac )
      else if( chFeIIAtom.ne.'Netzer' ) then
        write(qq,'('' metdif has insane chFeIIAtom'')')
        stop
      endif
*
*     factor=0.5 in parameter above is damper for ots continuum
*     rec producing ionizing radiation
      do nelem=3,limelm
        do i=1,nelem-1
          if( xIonFracs(nelem,i+1).gt.0. ) then
            ip = ipHeavy(nelem,i)
*           receff is escape prob from this zone
*           esc = receff( ip+1 )
*           this is exp(-tau zone)
*           this is extinction to face
            esc = ExpmTau(ip)
*           DiffusHeavy is rad rec to ground, with electron density,
*           it is evaluated in routine MakeRecomb
            diffuse = DiffusHeavy(nelem,i)* xIonFracs(nelem,i+1)
            if( opac(ip).gt.0. ) then
              ots = diffuse * min(0., 1.-esc ) / opac( ip )
            else
              ots = 0.
            endif
            ots = factor * ots + otscon(ip)*(1.-factor)
            ots = ots * opac(ip)
            if( ots.lt.0. ) then
              write(qq,'('' metdif found negative OTS heav, n='',2i4,
     1        '' val='',1p,e10.1,'' nzone='',i4)')nelem,i, ots,nzone
              call ShowMe
              stop
            endif
            Call AddOTSCon( ots , ip )
*           otscon(ip) = ots
*           >>chng 97 Apr 28, remove frm reflected continuum since should
*           not be line
*           refcon(ip) = refcon(ip) + diffuse*esc*RefFac
*           ExpZone => tmn 95 nov 2
            outcon(ip ) = outcon(ip ) + diffuse*OutFac*esc*tmn(ip)
*           now do the recombination Lya
            ipla = ipLyHeavy(nelem,i)
            esc = ExpmTau(ipla)
*           xLyaHeavy is set to a fraction of rad rec in MakeRecomb
            difflya = xLyaHeavy(nelem,i) * xIonFracs(nelem,i+1)
*begin sanity check
            if( difflya.lt.0. ) then
              write(qq,'('' METDIF Negative Lya flux for element, ion=''
     1        ,2i4)')nelem,i
              write(qq,'('' METDIF xLyaHeavy, xIonFracs='',1p,2e10.2)')
     1        xLyaHeavy(nelem,i) , xIonFracs(nelem,i+1)
              Call ShowMe
              stop
            endif
*end sanity check
*           ExpZone => tmn 95 nov 2
*           >>chng 97 apr 28, next two had extra factor of outwrd
            outlin( ipla ) = outlin(ipla) + difflya *OutFac *
     1      tmn(ipla) * esc
            reflin( ipla ) = reflin(ipla) + difflya *RefFac *
     1      tmn(ipla) * esc
            ots = difflya * min(0.,1.-esc)
            if( ots.lt.0. ) then
              write(qq,'('' metdif found negative OTS line heav'',2i4,
     1        '' val='',1p,e10.1)')nelem,i , ots
              write(qq,'('' 1-esc ='',1p,e10.2)') 1.-esc
              call ShowMe
              stop
            endif
            call AddOTSLin( ots , ipla , 0.5 )
          else
*           abundance  is zero
            ip = ipHeavy(nelem,i)
            ots = 0.
            Call AddOTSCon( ots , ip )
            ipla = ipLyHeavy(nelem,i)
            call AddOTSLin( ots , ipla , 0.5 )
          endif
        end do
      end do
*
*     Fe Auger K-alpha in outward only
*     first is rec plus hot auger
*     this is pointer to valence shell Lya
*     >>chng 97 apr 28, had been 26,20, so picked up vastly wrong energy for Ka
*     improve to real pointers for line
*     >>chng 96 nov 20, added tmn to two below, to prevent line from
*     overwhelming very thick models
*     >>chng 97 apr 28, put in reflected Ka, had been only outward
*     outlin(ip) = outlin(ip) + fekhot/1.11e-8 * dReff *
      outlin(ipkhot) = outlin(ipkhot) + fekhot*OutFac*tmn(ipkhot)
      reflin(ipkhot) = reflin(ipkhot) + fekhot * RefFac
*     >>chng 97 apr 28, put in reflected Ka, had been only outward
*     this is cold iron, one cell below hot
*     outlin(ip-1) = outlin(ip-1) +fekcld/1.03e-8*dReff*
      outlin(ipkcld) = outlin(ipkcld) +fekcld*OutFac*tmn(ipkcld-1)
      reflin(ipkcld) = reflin(ipkcld) +fekcld*RefFac
*     save1(7) = outlin(1384)
*     save2(7) = outlin(1879)
*
*     now figure out how much we added to the beam
*     this is used for setting zone thickness - do not want to
*     add too much energy in outward beam
      SumOutCon = 0.
      SumIncCon = 0.
      ots = 0.
*     this will be photon energy where this peak occurs
      SumOutMax = 0.
      do i=1,ipHn(1)-1
*       >>chng 96 jan 14, was photon number, now energy
*       >>chng 96 nov 19, save difference in SavOutCon array, for later punch
        SavOutCon(i) = max(0.,outlin(i)+outcon(i)-SavOutCon(i))
        esc = SavOutCon(i) * opac(i) * anu(i)
        if( esc.gt.ots ) then
          ots = esc
          SumOutMax = anu(i)
          ipSumOutMax = i
        endif
*       the ratio of SumOutCon to SumIncCon is kept below 5% in nextdr
        SumOutCon = SumOutCon + esc
*       >>chng 96 nov 18, add outcon, outlin to sum
*       SumIncCon = SumIncCon + (flux(i)+otscon(i)+otslin(i)) *opac(i)*
        SumIncCon = SumIncCon +
     1  (flux(i)+otscon(i)+otslin(i)+outcon(i)+outlin(i) ) *
     1  opac(i)* anu(i)
      end do
      SumHOutCon = 0.
      SumHIncCon = 0.
*     this will be sum of H-ionizing continuum
*     >>chng 96 jan 14, was photon number, now energy
      do i=ipHn(1),nflux
*       esc = ( outlin(i)+outcon(i)-SavOutCon(i) )* opac(i)* anu(i)
        SavOutCon(i) = max(0.,outlin(i)+outcon(i)-SavOutCon(i))
        esc = SavOutCon(i) * opac(i) * anu(i)
        if( esc.gt.ots ) then
          ots = esc
          SumOutMax = anu(i)
          ipSumOutMax = i
        endif
        SumHOutCon = SumHOutCon + esc
*       >>chng 96 nov 18, add outcon, outlin to sum
        SumHIncCon = SumHIncCon +
     1  (flux(i)+otscon(i)+otslin(i)+outcon(i)+outlin(i))*opac(i)*
     1  anu(i)
      end do
      SumOutCon = SumOutCon + SumHOutCon
      SumIncCon = SumIncCon + SumHIncCon
*     write(60,'(i4,1p,7e9.1)')nzone, (save1(i)/max(1.,save1(1)),i=1,7)
*     write(61,'(i4,1p,7e9.1)')nzone, (save2(i)/max(1.e-20,save2(1)),
*    1 i=1,7)
*
      if( lgTrace ) write(qq,'('' metdif returns.'')')
*
      end
