*****************************************************************
      subroutine nphot(umin,umax,xphot,ndust1)
      implicit none
*one of Kevin Kolk's quantum heating routines for grains
* This routine calculates the photon flux able to produce a 
* transition.  umin and umax give the energy range in rydberg 
* for which the total flux of photons weighted by the absorption
* cross-section of the grain is to be calculated.
      integer ndust1
      real umin,umax,xphot
*
      include "ndust.par"
      include "ncell.par"
      include "nqgrid.par"
      include "rfield.com"
      include "ots.com"
      include "phycon.com"
      include "widflx.com"
      include "qheat2.com"
      include "dstop.com"
      include "nphotl.com"
      include "SummdCon.com"
      include "dstfac.com"
*
*     local variables
      integer lget
      integer j,j1,j2
      real val1,val2
*
c The following assumes that nflux is always larger than 1
c
      if (iflnph.lt.nflux) then
c
          do j=iflnph,nflux
            vmin(j)=anu(j)-widflx(j)/2.
            vmax(j)=anu(j)+widflx(j)/2.
          end do
c
          iflnph=nflux
      end if
      xphot=0.
      j1=lget(anu,nflux,umin)-1
      j2=lget(anu,nflux,umax)+1
*
*     >>chng 97 june get rid of go to
*     do j=j1,j2
      j = j1
      do while( j.lt.j2 .and. vmin(j).le.umax )
        if(vmax(j).ge.umin) then
*         if(vmin(j).gt.umax) goto 515
          val1 =max(umin,vmin(j))
          val2 =min(umax,vmax(j))
*         xphot =xphot+(flux(j)+otslin(j)+outcon(j)+otscon(j))*
*         >>chng 97 july 17, summedcon
          xphot =xphot + SummedCon(j) *
     1    dstab1(j,ndust1)*(val2-val1)/widflx(j)
        endif
        j = j + 1
      end do
      xphot = xphot * dstAbund(ndust1)
*
* this assumes that the flux arrays are in photons/s/rydb/cm^2 units,
* rather than cgs flux density units
*515  xphot = xphot*qhnrat(ndust1)/qdep(ndust1)
      xphot = xphot*qhnrat(ndust1)/qdep(ndust1)
      end
