******************************************************************************
      subroutine oxycol
      implicit none
*evaluate total cooling due to oxygen
      include "ipLnArry.par"
      include "limLevelN.par"
      include "limelm.par"
      include "ncell.par"
      include "nta.par"
      include "ndfst.par"
      include "dcool.com"
      include "coolox.com"
      include "occnum.com"
      include "oii.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "o3exc.com"
      include "embesq.com"
      include "logte.com"
      include "pciexc.com"
      include "h.com"
      include "edsqte.com"
      include "hmi.com"
      include "o3data.com"
      include "TauDmmy.com"
      include "PopLevls.com"
      include "IonFracs.com"
      include "Lev3Fail.com"
      include "IOqq.com"
      include "he.com"
*     local variables
      real cse01,cse12,cse02
      real csh01,cshe01,csh201,csh12,cshe12,csh212,csh02,cshe02,csh202
      real csh2o01,csh2o02,csh2o12,csh2p01,csh2p02,csh2p12,csp01,csp02
      real csp12
*
*     local variables
      real hold , o3cs23 , cs21, cs31, cs41,cs51,cs32,cs42,cs52,
     1 cs43,cs53,cs54
      real go2(5) , p(5) , exo2(4)
      real cs23 , cs13 , a6300 , a6363 , a32 , hdcor , cs01 , cs12 ,
     1 cs02, pop3 , a31,a41,a21,a51 , a42 , a52 , a43,a53,a54,
     3 cs , aeff , csoi, cs2s2p , cs2s3p
      data go2/4.,6.,4.,4.,2./ , exo2/26808.4,21.0,13637.5,1.5/
*
*     following does the OI Bowen Ly-bet pumping problem
      call p8446( coolOi )
      call coladd( 'o  1' , 8446 , coolOi )
*
*     O I 6300, 6363, A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     only electrons assumed; ok if ionized fraction GT 1E-4
*     >>refer Federman, S.R., & Shipsey, E.J. 1983, ApJ, 269, 791
      csoi = 2.68e-5*te*(1.+1.67e-6*te-2.95e-10*te*te)
      csoi = max( 0.1 , csoi)
      cs23 = 1.05e-3 * sqrte
      cs13 = 3.24e-6 * te
      a6300 = t6300(ipLnAul) *t6300(ipLnEscP)
      t6300(ipLnPopOpc) = xIonFracs(8,1)*5./5.
      t6300(ipLnPopl) = xIonFracs(8,1)*5./5.
      t6300(ipLnPopu) = 0.
      t6300(ipLnCS) = csoi * 5./9.
      t6363(ipLnPopOpc) = xIonFracs(8,1)*5./3.
      t6363(ipLnPopl) = xIonFracs(8,1)*5./3.
      t6363(ipLnPopu) = 0.
      t6363(ipLnCS) = csoi*3./9.
      a6363 = t6363(ipLnAul)*t6363(ipLnEscP)
*     d6300 is the photoionization rate from the excited level
*     was computed when ionization balance done
      a21 = a6300 + a6363 + d6300
      a32 = t5577(ipLnAul) * t5577(ipLnEscP)
      call PutCS( cs23 , t5577 )
      c5577 = pop3( 9.,5.,1., csoi,cs13,cs23,
     1 a21 , 7.56e-2 , a32 ,
     2 22590. , 25775.7 , poiexc , xIonFracs(8,1) ,0. )
     3 * a32 * 3.57e-12
      t5577(ipLnPopOpc) = poiexc
      t5577(ipLnPopl) = poiexc
      t5577(ipLnPopu) = 0.
*     convert poiexc to relative abundances
      c6300 = poiexc * a6300 * t6300(ipLnEnrErg)
      c6363 = poiexc * a6363 * t6363(ipLnEnrErg)
      dCooldT = dCooldT + c6300* ( 2.28e4*tsq1 + halfte )
      poiexc = poiexc/ max(1e-20, xIonFracs(8,1) )
      call coladd( 'o  1' , 5577 , c5577 )
      call coladd( 'o  1' , 6300 , c6300 )
      call coladd( 'o  1' , 6363 , c6363 )
*
*     O I fine structure lines rad data from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     >>refer Berrington, K.A. 1988, JPhB, 21, 1083
*     hydrogen collisions from 
*     >>refer Tielens, A.G.G., & Hollenbach, D. 1985, ApJ, 291, 722
*     factor in () is their rate coef
*     assume H2 and H are same
*     CDSQTE = 8.629E-6*EDEN/SQRTE
*     cs01 = 9.8e-6*te + (4.2e-12*te70/te03) / cdsqte * 3. * hdcor
*     NOTE: the Tielens & Hollenbach paper contains a typo, is repaired below
*     cs12 = 2.6e-6*te  + (1.5e-11*sqrte/te03/te03)/cdsqte*hdcor
*     cs02 = 2.9e-6*te  + (1.1e-12*te70*te10)/cdsqte*hdcor
*     evaluate fits to OI electron rates, indices on var do not agree
*     with Kirk's in sub, but are OK
* effective collision strength of O^o(3P) with e
      call oi3Pcs(cse01,cse02,cse12)
* rate coefficients for collisional de-excitation of O^o(3P) with H^o(2S1/2)
* NOTE: due to lack of data these relations are extrapolated to higher Te !
*     >>refer Launay & Roueff 1977, AA 56, 289
* the first fit is for Te <= 300K, the second for higher temps
* these data are valid for 50K <= Te <= 1000K
      csh12 = max(2.00e-11*te30*te05*te02,7.67e-12*sqrte*te03)
* these data are valid for 100K <= Te <= 1000K
      csh01 = min(3.12e-12*te70*te02*te02,7.51e-12*sqrte*te05*te03)
* these data are valid for 150K <= Te <= 1000K
      csh02 = min(6.96e-13*te/te10/te02,1.49e-12*te70*te05)
* rate coefficients for collisional de-excitation of O^o(3P) with He^o(1S)
* NOTE: due to lack of data these relations are extrapolated to higher Te !
*     >>refer Monteiro & Flower 1987, MNRAS 228, 101
* the first fit is for Te <= 300K, the second for higher temps
* these data are valid for 100K <= Te <= 1000K
      cshe12 = min(8.09e-16*te32*te10*te03,9.72e-15*te*te20)
      cshe01 = 1.57e-12*te70/te01
      cshe02 = min(1.80e-12*te70*te05,4.45e-12*te70/te10)
      if( te.le.1.5e3 ) then
* rate coefficients for collisional de-excitation of O^o(3P) with H2(J=1,0)
*     >>refer Jaquet et al. 1992, J.Phys.B 25, 285
* these data are valid for 40K <= Te <= 1500K
* the first entry is contribution from ortho H2, the second para H2.
         csh2o12 = 2.21e-14*te*te10/te01
         csh2p12 = 9.45e-15*te*te20/te01
* assume standard mixture of ortho and para H2
         csh212 = 0.75*csh2o12 + 0.25*csh2p12
         csh2o01 = 2.37e-11*te30*te10/te02
         csh2p01 = 3.40e-11*te30*te02
         csh201 = 0.75*csh2o01 + 0.25*csh2p01
         csh2o02 = 4.86e-11*te30*te02*te02
         csh2p02 = 6.82e-11*te30/te02
         csh202 = 0.75*csh2o02 + 0.25*csh2p02
      else
         csh212 = 0.
         csh201 = 0.
         csh202 = 0.
      endif         
* effecitive collision strength of O^o(3P) with p
*     >>refer Pequignot, 1990, A&A 231, 499
*     original data: Chambaud et al., 1980, J.Phys.B, 13, 4205 (upto 5000K)
*                    Roueff, private communication (10,000K and 20,000K)
      if( te.le.1000. ) then
         csp01 = max(2.22e-5*te/te10,2.69e-6*te*te30)*hii/eden
         csp02 = min(7.07e-8*te32*te10,2.46e-7*te32/te10)*hii/eden
      else
         csp01 = min(2.69e-6*te*te30,9.21e-5*te/te10/te03)*hii/eden
         csp02 = min(2.46e-7*te32/te10,5.21e-5*te/te20)*hii/eden
      endif
      csp12 = min(2.35e-6*te*te05*te01,3.98e-5*te70/te01)*hii/eden
*
      cs01 = cse01+csp01+3.*(csh01*hi + cshe01*hei + csh201*htwo)/cdsqte
      cs12 = cse12+csp12+(csh12*hi + cshe12*hei + csh212*htwo)/cdsqte
      cs02 = cse02+csp02+(csh02*hi + cshe02*hei + csh202*htwo)/cdsqte

      call PutCS( cs01 , t63 )
      call PutCS( cs12 , t146 )
      call PutCS( cs02 , TauDummy )
      call level3( t63,t146,TauDummy)
*
*     O II lines, CS data from 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     A;s from NIST
*     full five level atom, ex in wavenumbers
*     more recent cs 
*     >>refer McLaughlin, B.M., & Bell, K.L. 1993, ApJ, 408, 753
*     >>chng 97 feb 19, change in last sig fig as per Bob Rubin e-mail feb 11 97
*     A from NIST compilation
*     >>refer Wiese, W.L., Fuhr, J.R., Deters, T.M. 1996, J Phys Chem Ref Data,
*     >>refer Monograph 7
      a21 = 3.058e-5
      a31 = 1.776e-4
      a41 = 5.22e-2
      a51 = 2.12e-2
      a32 = 1.30e-7
      a42 = 0.09907
      a52 = 0.0519
      a43 = 0.0534
      a53 = 0.08672
      a54 = 1.41e-10
*     >>chng 97 feb 19, mostly in last sig figs, as per Bob Rubin e-mail and
*     >>refer McLaughlin, B.M., & Bell, K.L. 1993, ApJ, 408, 753
      cs21 = 0.825
      cs31 = 0.55
      cs41 = 0.2765
      cs51 = 0.1382
      cs32 = 1.17
*     scale factor from
*     >>refer McLaughlin, B.M., & Bell, K.L. 1993, ApJ, 408, 753
      cs42 = 0.730 * 1.207
      cs52 = 0.295 * 1.207
      cs43 = 0.408 * 1.207
      cs53 = 0.275 * 1.207
      cs54 = 0.287
*     subroutine fivel(g,ex,cs12,cs13,cs14,cs15,
*    1 cs23,cs24,cs25,cs34,cs35,cs45, a21,a31,a41,a51, a32,a42,a52,
*    2 a43,a53,a54, p,abund)
      call fivel(go2, exo2 , cs21,cs31,cs41,cs51,
     1 cs32,cs42,cs52,cs43,cs53,cs54,
     2 a21 ,a31 ,a41 ,a51 ,a32 ,a42 ,a52 ,a43 ,
     3 a53 ,a54 , p, xIonFracs(8,2) )
      O3730 = p(2) * a21 * 5.34e-12
      O3727 = p(3) * a31 * 5.34e-12
      O2471 = ( p(4)*a41 + p(5)*a51 ) * 8.05e-12
      O7323 = ( p(4)*a42 + p(5)*a52 ) * 2.72e-12
      O7332 = ( p(4)*a43 + p(5)*a53 ) * 2.71e-12
      c3727 = O3730+O3727
      c7325 = O7323+O7332
      dCooldT = dCooldT + c3727*(3.86e4*tsq1 - halfte)
      call coladd( 'O  2' , 3727 , c3727 )
      call coladd( 'O  2' , 7325 , c7325 )
      call coladd( 'O  2' , 2470 , c7325*0.78 )
*
*     O II 833.9A, CS 
*     >>refer McLaughlin, B.M., & Bell, K.L. 1993, ApJ, 408, 753
      cs = 0.355 * te10 * te10 * te003 * te001 *te001
      call PutCS( cs , t834 )
      call level2( t834 )
*
*     O III 1666, crit den=2.6+10, A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     c.s. 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      call PutCS( 0.756 , t1666 )
      call PutCS( 0.454 , t1661 )
      call PutCS( 1.3 , TauDummy )
      call level3( TauDummy, t1666,t1661 )
*     if( nLev3Fail.gt.0 )write(qq,'('' nlev3fail='',i3)') nLev3Fail
*
*     oiii 304 not in cooling function
* 666 error! put all these in cooling
      t304(ipLnPopOpc) = xIonFracs(8,3)
      t304(ipLnPopl) = xIonFracs(8,3)
      t304(ipLnPopu) = 0.
*
*     o iii 5007+4959, As 96 nist
      aeff = 0.0263 + d5007r
*     following data used in routine that deduces oiii temp from spectrum
*     
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     IP paper Y(ki) differ significantly from those
*     calculated by
*     >>refer Burke, V.M., Lennon, D.J., & Seaton, M.J. 1989, MNRAS, 236, 353
*     especially for 1D2-1S0.
*     BLS89 is adopted for 1D2-1S0 and LB94 for 3P2,1-1D2.
*     NB!!  these cs's must be kept parallel with those in Peimbert analysis
      if( te.gt.3981 .and. te.le.1e5 ) then
        o3cs12 = 3.0211144 - 101.57536 /sqrte + 355.06905 *alogete/te
        o3cs23 = 0.32412181 + 79.051672/sqrte -4374.7816/te
      else if( te.lt.3981. ) then
        o3cs12 = 2.15
        o3cs23 = 0.4781
      else 
        o3cs12 = 2.6594
        o3cs23 = 0.5304
      endif
      o3cs13 = min(0.36 , 0.0784*te10*te03*te01*te003 )
      a21 = 0.02431
      a31 = .215634
      a32 = 1.71
      o3ex23 = 32947.
      o3br32 =  a32 / ( a31 + a32 )
      o3enro = 4.56e-12 / 3.98e-12
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      poiii3 = pop3( 9.,5.,1.,o3cs12,o3cs13,o3cs23,a21 ,a31 ,a32 ,
     1 28990.,o3ex23 , poiii2,xIonFracs(8,3),d5007r) 
      c4363 = poiii3 * a32 * 4.56e-12
      c5007 = poiii2 * a21 * 3.98e-12
      d5007t = c5007 * d5007r/aeff
      dCooldT = dCooldT + c5007* ( 2.88e4*tsq1 - halfte )
      dCooldT = dCooldT + c4363*6.20e4*tsq1
      call coladd( 'O  3' , 5007 , c5007 )
      call coladd( 'O  3' , 4363 , c4363 )
      call coladd( 'O  3' , 2331 , c4363*0.236 )
      if( xIonFracs(8,3).gt.0. ) then
        poiii3 = poiii3 / xIonFracs(8,3)
        poiii2 = poiii2 / xIonFracs(8,3)
      endif
*
*     oiii ir lines, col str from iron project, 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      call PutCS( 0.5590 , tO88 )
      call PutCS( 1.335 , t52 )
      call PutCS( 0.2832 , TauDummy )
      call level3( tO88,t52,TauDummy)
*
*     O III 834A, CS 
*     >>refer Aggarwal, K.M., 1985 Ast Ap 146, 149.
      call PutCS( 5. , t835 )
      call level2( t835 )
*     call DumpLine( t835 )
*
*     O IV 26 mic, CS 
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
*     A=
*     >>refer Brage, T., Judge, P.G., & Brekke, P. 1996, ApJ. 464, 1030
      hold = max( te,4500.)
      hold = min( hold, 450000. )
      aeff = log( hold )
      cs = 9.2141614  - 5.1727759e-3*sqrt(hold) - 58.116447/aeff
      call PutCS( cs , t26 )
      call level2( t26 )
*
*     O IV 1402, wl from 
*     >>refer Wills, D., & Netzer, H. 1979, ApJ, 233, 1
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     CS 
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
      cs = -13.860726 - 0.14091452*aeff**2 + 2.9626895*aeff
      call PutCS( cs , t1402 )
      call level2( t1402 )
*
*     O IV 789A, CS from 
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
      cs = -3.0102462 + 109.22973/aeff - 18666.357/hold
      call PutCS( cs , t789 )
      call level2( t789 )
*     call DumpLine( t789 )
*
*     O V 630, CS from 
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
      cs = min( 4.0 , 1.317 * te10/te03 )
      call PutCS( cs , t630 )
      call level2( t630 )
*
*     O V 1218; coll data from 
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
      if( te.le. 3.16e4 ) then
        cs = 3.224 /(te10*te03*te03*te003)
      else
        cs = 10.549 / (te10*te10*te10/te03)
      endif
      call PutCS( cs , t1214 )
*     c1214 = beseq( .87,1.05,3.32, t1214, .0216) * 1.64E-11
*     BESEQ(CS23,CS24,CS34,tarray,A41)
*     A's 
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer  1996, MNRAS, 279, 1289
      call beseq( .87,0.602,2.86, t1214, .02198)
      em1218 = PopLevels(3)*0.0216 * 1.64e-11
*
*     O VI 1035 li seq
*     generate collision strengths, then stuff them in
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 8 , t1032, t150, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , t1032 )
      call PutCS( cs2s2p*0.5 , t1037 )
*     no data for the 2-3 transition
      call PutCS(  1.0 , TauDummy )
*     solve the 3 level atom
      call level3( t1037,TauDummy, t1032)
*
      call PutCS( cs2s3p , t150 )
      call level2( t150 )
*
      end

