******************************************************************************
      subroutine PhosCol
      implicit none
*compute phosphorus cooling
      include "ipLnArry.par"
      include "nta.par"
      include "limelm.par"
      include "dcool.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "logte.com"
      include "IonFracs.com"
      include "TauDmmy.com"
*
*     local variables
      real cs
*
*     [P II] 60.64, 32.87 microns
*     cs, As from
*     >>refer Mendoza, C., & Zeippen, C.J., 1982, MNRAS 199, 1025
*     >>refer Krueger, T.K., and Czyzak, S.J., 1970,
*     >>refer Proc Roy Soc London A 318, 531
      call PutCS( 1.587 , P0260 )
      call PutCS( 3.566 , P0233 )
      call PutCS( 1.0 , TauDummy )
*     level3(  t10,t21,t20)
      call level3( P0260 , P0233 , TauDummy )
*
*     [P III] 17.885 microns
*     CS, A from
*     >>refer Kaufman, V., & Sugar, J., 1986, J Phys Chem Ref Data 15, 321
*     >>refer Krueger, T.K., and Czyzak, S.J., 1970,
*     >>refer Proc Roy Soc London A 318, 531
      call PutCS( 1.859 , P0318 )
      call level2( P0318 )
*
*     [P VII] 1.374 microns
*     cs from Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.27, P713 )
      call level2( P713 )
*
*     [P VIII] 4.85, 1.735 microns
      call PutCS( 0.30 , P848 )
      call PutCS( 0.97 , P817 )
      call PutCS( 0.26 , TauDummy )
*     j levels inverted
      call level3( P817 , P848 , TauDummy )
*
*     [P X] 2.708, 1.868 microns
      cs = min( 0.33 , 0.892/(te10/te001) )
      call PutCS( cs , P1027 )
      cs = min( 1.082 , 5.949/(te20/te03*te003) )
      call PutCS( cs , P1018 )
      cs = min( 0.33 , 3.054/(te20*te02*te005 ) )
      call PutCS( cs , TauDummy )
      call level3( P1027 , P1018 , TauDummy )
*
      end
