******************************************************************************
      subroutine PIonte
      implicit none
*drive pressure, ionization, and thermal balance
      include "itrdim.par"
      include "pnow.com"
      include "phycon.com"
      include "ZoneCnt.com"
      include "ntry.com"
      include "called.com"
      include "presok.com"
      include "nfail.com"
      include "tfail.com"
      include "TrConvg.com"
      include "iondun.com"
      include "IOqq.com"
*
*     local variables
      integer nmax , nThLoop
      parameter (nmax=20)
      integer loop
      logical lgLoopOnce
*
      if( lgTrConvg ) then
        write(qq,'(''  '')')
        write(qq,'('' PIonte entered zone'',i4)') nzone
      endif
*     ntry is number of times ionize called
      ntry = 0
      loop = 0
      lgPresOK = .false.
      lgLoopOnce = .true.
      do while((.not.lgPresOK .and. loop.lt.nmax) .or. 
     1  lgLoopOnce )
        if( lgTrConvg ) then
          write(qq,'('' PIonte  loop'',I4,'' Te:'',1P,
     1    E9.2,'' Hden:'',E9.2,'' current Pres:'',E9.2,'' Corr Pres'',
     2    E9.2)') loop , te,hden,pnow,pcorec
        endif
*       pressure loop, presur evaluates lgPresOK, true if pressure now ok
        call presur(loop)
*       heating cooling balance while doing ionization
        call ionte(nThLoop,loop)
*       make sure boltzmann factors are up to date
        call boltgn
        loop = loop + 1
*       this just makes sure we do two solutions
        if( loop.gt.1 .or. nThLoop.gt.1 ) lgLoopOnce = .false.
      end do
*     lgTeFail is flag set in IONTE to say whether heating - cooling matched
      if( lgTeFail ) then
        call tefail
      endif
      if( .not.lgIonDone.and. .not.lgTeFail ) then
        write(qq,'('' No Ioniz Convergence'')')
      endif
*
*     keep track of high and low pressures
*     plow = min( plow , pnow )
*     phi = max( phi , pnow )
*
      if( .not.lgPresOK .and.lgTalk ) then
*       record number of pressure failures
        nPreFail = nPreFail + 1
        write(qq,'('' PIonte exit, pressure not converged; zone'',I4,
     1  '' Te:'',1P,E9.2,'' Hden:'',E9.2,'' current Pres:'',E9.2,
     1  '' Corr Pres'',e9.2)') nzone, te,hden,pnow,pcorec
      else if( lgTrConvg ) then
*       option to follow convergene, only necessary to print if not above
        write(qq,'('' PIonte exit, pressure converged, Te:'',1p,
     1  e9.2,'' Hden:'',E9.2,'' current Pres:'',E9.2,'' Corr Pres'',
     2  e9.2)') te,hden,pnow,pcorec
      endif
*
      end
