******************************************************************************
      subroutine pmeani
      implicit none
*print mean ionization fractions for all elements
      include "ndust.par"
*     include "colden.exp"
      include "cldnEXP.com"
      include "toiii.com"
      include "sphere.com"
      include "IOqq.com"
      include "GeoPP.com"
      include "limelm.par"
      include "elmton.com"
      include "elnam.com"
*
*     local variables
      integer i , nelem , n
      real aa(64) , c(64)
*     character*10 chElNam(limelm)
*     common/elnam/ chElNam
*     data
*    1   chElNam/'Hydrogen  ', 'Helium    ', 'Lithium   ', 'Beryllium ',
*    1           'Boron     ', 'Carbon    ', 'Nitrogen  ', 'Oxygen    ',
*    2           'Fluorine  ', 'Neon      ', 'Sodium    ', 'Magnesium ',
*    2           'Aluminium ', 'Silicon   ', 'Phosphorus', 'Sulphur   ',
*    2           'Chlorine  ', 'Argon     ', 'Potassium ', 'Calcium   ',
*    2           'Scandium  ', 'Titanium  ', 'Vanadium  ', 'Chromium  ',
*    2           'Manganese ', 'Iron      ', 'Cobalt    ', 'Nickel    ',
*    2           'Copper    ', 'Zinc      '/
*
*     print mean ionization
*
*     only print sphereical if not plane parallel
      if( lgSphere.and.(.not.lgGeoPP) ) then
*
        call VolMean( 1 , n , aa )
        call VolMean( 2 , n , c )
        write(qq,'(/,'' Hydrogen  '',2F7.3,27X,
     1 ''Log10 Mean Ionisation (over volume)'',/,'' Helium    '',3F7.3)'
     2  )(aa(i),i=1,2) ,  (c(i),i=1,3)
        do nelem=3,limelm
          if( lgElmtOn(nelem) ) then
            call VolMean( nelem , n , aa )
            write(qq,'(1x,a10,17F7.3)')chElNam(nelem),(aa(i),
     1      i=1,min(17,n))
            if(n.gt.17)write(qq,'(11x,17F7.3)')(aa(i),i=18,n)
          endif
        end do
      endif
*
      write(qq,'(7x,17i7)') (i,i=1,17)
*
      call RadMean( 1 , n , aa )
      call RadMean( 2 , n , c )
      write(qq,'(/,'' Hydrogen  '',2F7.3,27X,
     1''Log10 Mean Ionisation (over radius)'',/,'' Helium    '',3F7.3)')
     2 (aa(i),i=1,2) , (c(i),i=1,3)
*
      do nelem=3,limelm
        if( lgElmtOn(nelem) ) then
          call RadMean( nelem , n , aa )
          write(qq,'(1x,a10,17F7.3)')chElNam(nelem),(aa(i),
     1    i=1,min(17,n))
          if(n.gt.17)write(qq,'(11x,17F7.3)')(aa(i),i=18,n)
        endif
      end do
*
      end
