******************************************************************************
      real function popexc( omega , g1 , g2 , a21 , bltz , abund )
      implicit none
*do level population for simple two level atom, no radiative transfer
      real omega , g1 , g2 , a21 , bltz , abund
*
      include "p2ovp1.com"
      include "phycon.com"
      include "edsqte.com"
      include "teinv.com"
      include "IOqq.com"
*
*     local variables
      real boltz , q21 , q12 , r
*
*     result is density (cm-3) of excited state times a21
*     result normalized to n1+n2=abund
*     cdsqte is eden / sqrte * 8.629e-6
*
      boltz = bltz * teinv
      if( abund.eq.0. .or. boltz.gt.15. ) then
         popexc = 0.
         p2ovp1 = 0.
         return
      endif
*
*begin sanity check
      if( omega.le.0. ) then
        write(qq,'('' POPEXC called with non-positive collision'',
     1  '' strength, ='',1P,E10.2)') omega
        write(qq,'('' bltz='',1P,E10.2)') bltz
        write(qq,'('' args were omega , g1 , g2 , a21 , bltz , abund '',
     1  1p6e12.5)') omega , g1 , g2 , a21 , bltz , abund 
        call ShowMe
        stop
      endif
*end sanity check
*
      q21 = cdsqte * omega
      q12 = q21 / g1 * exp(-boltz)
      q21 = q21 / g2
      r = (a21+q21) / q12
      popexc = abund * a21 / ( r + 1. )
*
*     following is relative popultation per sub-level, used
*     to calculate radiation pressure in TEMP
      p2ovp1 = g1 / ( g2*r )
*
      end
