******************************************************************************
      subroutine prhead
      implicit none
*print program's header, including luminosities and ionization parameters
      include "ncell.par"
      include "planck.par"
      include "hnu3c2.par"
      include "pi4.par" 
      include "ndust.par"
      include "en1ryd.par"
      include "te1ryd.par"
      include "dstfac.com"
      include "comsig.com"
      include "phycon.com"
      include "bounds.com"
      include "prhd.com"
*     include "gampow.com"
      include "totlum.com"
      include "u.com"
      include "h.com"
      include "he.com"
      include "rfield.com"
      include "ots.com"
      include "widflx.com"
      include "occnum.com"
      include "qs.com"
      include "fourpi.com"
      include "called.com"
      include "nhlvl.par"
      include "nh.com"
      include "comptn.com"
      include "comund.com"
      include "only.com"
      include "tenden.com"
      include "edgtcm.com"
      include "IOqq.com"
*
*     local variables
      integer ipoint,ip2kev,ip2500,i
      real qxl,pionl,avpow,qhel,qheiil,ql,ratio,alfox,gpowl,
     1 qgaml,radpwl,solar,fluxv,ffun,absv,fbeta,absbol,bolc,
     2 tcomp, tradio , pballog , qballog
*
      if( .not.lgTalk ) return
*
      write(qq,'(10X,I4,''Cell Peak'',1P,E8.2,
     1 3X,''Lo'',1P,E9.2,''='',0P,F6.4,''cm'',
     2 3X,''Hi-Con:'',1P,E8.2,'' Ryd'',
     3 3X,''E(hi):'',1P,E8.2,''Ryd'',
     4 5X,''E(hi):  '',0P,F9.2,'' MeV'')') nflux , anu(ipeak) ,
     5 anu(1)-widflx(1)/2.,9.117e-6/(anu(1)-widflx(1)/2.),
     6 anu(nflux)+widflx(nflux)/2. ,
     6 egamry,egamry*0.0000136

*
      if( xpow.gt.0. ) then
        xpow = log10( xpow ) + pirsq
        qxl = log10( qx ) + pirsq
      else
        xpow = 0.
        qxl = 0.
      endif
*
      if( powion.gt.0. ) then
        pionl = log10(powion) + pirsq
        avpow = powion/qhtot/en1ryd 
      else
        pionl = 0.
        avpow = 0.
      endif
*
*     >>chng 97 mar 18, break these two out here, so that returns zero
*when no radiation - had been done in the print statement so pirsq was printed
      if( pbal.gt.0. ) then
        pballog = log10(max(1e-30,pbal))+pirsq
        qballog = log10(max(1e-30,qbal))+pirsq
      else
        pballog = 0.
        qballog = 0.
      endif
*
      if( pirsq.gt. 0. ) then
        write(qq,'(10X,'' L(nu>1ryd):'',F9.4,1P,''   Average nu:'',
     1  e9.3,''   L( X-ray):'',0P,F9.4,''   L(BalC):'',F9.4,5X,
     2  ''Q(Balmer C):'',F9.4)') pionl , avpow ,
     3  xpow, pballog , qballog
      else
        write(qq,'(10X,'' I(nu>1ryd):'',F9.4,1P,''   Average nu:'',
     1  e9.3,''   I( X-ray):'',0P,F9.4,''   I(BalC):'',F9.4,5X,
     2  ''Phi(BalmrC):'',F9.4)') pionl , avpow ,
     3  xpow, log10(max(1e-30,pbal)) ,
     4  log10(max(1e-30,qbal))
      endif
*
      if( qhe.gt.0. ) then
        qhel = log10(qhe) + pirsq
      else
        qhel = 0.
      endif
*
      if( qheii.gt.0. ) then
        qheiil = log10(qheii) + pirsq
      else
        qheiil = 0.
      endif
      if( q.gt.0. ) then
        ql = log10( q ) + pirsq
      else
        ql = 0.
      endif
*
      if( pirsq.ne.0. ) then
        write(qq,'(10X,'' Q(1.0-1.8):'',F9.4,''   Q(1.8-4.0):'',F9.4,
     1  ''   Q(4.0-20):'',F9.4,''   Q(20--):'',F9.4,5X,''Ion pht flx:'',
     2  1p,e9.3)') ql , qhel , qheiil , qxl , qhtot
      else
        write(qq,'(10X,'' phi(1.0-1.8):'',F7.4,''   phi(1.8-4.0):''
     1  ,F7.3, ''   phi(4.0-20):'',F7.3,''   phi(20--):'',F7.3,5X,
     2  ''Ion pht flx:'',1P,E9.3)') ql , qhel , qheiil , qxl , qhtot
      endif
*
*     estimate alpha (o-x)
      if( anu(nflux).gt.150. ) then
*       the ratio of fluxes is nearly 403.3^alpha ox
        ip2kev = ipoint( 147. )
        ip2500 = ipoint( 0.3645 )
        if( flux(ip2500).gt.1e-28 ) then
          ratio = (flux(ip2kev)*anu(ip2kev)/widflx(ip2kev) ) /
     1    (flux(ip2500)*anu(ip2500)/widflx( ip2500) )
        else
          ratio = 0.
        endif
        if( ratio .gt. 0. ) then
          alfox = log( ratio ) / log( anu(ip2kev)/anu(ip2500) )
        else
          alfox = 0.
        endif
      else
        alfox = 0.
      endif
*
      if( GammaLumin.gt.0. ) then
        gpowl = log10(GammaLumin) + pirsq
        qgaml = log10( qgam ) + pirsq
      else
        gpowl = 0.
        qgaml = 0.
      endif
      if( pradio.gt.0. ) then
        radpwl = log10( pradio ) + pirsq
      else
        radpwl = 0.
      endif
*
      if( pirsq.gt.0. ) then
        write(qq,'(10X,'' L(gam ray):'',F9.4,''   Q(gam ray):'',F9.4,
     1  3X,''L(Infred):'',F9.4,''   Alf(ox):'',F9.4,5X,
     2  ''Total lumin:'',F9.4)
     3  ') gpowl , qgaml , radpwl , alfox , log10(totlum)+pirsq
      else
        write(qq,'(10X,'' I(gam ray):'',F9.4,''   phi(gam r):'',F9.4,
     1  3X,''I(Infred):'',F9.4,''   Alf(ox):'',F9.4,5X,
     2  ''Total inten:'',F9.4)
     3  ') gpowl , qgaml , radpwl , alfox , log10(totlum)+pirsq
      endif
*
*     magnitudes
      if( pirsq.gt.0. ) then
        solar = log10(totlum) + pirsq - 33.5828
        absbol = 4.75 - 2.5 * solar
*       flux density in V, erg / s / cm2 / hz
        fluxv = ffun( 0.1643 ) * planck * 0.1643
*       absv = 4.79 - 2.5 * (log10(max(1e-30,fluxv)) + pirsq - 18.742 -
*    1  0.016)
*       allen 76, page 197
        absv = -2.5 * (log10(max(1e-30,fluxv)) + pirsq - 20.654202)
        fbeta = ffun( 0.1875 ) * planck * 0.1875 * 6.167e14
*     >>chng 97 mar 18, following branch so zero returned when no radiation at all
        if( fbeta.gt.0. ) then
          fbeta = log10( max(1e-37, fbeta ) ) + pirsq
        else
          fbeta = 0.
        endif
        bolc = absbol - absv
        write(qq,'(11X,''log L/Lsun:'',F9.4,''   Abs bol mg:'',F9.4,3X,
     1  ''Abs V mag:'',F9.4,''   Bol cor:'',F9.4,5X,
     2  ''nuFnu(Bbet):'',F9.4)')
     3  solar , absbol , absv , bolc , fbeta
      endif
*
      cmcool = 0.
      cmheat = 0.
      do i=1,nflux
*       CSIGC is Tarter expression times ANU(I)*3.858E-25
        cmcool = cmcool + (flux(i)+outlin(i)+outcon(i)) * csigc(i)
*       Compton heating with correction for induced Compton scattering
*       CSIGH is Tarter expression times ANU(I)**2 * 3.858E-25
        cmheat = cmheat + (flux(i)+outlin(i)+outcon(i)) * csigh(i) *
     1  (1.+occnum(i) )
      end do
      cmheat = cmheat * ( eden  * 1e-15)
*     6.338E-6 is k in inf mass Rydbergs
      cmcool = cmcool*(eden*4.*6.338e-6*1e-15)
*
*     all of following need factor of 10^-15 to be true rates
      if( cmcool.gt.0. ) then
        lgComUndr = .false.
        tcomp = cmheat / cmcool
      else
*       underflow if Compt cooling rate is zero
        lgComUndr = .true.
        tcomp = 0.
      endif
*
*     check whether energy density temp is greater than compton temp
      if( TEnerDen.gt.1.05*tcomp ) then
        lgEdnGTcm = .true.
      else
        lgEdnGTcm = .false.
      endif
*
*     say some ionization parameters
      write(qq,'(10X,'' U(1.0----):'',1P,E9.3,''   U(4.0----):'',
     1E9.3,''   T(En-Den):'',E9.3,''   T(Comp):'',E9.3,5X,
     2''nuJnu(912A):'',E9.3)')
     3 uh , uheii , TEnerDen , tcomp , fx1ryd
*
*     some occupation numbers
      write(qq,'(10X,'' Occ(FarIR):'',1P,E9.3,''   Occ(H n=6):'',
     1E9.3,''   Occ(1Ryd):'',E9.3,''   Occ(4R):'',E9.3,5X,
     2''Occ (Nu-hi):'',E9.3)') occnum(1) , occnum(ipHn(6)) ,
     3 occnum(ipHn(1)) , occnum(nheii) , occnum(nflux)
*
*     now print brightness temps
      tradio = occnum(1)*te1ryd*anu(1)
      write(qq,'(10X,'' Tbr(FarIR):'',1P,E9.3,''   Tbr(H n=6):'',
     1E9.3,''   Tbr(1Ryd):'',E9.3,''   Tbr(4R):'',E9.3,5X,
     2''Tbr (Nu-hi):'',E9.3)') 
     3 tradio , occnum(ipHn(6))*te1ryd*anu(ipHn(6)) ,
     4 occnum(ipHn(1))*te1ryd*anu(ipHn(1)) ,
     4 occnum(nheii)*te1ryd*anu(nheii) , occnum(nflux)*te1ryd*anu(nflux)
*
      if( tradio.gt.1e9 ) then
        write(qq,'('' >>>The radio brightness temperature is very '',
     1  ''large,'',1P,E10.2,''K at'',E10.2,''cm.  Is this physical???''
     2  )')
     2  tradio , 9.115e-6/anu(1)
      endif
*
*     skip a line
      write(qq,'(''  '')')
*
      if( lgOnlyHead ) then
        stop
      endif
*
      end
