******************************************************************************
      subroutine qg32 (xl, xu, fct, y)
      implicit none
*32 point Gaussian quadrature, originally given to Gary F by Jim Lattimer
      real xl,xu,fct,y
      external fct
      real a,b,c
*
*******************************************************************************
*                                                                             *
*    32-point Gaussian quadrature.                                            *
*    xl  : the lower limit of integration                                     *
*    xu  : the upper limit                                                    *
*    fct : the (external) function                                            *
*    y   : the value of the integral                                          *
*                                                                             *
*******************************************************************************
*
      a = .5 * (xu + xl)
      b = xu - xl
      c = .498631930924740780       * b
      y = .35093050047350483e-2     * (fct (a + c) + fct (a - c))
      c = b * .49280575577263417
      y = y + .8137197365452835e-2  * (fct (a + c) + fct (a - c))
      c = b * .48238112779375322
      y = y + .1269603265463103e-1  * (fct (a + c) + fct (a - c))
      c = b * .46745303796886984
      y = y + .17136931456510717e-1 * (fct (a + c) + fct (a - c))
      c = b * .44816057788302606
      y = y + .21417949011113340e-1 * (fct (a + c) + fct (a - c))
      c = b * .42468380686628499
      y = y + .25499029631188088e-1 * (fct (a + c) + fct (a - c))
      c = b * .3972418979839712
      y = y + .29342046739267774e-1 * (fct (a + c) + fct (a - c))
      c = b * .36609105937014484
      y = y + .32911111388180923e-1 * (fct (a + c) + fct (a - c))
      c = b * .3315221334651076
      y = y + .36172897054424253e-1 * (fct (a + c) + fct (a - c))
      c = b * .29385787862038116
      y = y + .39096947893535153e-1 * (fct (a + c) + fct (a - c))
      c = b * .2534499544661147
      y = y + .41655962113473378e-1 * (fct (a + c) + fct (a - c))
      c = b * .21067563806531767
      y = y + .43826046502201906e-1 * (fct (a + c) + fct (a - c))
      c = b * .16593430114106382
      y = y + .45586939347881942e-1 * (fct (a + c) + fct (a - c))
      c = b * .11964368112606854
      y = y + .46922199540402283e-1 * (fct (a + c) + fct (a - c))
      c = b * .7223598079139825e-1
      y = y + .47819360039637430e-1 * (fct (a + c) + fct (a - c))
      c = b * .24153832843869158e-1
      y = b * (y + .482700442573639e-1 * (fct (a + c) + fct (a - c)))
*
      end
