******************************************************************************
      real function qintr( enlo , enhi )
      implicit none
*integrates Q for any continuum between two limits, used for normalization
      real enlo , enhi
*
      include "ncell.par"
      include "rfield.com"
      include "limspc.par"
      include "widflx.com"
      include "spec.com"
      include "sptype.com"
      include "IOqq.com"
*
*     local variables
      real skip
      parameter (skip=2.)
      logical lgMore
      external ffun1
      real sum , fsum , wanu , wfun, ffun1,en1,en2,piece
      integer i , j , ipoint , ip , ipLo , ipHi
*
      real aweigh(4) , fweigh(4)
      data  aweigh(1)/-0.4305682/ , aweigh(2)/-0.1699905/ , 
     1      aweigh(3)/+0.1699905/ , aweigh(4)/+0.4305682/ ,
     2      fweigh(1)/+0.1739274/ , fweigh(2)/+0.3260726/ ,  
     3      fweigh(3)/+0.3260726/ , fweigh(4)/+0.1739274/
*
*     returns LOG of number of photons over energy interval
      sum = 0.
      if( chSpType(ipspec).eq.'LASER' ) then
*        laser is special since delta function
         ip = ipoint( slope(ipspec) )
         do i= ip-20, ip+20
            fsum = 0.
            do j=1,4
               wanu = anu(i) + widflx(i)*aweigh(j)
               wfun = fweigh(j) * ffun1( wanu )
               fsum = fsum + wfun
            end do
            sum = sum + fsum * widflx(i)
         end do
      else if( chSpType(ipspec).eq.'INTER' ) then
*       interpolate is special since might be very chaotic
        ipLo = ipoint( enlo )
        ipHi = ipoint( enhi )
        sum = 0.
        do i=ipLo,ipHi
          sum = sum + ffun1( anu(i) ) * widflx(i)
        end do
      else
*       rest of cases should be smooth enough to just add up
        lgMore = .true.
        en1 = enlo / skip
        do while( lgMore )
          en1 = en1 * skip
          en2 = en1 * skip
          if( en2.ge.enhi ) then
            en2 = enhi
            lgMore = .false.
          endif
          call qg32( en1 , en2 , ffun1 , piece )
          sum = sum + piece
        end do
      endif
*
      if( sum.le.0. ) then
        write(qq,'('' Photon number sum in QINTR is'',1P,E10.3)') sum
        write(qq,'('' This source has no ionizing radiation, and the'',
     1  '' number of ionizing photons was specified.'')')
        write(qq,'('' This was continuum source number'',i3)') ipspec
        write(qq,'('' Sorry, but I cannot go on.  ANU and FLUX '',
     1  ''arrays follow.  Enjoy.'')')
        write(qq,'(1P,2E10.2)') (anu(i),flux(i),i=1,ncell)
        stop
      else
        qintr = log10( sum )
      endif
*
      end
