******************************************************************************
      subroutine rangr( nqh , chCard )
      implicit none
*parse the range option on the luminosity command
      character chCard*80
      integer nqh
*
      include "limspc.par"
      include "HIonPot.par"
      include "bounds.com"
      include "range.com"
      include "IOqq.com"
*
      logical lgEOL , lgMatch
      real fread , p1 , p2
      integer i
*
      if( lgMatch( 'TOTA', chCard ) ) then
        range(nqh,1) = emm
        range(nqh,2) = egamry
      else if( lgMatch( 'RANG', chCard ) ) then
        i = 1
*       first call return the luminosity on the card, ignore it
        p1 = fread( chCard , i , 76 , lgEOL )
*
*       this should be the lower limit
        p1 = fread( chCard , i , 76 , lgEOL )
        if( p1.eq.0. ) p1 = emm
*
        p2 = fread( chCard , i , 76 , lgEOL )
*       no third numer on card then go all the way to gamma ray
        if( p2.eq.0. ) p2 = egamry
*
*       option to enter log if first energy is neg
        if( p1.lt.0. .or. lgMatch( ' LOG', chCard ) ) then
          p1 = 10.**p1
*         second number may not have been entered
          if(.not.lgEOL) p2 = 10.**p2
        endif
*
*       make sure that energies are within array bounds
        range(nqh,1) = max( p1 , emm )
        range(nqh,2) = min( p2 , egamry )
        if( range(nqh,1).gt.range(nqh,2) ) then
          write(qq,'('' Range MUST be in increasing order - sorry.'')')
          stop
        endif
      else
*       range not specified, use default - total ionizing field
*     >>chng 96 dec 18, from 1.001 to 1 Ryd for H mass nuc
        range(nqh,1) = HIonPot
        range(nqh,2) = egamry
      endif
*
      end
