******************************************************************************
      subroutine RauchMod(nstar,temp,alogg,nspec,iabund)
      implicit none
*get one of the Rauch model atmospheres, coded by K. Volk
      real temp,alogg
      integer nspec,nstar
*     limit to number of cells in frequency array
*     NB is this every is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes
      include "ncell.par"
      include "limspc.par"
      include "terp.com"
      include "path.com"
      include "pthset.com"
      include "called.com"
      include "rfield.com"
      include "StarSize.com"
      include "NumUpper.com"
      include "IOqq.com"
*
*     local variables
      character chLine*80
      real flux1(ncell),flux2(ncell)
      logical lgTHit, lgAgain
      real tval(24)
      integer jval(5,24) ,ivals(ncell) , ierror
      integer nmods , j , i , j1, i1 , ierr,iabund
      real xval,fr1,fr2,fr3,fr4,gval
      real fact1,fact2
      parameter (nmods=66)
      real teff(nmods),xlogg(nmods)
      data teff/50000.,50000.,50000.,50000.,60000.,60000.,60000.,60000.,
     1          70000.,70000.,70000.,70000.,80000.,80000.,80000.,80000.,
     2          90000.,90000.,90000.,90000.,100000.,100000.,100000.,
     3          100000.,110000.,110000.,110000.,120000.,120000.,120000.,
     4          130000.,130000.,130000.,140000.,140000.,140000.,
     5          150000.,150000.,150000.,160000.,160000.,160000.,
     6          170000.,170000.,170000.,180000.,180000.,180000.,
     7          190000.,190000.,190000.,200000.,200000.,200000.,
     8          300000.,300000.,300000.,400000.,400000.,500000.,
     9          500000.,600000.,700000.,800000.,900000.,1000000./
      data xlogg/5.,6.,7.,8.,5.,6.,7.,8.,5.,6.,7.,8.,5.,6.,7.,8.,
     1           5.,6.,7.,8.,5.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,
     2           8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,
     3           6.,7.,8.,7.,8.,9.,7.,8.,9.,8.,9.,8.,9.,9.,9.,9.,
     4           9.,9./                
      data tval/50000.,60000.,70000.,80000.,90000.,100000.,
     1          110000.,120000.,130000.,140000.,150000.,
     2          160000.,170000.,180000.,190000.,200000.,
     3          300000.,400000.,500000.,600000.,700000.,
     4          800000.,900000.,1000000./
      data jval/ 2, 3, 4, 5, 5, 6, 7, 8, 9, 9,10,11,12,13,13,
     1          14,15,16,17,17,18,19,20,21,21,22,23,24,25,25,
     2          26,26,27,28,28,29,29,30,31,31,32,32,33,34,34,
     3          35,35,36,37,37,38,38,39,40,40,41,41,42,43,43,
     4          44,44,45,46,46,47,47,48,49,49,50,50,51,52,52,
     5          53,53,53,54,55,56,56,56,57,58,59,59,59,59,60,
     6          61,61,61,61,62,63,63,63,63,63,64,64,64,64,64,
     7          65,65,65,65,65,66,66,66,66,66,67,67,67,67,67/
*
      if( lgPathSet ) then
        j = 1
        lgAgain = .true.
        i = 1
*       >>chng 97 may 13, get rid of statement numbers
*       do i=1,80
        do while (lgAgain.and. i.le.80 )
          if( chPath(i:i).ne.' ') then
            chLine(j:j) = chPath(i:i)
            j = j + 1
          else
*           go to2
            lgAgain = .false.
          endif
          i = i + 1
        end do
*2      continue
*       j now points to first free character
        if (iabund.eq.0) then
            chLine(j:j+14) = 'rauch_solar.mod'
*       end string with zero character
            chLine(j+15:j+15) = char(0)
        else
            chLine(j:j+13) = 'rauch_halo.mod'
*       end string with zero character
            chLine(j+14:j+14) = char(0)
        end if
      else
        if (iabund.eq.0) then
            chLine(1:15) = 'rauch_solar.mod'
*       end string with zero character
            chLine(16:16) = CHAR(0)
        else
            chLine(1:14) = 'rauch_halo.mod'
*       end string with zero character
            chLine(15:15) = CHAR(0)
        endif
      endif
      open(unit=94,file=chLine,
     1     status='old',access='direct',
     1     form='formatted',iostat=ierr,recl=7*ncell)
*
*     something went wrong
      if( ierr.ne.0 ) then
        write(qq,'(''Error: Rauch stellar atmosphere file'',
     1  '' rauch_solar.mod or rauch_halo.mod not found.'')')
        write(qq,'('' The path I tried:'',A80)') chLine
        write(qq,'('' And here comes its octal representation:'')')
        write(qq,'(1X,A1,Z4)') (chLine(i:i),chLine(i:i),i=1,80)
*       write(qq,'(1X,A1,O4)') (chLine(i:i),chLine(i:i),i=1,80)
        stop
      endif
*
*     determine which models are to be interpolated
*
      lgTHit = .false.
      do j=1,23
        if( tval(j).le.temp.and.tval(j+1).gt.temp ) then
          j1 = j
          lgTHit = .true.
        endif
      end do
*
      if( .not.lgTHit ) then
        if( tval(24).eq.temp ) then
          j1 = 23
        else
          write(qq,'('' Requested temperature of'',1P,E10.2,
     1    '' is not within the range'',1P,2E10.2)')
     2    temp, tval(1), tval(24)
          stop
        endif
      endif
*
      read(94,'(4000i7)' ,rec=1,iostat=ierror)
     1 (ivals(j),j=1,nRauch)
*
      do j=1,nRauch
*       tnu holds the frequency arrays
        tnu(nspec,j) = 10.**(-1.*float(ivals(j))/1000000.+5.0)
      end do
*
      xval=alogg-4.0
      i1=int(xval)
*
* Interpolation is carried out first in Teff and then in log(g).
* Two Rauch models are read in for the lower log(g) value first, which
* I denote models A and B with B the higher T model [j1+1 rather than j1].
* unless alogg is 8.0 a second pair of Rauch models are read in for the
* higher log(g) value, denoted models C and D.  Then the interpolation is
*
*  RESULT = fr2*(fr3*B+fr4*A)+fr1*(fr3*D+fr4*C)
*
* when one has 4 models and
*
* RESULT = (fr3*B+fr4*A)
*
* when one has just 2 models.
      fr1 = xval-float(i1)
      fr2 = 1.-fr1
      fr3 = (temp-tval(j1))/(tval(j1+1)-tval(j1))
      fr4 = 1.-fr3
*
*     following must change if ncell changes
      read(94,'(4000i7)' ,rec=jval(i1,j1),iostat=ierror)
     1 (ivals(j),j=1,nRauch)
      if( ierror.ne.0 ) then
        ierr = 1
        return
      endif
      gval = xlogg(jval(i1,j1)-1)
*
      if(lgTalk)write(qq,'(23x,''*<<< Rauch model '',I3,'' READ'',
     1    '' IN.  T_eff = '',F10.2,'' log(g) = '',F8.5,''  >>>'',
     2    10x,''*'')')
     2  jval(i1,j1)-1,teff(jval(i1,j1)-1),gval
*
      do j=1,nRauch
        if( ivals(j).lt.9999999 ) then
          flux1(j) = (3.-1.*float(ivals(j))/100000.0)
        else
          flux1(j) = -35.
        endif
      end do
*
      read(94,'(4000i7)' ,rec=jval(i1,j1+1),iostat=ierror)
     1 (ivals(j),j=1,nRauch)
      if( ierror.ne.0 ) then
        ierr = 1
        return
      endif
      gval=xlogg(jval(i1,j1+1)-1)
      if(lgTalk)write(qq,'(23X,''*<<< Rauch model '',I3,'' READ'',
     1    '' IN.  T_eff = '',F10.2,'' log(g) = '',F8.5,''  >>>'',
     2    10x,''*'')')
     2 jval(i1,j1+1)-1,teff(jval(i1,j1+1)-1),gval
*
      do j=1,nRauch
*       flux2(j) = 10.**(-1.*float(ivals(j))/100000.)
        if( ivals(j).lt.9999999 ) then
          flux2(j) = (3.-1.*float(ivals(j))/100000.0)
        else
          flux2(j) = -35.
        endif
      end do
*
* The following is an approximate scaling to use for the range of 
* temperatures above 200000 K where the temperature steps are large 
* and thus the interpolations are over large ranges.  For the lower 
* temperatures I assume that there is no need for this since the 
* step of 10000 K is not so large.
*
* It should be remembered that this interpolation is not exact, and 
* the possible error at high temperatures might be large enough to 
* matter.
*
* At the end of the subroutine the fluxes are re-scaled to force the 
* correct total flux (sigma * T^4).
*
      if (temp.gt.200000.) then
          fact1=alog10(temp/tval(j1))*4.
          fact2=alog10(temp/tval(j1+1))*4.
      else
          fact1=0.
          fact2=0.
      end if
*
      do j=1,nRauch
        flux(j) = fr4*(flux1(j)+fact1)+fr3*(flux2(j)+fact2)
      end do
*
      if (i1.lt.5) then
*         for log(g) < 8.0 repeat the interpolation at the larger log(g) then
*         carry out the interpolation in log(g)
          read(94,'(4000i7)' ,rec=jval(i1+1,j1),iostat=ierror)
     1    (ivals(j),j=1,nRauch)
          if( ierror.ne.0 ) then
            ierr = 1
            return
          endif
          gval = xlogg(jval(i1+1,j1)-1)
          if(lgTalk)write(qq,'(23X,''*<<< Rauch model ''
     1    ,I3,'' READ''
     1    ,'' IN.  T_eff = '',F10.2,'' log(g) = '',F8.5,''  >>>'',
     2    10x,''*'')')
     2    jval(i1+1,j1)-1,teff(jval(i1+1,j1)-1),gval
*
          do j=1,nRauch
            if( ivals(j).lt.9999999 ) then
              flux1(j) = (3.-1.*float(ivals(j))/100000.0)
            else
              flux1(j) = -35.
            endif
          end do
*
          read(94,'(4000I7)' ,rec=jval(i1+1,j1+1),iostat=ierror)
     1            (ivals(j),j=1,nRauch)
          if( ierror.ne.0 ) then
            ierr = 1
            return
          endif
          gval = xlogg(jval(i1+1,j1+1)-1)
          if(lgTalk)write(qq,'(23X,''*<<< Rauch model ''
     1    ,I3,'' READ''
     1    ,'' IN.  T_eff = '',F10.2,'' log(g) = '',F8.5,''  >>>'',
     2    10x,''*'')')
     1    jval(i1+1,j1+1)-1,teff(jval(i1+1,j1+1)-1),gval
*
          do j=1,nRauch
            if( ivals(j).lt.9999999 ) then
              flux2(j) = (3.-1.*float(ivals(j))/100000.0)
            else
              flux2(j) = -35.
            endif
          end do
*
          do j=1,nRauch
            flux1(j)=(flux1(j)+fact1)*fr4+(flux2(j)+fact2)*fr3
          end do
*
          do j=1,nRauch
            flux(j) = 10.**(fr2*flux(j)+fr1*flux1(j))
          end do
      else
*     One gets here if log(g) is 8.0 and there is no higher log(g) pair of
*     models to interpolate.
*
        do j=1,nRauch
          flux(j) = 10.**flux(j)
        end do
      endif
* Note on the interpolation: 15 August 1997 (Kevin Volk)
*
* I tested the total flux from the interpolated grids.  I found that the 
* ratio of actual to expected total flux is about 1.05 for 55000 K and 
* log(g) of 7.5, between 0.99 and 1.01 for temperature values between 
* 60000 K and 200000 K, and about 1.15 for 250000 K declining to 0.95 
* for 500000 K.  So for most of the range things are O.K. but where 
* the interpolation interval is large and at the highest temperatures 
* there is a noticeable scaling.
*
* I do not know why the hottest models require a scaling factor of less than 
* 1.0.  This may mean that the extrapolation beyond 2000 Angstroms is bad 
* although one would think that at such high temperatures it would not 
* matter.
*
* Since Cloudy checks the scaling elsewhere there is no need to re-scale 
* things here, but this inaccuracy should be kept in mind.
*
      do j=1,nRauch
*       TSLOP is f_nu for each TNU point
        tslop(nspec,j) = flux(j)
      end do
      do j=nRauch+1, ncell
        tslop(nspec,j) = 0.
      end do
*
      nstar = nRauch
      close(94)
*
      ierr = 0
      end
