******************************************************************************
      real function receff( ip )
      implicit none
*generate escape probability function for continua,
      integer ip
      include "te1ryd.par"
      include "nhlvl.par"
      include "ncell.par"
      include "e2tau.com"
      include "corind.com"
      include "rfield.com"
      include "otsmin.com"
      include "tautot.com"
      include "phycon.com"
      include "touton.com"
      include "nh.com"
      include "deptau.com"
      include "dtrans.com"
      include "dRdVeff.com"
      include "opac.com"
      include "tmn.com"
      include "facexp.com"
      include "IOqq.com"
*
      real hnukt , tin , escin , escpcn, tout , escout
      real sum , denom , dEner
      integer i
*
*     escape probability functin for continua,
*     formally correct for photoelectric absorption only
      if( ip.gt.nflux ) then
        receff = 0.
        return
      endif
*
*     bug in following statement unocvered June 93 S. Schaefer
      hnukt = te1ryd * anu(ip)/te
*
*     inward optical depth and escape prob
      if( chDffTrns.EQ.'OTS' ) then
        tin = tauabs( ip , 1 )
        if( tin.lt.5. ) then
          escin = escpcn( tin , hnukt )
        else
          escin = 1e-4
        endif
*
*       outward optical depth
        tout = tauabs( ip , 2 ) - tin
*
        if( lgTauOutOn ) then
          if( tout.gt.0. ) then
            if(tout.lt.5. ) then
              escout = escpcn( tout , hnukt )
            else
              escout = 1e-4
            endif
            receff = 0.5*(escin + escout)
          else
*           this logic added april 93 to prevent big change in
*           esc prob, resulting in terminal oscillations, when optical
*           depth scale overrun
*           tau was negative, use 5% of inward optical depth
            escout = escpcn( tin*0.05 , hnukt )
            receff = 0.5*(escin + escout)
          endif
        else
          receff = escin
        endif
      else if( chDffTrns.eq.'OU1' ) then
        receff = ExpZone(ip+2)
      else if( chDffTrns.eq.'OU2' ) then
*       this is the default, set in zero
        receff = e2TauAbs(ip+2)
      else if( chDffTrns.eq.'OU3' ) then
        receff = 1.
      else if( chDffTrns.eq.'OU4' ) then
*       this cannot happen, was the former outward treat
*       optical depth for this zone
        if( ContBoltz(ip).gt.0. ) then
          i = ip
          dEner = te / te1ryd * 0.5
          sum = 0.
          denom = 0.
          do while ( ContBoltz(i).gt.0. .and.(anu(i)-anu(ip)).lt.
     1      dEner.and.i.le.nflux )
            sum = sum + ContBoltz(i) * tmn(i)
            denom = denom + ContBoltz(i)
            i = i + 1
          end do
          receff = sum / denom
        else
          receff = tmn(ip)
        endif
      else
        write(qq,'('' RECEFF does not understand the transfer method='',
     1  A3)') chDffTrns
        stop
      endif
*
      receff = max( otsmin , receff )
*     can get epsilon above unity on cray
      receff = min( 1. , receff )
*
      end
