******************************************************************************
      subroutine ScCol
      implicit none
*compute scandium cooling
      include "limelm.par"
      include "dcool.com"
      include "nta.par"
      include "TePowers.com"
      include "phycon.com"
      include "IonFracs.com"
      include "coolsc.com"
      include "TLineEXP.com"
*
*     local variables
      real a21, a31 , a32 , pop3, p3, p2 , popexc,g1,g2,g3
*
*     Sc scandium cooling
*
*     Sc II
*     these are 3 lines estimated by Jim Kingdon
*     a's are bad, collision strengths just one
      a21 = 0.004
      a31 = 6.95e-3
      a32 = 5.0e-4
      g1 = 15.
      g2 = 5.
      g3 = 21.
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( g1,g2,g3, g1 ,g2,g3, a21 ,a31,a32,
     1  3504., 3407., p2, xIonFracs(21,2),0.)
*     2.08 microns
      Sc22p08m = p3 * a31 * 9.56e-13
*     4.1 micron
      Sc24p1m = p2 * a21 * 4.85e-13
*     4.22 micron
      Sc24p2m = p3 * a32 * 4.71e-13
      call coladd( 'Sc 2' , 41 , Sc24p1m  )
      call coladd( 'Sc 2' , 42 , Sc24p2m  )
      call coladd( 'Sc 2' , 21 , Sc22p08m  )
*
*     Sc III 3933
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21
*     [Sc III] 3933, multiplet average
      g1 = 10.
      g2 = 2.
      Sc33936 = popexc(g1,g1,g2,0.03,3.66e4,xIonFracs(21,3))*
     1 5.06e-12
      call coladd( 'Sc 3' , 3933 , Sc33936  )
*
*     [Sc V] 2.31 mic
*     Y(ik) from 
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 6.00 , Sc05231 )
      call level2( Sc05231 )
*
*     Sc VI
      a21 = 4.94
      a31 = 49.24
      a32 = 4.3
      g1 = 9.
      g2 = 5.
      g3 = 1.
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( g1,g2,g3, g1 ,g2,g3, a21 ,a31,a32,
     1  28464., 40045., p2, xIonFracs(21,6),0.)
*     2100 ang - 3=>1
      Sc42100 = p3 * a31 * 9.47e-12
*     5054 - 2=>1
      Sc45058 = p2 * a21 * 3.93e-12
*     3592 3=>2
      Sc43595 = p3 * a32 * 5.53e-12
      call coladd( 'Sc 6' , 2100 , Sc42100  )
      call coladd( 'Sc 6' , 5054 , Sc45058  )
      call coladd( 'Sc 6' , 3592 , Sc43595  )
*
*     [Sc 13] 2637.97A, cs from 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.182 , Sc13264 )
      call level2( Sc13264 )
*
      end
