******************************************************************************
      subroutine SetPoint
      implicit none
*set up pointers for lines and continua
      include "ncell.par"
      include "nfill.par"
      include "nip2pht.par"
      include "pi4.par"
      include "ndfst.par"
      include "nfeii.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "ndust.par"
      include "ca2ex.com"
      include "h2ppnt.com"
      include "ipvfil.com"
      include "limelm.par"
      include "ipfe2.com"
      include "fe2pmp.com"
      include "tauend.com"
      include "xry.com"
      include "o3exc.com"
      include "pumpfe.com"
      include "pbowen.com"
      include "ip626.com"
      include "bounds.com"
      include "hehp.com"
      include "ipair.com"
      include "ircoil.com"
      include "rfield.com"
      include "anusave.com"
      include "flxsav.com"
      include "widflx.com"
      include "h.com"
      include "nh.com"
      include "iphl.com"
      include "HNIonRyd.com"
      include "He1NIonRyd.com"
      include "He2NIonRyd.com"
      include "iphe1l.com"
      include "iphe2l.com"
      include "nhe1.com"
      include "nhe2.com"
      include "he.com"
      include "ip2gam.com"
      include "i3727.com"
      include "mgexc.com"
      include "ipoi.com"
      include "fekems.com"
      include "trace.com"
      include "conbug.com"
      include "pntbug.com"
      include "called.com"
      include "iphmin.com"
      include "nxray.com"
      include "egray.com"
      include "NumUpper.com"
      include "dwork.com"
      include "idwork.com"
      include "trline.com"
      include "KshllEnr.com"
      include "fillnu.com"
      include "ipSecIon.com"
      include "LineLabl.com"
      include "HEnrRyd.com"
      include "ip2pht.com"
      include "Heavy.com"
      include "hhe2phtots.com"
      include "hetrpEXP.com"
      include "nitexc.com"
      include "nsShells.com"
      include "PredCont.com"
      include "photo.com"
      include "IOqq.com"
*
*     local variables
      integer i , j, nd , ipoint , n0,ipnt,low,n,nlap,ipConSafe,
     1 ipLinSafe
      real energy 
      logical lgOverLi , lgOverCo , lgPntEval
*
*     real hla(13)
      save lgPntEval
      data lgPntEval/.false./
*
*     free statement labels >=63
*
*     set up the current hydrogen atom for this run
      call MakeHydro
*
      if( lgPntEval ) then
        if( lgTrace )write(qq,'('' SetPoint called, not evaluating.'')')
*       now save current form of array
        do i=1,ncell
          anu(i) = AnuOrg(i)
        end do
        return
      else
        if( lgTrace ) write(qq,'('' SetPoint called first time.'')')
        lgPntEval = .true.
      endif
*
      n0 = 1
      ipnt = 0
*     fill in continuum with freq points
*     arg are range pointer, 2 energy limits, resolution
*     first argument is lower energy of the continuum range to be defined
*     second argument is upper range; both are in Rydbergs
*     third number is the relative energy resolution, dnu/nu,
*       for that range of the continuum
*     last two numbers are internal book keeping
*     N0 is number of energy cells used so far
*     IPNT is a counter for the number of fills used
*
*     if this is changed, then also change warning in GetTable about using
*     transmitted continuum - it says version number where continuum changed
*
*     call fill(  emm ,   0.001 , 0.02 , n0 , ipnt )
*     lower edge of following set by need to resolve 10 micron PAH emission
*     call fill(  emm ,   0.001 , 0.02 , n0 , ipnt )
*     call fill( 0.001,   0.061, 0.01 , n0 , ipnt )
*     call fill( 0.061,   0.064, 0.003, n0 , ipnt )
*     call fill( 0.064,   0.109, 0.01 , n0 , ipnt )
*
      call fill(  emm ,   0.001, 0.02 , n0 , ipnt )
      call fill( 0.001,   0.109, 0.003, n0 , ipnt )
      call fill( 0.109,   0.26 , 0.001, n0 , ipnt )
*     call fill( 0.109,   0.115, 0.001, n0 , ipnt )
*     call fill( 0.115,   0.22 , 0.009, n0 , ipnt )
*     call fill( 0.22,    0.26 , 0.001, n0 , ipnt )
      call fill( 0.26,    0.90 , 0.009, n0 , ipnt )
      call fill( 0.90 ,   0.985, 0.001, n0 , ipnt )
*     all the lyman lines merge here
      call fill( 0.985,   1.01 , 0.0003,n0 , ipnt )
      call fill( 1.01 ,   1.78 , 0.008, n0 , ipnt )
      call fill( 1.78 ,   1.82 , 0.002, n0 , ipnt )
      call fill( 1.82 ,   3.97 , 0.008, n0 , ipnt )
*     >>chng 97 jan 27, increase resolution between 4 and 4.05 ryd
      call fill( 3.97 ,   4.05 , 0.002, n0 , ipnt )
      call fill( 4.05 ,   50.0 , 0.008, n0 , ipnt )
      call fill( 50.  ,  600.0 , 0.01 , n0 , ipnt )
      call fill( 600. ,    7e4 , 0.05 , n0 , ipnt )
      call fill(  7e4 , egamry , 0.10 , n0 , ipnt )
      nupper = n0 - 1
*     NUPPER is number of NCELL cells actually used for freq mesh
*     finish off rest of array, even if not used, N0 is next element to fill
      if( n0.le.ncell ) then
        do i=n0,ncell
          widflx(i) = widflx(i-1)
          anu(i) = anu(i-1) + widflx(i)
        end do
      endif
*     this is a sanity check for fill
      call ChckFill
*
*     following is to check that no OTS pointers overlap
      do i=1,ncell
*       flux stores line pointers
*       NB!! ipLinSafe needs for this to have happened!
*       it checks the flux array for preexisting hits
        flux(i) = 0.
*       FluxSave stores continuum pointers
        FluxSave(i) = 0.
      end do
*
*     array of either 1 or 0 for energy of elec to be counted
*     as able to produce secondary ionizaitons
*     below 100eV no secondary ionization
      ipSecIon = ipoint( 7.353 )
*
*     this is highest energy where k-shell opacities are counted
*     can be adjusted with "set kshell" command
      KshellLimit = ipoint( EnergyKshell )
*
*     pointer to 8 ev, photoionization thresh for dust
      low = 10000
      do nd=1,ndust
*       grain treatment requries that we have good points to
*       threshold when grain charges up - cannot up an ipsafe
*       routine here since can't there either - would end up
*       with mismatched pointers
*begin sanity check
        if( DustWorkFcn(nd).le.0. ) then
          write(qq,'('' Grain work function for species'',i3,
     1    '' is not positive.  This is impossible.  Was block data'',
     1    '' martin linked in?'')') nd
          stop
        endif
*end sanity check
        idwork(nd) = ipoint( DustWorkFcn(nd) )
        low = min( low , idwork(nd) )
      end do
*
*     pointers for molecules
*     H2+ dissociation energy 2.647 eV but cs small below 0.638 Ryd
      ih2pnt(1) = ipConSafe( 0.502 , 'H2+ ' )
      ih2pnt(2) = ipoint( 1.03 )
*
*     pointers for most prominent PAH features
*     energies used in ipoint are actually from opacity punch file
*     wavelenghts are rough observed values of blends
*     7.6 microns
      i = ipoint( 0.0117 )
      chContLabel(i) = 'PAH '
*     feature near 6.2 microns
      i = ipoint( 0.0147 )
      chContLabel(i) = 'PAH '
*     3.3 microns
      i = ipoint( 0.028 )
      chContLabel(i) = 'PAH '
*     11.2 microns
      i = ipoint( 0.0080 )
      chContLabel(i) = 'PAH '
*     12.3 microns
      i = ipoint( 0.0077 )
      chContLabel(i) = 'PAH '
*     13.5 microns
      i = ipoint( 0.0069 )
      chContLabel(i) = 'PAH '
*
*     fix pointers for hydrogen and helium
*
*     following are pointers to places to save locally destroyed
*     two photon continua
      ipH12pht = ipConSafe( 0.6 , 'H1p2' )
      ipHe12pht = ipConSafe( 1.2 , 'He12' )
      ipHe22pht = ipConSafe( 1.5 , 'He22' )
*
*     pointers to He I triplet lines
      ipHe3l(1) = ipLinSafe( 0.08416 , 'HeI3')
      ipHe3l(2) = ipLinSafe( 911.6/5876. , 'HeI3')
      ipHe3l(3) = ipLinSafe( 911.6/7065. , 'HeI3')
      ipHe3l(4) = ipLinSafe( 911.6/3889. , 'HeI3')
*
*     pointer to Bowen 374A resonance line
      ip374 = ipLinSafe( 1.92 , 'He 2')
      ip660 = ipLinSafe( 1.38 , 'He 2')
*
*     pointers to i => i-1 lines
      do i=1,nhlvl-1
*       HLevNIonRyd is level energy ryd
        ipHn(i) = ipConSafe( HLevNIonRyd(i) ,'H  1' )
        do j=i+1,min(25,nhlvl)
*         this was set in zero
          iphl(j,i) = ipLinSafe( HEnerRyd(j,i) , 'H  1')
*         make sure pointer not in next higher continuum
          if( iphl(j,i).ge.ipHn(i) ) then
            write(qq,'('' H line'',2i3,'' spills over into'',i3,
     1      '' continuum, energy='',1p,e11.3)') j,i,i,anu(iphl(j,i))
          endif
        end do
        do j=max(i+1,26),nhlvl
*         this was set in zero, these will not be used for ots
          iphl(j,i) = ipoint( HEnerRyd(j,i)  )
          if( iphl(j,i).ge.ipHn(i) ) then
            write(qq,'('' H line'',2i3,'' spills over into'',i3,
     1      '' continuum, energy='',1p,e11.3)') j,i,i,anu(iphl(j,i))
          endif
        end do
      end do
      ipHn(nhlvl+1) = ipHn(2)
*     photoioinization of highest level
*     this is a continuum pointer
      ipHn(nhlvl) = ipConSafe( HLevNIonRyd(nhlvl) , 'H  1' )
*
*     set up series of continuum pointers to be used in routine lines to
*     enter continnum points into line array
      do i=1,nPredCont
*       EnrPredCont contains array of energy points, from block data scalar
        ipPredCont(i) = ipoint( EnrPredCont(i) )
      end do
*
*     for induced two photon emission we need mirror image set
*     of pointers for continuum between Lya and helf Lya
      ipHalfLya = ipoint( 0.375 )
      if( ipHalfLya.gt.nip2pht ) then
        write(qq,'('' SetPoint: too many continuum points needed'',
     1  '' to fill ip2pht array - increase nip2pht to at least'',
     2  i7)') ipHalfLya
        stop
      endif
      do i=1,ipHalfLya
*       energy is symmetric energy, the other side of half lya
        energy = 0.75 - anu(i)
        ip2pht(i) = ipoint(energy)
      end do
*
*     do HeI
      do i=1,nhe1lvl-1
        nhe1(i) = ipConSafe( He1IonRyd(i) , 'He 1' )
        do j=i+1,nhe1lvl
*         get energies from table, in zero
          iphe1l(j,i) = ipLinSafe( He1IonRyd(i) - He1IonRyd(j),'He 1')
*         make sure pointer not in next higher continuum
          if( iphe1l(j,i).ge.nhe1(i) ) then
            write(qq,'('' He1 line'',2i3,'' spills over into'',i3,
     1      '' continuum, energy='',1p,e11.3)') j,i,i,anu(iphe1l(j,i))
          endif
        end do
      end do
      nhe1(nhe1lvl) = ipConSafe( He1IonRyd(nhe1lvl) , 'He 1' )
      nhe1(nhe1lvl+1) = nhe1(2)
*
*     now do HeII
      do i=1,nhe2lvl-1
*       want heii to be just blueward of hydrogne
        nhe2(i) = ipConSafe( He2IonRyd(i) , 'He 2' )
        do j=i+1,nhe2lvl
          iphe2l(j,i) = ipLinSafe( He2IonRyd(i) - He2IonRyd(j),'He 2')
          if( iphe2l(j,i).ge.nhe2(i) ) then
            write(qq,'('' He2 line'',2i3,'' spills over into'',i3,
     1      '' continuum, energy='',1p,e11.3)') j,i,i,anu(iphe2l(j,i))
          endif
        end do
      end do
      nhe2(nhe2lvl) = ipConSafe( He2IonRyd(nhe2lvl) , 'He 2')
      nhe2(nhe2lvl+1) = nhe2(2)
*
*     pointer to helium 2 trip s to ground decay
      ipHe23sGrnd = ipLinSafe( 1.457 , 'HeI3')
*
*     photoionization for HeI triplet 23s
      nhei3 = ipConSafe( 0.3506 ,'HeI3' )
* 666 error! remove following two, replace with above
      nhei1 = nhe1(1)
      nheii = nhe2(1)
*
*     pointer to energy defining effect x-ray column
      ipxry = ipoint( 73.5 )
*     double photoionization
* 666 error! most of these have been removed
      ip2gam = ipoint( 7.3 )
*     pointer to Hminus edge at 0.754eV
      iphmin = ipConSafe(0.05544 , 'H-  ' )
*     pointer to CaII XYZ at 8700A
*     ipxyz = ipoint(0.1)
*
      iheh1 = ipoint(1.6)
      iheh2 = ipoint(2.3)
*     pointer to carbon k-shell ionization
      nxray = ipoint(20.6)
*     pointer to threshold for pair production
      ippr = ipoint( 7.51155e4 ) + 1
*     pointer to x-ray - gamma ray bound; 100 kev
      ipEnerGammaRay = ipoint( EnerGammaRay )
*     pointers to bound compton electron scattering of H, He
      ircoil = ipoint(194.)
      irche = ipoint(260.)
*
      do i=1,nfeii
        ipfe2(i) = ipoint( fe2enr(i) )
      end do
*     pointers to hot and cold iron
      ipkcld = ipLinSafe( 6400./13.54 , 'Fekc' )
      ipkhot = ipLinSafe( 6600./13.54 , 'Fekh' )
      ipHe3l(1) = ipLinSafe( 0.08416 , 'HeI3')
*
*     make low energy edges of some cells exact
      call fiddle( ipHn(1) , 0.99946 )
      call fiddle( ipHn(2) , 0.24986 )
      call fiddle( nhe1(1) , 1.8072 )
      call fiddle( nhe2(1) , 4.00000 )
*     pointer to excited state of O+2
      ipo3exc(1) = ipConSafe(3.855 ,'O3ex' )
      call fiddle(   ipo3exc(1) , 3.855   )
*
*     now save current form of array
      do i=1,ncell
        AnuOrg(i) = anu(i)
        anusqr(i) = sqrt( AnuOrg(i) )
      end do
*
*     following order of elements is in roughly decreasing abundance
*     when ipShells gets a cell for the valence IP it does so through
*     ipConSafe, which makes sure that no two ions get the same cell
*     earliest elements have most precise ip mapping
*
*     set up shell pointers for hydrogen and helium
      nsShells(1,1) = 1
      ipHeavy(1,1) = ipHn(1)
      nsShells(2,1) = 1
      nsShells(2,2) = 1
      ipHeavy(2,1) = nhe1(1)
      ipHeavy(2,2) = nhe2(1)
*
*begin sanity check
*     check that ionization potential of neutral carbon valence shell is
*     positive - check that block data has been linked in
      if( PH1(1,6,6,3).le.0. ) then
        write(qq,'('' PH1 returned non-positive threshold for Co.'')')
        write(qq,'('' Was the photo common block linked in?'')')
        stop
      endif
*end sanity check
*
*     Carbon
      call ipShells( 6 )
*
*     oxygen
*     pointers for excited states
*     IO3 is pointer to O++ exc state, is set above
      i2d = ipoint( 1.242 )
      i2p = ipoint( 1.367 )
      ipo1exc(1) = ipConSafe(0.856 ,'O1ex' )
      ipo1exc(2) = ipoint(2.0 )
*     finish off excited state photoionization
*     do not use ipConSafe since only upper limit
      ipo3exc(2) = ipoint(5.0 )
*     upper level of 4363
      ipo3exc3(1) = ipConSafe(3.646 ,'O3ex' )
      ipo3exc3(2) = ipoint(5.0 )
*
*     following are various pointers for OI - Lybeta pump problem
*     these are delta energies for boltzmann factors
* 666 error! this is redundant with contents of oxygen line arrays
*     use them instead
*     when removing this, make sure all line intensity predictions
*     also go into oi line arrays
      ipoiex(1) = ipoint( 0.7005 )
      ipoiex(2) = ipoint( 0.10791)
      ipoiex(3) = ipoint( 0.06925)
      ipoiex(4) = ipoint( 0.01151)
      ipoiex(5) = ipoint( 0.01999)
      call ipShells( 8 )
      if( ipHeavy(8,1).eq.ipHn(1) ) then
*       ipShells uses ipConSave and this cannot happen
        write(qq,'('' SetPoint insanity in ipShells for O'')')
        call ShowMe
        stop
      endif
*     probable pointer overlap here; cells very narrow, no problem
      if( nhe2(2).eq.ipHeavy(8,1)) then
*       ipShells uses ipConSave and this cannot happen
        write(qq,'('' SetPoint insanity in ipShells for O-He+'')')
        call ShowMe
        stop
      endif
*
*     >>chng 97 jan 27, move nitrogen after oxygen so that O gets the
*     most accurate pointers
*     Nitrogen
*     in1(1) is thresh for photo from excited state
      in1(1) = ipConSafe(0.893 ,'N1ex' )
*     upper limit
      in1(2) = ipoint( 2. )
      call ipShells( 7 )
*
      if( (lgTrace.and.lgConBug).or.(lgTrace.and.lgPointBug) ) then
        write(qq,'(''   SetPoint:'',I5,''cells possible,'',I5,
     1  '' used. N(1R):'',I4,'' N(1.8):'',
     1  I4,''  N(4Ryd):'',I4,'' N(O3)'',I4,''  N(x-ray):'',
     2  I5,'' N(rcoil)'',I5)') ncell , nupper, ipHn(1) , nhe1(1) ,
     3  nhe2(1) , ipo3exc(1) , nxray , ircoil
        write(qq,'(''   SetPoint: HeI trip: '',I5)') nhei3
        write(qq,'(''   SetPoint: ipEnerGammaRay: '',I5,
     1  '' IPPRpari produc'',I5)') ipEnerGammaRay, ippr
        write(qq,'(''   SetPoint: H pointers;'',12I4)')(i,ipHn(i),i=1,6)
        write(qq,'(''   SetPoint: HeI pnters;'',12I4)')(i,nhe1(i),i=1,6)
        write(qq,'(''   SetPoint: Oxy pnters;'',16I4)')(i,
     1  ipHeavy(8,i),i=1,8)
      endif
*
*     Neon
      call ipShells( 10 )
*
*     Sodium
      call ipShells( 11 )
*
*     Magnesium
*     following is energy for phot of MG+ from exc state producing 2798
      ipmgex = ipoint( 0.779 )
      call ipShells( 12 )
*     ipmgla(12) = ipoint( hla(5) )
*
*     Aluminium
      call ipShells( 13 )
*     ipalla(13) = ipoint( hla(6) )
*
*     Silicon
      call ipShells( 14 )
*     ipsila(14) = ipoint( hla(7) )
*
*     phosphorus
      call ipShells( 15 )
*
*     Sulphur
      call ipShells( 16 )
*     ipsla(16) = ipoint( hla(8) )
*
*     chlorine
      call ipShells( 17 )
*     ipclla(17) = ipoint( hla(9) )
*
*     Iron
      call ipShells( 26 )
*     ipfela(26) = ipoint( hla(12) )
*
*     Argon
      call ipShells( 18 )
*     iparla(18) = ipoint( hla(10) )
*
*     Potassium
      call ipShells( 19 )
*
*     Calcium
      call ipShells( 20 )
*     ipcala(20) = ipoint( hla(11) )
*
*     pointers to ir triplet, kh
*     icaxyz = ipoint( 0.11 )
*     icakh = ipoint( 0.235 )
*     lower, upper edges of Ca+ excited term photoionizaiton
*     ica2ex(1) = ipoint(0.72)
      ica2ex(1) = ipConSafe(0.72 ,'Ca2x' )
      ica2ex(2) = ipoint(1.)
*
*     scandium
      call ipShells( 21 )
*
*     titanium
      call ipShells( 22 )
*
*     vanadium
      call ipShells( 23)
*
*     chromium
      call ipShells( 24 )
*
*     manganese
      call ipShells( 25 )
*
*     fluorine
      call ipShells( 9 )
*
*     Lithium
      call ipShells( 3 )
*
*     Beryllium
      call ipShells( 4 )
*
*     Boron
      call ipShells( 5 )
*
*     Cobalt
      call ipShells( 27 )
*
*     Nickel
      call ipShells( 28 )
*
*     copper
      call ipShells( 29 )
*
*     zinc
      call ipShells( 30 )
*
*     set all pointers to ionizaiton edges with labels
*
*     set up factors and pointers for Fe continuum fluorescence
      ipfe10 = ipoint( 2.605 )
*
*     center of V filter
      ipVFilter = ipoint( 0.164 )
*
*     following is WL(CM)**2/(8PI) * conv fac for RYD to NU *A21
      pfe10 = 2.00e-18 / widflx(ipfe10)
*     this is 353 pump, f=0.032
      pfe11a = 4.54e-19 / widflx(ipfe10)
*     this is 341.1 f=0.012
      pfe11b = 2.75e-19 / widflx(ipfe10)
      pfe14 = 1.15e-18 / widflx(ipfe10)
*
*     option to print out line pointers
      if(lgTrLine ) then
        do i=1,nhlvl
          write(qq,'('' H  '',I2,10I4)')i,(iphl(n,i),n=i+1,nhlvl)
        end do
        do i=1,nhe1lvl
          write(qq,'('' He1'',I2,10I4)')i,(iphe1l(n,i),n=i+1,nhe2lvl)
        end do
        do i=1,nhe2lvl
          write(qq,'('' He2'',I2,10I4)')i,(iphe2l(n,i),n=i+1,nhe2lvl)
        end do
      endif
*
*     set up energy pointers for line optical depth arrays
*     this also increments flux, sets other parameters for lines
      call SetLine
*
*begin sanity check
      lgOverCo = .false.
      nlap = 0
      do i=1,ncell
        if( FluxSave(i).gt.1. ) then
          write(qq,'('' Cont pointers overlap'',I3,'' times at '',
     1    ''frequency'',1P,E10.3,'' I='',I4)') int(FluxSave(i)),anu(i),i
          lgOverCo = .true.
          nlap = nlap + 1
        endif
      end do
      if( lgOverCo ) then
        write(qq,'('' OTS continuum pointer overlap occurs'',I4,
     1  '' times.  STOP.'')') nlap
      endif
*
*     if ipLinSafe worked then this check is totally redundant
      lgOverLi = .false.
      nlap = 0
      do i=1,ncell
        if( flux(i).gt.1. ) then
          write(qq,'('' Line pointers overlap'',I3,'' times at '',
     1    ''frequency'',1P,E10.3,'' I='',I4,'' wl='',E10.3,''A'')')
     2    int(flux(i)) , anu(i),i,911.6/anu(i)
          lgOverLi = .true.
          nlap = nlap + 1
        endif
      end do
      if( lgOverLi ) then
        write(qq,'('' OTS line pointer overlap occurs'',I4,
     1  '' times.  STOP.'')') nlap
      endif
*
      if( lgOverLi .or. lgOverCo ) stop
*
*end sanity check
*
      end
