**************************************************************
      subroutine setqhe(chCard,lgQHeat,iopt)
      implicit none
*parse qheat command line to set grains quantum heating, by K Volk
      character*80 chCard
      integer iopt
      include "nqgrid.par"
      include "ncell.par"
      include "ndust.par"
      logical lgQHeat(ndust)
      include "nphotl.com"
      include "qheat2.com"
*
*     local variables
      logical lgEOL
      integer nvals , i , j
      parameter (nvals=500)
      real fread,qtmax1,xqhg1
*     real frad(nvals),fhden(nvals)
*     save frad,fhden
*
* initialize the values to defaults
      iflnph =1
      nqhg1 =50
      qtmax =3000.0
      qtmin =0.0
      qwavec =0.00911267/30.0
*     30 microns converted into rydberg units
      qdudt0 =0.
      qtcol =0.
*
      do i=1,nqgrid
        do j=1,2
          qhprob(j,i)=0.
          qtemp(j,i)=0.
        end do
      end do
*
* read an optional second value on the command line, which is the number
* of values in the enthalpy array, and third value which is the maximum
* temperature for the calculation (which must be less than 5000 k, and
* greater than 50 k).  note that qtmax will be set higher if the
* calculated equilibrium temperature is larger than 0.2 times qtmax.
      i = index(chCard,' ')
      lgEOL = .true.
*     first number is number of bins in the temperature array
      xqhg1 = fread(chCard, i, 76, lgEOL)
      if(lgEOL) then
        nqhg1 = 50
      else
        nqhg1 = int(xqhg1)
        if (nqhg1.lt.10.or.nqhg1.gt.nqgrid) nqhg1=50
      end if
*
      qtmax1 = fread(chCard, i, 76, lgEOL)
      if(lgEOL) qtmax1 = 3000.
*     insure that qtmax is between 50 and 5000
      qtmax1 = min( 5000. , qtmax1 )
      qtmax1 = max( 50. , qtmax1 )
*     this is the default value for qtmax, probably safe under normal
*     nebular conditions
      if(lgEOL) then
        qtmax = 3000.
      else
        qtmax = qtmax1
      endif
*
      if (index(chCard,'ALL').gt.0) then
*     key option all sets quantum heating for all grains
        do j=1,ndust
          lgQHeat(j)=.true.
        end do
      else
        if (iopt.eq.0) then
           lgQHeat(9)=.true.
           lgQHeat(10)=.true.
        end if
      end if
*     default: set quantum heating for only the pah grains
      if (index(chCard,'PRINT').gt.0) then
        iqp = 90
        open(unit=iqp,file='qheat.out',status='unknown')
      end if
*
*     flag for printing the temperature arrays for any layer that is
*     included in the print-out
      end
