******************************************************************************
      subroutine sodium
      implicit none
*ionization balance for sodium
      include "limelm.par"
      include "trace.com"
      include "elmton.com"
      include "h.com"
      include "timed.com"
      include "TePowers.com"
      include "IonFracs.com"
      include "phycon.com"
      include "TrHeav.com"
      include "IOqq.com"
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=12)
      parameter (nelem=11)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real grdeff(11)  , Yyield(9) , Yyieldl(1)
*     real CollidRate(nelem,2)
*     data grdeff/11*0.2/ , Yyield/9*0./ , Yyieldl/1*1./
*
*     sodium nelem=11
*
*
*     rates taken from Mg Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /8.90E-11,5.90E-11,1.10E-11,9.14E-12,5.02E-12,2.73E-12,
     1 1.47E-12,7.35E-13,4.11E-13,1.64E-13,1.42E-14/
      data (cion(i,2),i=1,ndim-1)
     1 /8.87E4,1.74E5,9.30E5,1.26E6,1.64E6,2.17E6,2.61E6,
     2 3.09E6, 3.81E6,4.25E6,2.04E7/
*
*     from Aldrovandi and Pequignot Revista Brasileira de Fisica, 4, 491,
      data rec , pl
     1/ 3.42E-10, 1.17E-9, 2.60E-9, 4.56E-9, 6.81E-9, 1.07E-8, 1.32E-8,
     2  1.92E-8 , 2.24E-8, 2.54E-8,
     2  -0.85  , -0.73 , -0.70 , -0.68 , -0.66 , -0.66 , -0.65 ,
     3  -0.68  , -0.67 , -0.63  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.35e-10 , -0.682/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.0E-3 , 2.6E-3 , 6.0E-3 , 1.1E-2 , 8.0E-3 , 1.0E-2 ,
     2 3.2E-2 , 1.2E-2 , 2.2E-1 , 1.8E-1 , 0./
      data (dite(i,1),i=1,ndim-1)
     3/3.6E5  , 3.8E5  , 3.4E5  , 3.0E5  , 2.7E5  , 2.8E5  ,
     4 3.2E5  , 1.9E5  , 1.2E7  , 1.3E7  , 0./
      data ditcrt
     5/0.,      1.3E5  , 4.4E5  , 7.2E4  , 2.8E5  , 4.0E5  ,
     6 1.3E6  , 1.6E6  , 1.9E6  , 3.4E4  , 0./
      data (dicoef(i,2),i=1,ndim-1)/nelem*0./
      data (dite(i,2),i=1,ndim-1)/nelem*0./
*
      data aa/11*0./, bb/11*0./, cc/11*0./, dd/11*0./, ff/0.1,10*0./
*
*     sodium, atomic number 11
      if( .not.lgElmtOn(11) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if(lgTrace.and.lgHeavyBug) then
        write(qq,'(5X,''SODIUM returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
