******************************************************************************
      subroutine sulcol
      implicit none
*compute sulphur cooling
      include "ndfst.par"
      include "limLevelN.par"
      include "ipLnArry.par"
      include "nta.par"
      include "limelm.par"
      include "dcool.com"
      include "cools.com"
      include "sii.com"
      include "TLineEXP.com"
      include "TePowers.com"
      include "p2ovp1.com"
      include "phycon.com"
      include "embesq.com"
      include "PopLevls.com"
      include "TauDmmy.com"
      include "logte.com"
      include "IonFracs.com"
      include "IOqq.com"
*
*     local variables
      real gS2(5) , p(5) , exS2(4)
      real popexc,expion,cs2s2p,cs2s3p,pop2,pop3, cs02 , cs01,
     1 cs , cs12 , cs13, cs15,cs14,cs23,cs24,cs25,
     2 cs34,cs35,cs45
      data gS2/4.,4.,6.,2.,4./ , exS2/14851.9,31.5,9640.8,48.6/
*
*     Sulphur II [S II] 6731 + 6716, A 
*     >>refer Mendoza, C., & Zeippen, C.J., 1982, MNRAS, 198, 127
*     collision strength from 
*     >>refer Ramsbottom, C.A., Bell, K.L., Stafford, R.P. 1996, ADNDT, 63, 57
      call S2cs(alogte,cs12,cs13,cs14,cs15,cs23,cs24,cs25,
     1                 cs34,cs35,cs45)
*     cs13 = min(4.95 , 3.2640828 + 1.9369099*sexp(te/30337.498) )
*     cs12 = cs13 / 1.5
*     cs15 = min( 1.59 , 0.10*te10*te10*te10/te01/te003/te001/te001)
*     cs14 = cs15 * 0.5
*     FIVEL( G(1-5) , ex(wn,1-5), cs12,cs13,14,15,23,24,25,34,35,45,
*            A21,31,41,51,32,42,52,43,53,54, pop(1-5), abund)
      call fivel(gS2, exS2 ,
     1 cs12 , cs13 , cs14 , cs15 , cs23 , cs24 , cs25 ,
     2 cs34 ,cs35 ,cs45 ,
     2 8.82e-4,2.60e-4,9.06e-2,0.225,3.35e-7,0.163,0.133,0.078,0.179,
     3 1.03e-6, p , xIonFracs(16,2) )
      S6733 = p(2)*8.82e-4*2.96e-12
      S6718 = p(3)*2.60e-4*2.962e-12
      S4070 = p(5)*0.225*4.89e-12
      S4078 = p(4)*0.0906*4.88e-12
      S10323 = p(5)*0.179*1.93e-12
      S10289 = p(5)*0.133*1.93e-12
      S10373 = p(4)*0.078*1.92e-12
      S10339 = p(4)*0.163*1.92e-12
      c6731 = S6733 + S6718
      c10330 = S10323+S10289+S10373+S10339
      dCooldT = dCooldT + c6731 * (2.14e4*tsq1 - halfte)
      dCooldT = dCooldT + c10330*2.58*(3.53e4*tsq1 - halfte)
      call coladd( 'S  2' , 6731 , c6731  )
      call coladd( 'S  2' , 10330 , c10330  )
      call coladd( 'S  2' , 4070 , c10330*1.58  )
*
*     SII 1256
*     
      cs = max(4.466, min(8.46, -4.9416304 + 47.01064/alogte ))
      call PutCS( cs , t1256 )
      call level2( t1256 )
*
*     S III 18.7M, 33.6M, A 
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      cs = min(2.331, 7.935 * te/(te10*te03*te003))
      call PutCS( cs , tS34 )
      if(te.le. 39811. ) then
        cs = min( 5.78 , 3.114*te03*te03 )
      else
        cs = 24.93/(te10*te03*te01/te001/te001)
      endif
      call PutCS( cs , tS19 )
      cs = min(1.413, 0.221 * te*te20/te03*te005 )
      call PutCS( cs , TauDummy )
      call level3(tS34,tS19,TauDummy)
*
*     S III O III-like lines, A from 
*     >>refer Mendoza, C., & Zeippen, C.J. 1982, MNRAS, 199, 1025
*     CS from 
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      cs = min( 2.05 , 0.0821*te30)
      c6312 = pop3( 9.,5.,1.,  7.98,1.14,cs , 7.97E-2,0.807,2.22,
     1 1.55e4,2.28e4 ,pop2,xIonFracs(16,3),0.) * 2.22 * 3.15e-12
*     folowing is 9532 + 9069 together (OIII-like)
      c9532 = pop2 * 7.93e-2 * 2.11e-12
      call coladd( 'S  3' , 6312 , c6312  )
      call coladd( 'S  3' , 9532 , c9532  )
      call coladd( 'S  3' , 3722 , c6312*0.59  )
*
*     S III 1194, data from 
*     >>refer Ho, Y.K., & Henry,R.J.W. 1984, ApJ, 282, 816
*     >>chng 97 may 17, to, about 2x larger than above
*     >>refer Tayal, S.S. 1997, ApJ 481, 550
      if( te.le.3e4) then
        cs = 12.04/(te02*te02)
      else if( te.gt.3e4 .and.te.le.4e4 ) then
        cs = 7.97
      else
        cs = 55.42 / (te20/te02*te003)
      endif
      call PutCS( cs , t1194 )
      call level2( t1194 )
*
*     S III] 1713.12, 1728.94, cs from 
*     >>refer Hayes, M.A., 1986, J Phys B 19, 1853.
*     cs = min( 4.0 , 7.794 / (te10/te02/te001/te001)  )
*     >>chng 97 may 17, about 20% smaller than before
*     >>refer Tayal, S.S. 1997, ApJ 481, 550
      if( te.le.3e4 ) then
        cs = 1.786 * te05*te01*te001
      else
        cs = 9.392 / te10
      endif
      call PutCS( cs , tS1720 )
      call level2( tS1720 )
*
*     S IV 10.5MI, CS and A FROM 
*     >>refer Johnson, C.T., Kingston, A.E., Dufton, P.L. 1986, MNRAS, 220, 155
*     >>chng 97 feb 14, error in cs below t = 10,000K
*     >>chng 96 dec 19, to CS from 
*     >>refer Saraph, H.E., Storey, P.J., & Tully, J.A. 1995, 5th International
*     >>refer Colloquium on Atomic Spectra and Oscillator Strengths, ed. by
*     >>refer W.-U L.  Tchang-Brillet, J.-F. Wyart, C.J. Zeippen,
*     >>refer (Meudon: Publications de l'Observaroire de Paris), p.110
*     above said to be A&A in press
      if( te.lt.1e4 ) then
        cs = 3.71*te10/te01
      else
        cs = min( 8.5 , 19.472/(te10/te01) )
      endif
      call PutCS( cs , tS11 )
      call level2( tS11 )
*
*     S IV 1406, cs from 
*     >>refer Dufton, P.L., Hibbert, A., Kingston, A.E., & Doschek, G.A. 1982,
*     >>refer ApJ, 257, 338
      cs = 16.67 / (te10*te02)
      call PutCS( cs , t1406 )
      call level2( t1406 )
*
*     S V Be-seq line, A=
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     all cs 
*     >>refer Dufton, P.L., Hibbert, A., Keenan, F.P, Kingston, A.E., &
*     >>refer Doschek, G.A. 1986, ApJ, 300, 448
*     and 
*     >>refer Dufton, P.L., & Kingston, A.E. 1984, JPhB, 17, 3321
      cs = min(1.58 , 35.372/(te10*te10*te10) )
      call PutCS( cs , t1198 )
*     cs01 = min(1.98, 29.625/(T**0.25))
      cs01 = min(1.98, 29.625/(te20*te05 ) )
*     cs02 = min(2.26, 13.477/(T**0.165))
      cs02 = min(2.26, 13.477/(te10*te03*te03*te005) )
*     cs12 = min(7.59, 63.994/(T**0.197))
      cs12 = min(7.59, 63.994/(te20/te003) )
*     beseq(cs23,cs24,cs34,tarray,a41)
*     call beseq( 1.98 , 2.26 , 7.59, t1198 ,.066)
      call beseq( cs01 , cs02 , cs12 , t1198 ,.066)
      em1198 = PopLevels(3) * 0.066 * 1.66e-11
*
*     S V 786
*     cs from 
*     >>refer Dufton, P.L., & Kingston, A.E. 1984, JPhB, 17, 3321
      call PutCS( 8.3 , t786 )
      call level2( t786 )
*
*     S VI, Li sequence, A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     CS from 
*     >>refer Dufton, P.L., & Kingston, A.E. 1987, JPhB, 20, 3899
      cs = 11.9
      call PutCS( cs*0.667, t933 )
      call PutCS( cs*0.333, t944 )
      call PutCS(  1.0 , TauDummy )
      call level3( t944,TauDummy, t933)
*
*     S VIII 9913
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.192 , min( 0.291, 0.0289*te20/te01*te001 ) )
      call PutCS( cs , fsS810 )
      call level2( fsS810 )
*
*     S IX 1715, 1987, 
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1715 = popexc(0.4,9.,5.,80.,8.39e4,xIonFracs(16,9))*1.16E-11
      call coladd( 'S  9' , 1715 , c1715  )
*
*     S IX 1.25, 3.78 microns
*     cs 
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      cs = min( 3.10 , 277.2/(sqrte/te003) )
      call PutCS( cs , fsS912 )
      cs = min( .50 , 7.940/(te10*te10*te10) )
      call PutCS( cs , fsS938 )
      cs = min( 1.1, 195.72/(sqrte*te03*te03*te01*te003*te001) )
      call PutCS(cs  , TauDummy )
      call level3( fsS912 , fsS938 ,TauDummy )
*
*     S X 1213, 1197, 
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1213 = popexc(0.28,4.,6.,6.,1.19e5,xIonFracs(16,10))*1.64E-11
      call coladd( 'S 10' , 1213 , c1213  )
*
*     S XI 1.91, 1.40 microns, cs 
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      cs = min( 0.22 , 0.0151*te20*te03*te001*te001 )
      call PutCS( cs , fsS1119 )
      cs = min( 0.6 , 0.0168*te10*te10*te10*te01 )
      call PutCS( cs , fsS1114 )
      cs = min( 0.15 , 1.5e-3*te30*te10*te005 )
      call PutCS( cs , TauDummy )
      call level3( fsS1119 , fsS1114 ,TauDummy )
*
*     S XI 1615, 1826, 
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1826 = popexc(0.3,9.,5.,100.,8.92e4,xIonFracs(16,11))*1.23e-11
      call coladd( 'S 11' , 1615 , c1826  )
*
*     S XII 7611.2, cs from 
*     >>refer Oliva, E., Pasquali, A., & Reconditi, M. 1996, A&A, 305, 210
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     >>refer Saha, H.P., & Trefftz, E. 1983, SoPh, 87, 233
      call PutCS( 0.135 , fsS1207 )
      call level2( fsS1207 )
*
*     S XII 520, actually group of four intercombination lines
*     all atomic data from 
*     >>refer Saha, H.P., & Trefftz, E. 1983, SoPh, 87, 233
      c520 = 0.03 * 1.65e-16 * expion( 2.8e5 , xIonFracs(16,12) )
      call coladd( 'S 12' , 520 , c520  )
*
*     S XIII 488.4, 1909-like
      c488 = popexc(0.11,1.,9.,3.3e5,2.948e5,xIonFracs(16,13))*4.07E-11
      call coladd( 'S 13' , 488 , c488  )
*
*     li seq 2s2p and 2s3p, S XIV 418, 446
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 16 , tSu418, tSu30, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , tSu418 )
      call PutCS( cs2s2p*0.5 , tSu446 )
      call PutCS(  1.0 , TauDummy )
      call level3( tSu446,TauDummy, tSu418)
*
      call PutCS( cs2s3p , tSu30 )
      call level2( tSu30 )
*
      end
