******************************************************************************
      subroutine SumCool(total)
      implicit none
*evaluate total cooling from all entries into cooling stack
      real total
*
      include "ncolnt.par"
      include "nta.par"
      include "ipLnArry.par"
      include "limelm.par"
      include "nwindline.par"
      include "heating.com"
      include "TLineARR.com"
      include "WindData.com"
      include "coolnt.com"
      include "tcool.com"
      include "heat.com"
      include "CHMax.com"
      include "collab.com"
      include "IOqq.com"
*
*     local variables
      integer i
*
*     routine to add together all line heating and cooling
*
      total = 0.
      coolheat = 0.
*     this is sum of agents that should be coolants
*     coolheat will be coolants that came out as heat
      do i=1,ncltot
        total = total + cooling(i)
        coolheat = coolheat + heatnt(i)
      end do
      heating(1,13) = coolheat
*
*     make comment if negative cooling ever significant
      if( htot.gt.0. ) then
        if( coolheat/htot.gt.0.01 ) then
*         CoolHeatMax was set to zero at start of calc, we want very biggest
          do i=1,ncltot
            if( heatnt(i)/htot.gt.CoolHeatMax) then
              CoolHeatMax = heatnt(i) / htot
              ipCoolHeatMax = collam(i)
              chCoolHeatMax = chClntLab(i)
            endif
          end do
        endif
      endif
*
*     this sum of lines that were heat sources - this
*     part was not counted as heating in call to cooling add routine
*     since level 2 and level 3 separate this out - this does
*     NOT double count line heating
      heatl = 0.
      do i=1,NWINDLINE*nWindOn
        heatl = heatl + WindLine(ipLnHeat,i)
      end do
      do i=1,nTauLines
        heatl = heatl + TauLines(ipLnHeat,i)
      end do
*
*     line heating added in following, only here
      heating(1,23) = heatl
*
*begin sanity check
      if( total.le.0. ) then
        write(qq,'('' SumCool finds cooling <= 0'',1p,e10.2)') total
      endif
      if( heatl/ctot.lt.-1e-15 ) then
        write(qq,'('' SumCool finds negative heating'',1p,2e10.2)')
     1  heatl,ctot
*       write(qq,'('' dump went to fort.66'')') 
*       write(66,'(1p,12e10.1)') (heatnt(i),i=1,ncltot)
      endif
*end sanity check
*
      end
