******************************************************************************
      real function tabden ( r0 , depth )
      implicit none
*interpolate on table of points for density with dlaw table command, by K Volk
*each line is log radius and H density per cc.
      double precision r0 , depth
      include "limTabD.par"
      include "tablaw.com"
      include "IOqq.com"
*
*     local variables
      integer j
      logical lgHit
      real x,frac
*
*begin sanity check
      if( r0.le.0. .or. depth.le.0. ) then
        write(qq,'('' tabden called with insane depth, radius, ='',
     1  1p,2e10.2)') depth, r0
      endif
*end sanity check
*
*     interpolate on radius or depth?
      if( lgDLWDepth ) then
*       depth key appeared = we want depth
        x = log10( depth )
      else
*       use radius
        x = log10( r0 )
      endif
*
      if( x.lt.frad(1).or.x.ge.frad(nvals) ) then
        write(qq,'('' requested radius outside range of tabden'')')
        write(qq,'('' radius was'',1p,e10.2,'' min, max='',2e10.2)')
     1  x,frad(1),frad(nvals)
        stop
      else
        lgHit = .false.
        j = 1
*       do j=1,nvals-1
        do while( .not.lgHit .and. j.le.nvals-1 )
          if (frad(j).le.x.and.frad(j+1).gt.x) then
            frac=(x-frad(j))/(frad(j+1)-frad(j))
            tabden=fhden(j)+frac*(fhden(j+1)-fhden(j))
            lgHit = .true.
          end if
          j = j + 1
        end do
        if( .not.lgHit ) then
          write(qq,'('' radius outran dlaw table scale, requested='',
     1    f6.2,'' largest='',f6.2)')x,frad(nvals)
          stop
        endif
      endif
*
*     got it, now return value, not log of density
      tabden = 10.** tabden
*
      end
