******************************************************************************
      subroutine TauInc
      implicit none
*increment optical depths once per zone
      include "pi.par"
      include "ndust.par"
      include "ncell.par"
      include "limelm.par"
      include "evryd.par"
      include "nta.par"
      include "ipLnArry.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "ndfst.par"
      include "nfeii.par"
      include "nzlim.par"
      include "itrdim.par"
      include "nwindline.par"
      include "dstfac.com"
      include "LyaExT.com"
      include "densty.com"
      include "rfield.com"
      include "corind.com"
      include "iphmin.com"
      include "heat.com"
      include "hmidep.com"
      include "lyamas.com"
      include "trace.com"
      include "optbug.com"
      include "htau.com"
      include "htnext.com"
      include "he1tau.com"
      include "he2tau.com"
      include "he1nxt.com"
      include "he2nxt.com"
      include "hlvcol.com"
      include "he1blt.com"
      include "he2blt.com"
      include "he1bn.com"
      include "he2bn.com"
      include "tedust.com"
      include "wind.com"
      include "DoppVel.com"
      include "toiii.com"
      include "dstdft.com"
      include "GrainPot.com"
      include "hetrpEXP.com"
      include "phlevl.com"
      include "phe1lv.com"
      include "phe2lv.com"
      include "abrems.com"
      include "opac.com"
      include "sound.com"
      include "filfac.com"
      include "TePowers.com"
      include "hehp.com"
      include "cldnEXP.com"
      include "hmi.com"
      include "he3tuEXP.com"
      include "taucon.com"
      include "pciexc.com"
      include "h.com"
      include "he.com"
      include "phycon.com"
      include "radius.com"
      include "nh.com"
      include "colmas.com"
      include "prad.com"
      include "dRdVeff.com"
      include "jmin.com"
      include "fe2tau.com"
      include "logte.com"
      include "struc.com"
      include "windeff.com"
      include "ZoneCnt.com"
      include "hstat.com"
      include "TLineARR.com"
      include "FeIIAtom.com"
      include "IonFracs.com"
      include "WindData.com"
      include "EdError.com"
      include "TrueEden.com"
      include "he1stat.com"
      include "he2stat.com"
      include "dtMase.com"
      include "he1esc.com"
      include "KatyaDat.com"
      include "IOqq.com"
*
*     local variables
      character chLbl*10, chLineLbl*10
      real CapMaser
      parameter (CapMaser=-30.)
      integer i,j,nd , low , ihi
      real r,factor,fnext,dtau,rjeans,ajmass , ErrorEden
*
*     free statement numbers >= 30
*
      if(lgTrace) write(qq,'('' TauInc called.'')')
*
*     following is general method to find means weighted by various functions
*     called int startr to initialize to zero, called here to put in numbers
*     results will be weighted by radius and volumn
*     this is the only place things must be entered to create averages
      call aver('zone', 1. , 1.                  ,'          ' )
      call aver('doit', te , 1.                  ,'    Te    ' )
      call aver('doit', te , eden                ,'  Te(Ne)  ' )
      call aver('doit', te , eden*hii            ,' Te(NeNp) ' )
      call aver('doit', te , eden*heii           ,' Te(NeHe+)' )
      call aver('doit', te , eden*heiii          ,'Te(NeHe2+)' )
      call aver('doit', te , eden*xIonFracs(8,2) ,' Te(NeO+) ' )
      call aver('doit', te , eden*xIonFracs(8,3) ,' Te(NeO2+)' )
      call aver('doit',hden, 1.                  ,'    NH    ' )
      call aver('doit',eden, xIonFracs(8,3)      ,'  Ne(O2+) ' )
      call aver('doit',eden, hii                 ,'   Ne(Np) ' )
*
*     save information about structure of model, now used to get t^2
      testr(min(nzone,nzlim)) = te
      pdenstr(min(nzone,nzlim)) = pden
      heatstr(min(nzone,nzlim)) = htot
      volstr(min(nzone,nzlim)) = dVeff
      radstr(min(nzone,nzlim)) = dReff
      histr(min(nzone,nzlim)) = hi
      hiistr(min(nzone,nzlim)) = hii
      ednstr(min(nzone,nzlim)) = eden
      o3str(min(nzone,nzlim)) = xIonFracs(8,3)
*
*     check on error budget for eden
      ErrorEden = (eden-EdenTrue)/EdenTrue
      if( abs(ErrorEden).gt.abs(BigEdenError) ) then
        BigEdenError = ErrorEden
        ipEdenError = nzone
      endif
*
      vsound = sqrt( GasPres /xMassDensity )
*     sound is sound travel time
      sound = sound+dReff/vsound
*
      dlnenp = dlnenp + dble(eden) * dble(hii) * dble(dReff)
      colden = colden + hden * dReff
      chi = chi + hi*dReff
*
*     counter for number of times Lya excit temp hotter than gas
      if( TexcLya.gt.te ) then
        nLyaHot = nLyaHot + 1
        if( TexcLya.gt.TLyaMax ) then
          TLyaMax = TexcLya
          TeLyaMax = te
          nZTLaMax = nzone
        endif
      endif
*
      chmin = chmin + hminus * dReff
      colh2 = colh2 + htwo * dReff
      chehp = chehp + hehp * dReff
      ch2pls = ch2pls + h2plus*dReff
*
*     now add total molecular column densities
      call molcol( 'ADD ' )
*
*     call zmean zeros out these arrays
*     rest of elements
      call mean
*
*-----------------------------------------------------------------------
*
      reftot = reftot + dReff
      avhden = avhden + dReff
      do nd=1,ndust
        if( lgDustOn1(nd) ) theN
          avdust(nd) = avdust(nd) + tedust(nd) * dReff
          avdft(nd) = avdft(nd) + DustDftVel(nd) * dReff
          avdpot(nd) = avdpot(nd) + dstpot(nd)*evryd * dReff
        endif
      end do
      chii = chii + hii * dReff
      thtot = thtot + te * dReff * hden
      TotMassColl = TotMassColl + xMassDensity * dReff
      tmas = tmas + te * xMassDensity * dReff
      wmas = wmas + wmole * xMassDensity * dReff
*
*     now find minimum Jeans length and mass; length in cm
      rjeans = 7.79637 +(alogte-log10(wmole)-
     1 log10(xMassDensity*FillFac))/2.
*     minimum Jeans mass in gm
      ajmass = 3.*(rjeans-0.30103)+log10(4.*pi/3.*xMassDensity*FillFac)
      rjnmin = min( rjnmin , rjeans )
      ajmmin = min( ajmmin , ajmass )
*
      telec = telec + dReff * eden * 6.65e-25
      thmin = thmin + dReff * hminus * 3.9e-17 * 
     1 (1. - ContBoltz(iphmin)/hmidep )
*
*     find line widths for thermal and turbulent motion
*     CLOUDY uses line center optical depths, =0.015 F / DELTA NU
      call velset
*
*     following used for wind solution in TAUCHN
      if(windv.gt.0.) wndeff = min( depth , radius ) / 
     1 max( doppler(1),windv ) * FillFac
*
*     prevent maser runaway
      dTauMase = 0.
*     if following is still zero when maser used, then maser was in
*     heavy element line
      ijMase = 0
*
*     increment optical depths for all heavy element lines
*     same routine does wind and static
      do i=1,nTauLines
        call tauchn( TauLines(1,i))
        if( TauLines(ipLnTauIn,i).lt.CapMaser ) then
          write(qq,'('' TauInc, Tau line maser tau too small,'',1p,
     1    e10.2)')TauLines(ipLnTauIn,i) 
          chLbl = chLineLbl( TauLines(1,i) )
          write(qq,'('' line='',i3,'' zone='',i4,1x,a10)')
     1    i,nzone,chLbl
          call ShowMe
          stop
        endif
      end do
*
*     all lines in cooling with g-bar
      do i=1,NWINDLINE*nWindOn
        call tauchn( WindLine(1,i))
        if( WindLine(ipLnTauIn,i).lt.CapMaser ) then
          write(qq,'('' TauInc, Wind line maser tau too small,'',1p,
     1    e10.2)')WindLine(ipLnTauIn,i)
          write(qq,'('' line='',i3,'' zone='',i4)')
     1    i,nzone
          call ShowMe
          stop
        endif
      end do
*
*     do Katya Verner FeII atom if this is enabled
      if( chFeIIAtom.eq.'Verner'.and.xIonFracs(26,2).gt.0.) then
        if(.not.lgSimKatya) call TauIncFe2
      endif
*
      if( windv.eq.0. ) then
*
      if(lgTrace) write(qq,'('' TauInc updates for static atmos'')')
*
*     following is for static atmosphere
*
*     hydrogen lines
      factor = hii * dReff / doppler(1)
      fnext = hii * dRNeff / doppler(1) * 0.6
      do low=1,nhlvl-1
        do ihi=max(3,low+1),nhlvl
*         line absorption, corrected for stimulated emission
          if( ihi.lt.nhlvl-2 ) then
            dtau = (hn(low) - hn(ihi)* hstat(low) / hstat(ihi) ) *
     1      hopac(ihi,low)
          else
*           do not allow stim em cor for highest state since it
*           has especially flaky departure coef
            dtau = hn(low) * hopac(ihi,low)
          endif
          if( dtau*factor .lt. dTauMase) then
            dTauMase = dtau * factor
            ijMase = 100*ihi + low
          endif
*     >>chng 96 aug 8, added max, so that smallest maser tau is -1
          htau(ihi,low) = htau(ihi,low) + max(-1.,dtau * factor)
          htnext(ihi,low) = htau(ihi,low) + max(-1.,dtau * fnext)
          if( htnext(ihi,low).lt.CapMaser ) then
            write(qq,'('' TauInc, H line maser tau too small,'',1p,
     1      e10.2)')htnext(ihi,low)
            write(qq,'('' upper, lower='',2i3,'' zone='',i4)')
     1      ihi,low,nzone
            call ShowMe
            stop
          endif
        end do
      end do
*     Ly-alpha absorption, corrected for stimulated emission
      dtau = (hn(1) - hn2p* 2. / 6. ) * hopac(2,1)
      if( dtau.lt.0. ) lgHLyaMased = .true.
      htau(2,1) = htau(2,1) + dtau * factor
      htnext(2,1) = htau(2,1) + dtau * fnext
*
*     He I lines
*     Helium lines, optical depths are total, not He alone
*     hydrogen and helium were added in with correction for stimulated emission
      factor = heii * dReff / doppler(2)
      fnext = heii * dRNeff / doppler(2) * 0.6
      do low=1,nhe1lvl-1
        do ihi=low+1,nhe1lvl
*         line absorption, corrected for stimulated emission
          if( ihi.lt.nhe1lvl-2 ) then
            dtau = (he1n(low) - he1n(ihi)*he1stat(low)/he1stat(ihi))*
     1      he1opc(ihi,low)
          else
*           do not allow stim emission for psuedo-states
            dtau = he1n(low) * he1opc(ihi,low)
          endif
          he1tau(ihi,low) = he1tau(ihi,low) + dtau * factor
          he1nxt(ihi,low) = he1tau(ihi,low) + dtau * fnext
          if( he1nxt(ihi,low).lt.CapMaser ) then
            write(qq,'('' TauInc, He1 line maser tau too small,'',1p,
     1      e10.2)') he1nxt(ihi,low)
            write(qq,'('' upper, lower='',2i3,'' zone='',i4)')
     1      ihi,low,nzone
            call ShowMe
            stop
          endif
        end do
      end do
*666  write(6,'('' he1'',1p,9e10.2)') (he1dst(i+1,i), i=1,2),
*    1 (he1nxt(i+1,i),i=1,2), (he1esc(i+1,i),i=1,2)
*     >>chng 96 july 8, optical depth increment had been deleted around beta 3
*     >>chng 96 july 8, did not have correction for stimulated emission, ever
      t206(ipLnTauIn) = t206(ipLnTauIn) + (he12s-he12p*0.333) *
     1 1.162e-6 * factor
      if( t206(ipLnTauIn).lt.CapMaser ) then
        write(qq,'('' TauInc, He1 2.06 mic line maser tau too small,'',
     1  1p,e10.2)') t206(ipLnTauIn)
        write(qq,'('' zone='',i4)') nzone
        call ShowMe
        stop
      endif
*
*     He II lines
      factor = heiii * dReff / doppler(2)
      fnext = heiii * dRNeff / doppler(2) * 0.6
      do low=1,nhe2lvl-1
        do ihi=low+1,nhe2lvl
          if( ihi.lt.nhe2lvl-2 ) then
*           line absorption, corrected for stimulated emission
            dtau = (he2n(low) - he2n(ihi)*he2stat(low)/he2stat(ihi))*
     1      he2opc(ihi,low)
          else
*           do not include stim emission for highest level
            dtau = he2n(low) * he2opc(ihi,low)
          endif
          he2tau(ihi,low) = he2tau(ihi,low) + dtau * factor
          he2nxt(ihi,low) = he2tau(ihi,low) + dtau * fnext
          if( he2nxt(ihi,low).lt.CapMaser ) then
            write(qq,'('' TauInc, He2 line maser tau too small,'',1p,
     1      e10.2)') he2nxt(ihi,low)
            write(qq,'('' upper, lower='',2i3,'' zone='',i4)')
     1      ihi,low,nzone
            call ShowMe
            stop
          endif
        end do
      end do
*
      factor = dReff / doppler(2)
      t10830(ipLnTauIn) = t10830(ipLnTauIn)+8.80e-7 *(p2s-p2p/3.)*factor
       t3889(ipLnTauIn) = t3889(ipLnTauIn)  + 3.75e-8 * p2s * factor
       t5876(ipLnTauIn) = t5876(ipLnTauIn)  + 5.35e-7 * p2p * factor
       t7065(ipLnTauIn) = t7065(ipLnTauIn)  + 2.95e-7 * p2p * factor
*
*     iron fe 
*     first are overlapping feii lines
      do i=1,nfeii
        Fe2TauLte(i) = Fe2TauLte(i) + feopc(i)  * dReff
      end do
*
      else
      if(lgTrace) write(qq,'('' TauInc updates for wind'')')
*
*     expanding atmosphere
*     min of depth or radius is to stop (nearly) infinite line
*     line optical depths when ionization parameter set so
*     radius itself is very large
      r = min( depth , radius ) / max(doppler(1),windv) * FillFac
*
*     hydrogen lines
      factor = hii * r
*
      do i=1,nhlvl-1
        do j=max(3,i+1),nhlvl
*         line absorption, corrected for stimulated emission
          if(j.le.nhlvl-2) then
            dtau = (hn(i) - hn(j)* hstat(i) / hstat(j) ) * hopac(j,i)
          else
            dtau = hn(i) * hopac(j,i)
          endif
          htau(j,i) = dtau * factor
          htnext(j,i) = htau(j,i)
        end do
      end do
*     Ly-alpha absorption, corrected for stimulated emission
      dtau = (hn(1) - hn2p* 2. / 6. ) * hopac(2,1)
      if( dtau.lt.0. ) lgHLyaMased = .true.
      htau(2,1) = dtau * factor
      htnext(2,1) = htau(2,1)
*
*     He I lines
*     Helium lines and continua, optical depths are total, not He alone
*     hydrogen and helium were added in with correction for stimulated emission
      factor = heii * r
      do i=1,nhe1lvl-1
        do j=i+1,nhe1lvl
*         line absorption, corrected for stimulated emission
          if( j.le.nhe1lvl-2 ) then
            dtau = (he1n(i) - he1n(j)*he1stat(i)/he1stat(j))*he1opc(j,i)
          else
*           do not include stim emission for psuedo-states
            dtau = he1n(i) * he1opc(j,i)
          endif
          he1tau(j,i) = dtau * factor
          he1nxt(j,i) = he1tau(j,i)
        end do
      end do
      t206(ipLnTauIn) = he12s*heii*1.162e-6 * r
      t206(ipLnTauTot) = t206(ipLnTauIn)
*
*     He II lines
      factor = heiii * r
      do i=1,nhe2lvl-1
        do j=i+1,nhe2lvl
          if( j.le.nhe2lvl-2 ) then
*           line absorption, corrected for stimulated emission
            dtau = (he2n(i) - he2n(j)*he2stat(i)/he2stat(j))*he2opc(j,i)
          else
*           do not include stim emission for psuedo-sates
            dtau = he2n(i) * he2opc(j,i)
          endif
          he2tau(j,i) = dtau * factor
          he2nxt(j,i) = he2tau(j,i)
        end do
      end do
*
      t10830(ipLnTauIn) = r*(p2s-p2p/3.) * 8.80e-7
      t10830(ipLnTauTot) = t10830(ipLnTauIn)
       t3889(ipLnTauIn) = 3.75e-8 *p2s*r
       t3889(ipLnTauTot) = t3889(ipLnTauIn)
       t5876(ipLnTauIn) = 5.35e-7 *p2p*r
       t5876(ipLnTauTot) = t5876(ipLnTauIn)
       t7065(ipLnTauIn) = 2.95e-7 *p2p*r
       t7065(ipLnTauTot) = t7065(ipLnTauIn)
*
      endif
*
*     now do escape prob
      call MakeRT
      if( lgTrace.and.lgOptcBug ) call metprt
*
      if(lgTrace) write(qq,'('' TauInc returns.'')')
*
      end
