******************************************************************************
      subroutine tauout
      implicit none
*set initial outward optical depths at start of first iteration
      include "ncell.par"
      include "itrdim.par"
      include "nhlvl.par"
      include "nhe1lvl.par"
      include "nhe2lvl.par"
      include "ipLnArry.par"
      include "rydlam.par"
      include "nta.par"
      include "HEnrRyd.com"
      include "trace.com"
      include "rfield.com"
      include "tautot.com"
      include "turb.com"
      include "xry.com"
      include "taumin.com"
      include "htau.com"
      include "nh.com"
      include "htnext.com"
      include "he1tau.com"
      include "he2tau.com"
      include "he3tuEXP.com"
      include "he1as.com"
      include "he2as.com"
      include "he1nxt.com"
      include "he2nxt.com"
      include "phycon.com"
      include "qs.com"
      include "ZoneCnt.com"
      include "colend.com"
      include "static.com"
      include "caseb.com"
      include "hbug.com"
      include "hebug.com"
      include "sphere.com"
      include "double.com"
      include "NumUpper.com"
      include "tauend.com"
      include "TAddLya.com"
      include "hyas.com"
      include "hlife.com"
      include "hstat.com"
      include "IOqq.com"
*
*     local variables
      integer i ,j , ilo,ihi
      real f , fac , z , coleff, balc
      real taulim , branch
      parameter (taulim=1e8)
*
*     free statement labels >=29
*
*     set initial and total optical depths in arrays
*     TAUNU is set when lines read in, sets stopping radius
      if( taunu.gt.0. ) then
*        an optical depth has been specified
         if( iptnu.ge.ipHn(1) ) then
*           at ionizing energies
            do i=1,ipHn(1)-1
               tauabs(i,2) = taumin
               tausct(i,2) = taumin
               tautot(i,2) = taumin
            end do
            do i=ipHn(1),nupper
*              tauabs(i,2) = tauend * (anu(i)/anu(iptnu))**(-2.43)
               tauabs(i,2) = tauend
               tausct(i,2) = taumin
               tautot(i,2) = tauabs(i,2) + tausct(i,2)
            end do
         else
*           not specified at ionizing energies
            do i=1,ipHn(1)-1
               tauabs(i,2) = tauend
               tausct(i,2) = tauend
               tautot(i,2) = tauend
            end do
            do i=ipHn(1),nupper
               tauabs(i,2) = taulim * anu(i)**(-2.43)
               tausct(i,2) = taumin
               tautot(i,2) = tauabs(i,2) + tausct(i,2)
            end do
         endif
      else
*        ending optical depth not specified, assume 1E8 at 1 Ryd
         do i=1,ipHn(1)-1
            tauabs(i,2) = taumin
            tausct(i,2) = taumin
            tautot(i,2) = taumin
         end do
         do i=ipHn(1),nupper
            tauabs(i,2) = taulim * anu(i)**(-2.43)
            tausct(i,2) = taumin
            tautot(i,2) = tauabs(i,2) + tausct(i,2)
         end do
      endif
*
*     if lgSphere then double outer, set inner to half
*     assume will be optically thin at sub-ionizing energies
      if( lgSphere .or. lgCaseb ) then
         do i=1,ipHn(1)-1
            tauabs(i,1) = taumin
            tauabs(i,2) = taumin * 2.
            tausct(i,1) = taumin
            tausct(i,2) = taumin * 2.
            tautot(i,1) = 2.*taumin
            tautot(i,2) = 4.*taumin
         end do
         do i=ipHn(1),nupper
            tauabs(i,1) = tauabs(i,2)
            tauabs(i,2) = tauabs(i,2) * 2.
            tausct(i,1) = tausct(i,2)
            tausct(i,2) = tausct(i,2) * 2.
            tautot(i,1) = tautot(i,2)
            tautot(i,2) = tautot(i,2) * 2.
         end do
         if( taunu.gt.0. ) then
*           ending optical depth specified, and lgSphere also
            tauend = tauend * 2.
         endif
      endif
*
*     fix offset for effective column density optical depth
      tauxry = tauabs( ipxry , 1 )
*
      do i=1,nhlvl-1
        do j=1,nhlvl
          htnext(j,i) = taumin
          htau(j,i) = taumin
        end do
      end do
      do i=1,nhe1lvl-1
        do j=1,nhe1lvl
          he1nxt(j,i) = taumin
          he1tau(j,i) = taumin
        end do
      end do
      do i=1,nhe2lvl-1
        do j=1,nhe2lvl
          he2nxt(j,i) = taumin
          he2tau(j,i) = taumin
        end do
      end do
*
*     HeI 10830 when static
      if( lgStatic ) then
        t10830(ipLnTauIn) = 100.
        t10830(ipLnTauTot) = 200.
      endif
*
*     La may be case B
      htau(2,1) = tlamin
      htnext(2,1) = tlamin
      he1tau(2,1) = tlamin
      he2tau(2,1) = tlamin
      he1nxt(2,1) = tlamin
      he2nxt(2,1) = tlamin
*
      f = tlamin / hopac(2,1)
      do i=3,nhlvl
        htau(i,1) = f * hopac(i,1)
        htnext(i,1) = htau(i,1)
      end do
*
      f = tlamin / he1opc(2,1)
      do i=3,nhe1lvl
        he1tau(i,1) = f * he1opc(i,1)
        he1nxt(i,1) = he1tau(i,1)
      end do
*
      f = tlamin / he2opc(2,1)
      do i=3,nhe2lvl
        he2tau(i,1) = f * he2opc(i,1)
        he2nxt(i,1) = he2tau(i,1)
      end do
*
*     fix LA in ways of increasing accuracy
*
*     account for turbulence
      z = 1.28e6 / sqrt( 1.65e12 + TurbVel*TurbVel )
      if( lgCaseb ) then
*       force outer optical depth to twice inner if case B
        htlim(2,1) = 2. * htnext(2,1)
        he1lim(2,1) = 2. * he1nxt(2,1)
        he2lim(2,1) = 2. * he2nxt(2,1)
*       force off Balmer et al optical depths
        fac = 0.
      else
*       usual case for H LyA; try to guess outer optical depth
        if( colnut.lt.6e29 ) then
*         neutral column is defined
          htlim(2,1) = colnut * DoubleTau * 7.6e-14 * z
        else if( taunu.lt.3. .and. taunu.ge.0.99 ) then
*         Lyman continuum optical depth defined
          htlim(2,1) = tauend * 1.2e4 * z * DoubleTau
        else if( HColStop.lt. 6e29 ) then
*         neutral column not defined, guess from total col and U
          coleff = HColStop - min( min(qhtot/eden,1e24)/2.6e-13 ,
     1    0.6*HColStop )
          htlim(2,1) = coleff * 7.6e-14 * z
        else
*         no way to estimate 912 optical depth, set to large number
          htlim(2,1) = 1e20 * z
        endif
*       set He LyA optical depths to large number
        he1lim(2,1) = htlim(2,1)
        he2lim(2,1) = htlim(2,1)
*       allow Balmer et al. optical depths
        fac = 1.
      endif
*
      if( htlim(2,1).gt.1. ) then
        TAddHLya = min(1. , htlim(2,1)/1e4 )
        htau(2,1) = htau(2,1) + TAddHLya
        htnext(2,1) = htau(2,1)
      else
        TAddHLya = tlamin
      endif
      f = htlim(2,1) / hopac(2,1)
      do i=3,nhlvl
        htlim(i,1) = hopac(i,1) * f
        htau(i,1) = htau(i,1) + TAddHLya*hopac(i,1)/hopac(2,1)
        htnext(i,1) = htau(i,1)
      end do
*
      if( he1lim(2,1).gt.1. ) then
        TAddHeI = min(1. , he1lim(2,1)/1e4 )
        he1tau(2,1) = he1tau(2,1) + TAddHeI
        he1nxt(2,1) = he1tau(2,1)
      else
        TAddHeI = tlamin
      endif
*     min triggers if case b command entered
      TAddHeI = min(he1lim(2,1)/10., he1tau(2,1))
      f = he1lim(2,1) / he1opc(2,1)
      do i=3,nhe1lvl
        he1lim(i,1) = he1opc(i,1) * f
        he1tau(i,1) = he1tau(i,1) + TAddHeI*he1opc(i,1)/he1opc(2,1)
        he1nxt(i,1) = he1tau(i,1)
      end do
*
      if( he2lim(2,1).gt.1. ) then
        TAddHeII = min(1. , he2lim(2,1)/1e4 )
        he2tau(2,1) = he2tau(2,1) + TAddHeII
        he2nxt(2,1) = he2tau(2,1)
      else
        TAddHeII = tlamin
      endif
*     min triggers if case b used
      TAddHeII = min( he2lim(2,1)/10., he2tau(2,1))
      f = he2lim(2,1) / he2opc(2,1)
      do i=3,nhe2lvl
        he2lim(i,1) = he2opc(i,1) * f
        he2tau(i,1) = he2tau(i,1) + TAddHeII*he2opc(i,1)/he2opc(2,1)
        he2nxt(i,1) = he2tau(i,1)
      end do
*
*     try to guess what Balmer cont optical guess is
*     relation from Ferland and Netzer 1979
      if( taunu.gt.0.24 .and. taunu.lt.0.7 ) then
        htlim(3,2) = tauend * 3.7e4 * z * fac + 1e-20
      else
*       this is a guess based on something, but it gets very large
        balc = qhtot * 2.1e-19 * fac + 1e-20
*       z if the factor that account for turbulence, =1 is TurbVel=0
        htlim(3,2) = min(2e5,balc*3.7e4*z*fac+1e-20)
      endif
*
      htlim(4,3) = htlim(3,2) * 0.01 * z * fac + 1e-20
      htlim(5,4) = htlim(3,2) * 0.0005 * z * fac + 1e-20
      htlim(6,5) = htlim(3,2) * 7.7e-5 * z * fac + 1e-20
      do i=7,nhlvl
        htlim(i,i-1) = htlim(6,5) / i * fac + 1e-20
      end do
*     htlim(7,6) = htlim(6,5) / 10. * fac + 1e-20
*     htlim(8,7) = htlim(6,5) / 100. * fac + 1e-20
*     htlim(9,8) = htlim(6,5) / 1000. * fac + 1e-20
*
      do ihi=4,min(15,nhlvl)
        do ilo=2,ihi-1
          hyas(ihi,ilo) = hlife(ihi) * branch(ihi,ilo)
*         make self-consistent opaciity
          hopac(ihi,ilo) = hyas(ihi,ilo) * 2.249e-26 * 
     1    hstat(ihi)/hstat(ilo) * (rydlam/HEnerRyd(ihi,ilo))**3
        end do
      end do
      do ihi=4,nhe1lvl
        do ilo=1,ihi-1
*         scale HeII opacities from hydrogen
          he1opc(ihi,ilo) = hopac(ihi,ilo) / 1.808
        end do
      end do
      do ihi=4,nhe2lvl
        do ilo=1,ihi-1
*         scale HeII opacities from hydrogen
          he2opc(ihi,ilo) = hopac(ihi,ilo) / 4.
        end do
      end do
      do ilo=2,nhlvl-1
        f = htlim(ilo+1,ilo) / hopac(ilo+1,ilo) * fac + 1e-20
        do ihi=ilo+2,nhlvl
          htlim(ihi,ilo) = f * hopac(ihi,ilo)
        end do
      end do
*
      do i=2,nhe1lvl-1
        do j=i+1,nhe1lvl
          he1lim(j,i) = taumin
        end do
      end do
*
      do i=2,nhe2lvl-1
        do j=i+1,nhe2lvl
          he2lim(j,i) = taumin
        end do
      end do
*
*     fix escape prob for He, metals, first set log of Te, needed by RECEFF
      te = 2e4
      call tfidle
      call MakeRT
*
      if( lgTrace ) then
        if( lgHBug .and.lgHBugFull ) then
          write(qq,'(//'' HTLIM array as set in TAUOUT'')')
          do i=1,nhlvl
            write(qq,'(1X,I3,1P,15E9.2)') i,(htlim(i,j),j=1,nhlvl-1)
          end do
          write(qq,'(//'' HTAU array'')')
          do i=1,nhlvl
            write(qq,'(1X,I3,1P,15E9.2)') i,(htau(i,j),j=1,nhlvl-1)
          end do
          write(qq,'(//'' HTAU As array'')')
          do i=1,nhlvl
             write(qq,'(1X,I3,1P,15E9.2)') i,(hyas(i,j),j=1,nhlvl-1)
          end do
          write(qq,'(//'' H opac array'')')
          do i=1,nhlvl
            write(qq,'(1X,I3,1P,15E9.2)') i,(hopac(i,j),j=1,nhlvl-1)
          end do
        else if( lgHe1Bug ) then
          write(qq,'(//'' HE1LIM array as set in TAUOUT'')')
          do i=1,nhe1lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he1lim(i,j),j=1,nhe1lvl-1)
          end do
          write(qq,'(//'' HE1TAU array'')')
          do i=1,nhe1lvl
            write(qq,'(1x,i3,1p,8e11.3)') i,(he1tau(i,j),j=1,nhe1lvl-1)
          end do
          write(qq,'(//'' HE1 As array'')')
          do i=1,nhe1lvl
            write(qq,'(1x,i3,1p,8e11.3)') i,(He1EinA(i,j),j=1,nhe1lvl-1)
          end do
          write(qq,'(//'' HE1 opac array'')')
          do i=1,nhe1lvl
            write(qq,'(1x,i3,1p,8e11.3)') i,(he1opc(i,j),j=1,nhe1lvl-1)
          end do
*
        else if( lgHe2Bug ) then
          write(qq,'(//'' HE2LIM array as set in TAUOUT'')')
          do i=1,nhe2lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he2lim(i,j),j=1,nhe2lvl-1)
          end do
          write(qq,'(//'' HE2TAU array'')')
          do i=1,nhe2lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he2tau(i,j),j=1,nhe2lvl-1)
          end do
          write(qq,'(//'' HE2TAU As'')')
          do i=1,nhe2lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he2as(i,j),j=1,nhe2lvl-1)
          end do
          write(qq,'(//'' HE2TAU opcity array'')')
          do i=1,nhe2lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he2opc(i,j),j=1,nhe2lvl-1)
          end do
        else
          write(qq,'(1X,''TAUOUT called.'')')
        endif
      endif
*
      end
