******************************************************************************
      subroutine tav( t , f1 )
      implicit none
*computes average of old and new optical depths for new scale at end of iter
      include "nta.par"
      real t(nta) , f1
      include "ipLnArry.par"
      include "IterCnt.com"
      include "taumin.com"
      include "sphere.com"
      include "double.com"
      include "static.com"
      include "PrtMaser.com"
      include "IOqq.com"
*
*     local variables
      character chLineLbl*10, chSave*10
*
*     option to print masing lines, set with print maser
      if( lgPrtMaser .and.
     1  (t(ipLnTauTot).lt.-0.01 .or. t(ipLnTauIn).lt.-0.01) ) then
        chSave = chLineLbl( t )
        write(qq,'('' Masing line:'',a10,'' t(in, out)='',1p,2e10.2)')
     1  chSave , t(ipLnTauIn) ,  t(ipLnTauTot)
      endif
*
*     (1) is inner optical depth, (2) is outer, (3) is esc prob
      if( iter.eq.1 .and. (.not.lgStatic) ) then
*       first shot at model, set T(ipLnTauTot) to T(1)
*       DoubleTau normally 1, set to 2 by DoubleTau command in order
*       to simulate two-sided photoionization
        t(ipLnTauTot) = t(ipLnTauIn) * DoubleTau
        t(ipLnTauIn) = min(taumin,t(ipLnTauTot)/2.)
      else if( lgSphere.and.lgStatic ) then
*       static sphere, both sides interact
*       t(ipLnTauIn) = max( taumin, t(ipLnTauIn) - t(ipLnTauTot)/2. )
*       t(ipLnTauTot) = 2. * t(ipLnTauIn)
*     >>chng 96 july 6 from above to below
        if( iter.eq.1 ) then
*         on first iteration TauIn was 0 for first zone
          t(ipLnTauTot) = 2. * t(ipLnTauIn)
        else
          t(ipLnTauTot) = t(ipLnTauIn)*f1+t(ipLnTauTot)*(1.-f1)
        endif
        t(ipLnTauIn) = t(ipLnTauTot)/2.
      else
*       take some sort of mean of old and new limiting optical depths
        if( t(ipLnTauIn).gt.0. .and. t(ipLnTauTot).gt.0. ) then
          t(ipLnTauTot) = 10.**( log10(t(ipLnTauTot))*(1.-f1) + 
     1    log10(t(ipLnTauIn)*DoubleTau)*f1 )
          t(ipLnTauIn) = min(taumin,t(ipLnTauTot)/2.)
        else
          t(ipLnTauTot) = ( t(ipLnTauIn)*DoubleTau + t(ipLnTauTot) )/2.
          t(ipLnTauIn) = min(taumin,t(ipLnTauTot)/2.)
        endif
      endif
*
*     this is escape prob
      t(ipLnEscP) = 0.5 * (1. + 1./max(1.,t(ipLnTauTot)) )
*
*     this is fraction inward
      t(ipLnInwd) = min(1., 1.5-t(ipLnEscP) )
*
*     this is destruction probability
*     >>chng 96 sep 4, was not here, needed to add since now taking
*     mean of old and new dest prob
      t(ipLnDesP) = 0.
*
*     line opacity
      t(ipLnDTau) = 0.
*
*     optical depth to the continuum source
      t(ipLnTauCon) = 0.
*
      end
