******************************************************************************
      subroutine timer
      implicit none
*time dependent models
      include "nlines.par"
      include "ncell.par"
      include "cpres.com"
      include "timefc.com"
      include "timed.com"
      include "TePowers.com"
      include "he.com"
      include "h.com"
      include "heat.com"
      include "phycon.com"
      include "tcool.com"
      include "itrdim.par"
      include "ZoneCnt.com"
      include "sum.com"
      include "radius.com"
      include "rfield.com"
      include "called.com"
      include "IOqq.com"
*
*     local variables
      real time,rad,TotalPressure,psave,dcdt,coll,sexp,c31,dion,
     1 change,rec,fac
      integer i,loop
      data change/40./
*
*     time dependent rec-col behind shock with no radiation.
*     initial conditions set by physical conditions in last zone
*
      nflux = -1
      time = 0.
*     this is the flag that will be used to say time-dep model
      itime = -1
      rad = 0.
      call prstep
      nzone = 1
      timefc = 1.
      power = 0.
      totcol = 0.
      GrossHeat = 0.
      htot = TotalPressure() * 1.5
      psave = htot
      if( lgTalk ) write(qq,'(''1'',30X,''TIME DEPENDENT MODEL OF ZONE''
     1 ,I3,'' THERMAL ENERGY='',1P,E10.3)') itime, psave
*
*     clear out line array
      do i=1,NLINES
        sumlin(i) = 0.
      end do
*
*-------------------------------------------------------------------
*     choose dt to 1/change of cooling time
*     continue until TE drops below TEND
      do while( te.gt. tend )
        call coolr( ctot , dcdt )
        dt = htot / ctot / change
*
*       hydrogen
*       soln of rad trans like eqn for ioniz of h
        coll = 1.03e-11 * sexp(1.579e5/te) * te**0.652
        if( te .lt. 2e4 ) rec = 2.9e-10/(te70*te10/te03)
        if( te .ge. 2e4 ) rec = 1.31e-8/(te*te10*te03)
*
        fac = sexp( eden * (rec+coll) * dt )
        hii = hden * coll/(coll+rec) * (1.-fac) + hii*fac
        hi = hden - hii
*
*       helium + => 0
        rec = 9.96e-11 * te**( -0.669 )
        c31 = 1.074e-5 / sqrte * exp(-1.15e4/te )
        hei3 = rec * eden * heiii / (c31*eden+1.27e-4)
        dion = heii * (1.-exp(-eden*dt*rec*1.3333) )
        hei1 = (hei1 + dion) * timefc
        hei = (hei + dion) *timefc
        heii = (heii - dion) * timefc
*
*       helium ++ => +
        dion = heiii * (1.-exp(-eden*dt*2.44e-9/(te70*te10 ) ))
        heiii = (heiii - dion )* timefc
        heii = (heii + dion) * timefc
*
*       heavy elements
        call carbon
        call nitrog
        call oxygen
        call neon
        call magnes
        call alumin
        call silicn
        call sulphr
        call clrine
        call argoni
        call calcm
        call iron
        call cobalt
        call nickel
*
*       get new electron density, find emission spectrum and rATE
        drad = dt
        call esum
        call lines
        depth = time
        if((nzone/nprint)*nprint.eq.nzone)call prstep
        nzone = nzone + 1
        htot = htot - ctot * dt
*
        if( htot.lt. 0. ) then
          if( lgTalk ) write(qq,'('' htot is <0, htot, ctot, dt='',3(1p,
     1    e12.3))') htot , ctot , dt
          stop
        endif
*
        te = te * htot / (htot+ctot*dt)
        rad = rad + ctot * dt
        time = time + dt
*
*       following for density changing with time
        timefc = 1.
*       if( tmpwr.eq.0. ) go to4
        if( tmpwr.ne.0. ) then
          timefc = ( (tmt1+dt)/tmt1 ) ** tmpwr
          chCPres = 'TIME'
          loop = 0
          call presur( loop )
          tmt1 = tmt1 + dt
          htot = htot * timefc
        endif
      end do
*     go to4
*
      power = psave
      totcol = rad
      call prstep
      call final
*
      end
