******************************************************************************
      subroutine TrimStages(nelem)
      implicit none
*raise or lower most extreme stages of ionization considered
      integer nelem
*
*     real trimhi , trimlo
*     common/trimstg/ trimhi , trimlo
*     parameter (trimhi=1e-6)
*     parameter (trimlo=1e-10)
      include "limelm.par"
      include "IonFracs.com"
      include "trimstg.com"
      include "IonRange.com"
      include "heating.com"
      include "nodec.com"
      include "Trimed.com"
      include "IOqq.com"
*
*begin sanity check
      if( IonLow(nelem).le.0 ) then
        write(qq,'('' TrimStages called with LOW <1.'')')
        call ShowMe
        stop
      endif
*end sanity check
*
*     raise or lower highest and lowest stages of ionization to
*     consider only significant stages
*     IonLow(nelem) lowest stage of ionization
*     IonHigh(nelem)  stage of ionization
*
*     special trim if upper stages have zero abundance
      do while( xIonFracs(nelem,IonHigh(nelem))/xIonFracs(nelem,0).lt.
     1  1e-35 .and. IonHigh(nelem).gt.IonLow(nelem)+1 )
*       xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
        xIonFracs(nelem,IonHigh(nelem))  = 0.
        heating(nelem,IonHigh(nelem)-1) = 0.
        IonHigh(nelem) = IonHigh(nelem) - 1
      end do
*
      if( IonHigh(nelem) .eq. 2 ) return
*
*     trim down high stages
      if( .not.lgNoDec .and.
     1  xIonFracs(nelem,IonHigh(nelem))/xIonFracs(nelem,0)
     1  .le.trimhi .and.  IonHigh(nelem).gt.3) then
        xIonFracs(nelem,IonHigh(nelem))  = 0.
        heating(nelem,IonHigh(nelem)-1) = 0.
        IonHigh(nelem) = IonHigh(nelem) - 1
      endif
*
*     raise or lower lowest stage of ionization
      if( xIonFracs(nelem,IonLow(nelem))/xIonFracs(nelem,0).gt.1e-3
     1  .and.  IonLow(nelem).gt.1 ) then
*       lower lowest level of ionization
        IonLow(nelem) = IonLow(nelem)-1
*       tell code to do all photo rates
        lgTrimed = .true.
      else if( xIonFracs(nelem,IonLow(nelem))/xIonFracs(nelem,0).le.
     1  trimlo .and.  IonLow(nelem).lt.(IonHigh(nelem)-2) ) then
*       raise lowest level of ionization
        xIonFracs(nelem,IonLow(nelem))  = 0.
        heating(nelem,IonLow(nelem)) = 0.
        IonLow(nelem) = IonLow(nelem) + 1
      endif
*
      end
