******************************************************************************
      subroutine twopht
      implicit none
*hydrogen two photon emission, including induced emission
      include "nhlvl.par"
      include "ncell.par"
      include "nip2pht.par"
      include "ip2pht.com"
      include "iphl.com"
      include "rfield.com"
      include "rin2ph.com"
      include "occnum.com"
      include "em2nu.com"
      include "trace.com"
      include "Max2Pht.com"
      include "IOqq.com"
      include "bug2nu.com"
      include "newion.com"
      include "SummdCon.com"
      include "fluors.com"
*
*     local variables
      integer i
      real sum
*
      if( .not. lgNewIon ) return
      ri2s1s = 0.
      if( .not. lgFluor ) return
      do i=1,ipHalfLya
        ri2s1s = ri2s1s + SummedOcc(i)* Hy2nu(i) * 
     1  occnum( ip2pht(i) )
      end do
*     integral is symmetric
      ri2s1s = ri2s1s * 2.
*
*     remember maximum value
      xMax2Pht = max( xMax2Pht , ri2s1s )
*
      ri1s2s = ri2s1s * 1.
*
      if( lgTrace.and.lgBug2nu ) then
        write(qq,'(1p,2e12.4)') (anu(i),occnum(i),i=1,iphl(2,1),10)
*       sum two-nu A's to check OK
        sum = 0.
        do i=1,iphl(2,1)
          sum = sum + Hy2nu(i)
        end do
        write(qq,'(7X,''TWOPHT finds induced two photon rate ='',1P,
     1  E12.3,'' total A='',E12.3)') ri2s1s , sum
      endif
*
      end
