*
**************************************************************
      real function ufunct(temp,ndust1)
      implicit none
*one of K. Volk's quantum heating routines for grains
      real temp
      integer ndust1
      include "ndust.par"
      include "lastdt.com"
*
*     local variables
      integer itype1,j
      real atoms(ndust),pow(4),tlim(5),cval(4),term(4)
*
*     this common block holds the number of atoms and base grain type
*     for the 10 grains that can be read in from files.
      data pow/3.0,2.3,1.68,1.0/
      data tlim/0.,50.,150.,500.,1.e+30/
      data cval/2.300e-10,4.7141e-09,1.4081e-07,1.6806e-05/
*     coefficients converted to rydberg energy units, per unit atom
*     assuming a density of 3.3 g/cm^3 and pure silicon dioxide.
*     this is not right, but the result is correct because atoms 
*     was calculated using the same assumption.
      data term/0.,2.8749e-05,4.6752e-04,7.4916e-03/
      data atoms/3.991e+07,1.725e+07,5.863e+08,2.534e+08,3.902e+05,
     c           3.902e+07,1.725e+07,1.725e+07,24.0,144.0,0.0,0.0,
     c           0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/
*
      if (ndust1.gt.ndust-10) then
        atoms(ndust1)=anumkv(ndust1-10)
        itype1 = itype(ndust1-10)+1
      else
        itype1=0
      end if
*
      if(ndust1.eq.1.or.ndust1.eq.3.or.ndust1.gt.7.or.
     1  itype1.eq.1) then
*       pah/graphitic grains (and the greybody grains)
        ufunct=(temp**3.3)*1.904e-11/
     1  (1.+6.51e-03*temp+1.5e-06*temp*temp+8.3e-07*(temp**2.3))
      else
*       silicate grains
*       do j=1,4
        j = 1
        ufunct = 0.
        do while( j.lt.4 .and. ufunct.eq.0 )
*         limits of tlim set above, 0 and 1e30, so must happen
          if (temp.gt.tlim(j).and.temp.le.tlim(j+1)) then
            ufunct=term(j)+cval(j)*(temp**pow(j)-tlim(j)**pow(j))
*           go to 455
          end if
          j = j + 1
        end do
      end if
*455  ufunct=ufunct*atoms(ndust1)
      ufunct = ufunct*atoms(ndust1)
*
      end
