******************************************************************************
      subroutine VanCol
      implicit none
*compute vanadium cooling
      include "limelm.par"
      include "nta.par"
      include "dcool.com"
      include "TePowers.com"
      include "phycon.com"
      include "IonFracs.com"
      include "coolvan.com"
      include "TLineEXP.com"
*
*     local variables
      real a21, a31 , a32 , pop3, p3, p2 ,g1,g2,g3
*
*     V Vanadium cooling - element 23
*
*     V III 8823
      a21 = 0.05
      a31 = 0.10
      a32 = 0.00
      g1 = 28.
      g2 = 12.
      g3 = 18.
*     [V III] 8823, multiplet average
      p3 = pop3( g1,g2,g3, g1 ,g2,g3, a21 ,a31,a32,
     1  16303., 606., p2, xIonFracs(23,3),0.)
      V38830 = p2 * a21 * 2.25e-12
      V38507 = p3 * a31 * 2.34e-12
      call coladd( 'V  3' , 8823 , V38830  )
      call coladd( 'V  3' , 8507 , V38507  )
*
*     V IV
      a21 = 0.054
      a31 = 0.039
      a32 = 0.007
      g1 = 21.
      g2 = 5.
      g3 = 9.
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( g1,g2,g3, g1 ,g2,g3, a21 ,a31,a32,
     1  15159., 3437., p2, xIonFracs(23,4),0.)
*     7735 ang - 3=>1
      V47741 = p3 * a31 * 2.57e-12
*     9489 - 2=>1
      V49496 = p2 * a21 * 2.09e-12
*     4.19 microns 3=>2
      V44p2m = p3 * a32 * 4.74e-13
      call coladd( 'V  4' , 7735 , V47741  )
      call coladd( 'V  4' , 9489 , V49496  )
      call coladd( 'V  4' , 42 , V44p2m  )
*
*     [V VII] 1.3038 mic
*     Y(ik) from 
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 2.39 , Va07130 )
      call level2( Va07130 )
*
*     [V 15] 1721.38, cs from 
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.10 , Va15172 )
      call level2( Va15172 )
*
      end
